/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],R=0,r=Q.length;R<r;R++)e[R]=ne[Q[R]];return e};define(ne[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(A){return A?A.replace(/\$\((.*?)\)/g,(P,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=R;class r{constructor(P,E,b){this.id=P,this.definition=E,this.description=b,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",r.circleFilled.definition),r.closeDirty=new r("close-dirty",r.circleFilled.definition),r.debugBreakpoint=new r("debug-breakpoint",r.circleFilled.definition),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",r.circleFilled.definition),r.debugHint=new r("debug-hint",r.circleFilled.definition),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circle=new r("circle",{fontCharacter:"\\eabc"}),r.circleOutline=new r("circle-outline",r.circle.definition),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",r.circle.definition),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.circleSmallFilled=new r("circle-small-filled",{fontCharacter:"\\eb8a"}),r.debugStackframeDot=new r("debug-stackframe-dot",r.circleSmallFilled.definition),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLarge=new r("circle-large",{fontCharacter:"\\ebb5"}),r.circleLargeOutline=new r("circle-large-outline",r.circleLarge.definition),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.layoutActivitybarLeft=new r("layout-activitybar-left",{fontCharacter:"\\ebec"}),r.layoutActivitybarRight=new r("layout-activitybar-right",{fontCharacter:"\\ebed"}),r.layoutPanelLeft=new r("layout-panel-left",{fontCharacter:"\\ebee"}),r.layoutPanelCenter=new r("layout-panel-center",{fontCharacter:"\\ebef"}),r.layoutPanelJustify=new r("layout-panel-justify",{fontCharacter:"\\ebf0"}),r.layoutPanelRight=new r("layout-panel-right",{fontCharacter:"\\ebf1"}),r.layoutPanel=new r("layout-panel",{fontCharacter:"\\ebf2"}),r.layoutSidebarLeft=new r("layout-sidebar-left",{fontCharacter:"\\ebf3"}),r.layoutSidebarRight=new r("layout-sidebar-right",{fontCharacter:"\\ebf4"}),r.layoutStatusbar=new r("layout-statusbar",{fontCharacter:"\\ebf5"}),r.layoutMenubar=new r("layout-menubar",{fontCharacter:"\\ebf6"}),r.layoutCentered=new r("layout-centered",{fontCharacter:"\\ebf7"}),r.layoutSidebarRightOff=new r("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),r.layoutPanelOff=new r("layout-panel-off",{fontCharacter:"\\ec01"}),r.layoutSidebarLeftOff=new r("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),r.target=new r("target",{fontCharacter:"\\ebf8"}),r.indent=new r("indent",{fontCharacter:"\\ebf9"}),r.recordSmall=new r("record-small",{fontCharacter:"\\ebfa"}),r.errorSmall=new r("error-small",{fontCharacter:"\\ebfb"}),r.arrowCircleDown=new r("arrow-circle-down",{fontCharacter:"\\ebfc"}),r.arrowCircleLeft=new r("arrow-circle-left",{fontCharacter:"\\ebfd"}),r.arrowCircleRight=new r("arrow-circle-right",{fontCharacter:"\\ebfe"}),r.arrowCircleUp=new r("arrow-circle-up",{fontCharacter:"\\ebff"}),r.heartFilled=new r("heart-filled",{fontCharacter:"\\ec04"}),r.map=new r("map",{fontCharacter:"\\ec05"}),r.mapFilled=new r("map-filled",{fontCharacter:"\\ec06"}),r.circleSmall=new r("circle-small",{fontCharacter:"\\ec07"}),r.bellSlash=new r("bell-slash",{fontCharacter:"\\ec08"}),r.bellSlashDot=new r("bell-slash-dot",{fontCharacter:"\\ec09"}),r.commentUnresolved=new r("comment-unresolved",{fontCharacter:"\\ec0a"}),r.gitPullRequestGoToChanges=new r("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),r.gitPullRequestNewChanges=new r("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),r.searchFuzzy=new r("search-fuzzy",{fontCharacter:"\\ec0d"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function D(A,P){const E=["codicon","codicon-"+A];return P&&E.push("codicon-modifier-"+P),E}e.getClassNamesArray=D;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(w){if(w instanceof r)return["codicon","codicon-"+w.id];const p=P.exec(w.id);if(!p)return E(r.error);const[,v,h]=p,S=["codicon","codicon-"+v];return h&&S.push("codicon-modifier-"+h.substr(1)),S}A.asClassNameArray=E;function b(w){return E(w).join(" ")}A.asClassName=b;function I(w){return"."+E(w).join(".")}A.asCSSSelector=I})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[62],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(P,E,b)=>{let I=null,w=null;if(typeof b.value=="function"?(I="value",w=b.value):typeof b.get=="function"&&(I="get",w=b.get),!w)throw new Error("not supported");b[I]=A(w,E)}}e.createDecorator=R;function r(A,P,E){let b=null,I=null;if(typeof E.value=="function"?(b="value",I=E.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",I=E.get),!I)throw new Error("not supported");const w=`$memoize$${P}`;E[b]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,p)}),this[w]}}e.memoize=r;function D(A,P,E){return R((b,I)=>{const w=`$debounce$${I}`,p=`$debounce$result$${I}`;return function(...v){this[p]||(this[p]=E?E():void 0),clearTimeout(this[w]),P&&(this[p]=P(this[p],...v),v=[this[p]]),this[w]=setTimeout(()=>{b.apply(this,v),this[p]=E?E():void 0},A)}})}e.debounce=D;function L(A,P,E){return R((b,I)=>{const w=`$throttle$timer$${I}`,p=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...S){if(this[p]||(this[p]=E?E():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...S)),this[h])return;const C=this[v]+A;C<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0):(this[h]=!0,this[w]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0},C-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=R,e.errorHandler=new R;function r(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=r;function D(l){E(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function L(l){E(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function A(l){if(l instanceof Error){const{name:i,message:s}=l,t=l.stacktrace||l.stack;return{$isError:!0,name:i,message:s,stack:t,noTelemetry:a.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=A;const P="Canceled";function E(l){return l instanceof b?!0:l instanceof Error&&l.name===P&&l.message===P}e.isCancellationError=E;class b extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=b;function I(){const l=new Error(P);return l.name=l.message,l}e.canceled=I;function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=w;function p(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=p;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function S(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=S;class C extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=C;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const s=new a;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ne[19],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(X,ie=0){return X[X.length-(1+ie)]}e.tail=r;function D(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=D;function L(X,ie,se=(ue,he)=>ue===he){if(X===ie)return!0;if(!X||!ie||X.length!==ie.length)return!1;for(let ue=0,he=X.length;ue<he;ue++)if(!se(X[ue],ie[ue]))return!1;return!0}e.equals=L;function A(X,ie){const se=X.length-1;ie<se&&(X[ie]=X[se]),X.pop()}e.removeFastWithoutKeepingOrder=A;function P(X,ie,se){return E(X.length,ue=>se(X[ue],ie))}e.binarySearch=P;function E(X,ie){let se=0,ue=X-1;for(;se<=ue;){const he=(se+ue)/2|0,ve=ie(he);if(ve<0)se=he+1;else if(ve>0)ue=he-1;else return he}return-(se+1)}e.binarySearch2=E;function b(X,ie){let se=0,ue=X.length;if(ue===0)return 0;for(;se<ue;){const he=Math.floor((se+ue)/2);ie(X[he])?ue=he:se=he+1}return se}e.findFirstInSorted=b;function I(X,ie,se){if(X=X|0,X>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],he=[],ve=[],we=[];for(const Ee of ie){const Pe=se(Ee,ue);Pe<0?he.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return X<he.length?I(X,he,se):X<he.length+we.length?we[0]:I(X-(he.length+we.length),ve,se)}e.quickSelect=I;function w(X,ie){const se=[];let ue;for(const he of X.slice(0).sort(ie))!ue||ie(ue[0],he)!==0?(ue=[he],se.push(ue)):ue.push(he);return se}e.groupBy=w;function p(X,ie,se){const ue=[];function he(Ee,Pe,Ue){if(Pe===0&&Ue.length===0)return;const ze=ue[ue.length-1];ze&&ze.start+ze.deleteCount===Ee?(ze.deleteCount+=Pe,ze.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Pe,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===X.length){he(ve,0,ie.slice(we));break}if(we===ie.length){he(ve,X.length-ve,[]);break}const Ee=X[ve],Pe=ie[we],Ue=se(Ee,Pe);Ue===0?(ve+=1,we+=1):Ue<0?(he(ve,1,[]),ve+=1):Ue>0&&(he(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=p;function v(X,ie,se){const ue=p(X,ie,se),he=[],ve=[];for(const we of ue)he.push(...X.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:he,added:ve}}e.delta=v;function h(X,ie,se){if(se===0)return[];const ue=X.slice(0,se).sort(ie);return C(X,ie,ue,se,X.length),ue}e.top=h;function S(X,ie,se,ue,he){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=X.length,Pe=X.slice(0,se).sort(ie);for(let Ue=se,ze=Math.min(se+ue,Ee);Ue<Ee;Ue=ze,ze=Math.min(ze+ue,Ee)){if(Ue>se&&await new Promise(Ve=>setTimeout(Ve)),he&&he.isCancellationRequested)throw new R.CancellationError;C(X,ie,Pe,Ue,ze)}return Pe})().then(ve,we)})}e.topAsync=S;function C(X,ie,se,ue,he){for(const ve=se.length;ue<he;ue++){const we=X[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=b(se,Pe=>ie(we,Pe)<0);se.splice(Ee,0,we)}}}function m(X){return X.filter(ie=>!!ie)}e.coalesce=m;function g(X){let ie=0;for(let se=0;se<X.length;se++)X[se]&&(X[ie]=X[se],ie+=1);X.length=ie}e.coalesceInPlace=g;function a(X,ie,se){X.splice(se,0,X.splice(ie,1)[0])}e.move=a;function f(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=f;function l(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=l;function i(X,ie=se=>se){const se=new Set;return X.filter(ue=>{const he=ie(ue);return se.has(he)?!1:(se.add(he),!0)})}e.distinct=i;function s(X){const ie=new Set;return se=>{const ue=X(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=s;function t(X,ie){const se=n(X,ie);if(se!==-1)return X[se]}e.findLast=t;function n(X,ie){for(let se=X.length-1;se>=0;se--){const ue=X[se];if(ie(ue))return se}return-1}e.lastIndex=n;function o(X,ie){return X.length>0?X[0]:ie}e.firstOrDefault=o;function u(X,ie){return X.length>0?X[X.length-1]:ie}e.lastOrDefault=u;function c(X,ie,se=(ue,he)=>ue===he){let ue=0;for(let he=0,ve=Math.min(X.length,ie.length);he<ve&&se(X[he],ie[he]);he++)ue++;return ue}e.commonPrefixLength=c;function d(X){return[].concat(...X)}e.flatten=d;function y(X,ie){let se=typeof ie=="number"?X:0;typeof ie=="number"?se=X:(se=0,ie=X);const ue=[];if(se<=ie)for(let he=se;he<ie;he++)ue.push(he);else for(let he=se;he>ie;he--)ue.push(he);return ue}e.range=y;function _(X,ie,se){return X.reduce((ue,he)=>(ue[ie(he)]=se?se(he):he,ue),Object.create(null))}e.index=_;function F(X,ie){return X.push(ie),()=>T(X,ie)}e.insert=F;function T(X,ie){const se=X.indexOf(ie);if(se>-1)return X.splice(se,1),ie}e.remove=T;function O(X,ie,se){const ue=X.slice(0,ie),he=X.slice(ie);return ue.concat(se,he)}e.arrayInsert=O;function k(X,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else se=Math.random;for(let ue=X.length-1;ue>0;ue-=1){const he=Math.floor(se()*(ue+1)),ve=X[ue];X[ue]=X[he],X[he]=ve}}e.shuffle=k;function M(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.unshift(ie))}e.pushToStart=M;function $(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.push(ie))}e.pushToEnd=$;function q(X,ie){for(const se of ie)X.push(se)}e.pushMany=q;function J(X,ie){return Array.isArray(X)?X.map(ie):ie(X)}e.mapArrayOrNot=J;function H(X){return Array.isArray(X)?X:[X]}e.asArray=H;function G(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=G;function z(X,ie){for(const se of X){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=z;function x(X,ie,se){const ue=te(X,ie),he=X.length,ve=se.length;X.length=he+ve;for(let we=he-1;we>=ue;we--)X[we+ve]=X[we];for(let we=0;we<ve;we++)X[we+ue]=se[we]}e.insertInto=x;function Y(X,ie,se,ue){const he=te(X,ie),ve=X.splice(he,se);return x(X,he,ue),ve}e.splice=Y;function te(X,ie){return ie<0?Math.max(ie+X.length,0):Math.min(ie,X.length)}var ce;(function(X){function ie(he){return he<0}X.isLessThan=ie;function se(he){return he>0}X.isGreaterThan=se;function ue(he){return he===0}X.isNeitherLessOrGreaterThan=ue,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function W(X,ie){return(se,ue)=>ie(X(se),X(ue))}e.compareBy=W;function V(...X){return(ie,se)=>{for(const ue of X){const he=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=V;const U=(X,ie)=>X-ie;e.numberComparator=U;function N(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>0&&(se=he)}return se}e.findMaxBy=N;function j(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>=0&&(se=he)}return se}e.findLastMaxBy=j;function B(X,ie){return N(X,(se,ue)=>-ie(se,ue))}e.findMinBy=B;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(ie(he,se)))&&(ue=!1,se=he),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(X=>{})}),define(ne[114],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function r(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=r;function D(E,b="Unreachable"){throw new Error(b)}e.assertNever=D;function L(E){if(!E)throw new R.BugIndicatingError("Assertion Failed")}e.assert=L;function A(E){if(!E()){debugger;E(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function P(E,b){let I=0;for(;I<E.length-1;){const w=E[I],p=E[I+1];if(!b(w,p))return!1;I++}return!0}e.checkAdjacentItems=P}),define(ne[78],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(r){const D=this;let L=!1,A;return function(){return L||(L=!0,A=r.apply(D,arguments)),A}}e.once=R}),define(ne[52],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(r){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}r.is=D;const L=Object.freeze([]);function A(){return L}r.empty=A;function*P(s){yield s}r.single=P;function E(s){return s||L}r.from=E;function b(s){return!s||s[Symbol.iterator]().next().done===!0}r.isEmpty=b;function I(s){return s[Symbol.iterator]().next().value}r.first=I;function w(s,t){for(const n of s)if(t(n))return!0;return!1}r.some=w;function p(s,t){for(const n of s)if(t(n))return n}r.find=p;function*v(s,t){for(const n of s)t(n)&&(yield n)}r.filter=v;function*h(s,t){let n=0;for(const o of s)yield t(o,n++)}r.map=h;function*S(...s){for(const t of s)for(const n of t)yield n}r.concat=S;function*C(s){for(const t of s)for(const n of t)yield n}r.concatNested=C;function m(s,t,n){let o=n;for(const u of s)o=t(o,u);return o}r.reduce=m;function g(s,t){let n=0;for(const o of s)t(o,n++)}r.forEach=g;function*a(s,t,n=s.length){for(t<0&&(t+=s.length),n<0?n+=s.length:n>s.length&&(n=s.length);t<n;t++)yield s[t]}r.slice=a;function f(s,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,s];const o=s[Symbol.iterator]();for(let u=0;u<t;u++){const c=o.next();if(c.done)return[n,r.empty()];n.push(c.value)}return[n,{[Symbol.iterator](){return o}}]}r.consume=f;function l(s){return f(s)[0]}r.collect=l;function i(s,t,n=(o,u)=>o===u){const o=s[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const c=o.next(),d=u.next();if(c.done!==d.done)return!1;if(c.done)return!0;if(!n(c.value,d.value))return!1}}r.equals=i})(R=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var r;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function A(i,s=!1){let t=0;const n=i.length;let o="",u=0,c=16,d=0;function y($){let q=0,J=0;for(;q<$;){const H=i.charCodeAt(t);if(H>=48&&H<=57)J=J*16+H-48;else if(H>=65&&H<=70)J=J*16+H-65+10;else if(H>=97&&H<=102)J=J*16+H-97+10;else break;t++,q++}return q<$&&(J=-1),J}function _($){t=$,o="",u=0,c=16,d=0}function F(){const $=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&b(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&b(i.charCodeAt(t)))for(t++;t<i.length&&b(i.charCodeAt(t));)t++;else return d=3,i.substring($,t);let q=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&b(i.charCodeAt(t))){for(t++;t<i.length&&b(i.charCodeAt(t));)t++;q=t}else d=3;return i.substring($,q)}function T(){let $="",q=t;for(;;){if(t>=n){$+=i.substring(q,t),d=2;break}const J=i.charCodeAt(t);if(J===34){$+=i.substring(q,t),t++;break}if(J===92){if($+=i.substring(q,t),t++,t>=n){d=2;break}switch(i.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const G=y(4);G>=0?$+=String.fromCharCode(G):d=4;break}default:d=5}q=t;continue}if(J>=0&&J<=31)if(E(J)){$+=i.substring(q,t),d=2;break}else d=6;t++}return $}function O(){if(o="",d=0,u=t,t>=n)return u=n,c=17;let $=i.charCodeAt(t);if(P($)){do t++,o+=String.fromCharCode($),$=i.charCodeAt(t);while(P($));return c=15}if(E($))return t++,o+=String.fromCharCode($),$===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),c=14;switch($){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,o=T(),c=10;case 47:{const q=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!E(i.charCodeAt(t));)t++;return o=i.substring(q,t),c=12}if(i.charCodeAt(t+1)===42){t+=2;const J=n-1;let H=!1;for(;t<J;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,d=1),o=i.substring(q,t),c=13}return o+=String.fromCharCode($),t++,c=16}case 45:if(o+=String.fromCharCode($),t++,t===n||!b(i.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=F(),c=11;default:for(;t<n&&k($);)t++,$=i.charCodeAt(t);if(u!==t){switch(o=i.substring(u,t),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode($),t++,c=16}}function k($){if(P($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=O();while($>=12&&$<=15);return $}return{setPosition:_,getPosition:()=>t,scan:s?M:O,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>d}}e.createScanner=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function w(i,s){const t=[],n=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function d(y,_,F,T){u.value=y,u.offset=_,u.length=F,u.type=T,u.colonOffset=void 0,o=u}try{a(i,{onObjectBegin:(y,_)=>{if(s<=y)throw n;o=void 0,c=s>y,t.push("")},onObjectProperty:(y,_,F)=>{if(s<_||(d(y,_,F,"property"),t[t.length-1]=y,s<=_+F))throw n},onObjectEnd:(y,_)=>{if(s<=y)throw n;o=void 0,t.pop()},onArrayBegin:(y,_)=>{if(s<=y)throw n;o=void 0,t.push(0)},onArrayEnd:(y,_)=>{if(s<=y)throw n;o=void 0,t.pop()},onLiteralValue:(y,_,F)=>{if(s<_||(d(y,_,F,l(y)),s<=_+F))throw n},onSeparator:(y,_,F)=>{if(s<=_)throw n;if(y===":"&&o&&o.type==="property")o.colonOffset=_,c=!1,o=void 0;else if(y===","){const T=t[t.length-1];typeof T=="number"?t[t.length-1]=T+1:(c=!0,t[t.length-1]=""),o=void 0}}})}catch(y){if(y!==n)throw y}return{path:t,previousNode:o,isAtPropertyKey:c,matches:y=>{let _=0;for(let F=0;_<y.length&&F<t.length;F++)if(y[_]===t[F]||y[_]==="*")_++;else if(y[_]!=="**")return!1;return _===y.length}}}e.getLocation=w;function p(i,s=[],t=L.DEFAULT){let n=null,o=[];const u=[];function c(y){Array.isArray(o)?o.push(y):n!==null&&(o[n]=y)}return a(i,{onObjectBegin:()=>{const y={};c(y),u.push(o),o=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const y=[];c(y),u.push(o),o=y,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:c,onError:(y,_,F)=>{s.push({error:y,offset:_,length:F})}},t),o[0]}e.parse=p;function v(i,s=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function u(y){return n.children.push(y),y}a(i,{onObjectBegin:y=>{n=u({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,_,F)=>{n=u({type:"property",offset:_,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:_,length:F,parent:n})},onObjectEnd:(y,_)=>{n.length=y+_-n.offset,n=n.parent,o(y+_)},onArrayBegin:(y,_)=>{n=u({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,_)=>{n.length=y+_-n.offset,n=n.parent,o(y+_)},onLiteralValue:(y,_,F)=>{u({type:l(y),offset:_,length:F,parent:n,value:y}),o(_+F)},onSeparator:(y,_,F)=>{n.type==="property"&&(y===":"?n.colonOffset=_:y===","&&o(_))},onError:(y,_,F)=>{s.push({error:y,offset:_,length:F})}},t);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=v;function h(i,s){if(!i)return;let t=i;for(const n of s)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===n){t=u.children[1],o=!0;break}if(!o)return}else{const o=n;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function S(i){if(!i.parent||!i.parent.children)return[];const s=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}e.getNodePath=S;function C(i){switch(i.type){case"array":return i.children.map(C);case"object":{const s=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(s[t.children[0].value]=C(n))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=C;function m(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}e.contains=m;function g(i,s,t=!1){if(m(i,s,t)){const n=i.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=s;o++){const u=g(n[o],s,t);if(u)return u}return i}}e.findNodeAtOffset=g;function a(i,s,t=L.DEFAULT){const n=A(i,!1);function o(W){return W?()=>W(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(W){return W?V=>W(V,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=o(s.onObjectBegin),d=u(s.onObjectProperty),y=o(s.onObjectEnd),_=o(s.onArrayBegin),F=o(s.onArrayEnd),T=u(s.onLiteralValue),O=u(s.onSeparator),k=o(s.onComment),M=u(s.onError),$=t&&t.disallowComments,q=t&&t.allowTrailingComma;function J(){for(;;){const W=n.scan();switch(n.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(W){case 12:case 13:$?H(10):k();break;case 16:H(1);break;case 15:case 14:break;default:return W}}}function H(W,V=[],U=[]){if(M(W),V.length+U.length>0){let N=n.getToken();for(;N!==17;){if(V.indexOf(N)!==-1){J();break}else if(U.indexOf(N)!==-1)break;N=J()}}}function G(W){const V=n.getTokenValue();return W?T(V):d(V),J(),!0}function z(){switch(n.getToken()){case 11:{let W=0;try{W=JSON.parse(n.getTokenValue()),typeof W!="number"&&(H(2),W=0)}catch{H(2)}T(W);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return J(),!0}function x(){return n.getToken()!==10?(H(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(O(":"),J(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){c(),J();let W=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(W||H(4,[],[]),O(","),J(),n.getToken()===2&&q)break}else W&&H(6,[],[]);x()||H(4,[],[2,5]),W=!0}return y(),n.getToken()!==2?H(7,[2],[]):J(),!0}function te(){_(),J();let W=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(W||H(4,[],[]),O(","),J(),n.getToken()===4&&q)break}else W&&H(6,[],[]);ce()||H(4,[],[4,5]),W=!0}return F(),n.getToken()!==4?H(8,[4],[]):J(),!0}function ce(){switch(n.getToken()){case 3:return te();case 1:return Y();case 10:return G(!0);default:return z()}}return J(),n.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(n.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=a;function f(i,s){const t=A(i),n=[];let o,u=0,c;do switch(c=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:u!==c&&n.push(i.substring(u,c)),s!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,s)),u=t.getPosition();break}while(o!==17);return n.join("")}e.stripComments=f;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[46],re([0,1,35]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(b,I,w){let p,v,h,S,C;if(I){for(S=I.offset,C=S+I.length,h=S;h>0&&!E(b,h-1);)h--;let c=C;for(;c<b.length&&!E(b,c);)c++;v=b.substring(h,c),p=A(v,w)}else v=b,p=0,h=0,S=0,C=b.length;const m=P(w,b);let g=!1,a=0,f;w.insertSpaces?f=L(" ",w.tabSize||4):f="	";const l=(0,R.createScanner)(v,!1);let i=!1;function s(){return m+L(f,p+a)}function t(){let c=l.scan();for(g=!1;c===15||c===14;)g=g||c===14,c=l.scan();return i=c===16||l.getTokenError()!==0,c}const n=[];function o(c,d,y){!i&&d<C&&y>S&&b.substring(d,y)!==c&&n.push({offset:d,length:y-d,content:c})}let u=t();if(u!==17){const c=l.getTokenOffset()+h,d=L(f,p);o(d,h,c)}for(;u!==17;){let c=l.getTokenOffset()+l.getTokenLength()+h,d=t(),y="";for(;!g&&(d===12||d===13);){const F=l.getTokenOffset()+h;o(" ",c,F),c=l.getTokenOffset()+l.getTokenLength()+h,y=d===12?s():"",d=t()}if(d===2)u!==1&&(a--,y=s());else if(d===4)u!==3&&(a--,y=s());else{switch(u){case 3:case 1:a++,y=s();break;case 5:case 12:y=s();break;case 13:g?y=s():y=" ";break;case 6:y=" ";break;case 10:if(d===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?y=" ":d!==5&&d!==17&&(i=!0);break;case 16:i=!0;break}g&&(d===12||d===13)&&(y=s())}const _=l.getTokenOffset()+h;o(y,c,_),u=d}return n}e.format=r;function D(b,I){const w=JSON.stringify(b,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?w.replace(/\r\n|\r|\n/g,I.eol):w}e.toFormattedString=D;function L(b,I){let w="";for(let p=0;p<I;p++)w+=b;return w}function A(b,I){let w=0,p=0;const v=I.tabSize||4;for(;w<b.length;){const h=b.charAt(w);if(h===" ")p++;else if(h==="	")p+=v;else break;w++}return Math.floor(p/v)}function P(b,I){for(let w=0;w<I.length;w++){const p=I.charAt(w);if(p==="\r")return w+1<I.length&&I.charAt(w+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=P;function E(b,I){return`\r
`.indexOf(b.charAt(I))!==-1}e.isEOL=E}),define(ne[79],re([0,1,35,46]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,I,w){return L(b,I,void 0,w)}e.removeProperty=D;function L(b,I,w,p,v){const h=I.slice(),S=[],C=(0,R.parseTree)(b,S);let m,g;for(;h.length>0&&(g=h.pop(),m=(0,R.findNodeAtLocation)(C,h),m===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(m)if(m.type==="object"&&typeof g=="string"&&Array.isArray(m.children)){const a=(0,R.findNodeAtLocation)(m,[g]);if(a!==void 0)if(w===void 0){if(!a.parent)throw new Error("Malformed AST");const f=m.children.indexOf(a.parent);let l,i=a.parent.offset+a.parent.length;if(f>0){const s=m.children[f-1];l=s.offset+s.length}else l=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return A(b,{offset:l,length:i-l,content:""},p)}else return A(b,{offset:a.offset,length:a.length,content:JSON.stringify(w)},p);else{if(w===void 0)return[];const f=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,l=v?v(m.children.map(s=>s.children[0].value)):m.children.length;let i;if(l>0){const s=m.children[l-1];i={offset:s.offset+s.length,length:0,content:","+f}}else m.children.length===0?i={offset:m.offset+1,length:0,content:f}:i={offset:m.offset+1,length:0,content:f+","};return A(b,i,p)}}else if(m.type==="array"&&typeof g=="number"&&Array.isArray(m.children))if(w!==void 0){const a=`${JSON.stringify(w)}`;let f;if(m.children.length===0||g===0)f={offset:m.offset+1,length:0,content:m.children.length===0?a:a+","};else{const l=g===-1||g>m.children.length?m.children.length:g,i=m.children[l-1];f={offset:i.offset+i.length,length:0,content:","+a}}return A(b,f,p)}else{const a=g,f=m.children[a];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===a){const i=m.children[a-1],s=i.offset+i.length,t=m.offset+m.length;l={offset:s,length:t-2-s,content:""}}else l={offset:f.offset,length:m.children[a+1].offset-f.offset,content:""};return A(b,l,p)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(b,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(w)},p)}}e.setProperty=L;function A(b,I,w){let p=P(b,I),v=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;v>0&&!(0,r.isEOL)(p,v-1);)v--;for(;h<p.length&&!(0,r.isEOL)(p,h);)h++}const S=(0,r.format)(p,{offset:v,length:h-v},w);for(let m=S.length-1;m>=0;m--){const g=S[m];p=P(p,g),v=Math.min(v,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const C=b.length-(p.length-h)-v;return[{offset:v,length:C,content:p.substring(v,h)}]}e.withFormatting=A;function P(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=P;function E(b,I){const w=I.slice(0).sort((v,h)=>{const S=v.offset-h.offset;return S===0?v.length-h.length:S});let p=b.length;for(let v=w.length-1;v>=0;v--){const h=w[v];if(h.offset+h.length<=p)b=P(b,h);else throw new Error("Overlapping edit");p=h.offset}return b}e.applyEdits=E}),define(ne[115],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new R(()=>D(this.getValue()))}}e.Lazy=R}),define(ne[2],re([0,1,78,52]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let L=null;function A(o){L=o}if(e.setDisposableTracker=A,D){const o="__is_disposable_tracked__";A(new class{trackDisposable(u){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[o]||console.log(c)},3e3)}setParent(u,c){if(u&&u!==g.None)try{u[o]=!0}catch{}}markAsDisposed(u){if(u&&u!==g.None)try{u[o]=!0}catch{}}markAsSingleton(u){}})}function P(o){return L?.trackDisposable(o),o}function E(o){L?.markAsDisposed(o)}function b(o,u){L?.setParent(o,u)}function I(o,u){if(!!L)for(const c of o)L.setParent(c,u)}function w(o){return L?.markAsSingleton(o),o}e.markAsSingleton=w;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=p;function v(o){if(r.Iterable.is(o)){const u=[];for(const c of o)if(c)try{c.dispose()}catch(d){u.push(d)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=v;function h(o){for(const u of o)p(u)&&u.dispose();return[]}e.disposeIfDisposable=h;function S(...o){const u=C(()=>v(o));return I(o,u),u}e.combinedDisposable=S;function C(o){const u=P({dispose:(0,R.once)(()=>{E(u),o()})});return u}e.toDisposable=C;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return b(u,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new m,P(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&b(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&b(u,null),u}}e.MutableDisposable=a;class f{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(u){let c=u;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,E(this))},this}}e.SafeDisposable=l;class i{constructor(){this.references=new Map}acquire(u,...c){let d=this.references.get(u);d||(d={counter:0,object:this.createReferencedObject(u,...c)},this.references.set(u,d));const{object:y}=d,_=(0,R.once)(()=>{--d.counter===0&&(this.destroyReferencedObject(u,d.object),this.references.delete(u))});return d.counter++,{object:y,dispose:_}}}e.ReferenceCollection=i;class s{constructor(u){this.referenceCollection=u}async acquire(u,...c){const d=this.referenceCollection.acquire(u,...c);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(y){throw d.dispose(),y}}}e.AsyncReferenceCollection=s;class t{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=t;function n(o){const u=new m;try{o(u)}finally{u.dispose()}}e.disposeOnReturn=n}),define(ne[116],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(L){this.element=L,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class r{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let L=this._first;for(;L!==R.Undefined;){const A=L.next;L.prev=R.Undefined,L.next=R.Undefined,L=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const P=new R(L);if(this._first===R.Undefined)this._first=P,this._last=P;else if(A){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==R.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==R.Undefined&&L.next!==R.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===R.Undefined&&L.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):L.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):L.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==R.Undefined;)yield L.element,L=L.next}}e.LinkedList=r}),function(){function Q(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function A(E){L.push(E,Date.now())}function P(){const E=[];for(let b=0;b<L.length;b+=2)E.push({name:L[b],startTime:L[b+1]});return E}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(D+A.startTime)});return L}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=R(r))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var r in R)(typeof exports=="object"?exports:Q)[r]=R[r]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function R(r){if(e[r])return e[r].exports;var D=e[r]={i:r,l:!1,exports:{}};return Q[r].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=Q,R.c=e,R.d=function(r,D,L){R.o(r,D)||Object.defineProperty(r,D,{enumerable:!0,get:L})},R.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},R.t=function(r,D){if(1&D&&(r=R(r)),8&D||4&D&&typeof r=="object"&&r&&r.__esModule)return r;var L=Object.create(null);if(R.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:r}),2&D&&typeof r!="string")for(var A in r)R.d(L,A,function(P){return r[P]}.bind(null,A));return L},R.n=function(r){var D=r&&r.__esModule?function(){return r.default}:function(){return r};return R.d(D,"a",D),D},R.o=function(r,D){return Object.prototype.hasOwnProperty.call(r,D)},R.p="",R(R.s=0)}([function(Q,e,R){(function(r){var D;e=Q.exports=U,D=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],E=e.src=[],b=0,I=b++;E[I]="0|[1-9]\\d*";var w=b++;E[w]="[0-9]+";var p=b++;E[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=b++;E[v]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var h=b++;E[h]="("+E[w]+")\\.("+E[w]+")\\.("+E[w]+")";var S=b++;E[S]="(?:"+E[I]+"|"+E[p]+")";var C=b++;E[C]="(?:"+E[w]+"|"+E[p]+")";var m=b++;E[m]="(?:-("+E[S]+"(?:\\."+E[S]+")*))";var g=b++;E[g]="(?:-?("+E[C]+"(?:\\."+E[C]+")*))";var a=b++;E[a]="[0-9A-Za-z-]+";var f=b++;E[f]="(?:\\+("+E[a]+"(?:\\."+E[a]+")*))";var l=b++,i="v?"+E[v]+E[m]+"?"+E[f]+"?";E[l]="^"+i+"$";var s="[v=\\s]*"+E[h]+E[g]+"?"+E[f]+"?",t=b++;E[t]="^"+s+"$";var n=b++;E[n]="((?:<|>)?=?)";var o=b++;E[o]=E[w]+"|x|X|\\*";var u=b++;E[u]=E[I]+"|x|X|\\*";var c=b++;E[c]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[m]+")?"+E[f]+"?)?)?";var d=b++;E[d]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[g]+")?"+E[f]+"?)?)?";var y=b++;E[y]="^"+E[n]+"\\s*"+E[c]+"$";var _=b++;E[_]="^"+E[n]+"\\s*"+E[d]+"$";var F=b++;E[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=b++;E[T]="(?:~>?)";var O=b++;E[O]="(\\s*)"+E[T]+"\\s+",P[O]=new RegExp(E[O],"g");var k=b++;E[k]="^"+E[T]+E[c]+"$";var M=b++;E[M]="^"+E[T]+E[d]+"$";var $=b++;E[$]="(?:\\^)";var q=b++;E[q]="(\\s*)"+E[$]+"\\s+",P[q]=new RegExp(E[q],"g");var J=b++;E[J]="^"+E[$]+E[c]+"$";var H=b++;E[H]="^"+E[$]+E[d]+"$";var G=b++;E[G]="^"+E[n]+"\\s*("+s+")$|^$";var z=b++;E[z]="^"+E[n]+"\\s*("+i+")$|^$";var x=b++;E[x]="(\\s*)"+E[n]+"\\s*("+s+"|"+E[c]+")",P[x]=new RegExp(E[x],"g");var Y=b++;E[Y]="^\\s*("+E[c]+")\\s+-\\s+("+E[c]+")\\s*$";var te=b++;E[te]="^\\s*("+E[d]+")\\s+-\\s+("+E[d]+")\\s*$";var ce=b++;E[ce]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)D(W,E[W]),P[W]||(P[W]=new RegExp(E[W]));function V(ae,fe){if(ae instanceof U)return ae;if(typeof ae!="string"||ae.length>L||!(fe?P[t]:P[l]).test(ae))return null;try{return new U(ae,fe)}catch{return null}}function U(ae,fe){if(ae instanceof U){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(ae,fe);D("SemVer",ae,fe),this.loose=fe;var de=ae.trim().match(fe?P[t]:P[l]);if(!de)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<A)return Ie}return Ce}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=V,e.valid=function(ae,fe){var de=V(ae,fe);return de?de.version:null},e.clean=function(ae,fe){var de=V(ae.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof U||(ae=new U(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},U.prototype.compareMain=function(ae){return ae instanceof U||(ae=new U(ae,this.loose)),j(this.major,ae.major)||j(this.minor,ae.minor)||j(this.patch,ae.patch)},U.prototype.comparePre=function(ae){if(ae instanceof U||(ae=new U(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],Ce=ae.prerelease[fe];if(D("prerelease compare",fe,de,Ce),de===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(de===void 0)return-1;if(de!==Ce)return j(de,Ce)}while(++fe)},U.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,de,Ce){typeof de=="string"&&(Ce=de,de=void 0);try{return new U(ae,de).inc(fe,Ce).version}catch{return null}},e.diff=function(ae,fe){if(X(ae,fe))return null;var de=V(ae),Ce=V(fe);if(de.prerelease.length||Ce.prerelease.length){for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=j;var N=/^[0-9]+$/;function j(ae,fe){var de=N.test(ae),Ce=N.test(fe);return de&&Ce&&(ae=+ae,fe=+fe),de&&!Ce?-1:Ce&&!de?1:ae<fe?-1:ae>fe?1:0}function B(ae,fe,de){return new U(ae,de).compare(new U(fe,de))}function Z(ae,fe,de){return B(ae,fe,de)>0}function oe(ae,fe,de){return B(ae,fe,de)<0}function X(ae,fe,de){return B(ae,fe,de)===0}function ie(ae,fe,de){return B(ae,fe,de)!==0}function se(ae,fe,de){return B(ae,fe,de)>=0}function ue(ae,fe,de){return B(ae,fe,de)<=0}function he(ae,fe,de,Ce){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof de=="object"&&(de=de.version),Ie=ae===de;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof de=="object"&&(de=de.version),Ie=ae!==de;break;case"":case"=":case"==":Ie=X(ae,de,Ce);break;case"!=":Ie=ie(ae,de,Ce);break;case">":Ie=Z(ae,de,Ce);break;case">=":Ie=se(ae,de,Ce);break;case"<":Ie=oe(ae,de,Ce);break;case"<=":Ie=ue(ae,de,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function ve(ae,fe){if(ae instanceof ve){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,fe);D("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,fe){return j(fe,ae)},e.major=function(ae,fe){return new U(ae,fe).major},e.minor=function(ae,fe){return new U(ae,fe).minor},e.patch=function(ae,fe){return new U(ae,fe).patch},e.compare=B,e.compareLoose=function(ae,fe){return B(ae,fe,!0)},e.rcompare=function(ae,fe,de){return B(fe,ae,de)},e.sort=function(ae,fe){return ae.sort(function(de,Ce){return e.compare(de,Ce,fe)})},e.rsort=function(ae,fe){return ae.sort(function(de,Ce){return e.rcompare(de,Ce,fe)})},e.gt=Z,e.lt=oe,e.eq=X,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=he,e.Comparator=ve;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof ve)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,fe,de,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee){return((fe=Pe(de)?"":Pe(Ce)?">="+de+".0.0":Pe(Ie)?">="+de+"."+Ce+".0":">="+fe)+" "+($e=Pe(Ae)?"":Pe(Fe)?"<"+(+Ae+1)+".0.0":Pe(_e)?"<"+Ae+"."+(+Fe+1)+".0":ke?"<="+Ae+"."+Fe+"."+_e+"-"+ke:"<="+$e)).trim()}function ze(ae,fe){for(var de=0;de<ae.length;de++)if(!ae[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<ae.length;de++)if(D(ae[de].semver),ae[de].semver!==we&&ae[de].semver.prerelease.length>0){var Ce=ae[de].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function Ve(ae,fe,de){try{fe=new Ee(fe,de)}catch{return!1}return fe.test(ae)}function We(ae,fe,de,Ce){var Ie,Me,De,$e,Ae;switch(ae=new U(ae,Ce),fe=new Ee(fe,Ce),de){case">":Ie=Z,Me=ue,De=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=se,De=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ae,fe,Ce))return!1;for(var Fe=0;Fe<fe.set.length;++Fe){var _e=fe.set[Fe],ke=null,ee=null;if(_e.forEach(function(le){le.semver===we&&(le=new ve(">=0.0.0")),ke=ke||le,ee=ee||le,Ie(le.semver,ke.semver,Ce)?ke=le:De(le.semver,ee.semver,Ce)&&(ee=le)}),ke.operator===$e||ke.operator===Ae||(!ee.operator||ee.operator===$e)&&Me(ae,ee.semver)||ee.operator===Ae&&De(ae,ee.semver))return!1}return!0}ve.prototype.parse=function(ae){var fe=this.loose?P[G]:P[z],de=ae.match(fe);if(!de)throw new TypeError("Invalid comparator: "+ae);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new U(de[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new U(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,fe){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Ee(ae.value,fe),Ve(this.value,de,fe);if(ae.operator==="")return de=new Ee(this.value,fe),Ve(ae.semver,de,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Ie||Me&&De||$e||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),D("range",ae,fe);var de=fe?P[te]:P[Y];ae=ae.replace(de,Ue),D("hyphen replace",ae),ae=ae.replace(P[x],"$1$2$3"),D("comparator trim",ae,P[x]),ae=(ae=(ae=ae.replace(P[O],"$1~")).replace(P[q],"$1^")).split(/\s+/).join(" ");var Ce=fe?P[G]:P[z],Ie=ae.split(" ").map(function(Me){return function(De,$e){return D("comp",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){D("caret",ke,ee);var le=ee?P[H]:P[J];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return D("caret",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=ge==="0"?">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+".0 <"+(+ge+1)+".0.0":Re?(D("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+Re+" <"+(+ge+1)+".0.0"):(D("no pr"),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+" <"+(+ge+1)+".0.0"),D("caret return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),D("caret",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){var le=ee?P[M]:P[k];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return D("tilde",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":Re?(D("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0"):Te=">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0",D("tilde return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),D("tildes",De),De=function(Ae,Fe){return D("replaceXRanges",Ae,Fe),Ae.split(/\s+/).map(function(_e){return function(ke,ee){ke=ke.trim();var le=ee?P[_]:P[y];return ke.replace(le,function(me,ge,Se,be,Re,Te){D("xRange",ke,me,ge,Se,be,Re,Te);var qe=Pe(Se),Le=qe||Pe(be),Ne=Le||Pe(Re);return ge==="="&&Ne&&(ge=""),qe?me=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ne?(Le&&(be=0),Ne&&(Re=0),ge===">"?(ge=">=",Le?(Se=+Se+1,be=0,Re=0):Ne&&(be=+be+1,Re=0)):ge==="<="&&(ge="<",Le?Se=+Se+1:be=+be+1),me=ge+Se+"."+be+"."+Re):Le?me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ne&&(me=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),D("xRange return",me),me})}(_e,Fe)}).join(" ")}(De,$e),D("xrange",De),De=function(Ae,Fe){return D("replaceStars",Ae,Fe),Ae.trim().replace(P[ce],"")}(De,$e),D("stars",De),De}(Me,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Ce)})),Ie=Ie.map(function(Me){return new ve(Me,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ce){return ae.set.some(function(Ie){return Ie.every(function(Me){return Ce.intersects(Me,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(de){return de.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new U(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ze(this.set[fe],ae))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ae,fe,de){var Ce=null,Ie=null;try{var Me=new Ee(fe,de)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==-1||(Ie=new U(Ce=De,de)))}),Ce},e.minSatisfying=function(ae,fe,de){var Ce=null,Ie=null;try{var Me=new Ee(fe,de)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==1||(Ie=new U(Ce=De,de)))}),Ce},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,de){return We(ae,fe,"<",de)},e.gtr=function(ae,fe,de){return We(ae,fe,">",de)},e.outside=We,e.prerelease=function(ae,fe){var de=V(ae,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ae,fe,de){return ae=new Ee(ae,de),fe=new Ee(fe,de),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof U)return ae;if(typeof ae!="string")return null;var fe=ae.match(P[F]);return fe==null?null:V((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,R(1))},function(Q,e){var R,r,D=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(C){if(R===setTimeout)return setTimeout(C,0);if((R===L||!R)&&setTimeout)return R=setTimeout,setTimeout(C,0);try{return R(C,0)}catch{try{return R.call(null,C,0)}catch{return R.call(this,C,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:L}catch{R=L}try{r=typeof clearTimeout=="function"?clearTimeout:A}catch{r=A}})();var E,b=[],I=!1,w=-1;function p(){I&&E&&(I=!1,E.length?b=E.concat(b):w=-1,b.length&&v())}function v(){if(!I){var C=P(p);I=!0;for(var m=b.length;m;){for(E=b,b=[];++w<m;)E&&E[w].run();w=-1,m=b.length}E=null,I=!1,function(g){if(r===clearTimeout)return clearTimeout(g);if((r===A||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(g);try{r(g)}catch{try{return r.call(null,g)}catch{return r.call(this,g)}}}(C)}}function h(C,m){this.fun=C,this.array=m}function S(){}D.nextTick=function(C){var m=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)m[g-1]=arguments[g];b.push(new h(C,m)),b.length!==1||I||P(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=S,D.addListener=S,D.once=S,D.off=S,D.removeListener=S,D.removeAllListeners=S,D.emit=S,D.prependListener=S,D.prependOnceListener=S,D.listeners=function(C){return[]},D.binding=function(C){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(C){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[117],re([0,1]),function(Q,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class r{constructor(P,E,b){this.level=P,this.key=E,this.value=b,this.forward=[]}}const D=void 0;class L{constructor(P,E=2**16){this.comparator=P,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new r(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new r(this._maxLevel,D,D)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,E){return L._insert(this,P,E,this.comparator)&&(this._size+=1),this}delete(P){const E=L._delete(this,P,this.comparator);return E&&(this._size-=1),E}forEach(P,E){let b=this._header.forward[0];for(;b;)P.call(E,b.value,b.key,this),b=b.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",E=this._header.forward[0];for(;E;)P+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return P}static _search(P,E,b){let I=P._header;for(let w=P._level-1;w>=0;w--)for(;I.forward[w]&&b(I.forward[w].key,E)<0;)I=I.forward[w];if(I=I.forward[0],I&&b(I.key,E)===0)return I}static _insert(P,E,b,I){const w=[];let p=P._header;for(let v=P._level-1;v>=0;v--){for(;p.forward[v]&&I(p.forward[v].key,E)<0;)p=p.forward[v];w[v]=p}if(p=p.forward[0],p&&I(p.key,E)===0)return p.value=b,!1;{const v=L._randomLevel(P);if(v>P._level){for(let h=P._level;h<v;h++)w[h]=P._header;P._level=v}p=new r(v,E,b);for(let h=0;h<v;h++)p.forward[h]=w[h].forward[h],w[h].forward[h]=p;return!0}}static _randomLevel(P,E=.5){let b=1;for(;Math.random()<E&&b<P._maxLevel;)b+=1;return b}static _delete(P,E,b){const I=[];let w=P._header;for(let p=P._level-1;p>=0;p--){for(;w.forward[p]&&b(w.forward[p].key,E)<0;)w=w.forward[p];I[p]=w}if(w=w.forward[0],!w||b(w.key,E)!==0)return!1;for(let p=0;p<P._level&&I[p].forward[p]===w;p++)I[p].forward[p]=w.forward[p];for(;P._level>0&&P._header.forward[P._level-1]===D;)P._level-=1;return!0}}e.SkipList=L}),define(ne[42],re([0,1,9,2]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(f){const l=f;return l?typeof l.read=="function":!1}e.isReadable=D;function L(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function A(f){const l=f;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(f,l){return new E(f,l)}e.newWriteableStream=P;class E{constructor(l,i){this.reducer=l,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(i=>i(l))}emitError(l){this.listeners.error.length===0?(0,R.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(i=>i(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,i){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(l,i){if(this.state.destroyed)return;let s;switch(l){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(f,l){const i=[];let s;for(;(s=f.read())!==null;)i.push(s);return l(i)}e.consumeReadable=b;function I(f,l,i){const s=[];let t;for(;(t=f.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return f.read()}}}e.peekReadable=I;function w(f,l){return new Promise((i,s)=>{const t=[];p(f,{onData:n=>{l&&t.push(n)},onError:n=>{l?s(n):i(void 0)},onEnd:()=>{i(l?l(t):void 0)}})})}e.consumeStream=w;function p(f,l){let i=!1;return f.on("error",s=>{i||l.onError(s)}),f.on("end",()=>{i||l.onEnd()}),f.on("data",s=>{i||l.onData(s)}),(0,r.toDisposable)(()=>i=!0)}e.listenStream=p;function v(f,l){return new Promise((i,s)=>{const t=new r.DisposableStore,n=[],o=d=>{if(n.push(d),n.length>l)return t.dispose(),f.pause(),i({stream:f,buffer:n,ended:!1})},u=d=>s(d),c=()=>i({stream:f,buffer:n,ended:!0});t.add((0,r.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),t.add((0,r.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),t.add((0,r.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=v;function h(f,l){const i=P(l);return i.end(f),i}e.toStream=h;function S(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function C(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.toReadable=C;function m(f,l,i){const s=P(i);return p(f,{onData:t=>s.write(l.data(t)),onError:t=>s.error(l.error?l.error(t):t),onEnd:()=>s.end()}),s}e.transform=m;function g(f,l,i){let s=!1;return{read:()=>{const t=l.read();return s?t:(s=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=g;function a(f,l,i){let s=!1;const t=P(i);return p(l,{onData:n=>s?t.write(n):(s=!0,t.write(i([f,n]))),onError:n=>t.error(n),onEnd:()=>{s||(s=!0,t.write(f)),t.end()}}),t}e.prefixedStream=a}),define(ne[16],re([0,1,42]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u";let D,L;class A{static alloc(d){return r?new A(Buffer.allocUnsafe(d)):new A(new Uint8Array(d))}static wrap(d){return r&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new A(d)}static fromString(d,y){return!(y?.dontUseNodeBuffer||!1)&&r?new A(Buffer.from(d)):(D||(D=new TextEncoder),new A(D.encode(d)))}static fromByteArray(d){const y=A.alloc(d.length);for(let _=0,F=d.length;_<F;_++)y.buffer[_]=d[_];return y}static concat(d,y){if(typeof y>"u"){y=0;for(let T=0,O=d.length;T<O;T++)y+=d[T].byteLength}const _=A.alloc(y);let F=0;for(let T=0,O=d.length;T<O;T++){const k=d[T];_.set(k,F),F+=k.byteLength}return _}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=A.alloc(this.byteLength);return d.set(this),d}toString(){return r?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(d,y){return new A(this.buffer.subarray(d,y))}set(d,y){if(d instanceof A)this.buffer.set(d.buffer,y);else if(d instanceof Uint8Array)this.buffer.set(d,y);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),y);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return b(this.buffer,d)}writeUInt32BE(d,y){I(this.buffer,d,y)}readUInt32LE(d){return w(this.buffer,d)}writeUInt32LE(d,y){p(this.buffer,d,y)}readUInt8(d){return v(this.buffer,d)}writeUInt8(d,y){h(this.buffer,d,y)}}e.VSBuffer=A;function P(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0}e.readUInt16LE=P;function E(c,d,y){c[y+0]=d&255,d=d>>>8,c[y+1]=d&255}e.writeUInt16LE=E;function b(c,d){return c[d]*2**24+c[d+1]*2**16+c[d+2]*2**8+c[d+3]}e.readUInt32BE=b;function I(c,d,y){c[y+3]=d,d=d>>>8,c[y+2]=d,d=d>>>8,c[y+1]=d,d=d>>>8,c[y]=d}e.writeUInt32BE=I;function w(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0|c[d+2]<<16>>>0|c[d+3]<<24>>>0}e.readUInt32LE=w;function p(c,d,y){c[y+0]=d&255,d=d>>>8,c[y+1]=d&255,d=d>>>8,c[y+2]=d&255,d=d>>>8,c[y+3]=d&255}e.writeUInt32LE=p;function v(c,d){return c[d]}e.readUInt8=v;function h(c,d,y){c[y]=d}e.writeUInt8=h;function S(c){return R.consumeReadable(c,d=>A.concat(d))}e.readableToBuffer=S;function C(c){return R.toReadable(c)}e.bufferToReadable=C;function m(c){return R.consumeStream(c,d=>A.concat(d))}e.streamToBuffer=m;async function g(c){return c.ended?A.concat(c.buffer):A.concat([...c.buffer,await m(c.stream)])}e.bufferedStreamToBuffer=g;function a(c){return R.toStream(c,d=>A.concat(d))}e.bufferToStream=a;function f(c){return R.transform(c,{data:d=>typeof d=="string"?A.fromString(d):A.wrap(d)},d=>A.concat(d))}e.streamToBufferReadableStream=f;function l(c){return R.newWriteableStream(d=>A.concat(d),c)}e.newWriteableBufferStream=l;function i(c,d){return R.prefixedReadable(c,d,y=>A.concat(y))}e.prefixedBufferReadable=i;function s(c,d){return R.prefixedStream(c,d,y=>A.concat(y))}e.prefixedBufferStream=s;function t(c){let d=0,y=0,_=0;const F=new Uint8Array(Math.floor(c.length/4*3)),T=k=>{switch(y){case 3:F[_++]=d|k,y=0;break;case 2:F[_++]=d|k>>>2,d=k<<6,y=3;break;case 1:F[_++]=d|k>>>4,d=k<<4,y=2;break;default:d=k<<2,y=1}};for(let k=0;k<c.length;k++){const M=c.charCodeAt(k);if(M>=65&&M<=90)T(M-65);else if(M>=97&&M<=122)T(M-97+26);else if(M>=48&&M<=57)T(M-48+52);else if(M===43||M===45)T(62);else if(M===47||M===95)T(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${c[k]}`)}}const O=_;for(;y>0;)T(0);return A.wrap(F).slice(0,O)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:c},d=!0,y=!1){const _=y?o:n;let F="";const T=c.byteLength%3;let O=0;for(;O<c.byteLength-T;O+=3){const k=c[O+0],M=c[O+1],$=c[O+2];F+=_[k>>>2],F+=_[(k<<4|M>>>4)&63],F+=_[(M<<2|$>>>6)&63],F+=_[$&63]}if(T===1){const k=c[O+0];F+=_[k>>>2],F+=_[k<<4&63],d&&(F+="==")}else if(T===2){const k=c[O+0],M=c[O+1];F+=_[k>>>2],F+=_[(k<<4|M>>>4)&63],F+=_[M<<2&63],d&&(F+="=")}return F}e.encodeBase64=u}),define(ne[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(s){return typeof s=="string"}e.isString=R;function r(s){return Array.isArray(s)&&s.every(t=>R(t))}e.isStringArray=r;function D(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=D;function L(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=L;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function E(s){return s===!0||s===!1}e.isBoolean=E;function b(s){return typeof s>"u"}e.isUndefined=b;function I(s){return!w(s)}e.isDefined=I;function w(s){return b(s)||s===null}e.isUndefinedOrNull=w;function p(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function v(s){if(w(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=v;function h(...s){const t=[];for(let n=0;n<s.length;n++){const o=s[n];if(w(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function C(s){if(!D(s))return!1;for(const t in s)if(S.call(s,t))return!1;return!0}e.isEmptyObject=C;function m(s){return typeof s=="function"}e.isFunction=m;function g(...s){return s.length>0&&s.every(m)}e.areFunctions=g;function a(s,t){const n=Math.min(s.length,t.length);for(let o=0;o<n;o++)f(s[o],t[o])}e.validateConstraints=a;function f(s,t){if(R(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(s instanceof t)return}catch{}if(!w(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function l(s){return s===null?void 0:s}e.withNullAsUndefined=l;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ne[32],re([0,1,15]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const g=Array.isArray(m)?[]:{};return Object.keys(m).forEach(a=>{m[a]&&typeof m[a]=="object"?g[a]=r(m[a]):g[a]=m[a]}),g}e.deepClone=r;function D(m){if(!m||typeof m!="object")return m;const g=[m];for(;g.length>0;){const a=g.shift();Object.freeze(a);for(const f in a)if(L.call(a,f)){const l=a[f];typeof l=="object"&&!Object.isFrozen(l)&&!(0,R.isTypedArray)(l)&&g.push(l)}}return m}e.deepFreeze=D;const L=Object.prototype.hasOwnProperty;function A(m,g){return P(m,g,new Set)}e.cloneAndChange=A;function P(m,g,a){if((0,R.isUndefinedOrNull)(m))return m;const f=g(m);if(typeof f<"u")return f;if(Array.isArray(m)){const l=[];for(const i of m)l.push(P(i,g,a));return l}if((0,R.isObject)(m)){if(a.has(m))throw new Error("Cannot clone recursive data-structure");a.add(m);const l={};for(const i in m)L.call(m,i)&&(l[i]=P(m[i],g,a));return a.delete(m),l}return m}function E(m,g,a=!0){return(0,R.isObject)(m)?((0,R.isObject)(g)&&Object.keys(g).forEach(f=>{f in m?a&&((0,R.isObject)(m[f])&&(0,R.isObject)(g[f])?E(m[f],g[f],a):m[f]=g[f]):m[f]=g[f]}),m):g}e.mixin=E;function b(m,g){if(m===g)return!0;if(m==null||g===null||g===void 0||typeof m!=typeof g||typeof m!="object"||Array.isArray(m)!==Array.isArray(g))return!1;let a,f;if(Array.isArray(m)){if(m.length!==g.length)return!1;for(a=0;a<m.length;a++)if(!b(m[a],g[a]))return!1}else{const l=[];for(f in m)l.push(f);l.sort();const i=[];for(f in g)i.push(f);if(i.sort(),!b(l,i))return!1;for(a=0;a<l.length;a++)if(!b(m[l[a]],g[l[a]]))return!1}return!0}e.equals=b;function I(m){const g=new Set;return JSON.stringify(m,(a,f)=>{if((0,R.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=I;function w(m,g){const a=Object.create(null);return!m||!g||Object.keys(g).forEach(l=>{const i=m[l],s=g[l];b(i,s)||(a[l]=s)}),a}e.distinct=w;function p(m,g){const a=g.toLowerCase(),f=Object.keys(m).find(l=>l.toLowerCase()===a);return f?m[f]:m[g]}e.getCaseInsensitive=p;function v(m,g){const a=Object.create(null);for(const[f,l]of Object.entries(m))g(f,l)&&(a[f]=l);return a}e.filter=v;function h(m){let g=[],a=Object.getPrototypeOf(m);for(;Object.prototype!==a;)g=g.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return g}e.getAllPropertyNames=h;function S(m){const g=[];for(const a of h(m))typeof m[a]=="function"&&g.push(a);return g}e.getAllMethodNames=S;function C(m,g){const a=l=>function(){const i=Array.prototype.slice.call(arguments,0);return g(l,i)},f={};for(const l of m)f[l]=a(l);return f}e.createProxyObject=C}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(D){return R.test(D)}e.isUUID=r,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let E=0;E<P.length;E++)P[E]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){D(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,b="";return b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b}}()}),define(ne[118],re([0,1,37]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(A){const P=A.replace(/\-/g,":").toLowerCase();return!r.has(P)}function L(){const A=(0,R.networkInterfaces)();for(const P in A){const E=A[P];if(E){for(const{mac:b}of E)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[119],re([0,1,80]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(P,E,b,I=1){let w=!1;return new Promise(p=>{const v=setTimeout(()=>{if(!w)return w=!0,p(0)},b);D(P,E,I,h=>{if(!w)return w=!0,clearTimeout(v),p(h)})})}e.findFreePort=r;function D(P,E,b,I){if(E===0)return I(0);const w=new R.Socket;w.once("connect",()=>(A(w),D(P+b,E-1,b,I))),w.once("data",()=>{}),w.once("error",p=>(A(w),p.code!=="ECONNREFUSED"?D(P+b,E-1,b,I):I(P))),w.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,E,b){let I=!1,w,p=1;const v=R.createServer({pauseOnConnect:!0});function h(S,C){I||(I=!0,v.removeAllListeners(),v.close(),w&&clearTimeout(w),C(S))}return new Promise(S=>{w=setTimeout(()=>{h(0,S)},b),v.on("listening",()=>{h(P,S)}),v.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&p<E?(P++,p++,v.listen(P,"127.0.0.1")):h(0,S)}),v.on("close",()=>{h(0,S)}),v.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(E){console.error(E)}}}),define(ne[120],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function r(L){return L instanceof D?!0:L instanceof Error&&L.name===R&&L.message===R}e.isOfflineError=r;class D extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=D}),define(ne[121],re([0,1,16,9,120]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(E,b){if(!navigator.onLine)throw new D.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((w,p)=>{I.open(E.type||"GET",E.url||"",!0,E.user,E.password),A(I,E),I.responseType="arraybuffer",I.onerror=v=>p(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=v=>{w({res:{statusCode:I.status,headers:P(I)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=v=>p(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(I.timeout=E.timeout),I.send(E.data),b.onCancellationRequested(()=>{I.abort(),p((0,r.canceled)())})})}e.request=L;function A(E,b){if(b.headers){e:for(const I in b.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(I,b.headers[I])}}}function P(E){const b=Object.create(null);for(const I of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const w=I.indexOf(":");b[I.substr(0,w).trim().toLowerCase()]=I.substr(w+1).trim()}return b}}),define(ne[122],re([10,11]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[63],re([0,1,122]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,D=r*60,L=D*24,A=L*7,P=L*30,E=L*365;function b(w,p,v){typeof w!="number"&&(w=w.getTime());const h=Math.round((new Date().getTime()-w)/1e3);if(h<-30)return(0,R.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,R.localize)(1,null);let S;return h<r?(S=h,p?S===1?v?(0,R.localize)(2,null,S):(0,R.localize)(3,null,S):v?(0,R.localize)(4,null,S):(0,R.localize)(5,null,S):S===1?v?(0,R.localize)(6,null,S):(0,R.localize)(7,null,S):v?(0,R.localize)(8,null,S):(0,R.localize)(9,null,S)):h<D?(S=Math.floor(h/r),p?S===1?v?(0,R.localize)(10,null,S):(0,R.localize)(11,null,S):v?(0,R.localize)(12,null,S):(0,R.localize)(13,null,S):S===1?v?(0,R.localize)(14,null,S):(0,R.localize)(15,null,S):v?(0,R.localize)(16,null,S):(0,R.localize)(17,null,S)):h<L?(S=Math.floor(h/D),p?S===1?v?(0,R.localize)(18,null,S):(0,R.localize)(19,null,S):v?(0,R.localize)(20,null,S):(0,R.localize)(21,null,S):S===1?v?(0,R.localize)(22,null,S):(0,R.localize)(23,null,S):v?(0,R.localize)(24,null,S):(0,R.localize)(25,null,S)):h<A?(S=Math.floor(h/L),p?S===1?(0,R.localize)(26,null,S):(0,R.localize)(27,null,S):S===1?(0,R.localize)(28,null,S):(0,R.localize)(29,null,S)):h<P?(S=Math.floor(h/A),p?S===1?v?(0,R.localize)(30,null,S):(0,R.localize)(31,null,S):v?(0,R.localize)(32,null,S):(0,R.localize)(33,null,S):S===1?v?(0,R.localize)(34,null,S):(0,R.localize)(35,null,S):v?(0,R.localize)(36,null,S):(0,R.localize)(37,null,S)):h<E?(S=Math.floor(h/P),p?S===1?v?(0,R.localize)(38,null,S):(0,R.localize)(39,null,S):v?(0,R.localize)(40,null,S):(0,R.localize)(41,null,S):S===1?v?(0,R.localize)(42,null,S):(0,R.localize)(43,null,S):v?(0,R.localize)(44,null,S):(0,R.localize)(45,null,S)):(S=Math.floor(h/E),p?S===1?v?(0,R.localize)(46,null,S):(0,R.localize)(47,null,S):v?(0,R.localize)(48,null,S):(0,R.localize)(49,null,S):S===1?v?(0,R.localize)(50,null,S):(0,R.localize)(51,null,S):v?(0,R.localize)(52,null,S):(0,R.localize)(53,null,S))}e.fromNow=b;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[123],re([10,11]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,19,15,123]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,p){return p&&(w.stack||w.stacktrace)?D.localize(0,null,P(w),A(w.stack)||A(w.stacktrace)):P(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function E(w=null,p=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const v=R.coalesce(w),h=E(v[0],p);return v.length>1?D.localize(4,null,h,v.length):h}if(r.isString(w))return w;if(w.detail){const v=w.detail;if(v.error)return L(v.error,p);if(v.exception)return L(v.exception,p)}return w.stack?L(w,p):w.message?w.message:D.localize(5,null)}e.toErrorMessage=E;function b(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=b;function I(w,p){let v;return typeof w=="string"?v=new Error(w):v=w,v.actions=p,v}e.createErrorWithActions=I}),define(ne[124],re([10,11]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[125],re([0,1,124]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function r(D){switch(D){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=r}),define(ne[126],re([10,11]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,126]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const r="en";let D=!1,L=!1,A=!1,P=!1,E=!1,b=!1,I=!1,w=!1,p=!1,v=!1,h,S=r,C,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const a=typeof g?.versions?.electron=="string",f=a&&g?.type==="renderer";if(typeof navigator=="object"&&!f)m=navigator.userAgent,D=m.indexOf("Windows")>=0,L=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,v=m?.indexOf("Mobi")>=0,b=!0,h=R.getConfiguredDefaultLocale(R.localize(0,null))||r,S=h;else if(typeof g=="object"){D=g.platform==="win32",L=g.platform==="darwin",A=g.platform==="linux",P=A&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,I=a,p=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=r,S=r;const d=g.env.VSCODE_NLS_CONFIG;if(d)try{const y=JSON.parse(d),_=y.availableLanguages["*"];h=y.locale,S=_||r,C=y._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var l;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function i(d){switch(d){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let s=0;L?s=1:D?s=3:A&&(s=2),e.isWindows=D,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=P,e.isNative=E,e.isElectron=I,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isMobile=v,e.isCI=p,e.platform=s,e.userAgent=m,e.language=S;var t;(function(d){function y(){return e.language}d.value=y;function _(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}d.isDefaultVariant=_;function F(){return e.language==="en"}d.isDefault=F})(t=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=C,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const d=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let F=0,T=d.length;F<T;F++){const O=d[F];if(O.id===_.data.vscodeScheduleAsyncWork){d.splice(F,1),O.callback();return}}});let y=0;return _=>{const F=++y;d.push({id:F,callback:_}),e.globals.postMessage({vscodeScheduleAsyncWork:F},"*")}}return d=>setTimeout(d)})();var n;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||w?2:D?1:3;let o=!0,u=!1;function c(){if(!u){u=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,o=new Uint16Array(d.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const D=R.globals.vscode.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(ne[12],re([0,1,36]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,D=97,L=90,A=122,P=46,E=47,b=92,I=58,w=63;class p extends Error{constructor(f,l,i){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const t=f.indexOf(".")!==-1?"property":"argument";let n=`The "${f}" ${t} ${s} of type ${l}`;n+=`. Received type ${typeof i}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function v(a,f){if(typeof a!="string")throw new p(f,"string",a)}function h(a){return a===E||a===b}function S(a){return a===E}function C(a){return a>=r&&a<=L||a>=D&&a<=A}function m(a,f,l,i){let s="",t=0,n=-1,o=0,u=0;for(let c=0;c<=a.length;++c){if(c<a.length)u=a.charCodeAt(c);else{if(i(u))break;u=E}if(i(u)){if(!(n===c-1||o===1))if(o===2){if(s.length<2||t!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(l);d===-1?(s="",t=0):(s=s.slice(0,d),t=s.length-1-s.lastIndexOf(l)),n=c,o=0;continue}else if(s.length!==0){s="",t=0,n=c,o=0;continue}}f&&(s+=s.length>0?`${l}..`:"..",t=2)}else s.length>0?s+=`${l}${a.slice(n+1,c)}`:s=a.slice(n+1,c),t=c-n-1;n=c,o=0}else u===P&&o!==-1?++o:o=-1}return s}function g(a,f){if(f===null||typeof f!="object")throw new p("pathObject","Object",f);const l=f.dir||f.root,i=f.base||`${f.name||""}${f.ext||""}`;return l?l===f.root?`${l}${i}`:`${l}${a}${i}`:i}e.win32={resolve(...a){let f="",l="",i=!1;for(let s=a.length-1;s>=-1;s--){let t;if(s>=0){if(t=a[s],v(t,"path"),t.length===0)continue}else f.length===0?t=R.cwd():(t=R.env[`=${f}`]||R.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==f.toLowerCase()&&t.charCodeAt(2)===b)&&(t=`${f}\\`));const n=t.length;let o=0,u="",c=!1;const d=t.charCodeAt(0);if(n===1)h(d)&&(o=1,c=!0);else if(h(d))if(c=!0,h(t.charCodeAt(1))){let y=2,_=y;for(;y<n&&!h(t.charCodeAt(y));)y++;if(y<n&&y!==_){const F=t.slice(_,y);for(_=y;y<n&&h(t.charCodeAt(y));)y++;if(y<n&&y!==_){for(_=y;y<n&&!h(t.charCodeAt(y));)y++;(y===n||y!==_)&&(u=`\\\\${F}\\${t.slice(_,y)}`,o=y)}}}else o=1;else C(d)&&t.charCodeAt(1)===I&&(u=t.slice(0,2),o=2,n>2&&h(t.charCodeAt(2))&&(c=!0,o=3));if(u.length>0)if(f.length>0){if(u.toLowerCase()!==f.toLowerCase())continue}else f=u;if(i){if(f.length>0)break}else if(l=`${t.slice(o)}\\${l}`,i=c,c&&f.length>0)break}return l=m(l,!i,"\\",h),i?`${f}\\${l}`:`${f}${l}`||"."},normalize(a){v(a,"path");const f=a.length;if(f===0)return".";let l=0,i,s=!1;const t=a.charCodeAt(0);if(f===1)return S(t)?"\\":a;if(h(t))if(s=!0,h(a.charCodeAt(1))){let o=2,u=o;for(;o<f&&!h(a.charCodeAt(o));)o++;if(o<f&&o!==u){const c=a.slice(u,o);for(u=o;o<f&&h(a.charCodeAt(o));)o++;if(o<f&&o!==u){for(u=o;o<f&&!h(a.charCodeAt(o));)o++;if(o===f)return`\\\\${c}\\${a.slice(u)}\\`;o!==u&&(i=`\\\\${c}\\${a.slice(u,o)}`,l=o)}}}else l=1;else C(t)&&a.charCodeAt(1)===I&&(i=a.slice(0,2),l=2,f>2&&h(a.charCodeAt(2))&&(s=!0,l=3));let n=l<f?m(a.slice(l),!s,"\\",h):"";return n.length===0&&!s&&(n="."),n.length>0&&h(a.charCodeAt(f-1))&&(n+="\\"),i===void 0?s?`\\${n}`:n:s?`${i}\\${n}`:`${i}${n}`},isAbsolute(a){v(a,"path");const f=a.length;if(f===0)return!1;const l=a.charCodeAt(0);return h(l)||f>2&&C(l)&&a.charCodeAt(1)===I&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let f,l;for(let t=0;t<a.length;++t){const n=a[t];v(n,"path"),n.length>0&&(f===void 0?f=l=n:f+=`\\${n}`)}if(f===void 0)return".";let i=!0,s=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++s;const t=l.length;t>1&&h(l.charCodeAt(1))&&(++s,t>2&&(h(l.charCodeAt(2))?++s:i=!1))}if(i){for(;s<f.length&&h(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(a,f){if(v(a,"from"),v(f,"to"),a===f)return"";const l=e.win32.resolve(a),i=e.win32.resolve(f);if(l===i||(a=l.toLowerCase(),f=i.toLowerCase(),a===f))return"";let s=0;for(;s<a.length&&a.charCodeAt(s)===b;)s++;let t=a.length;for(;t-1>s&&a.charCodeAt(t-1)===b;)t--;const n=t-s;let o=0;for(;o<f.length&&f.charCodeAt(o)===b;)o++;let u=f.length;for(;u-1>o&&f.charCodeAt(u-1)===b;)u--;const c=u-o,d=n<c?n:c;let y=-1,_=0;for(;_<d;_++){const T=a.charCodeAt(s+_);if(T!==f.charCodeAt(o+_))break;T===b&&(y=_)}if(_!==d){if(y===-1)return i}else{if(c>d){if(f.charCodeAt(o+_)===b)return i.slice(o+_+1);if(_===2)return i.slice(o+_)}n>d&&(a.charCodeAt(s+_)===b?y=_:_===2&&(y=3)),y===-1&&(y=0)}let F="";for(_=s+y+1;_<=t;++_)(_===t||a.charCodeAt(_)===b)&&(F+=F.length===0?"..":"\\..");return o+=y,F.length>0?`${F}${i.slice(o,u)}`:(i.charCodeAt(o)===b&&++o,i.slice(o,u))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const f=e.win32.resolve(a);if(f.length<=2)return a;if(f.charCodeAt(0)===b){if(f.charCodeAt(1)===b){const l=f.charCodeAt(2);if(l!==w&&l!==P)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(C(f.charCodeAt(0))&&f.charCodeAt(1)===I&&f.charCodeAt(2)===b)return`\\\\?\\${f}`;return a},dirname(a){v(a,"path");const f=a.length;if(f===0)return".";let l=-1,i=0;const s=a.charCodeAt(0);if(f===1)return h(s)?a:".";if(h(s)){if(l=i=1,h(a.charCodeAt(1))){let o=2,u=o;for(;o<f&&!h(a.charCodeAt(o));)o++;if(o<f&&o!==u){for(u=o;o<f&&h(a.charCodeAt(o));)o++;if(o<f&&o!==u){for(u=o;o<f&&!h(a.charCodeAt(o));)o++;if(o===f)return a;o!==u&&(l=i=o+1)}}}}else C(s)&&a.charCodeAt(1)===I&&(l=f>2&&h(a.charCodeAt(2))?3:2,i=l);let t=-1,n=!0;for(let o=f-1;o>=i;--o)if(h(a.charCodeAt(o))){if(!n){t=o;break}}else n=!1;if(t===-1){if(l===-1)return".";t=l}return a.slice(0,t)},basename(a,f){f!==void 0&&v(f,"ext"),v(a,"path");let l=0,i=-1,s=!0,t;if(a.length>=2&&C(a.charCodeAt(0))&&a.charCodeAt(1)===I&&(l=2),f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let n=f.length-1,o=-1;for(t=a.length-1;t>=l;--t){const u=a.charCodeAt(t);if(h(u)){if(!s){l=t+1;break}}else o===-1&&(s=!1,o=t+1),n>=0&&(u===f.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=o))}return l===i?i=o:i===-1&&(i=a.length),a.slice(l,i)}for(t=a.length-1;t>=l;--t)if(h(a.charCodeAt(t))){if(!s){l=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(l,i)},extname(a){v(a,"path");let f=0,l=-1,i=0,s=-1,t=!0,n=0;a.length>=2&&a.charCodeAt(1)===I&&C(a.charCodeAt(0))&&(f=i=2);for(let o=a.length-1;o>=f;--o){const u=a.charCodeAt(o);if(h(u)){if(!t){i=o+1;break}continue}s===-1&&(t=!1,s=o+1),u===P?l===-1?l=o:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||s===-1||n===0||n===1&&l===s-1&&l===i+1?"":a.slice(l,s)},format:g.bind(null,"\\"),parse(a){v(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const l=a.length;let i=0,s=a.charCodeAt(0);if(l===1)return h(s)?(f.root=f.dir=a,f):(f.base=f.name=a,f);if(h(s)){if(i=1,h(a.charCodeAt(1))){let y=2,_=y;for(;y<l&&!h(a.charCodeAt(y));)y++;if(y<l&&y!==_){for(_=y;y<l&&h(a.charCodeAt(y));)y++;if(y<l&&y!==_){for(_=y;y<l&&!h(a.charCodeAt(y));)y++;y===l?i=y:y!==_&&(i=y+1)}}}}else if(C(s)&&a.charCodeAt(1)===I){if(l<=2)return f.root=f.dir=a,f;if(i=2,h(a.charCodeAt(2))){if(l===3)return f.root=f.dir=a,f;i=3}}i>0&&(f.root=a.slice(0,i));let t=-1,n=i,o=-1,u=!0,c=a.length-1,d=0;for(;c>=i;--c){if(s=a.charCodeAt(c),h(s)){if(!u){n=c+1;break}continue}o===-1&&(u=!1,o=c+1),s===P?t===-1?t=c:d!==1&&(d=1):t!==-1&&(d=-1)}return o!==-1&&(t===-1||d===0||d===1&&t===o-1&&t===n+1?f.base=f.name=a.slice(n,o):(f.name=a.slice(n,t),f.base=a.slice(n,o),f.ext=a.slice(t,o))),n>0&&n!==i?f.dir=a.slice(0,n-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let f="",l=!1;for(let i=a.length-1;i>=-1&&!l;i--){const s=i>=0?a[i]:R.cwd();v(s,"path"),s.length!==0&&(f=`${s}/${f}`,l=s.charCodeAt(0)===E)}return f=m(f,!l,"/",S),l?`/${f}`:f.length>0?f:"."},normalize(a){if(v(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E,l=a.charCodeAt(a.length-1)===E;return a=m(a,!f,"/",S),a.length===0?f?"/":l?"./":".":(l&&(a+="/"),f?`/${a}`:a)},isAbsolute(a){return v(a,"path"),a.length>0&&a.charCodeAt(0)===E},join(...a){if(a.length===0)return".";let f;for(let l=0;l<a.length;++l){const i=a[l];v(i,"path"),i.length>0&&(f===void 0?f=i:f+=`/${i}`)}return f===void 0?".":e.posix.normalize(f)},relative(a,f){if(v(a,"from"),v(f,"to"),a===f||(a=e.posix.resolve(a),f=e.posix.resolve(f),a===f))return"";const l=1,i=a.length,s=i-l,t=1,n=f.length-t,o=s<n?s:n;let u=-1,c=0;for(;c<o;c++){const y=a.charCodeAt(l+c);if(y!==f.charCodeAt(t+c))break;y===E&&(u=c)}if(c===o)if(n>o){if(f.charCodeAt(t+c)===E)return f.slice(t+c+1);if(c===0)return f.slice(t+c)}else s>o&&(a.charCodeAt(l+c)===E?u=c:c===0&&(u=0));let d="";for(c=l+u+1;c<=i;++c)(c===i||a.charCodeAt(c)===E)&&(d+=d.length===0?"..":"/..");return`${d}${f.slice(t+u)}`},toNamespacedPath(a){return a},dirname(a){if(v(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E;let l=-1,i=!0;for(let s=a.length-1;s>=1;--s)if(a.charCodeAt(s)===E){if(!i){l=s;break}}else i=!1;return l===-1?f?"/":".":f&&l===1?"//":a.slice(0,l)},basename(a,f){f!==void 0&&v(f,"ext"),v(a,"path");let l=0,i=-1,s=!0,t;if(f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let n=f.length-1,o=-1;for(t=a.length-1;t>=0;--t){const u=a.charCodeAt(t);if(u===E){if(!s){l=t+1;break}}else o===-1&&(s=!1,o=t+1),n>=0&&(u===f.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=o))}return l===i?i=o:i===-1&&(i=a.length),a.slice(l,i)}for(t=a.length-1;t>=0;--t)if(a.charCodeAt(t)===E){if(!s){l=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(l,i)},extname(a){v(a,"path");let f=-1,l=0,i=-1,s=!0,t=0;for(let n=a.length-1;n>=0;--n){const o=a.charCodeAt(n);if(o===E){if(!s){l=n+1;break}continue}i===-1&&(s=!1,i=n+1),o===P?f===-1?f=n:t!==1&&(t=1):f!==-1&&(t=-1)}return f===-1||i===-1||t===0||t===1&&f===i-1&&f===l+1?"":a.slice(f,i)},format:g.bind(null,"/"),parse(a){v(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const l=a.charCodeAt(0)===E;let i;l?(f.root="/",i=1):i=0;let s=-1,t=0,n=-1,o=!0,u=a.length-1,c=0;for(;u>=i;--u){const d=a.charCodeAt(u);if(d===E){if(!o){t=u+1;break}continue}n===-1&&(o=!1,n=u+1),d===P?s===-1?s=u:c!==1&&(c=1):s!==-1&&(c=-1)}if(n!==-1){const d=t===0&&l?1:t;s===-1||c===0||c===1&&s===n-1&&s===t+1?f.base=f.name=a.slice(d,n):(f.name=a.slice(d,s),f.base=a.slice(d,n),f.ext=a.slice(s,n))}return t>0?f.dir=a.slice(0,t-1):l&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[127],re([0,1,12]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const w=(0,R.extname)(I),p=r[w.toLowerCase()];return p!==void 0?p:A(I)}e.getMediaOrTextMime=L;function A(I){const w=(0,R.extname)(I);return D[w.toLowerCase()]}e.getMediaMime=A;function P(I){for(const w in D)if(D[w]===I)return w}e.getExtensionForMimeType=P;const E=/^(.+)\/(.+?)(;.+)?$/;function b(I,w){const p=E.exec(I);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:w?void 0:I}e.normalizeMimeType=b}),define(ne[81],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var r;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(r=e.Source||(e.Source={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...E){const b=E.reduce((p,v)=>(p[v]=!0,p),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!b[p]).forEach(p=>{for(let v=0;v<I.length;v++)if(p.search(I[v])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=L;function A(P){!P||(delete P.DEBUG,R.isMacintosh&&delete P.DYLD_LIBRARY_PATH,R.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ne[128],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=R.globals.performance&&typeof R.globals.performance.now=="function";class D{static create(A=!0){return new D(A)}constructor(A){this._highResolution=r&&A,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ne[3],re([0,1,9,78,2,116,128]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,E=!1;var b;(function(u){u.None=()=>D.Disposable.None;function c(N){if(E){const{onListenerDidAdd:j}=N,B=h.create();let Z=0;N.onListenerDidAdd=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),j?.()}}}function d(N){return(j,B=null,Z)=>{let oe=!1,X;return X=N(ie=>{if(!oe)return X?X.dispose():oe=!0,j.call(B,ie)},null,Z),oe&&X.dispose(),X}}u.once=d;function y(N,j,B){return M((Z,oe=null,X)=>N(ie=>Z.call(oe,j(ie)),null,X),B)}u.map=y;function _(N,j,B){return M((Z,oe=null,X)=>N(ie=>{j(ie),Z.call(oe,ie)},null,X),B)}u.forEach=_;function F(N,j,B){return M((Z,oe=null,X)=>N(ie=>j(ie)&&Z.call(oe,ie),null,X),B)}u.filter=F;function T(N){return N}u.signal=T;function O(...N){return(j,B=null,Z)=>(0,D.combinedDisposable)(...N.map(oe=>oe(X=>j.call(B,X),null,Z)))}u.any=O;function k(N,j,B,Z){let oe=B;return y(N,X=>(oe=j(oe,X),oe),Z)}u.reduce=k;function M(N,j){let B;const Z={onFirstListenerAdd(){B=N(oe.fire,oe)},onLastListenerRemove(){B?.dispose()}};j||c(Z);const oe=new C(Z);return j?.add(oe),oe.event}function $(N,j,B=100,Z=!1,oe,X){let ie,se,ue,he=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=N(Ee=>{he++,se=j(se,Ee),Z&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=se;se=void 0,ue=void 0,(!Z||he>1)&&we.fire(Pe),he=0},B)})},onLastListenerRemove(){ie.dispose()}};X||c(ve);const we=new C(ve);return X?.add(we),we.event}u.debounce=$;function q(N,j=(Z,oe)=>Z===oe,B){let Z=!0,oe;return F(N,X=>{const ie=Z||!j(X,oe);return Z=!1,oe=X,ie},B)}u.latch=q;function J(N,j,B){return[u.filter(N,j,B),u.filter(N,Z=>!j(Z),B)]}u.split=J;function H(N,j=!1,B=[]){let Z=B.slice(),oe=N(se=>{Z?Z.push(se):ie.fire(se)});const X=()=>{Z?.forEach(se=>ie.fire(se)),Z=null},ie=new C({onFirstListenerAdd(){oe||(oe=N(se=>ie.fire(se)))},onFirstListenerDidAdd(){Z&&(j?setTimeout(X):X())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}u.buffer=H;class G{constructor(j){this.event=j,this.disposables=new D.DisposableStore}map(j){return new G(y(this.event,j,this.disposables))}forEach(j){return new G(_(this.event,j,this.disposables))}filter(j){return new G(F(this.event,j,this.disposables))}reduce(j,B){return new G(k(this.event,j,B,this.disposables))}latch(){return new G(q(this.event,void 0,this.disposables))}debounce(j,B=100,Z=!1,oe){return new G($(this.event,j,B,Z,oe,this.disposables))}on(j,B,Z){return this.event(j,B,Z)}once(j,B,Z){return d(this.event)(j,B,Z)}dispose(){this.disposables.dispose()}}function z(N){return new G(N)}u.chain=z;function x(N,j,B=Z=>Z){const Z=(...se)=>ie.fire(B(...se)),oe=()=>N.on(j,Z),X=()=>N.removeListener(j,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}u.fromNodeEventEmitter=x;function Y(N,j,B=Z=>Z){const Z=(...se)=>ie.fire(B(...se)),oe=()=>N.addEventListener(j,Z),X=()=>N.removeEventListener(j,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}u.fromDOMEventEmitter=Y;function te(N){return new Promise(j=>d(N)(j))}u.toPromise=te;function ce(N,j){return j(void 0),N(B=>j(B))}u.runAndSubscribe=ce;function W(N,j){let B=null;function Z(X){B?.dispose(),B=new D.DisposableStore,j(X,B)}Z(void 0);const oe=N(X=>Z(X));return(0,D.toDisposable)(()=>{oe.dispose(),B?.dispose()})}u.runAndSubscribeWithStore=W;class V{constructor(j,B){this.obs=j,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{j.addObserver(this)},onLastListenerRemove:()=>{j.removeObserver(this)}};B||c(Z),this.emitter=new C(Z),B&&B.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,B){this._hasChanged=!0}endUpdate(j){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function U(N,j){return new V(N,j).emitter.event}u.fromObservable=U})(b=e.Event||(e.Event={}));class I{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${I._idPool++}`,I.all.add(this)}start(c){this._stopWatch=new A.StopWatch(!0),this.listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I,I.all=new Set,I._idPool=0;let w=-1;function p(u){const c=w;return w=u,{dispose(){w=c}}}e.setGlobalLeakWarningThreshold=p;class v{constructor(c,d=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,d){let y=w;if(typeof this.customThreshold=="number"&&(y=this.customThreshold),y<=0||d<y)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=y*.5;let F,T=0;for(const[O,k]of this._stacks)(!F||T<k)&&(F=O,T=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${T}):`),console.warn(F)}return()=>{const F=this._stacks.get(c.value)||0;this._stacks.set(c.value,F-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(c,d,y){this.callback=c,this.callbackThis=d,this.stack=y,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class C{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=w>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const d of c)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,d,y)=>{this._listeners||(this._listeners=new L.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let F,T;this._leakageMon&&this._listeners.size>=30&&(T=h.create(),F=this._leakageMon.check(T,this._listeners.size+1)),P&&(T=T??h.create());const O=new S(c,d,T),k=this._listeners.push(O);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,d);const M=O.subscription.set(()=>{F?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return y instanceof D.DisposableStore?y.add(M):Array.isArray(y)&&y.push(M),M}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const d of this._listeners)this._deliveryQueue.push(this,d,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class m{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(c,d,y){this._queue.push(new a(c,d,y))}clear(c){const d=new L.LinkedList;for(const y of this._queue)y.emitter!==c&&d.push(y);this._queue=d}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(d){(0,R.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=m;class g extends m{clear(c){this._queue.clear()}}class a{constructor(c,d,y){this.emitter=c,this.listener=d,this.event=y}}class f extends C{async fireAsync(c,d,y){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,c]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[_,F]=this._asyncDeliveryQueue.shift(),T=[],O={...F,token:d,waitUntil:k=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");y&&(k=y(k,_.callback)),T.push(k)}};try{_.invoke(O)}catch(k){(0,R.onUnexpectedError)(k);continue}Object.freeze(T),await Promise.allSettled(T).then(k=>{for(const M of k)M.status==="rejected"&&(0,R.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=f;class l extends C{constructor(c){super(c),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=l;class i extends l{constructor(c){super(c),this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=i;class s extends C{constructor(c){super(c),this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){!this.hasListeners()||(this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const d={event:c,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const y=()=>{this.hasListeners&&this.unhook(d);const _=this.events.indexOf(d);this.events.splice(_,1)};return(0,D.toDisposable)((0,r.once)(y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(d=>this.emitter.fire(d))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.buffers=[]}wrapEvent(c){return(d,y,_)=>c(F=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>d.call(y,F)):d.call(y,F)},void 0,_)}bufferEvents(c){const d=[];this.buffers.push(d);const y=c();return this.buffers.pop(),d.forEach(_=>_()),y}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ne[24],re([0,1,3]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(P,E){const b=setTimeout(P.bind(E),0);return{dispose(){clearTimeout(b)}}});var D;(function(P){function E(b){return b===P.None||b===P.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=E,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(D=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=A}),define(ne[129],re([0,1,24]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class r{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new R.CancellationTokenSource,E=this.task(P.token);return this.result={promise:E,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=r;class D{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const E=JSON.stringify(P);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=D;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const E=this.fn(P);return this._map.set(P,E),E}}e.CachedFunction=L}),define(ne[82],re([0,1,3,2]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=A=>({onDidChange:R.Event.None,value:A});e.staticObservableValue=D;class L extends r.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(ne[27],re([0,1,129,115]),function(Q,e,R,r){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function P(ee,...le){return le.length===0?ee:ee.replace(A,function(me,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=le.length?me:le[Se]})}e.format=P;const E=/{([^}]+)}/g;function b(ee,le){return ee.replace(E,(me,ge)=>le[ge]??me)}e.format2=b;function I(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=I;function w(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function p(ee,le){let me=0;const ge=le.charCodeAt(0);for(let Se=ee.length-1;Se>=0;Se--)ee.charCodeAt(Se)===ge&&me++;return me}e.count=p;function v(ee,le,me="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${me}`}e.truncate=v;function h(ee,le=" "){const me=S(ee,le);return C(me,le)}e.trim=h;function S(ee,le){if(!ee||!le)return ee;const me=le.length;if(me===0||ee.length===0)return ee;let ge=0;for(;ee.indexOf(le,ge)===ge;)ge=ge+me;return ee.substring(ge)}e.ltrim=S;function C(ee,le){if(!ee||!le)return ee;const me=le.length,ge=ee.length;if(me===0||ge===0)return ee;let Se=ge,be=-1;for(;be=ee.lastIndexOf(le,Se-1),!(be===-1||be+me!==Se);){if(be===0)return"";Se=be}return ee.substring(0,Se)}e.rtrim=C;function m(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function a(ee,le,me={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=w(ee)),me.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ge="";return me.global&&(ge+="g"),me.matchCase||(ge+="i"),me.multiline&&(ge+="m"),me.unicode&&(ge+="u"),new RegExp(ee,ge)}e.createRegExp=a;function f(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function l(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=i;function s(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=s;function t(ee){for(let le=0,me=ee.length;le<me;le++){const ge=ee.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function n(ee,le=0,me=ee.length){for(let ge=le;ge<me;ge++){const Se=ee.charCodeAt(ge);if(Se!==32&&Se!==9)return ee.substring(le,ge)}return ee.substring(le,me)}e.getLeadingWhitespace=n;function o(ee,le=ee.length-1){for(let me=le;me>=0;me--){const ge=ee.charCodeAt(me);if(ge!==32&&ge!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function u(ee,le,me){const ge=[];let Se=0;for(const be of ee.matchAll(le)){if(ge.push(ee.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,ge.push(me(be[0],...be.slice(1),be.index,ee,be.groups))}return ge.push(ee.slice(Se)),Promise.all(ge).then(be=>be.join(""))}e.replaceAsync=u;function c(ee,le){return ee<le?-1:ee>le?1:0}e.compare=c;function d(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){const qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe<Le)return-1;if(qe>Le)return 1}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstring=d;function y(ee,le){return _(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=y;function _(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){let qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe===Le)continue;if(qe>=128||Le>=128)return d(ee.toLowerCase(),le.toLowerCase(),me,ge,Se,be);T(qe)&&(qe-=32),T(Le)&&(Le-=32);const Ne=qe-Le;if(Ne!==0)return Ne}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstringIgnoreCase=_;function F(ee){return ee>=48&&ee<=57}e.isAsciiDigit=F;function T(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=T;function O(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=O;function k(ee,le){return ee.length===le.length&&_(ee,le)===0}e.equalsIgnoreCase=k;function M(ee,le){const me=le.length;return le.length>ee.length?!1:_(ee,le,0,me)===0}e.startsWithIgnoreCase=M;function $(ee,le){const me=Math.min(ee.length,le.length);let ge;for(ge=0;ge<me;ge++)if(ee.charCodeAt(ge)!==le.charCodeAt(ge))return ge;return me}e.commonPrefixLength=$;function q(ee,le){const me=Math.min(ee.length,le.length);let ge;const Se=ee.length-1,be=le.length-1;for(ge=0;ge<me;ge++)if(ee.charCodeAt(Se-ge)!==le.charCodeAt(be-ge))return ge;return me}e.commonSuffixLength=q;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function H(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=H;function G(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=G;function z(ee,le,me){const ge=ee.charCodeAt(me);if(J(ge)&&me+1<le){const Se=ee.charCodeAt(me+1);if(H(Se))return G(ge,Se)}return ge}e.getNextCodePoint=z;function x(ee,le){const me=ee.charCodeAt(le-1);if(H(me)&&le>1){const ge=ee.charCodeAt(le-2);if(J(ge))return G(ge,me)}return me}class Y{get offset(){return this._offset}constructor(le,me=0){this._str=le,this._len=le.length,this._offset=me}setOffset(le){this._offset=le}prevCodePoint(){const le=x(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=z(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class te{get offset(){return this._iterator.offset}constructor(le,me=0){this._iterator=new Y(le,me)}nextGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,Re=le.getGraphemeBreakType(me.nextCodePoint());if(de(Se,Re)){me.setOffset(be);break}Se=Re}return me.offset-ge}prevGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,Re=le.getGraphemeBreakType(me.prevCodePoint());if(de(Re,Se)){me.setOffset(be);break}Se=Re}return ge-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function ce(ee,le){return new te(ee,le).nextGraphemeLength()}e.nextCharLength=ce;function W(ee,le){return new te(ee,le).prevGraphemeLength()}e.prevCharLength=W;function V(ee,le){le>0&&H(ee.charCodeAt(le))&&le--;const me=le+ce(ee,le);return[me-W(ee,me),me]}e.getCharContainingOffset=V;let U;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(ee){return U||(U=N()),U.test(ee)}e.containsRTL=j;const B=/^[\t\n\r\x20-\x7E]*$/;function Z(ee){return B.test(ee)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=oe;function X(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=X;function ie(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=ie;function se(ee,le){if(ee.length<le)return ee;const me=/\b/g;let ge=0;for(;me.test(ee)&&!(ee.length-me.lastIndex<le);)ge=me.lastIndex,me.lastIndex+=1;return ee.substring(ge).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function we(ee){return ee&&(ee=ee.replace(ue,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Pe(ee){return Ee(ee)?ee.substr(1):ee}e.stripUTF8BOM=Pe;function Ue(ee,le){if(!ee||!le||ee.length<le.length)return!1;const me=le.length,ge=ee.toLowerCase();let Se=0,be=-1;for(;Se<me;){const Re=ge.indexOf(le[Se],be+1);if(Re<0)return!1;be=Re,Se++}return!0}e.fuzzyContains=Ue;function ze(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=ze;function Ve(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ve;function We(ee,le=1){if(le===0)return"";let me=-1;do me=ee.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?ee:(ee[me-1]==="\r"&&me--,ee.substr(0,me))}e.getNLines=We;function ae(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.singleLetterHash=ae;function fe(ee){return Ie.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=fe;function de(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var Ce;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this._data,ge=me.length/3;let Se=1;for(;Se<=ge;)if(le<me[3*Se])Se=2*Se;else if(le>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}Ie._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ee,le){if(ee===0)return 0;const me=$e(ee,le);if(me!==void 0)return me;const ge=new Y(le,ee);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=De;function $e(ee,le){const me=new Y(le,ee);let ge=me.prevCodePoint();for(;Ae(ge)||ge===65039||ge===8419;){if(me.offset===0)return;ge=me.prevCodePoint()}if(!ie(ge))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ae(ee){return 127995<=ee&&ee<=127999}var Fe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class _e{static getInstance(le){return _e.cache.get(Array.from(le))}static getLocales(){return _e._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,D=_e,_e.ambiguousCharacterData=new r.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new R.LRUCachedFunction(ee=>{function le(Le){const Ne=new Map;for(let xe=0;xe<Le.length;xe+=2)Ne.set(Le[xe],Le[xe+1]);return Ne}function me(Le,Ne){const xe=new Map(Le);for(const[Xe,Ze]of Ne)xe.set(Xe,Ze);return xe}function ge(Le,Ne){if(!Le)return Ne;const xe=new Map;for(const[Xe,Ze]of Le)Ne.has(Xe)&&xe.set(Xe,Ze);return xe}const Se=D.ambiguousCharacterData.getValue();let be=ee.filter(Le=>!Le.startsWith("_")&&Le in Se);be.length===0&&(be=["_default"]);let Re;for(const Le of be){const Ne=le(Se[Le]);Re=ge(Re,Ne)}const Te=le(Se._common),qe=me(Te,Re);return new _e(qe)}),_e._locales=new r.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ke.getRawData())),this._data}static isInvisibleCharacter(le){return ke.getData().has(le)}static get codePoints(){return ke.getData()}}e.InvisibleCharacters=ke,ke._data=void 0}),define(ne[47],re([0,1,12,4,27,15]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function P(o){return o.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function E(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function b(o,u=R.posix.sep){if(!o)return"";const c=o.length,d=o.charCodeAt(0);if(A(d)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let _=3;const F=_;for(;_<c&&!A(o.charCodeAt(_));_++);if(F!==_&&!A(o.charCodeAt(_+1))){for(_+=1;_<c;_++)if(A(o.charCodeAt(_)))return o.slice(0,_+1).replace(/[\\/]/g,u)}}return u}else if(m(d)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let y=o.indexOf("://");if(y!==-1){for(y+=3;y<c;y++)if(A(o.charCodeAt(y)))return o.slice(0,y+1)}return""}e.getRoot=b;function I(o){if(!r.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let c=2;const d=c;for(;c<o.length&&(u=o.charCodeAt(c),u!==92);c++);return!(d===c||(u=o.charCodeAt(c+1),isNaN(u)||u===92))}e.isUNC=I;const w=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,u=r.isWindows){const c=u?w:p;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||u&&v.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function S(o,u,c){const d=o===u;return!c||d?d:!o||!u?!1:(0,D.equalsIgnoreCase)(o,u)}e.isEqual=S;function C(o,u,c,d=R.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let _=u.length;return u.charAt(u.length-1)===d&&_--,o.charAt(_)===d}return u.charAt(u.length-1)!==d&&(u+=d),o.indexOf(u)===0}e.isEqualOrParent=C;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function g(o,u){return r.isWindows&&o.endsWith(":")&&(o+=R.sep),(0,R.isAbsolute)(o)||(o=(0,R.join)(u,o)),o=(0,R.normalize)(o),r.isWindows?(o=(0,D.rtrim)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,D.rtrim)(o,R.sep),o||(o=R.sep)),o}e.sanitizeFilePath=g;function a(o){const u=(0,R.normalize)(o);return r.isWindows?o.length>3?!1:f(u)&&(o.length===2||u.charCodeAt(2)===92):u===R.posix.sep}e.isRootOrDriveLetter=a;function f(o,u=r.isWindows){return u?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function l(o){return f(o)?o[0]:void 0}e.getDriveLetter=l;function i(o,u,c){return u.length>o.length?-1:o===u?0:(c&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=i;function s(o){const u=o.split(":");let c,d,y;for(const _ of u){const F=Number(_);(0,L.isNumber)(F)?d===void 0?d=F:y===void 0&&(y=F):c=c?[c,_].join(":"):_}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:y!==void 0?y:d!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,u,c=8){let d="";for(let _=0;_<c;_++)d+=t.charAt(Math.floor(Math.random()*t.length));let y;return u?y=`${u}-${d}`:y=d,o?(0,R.join)(o,y):y}e.randomPath=n}),define(ne[64],re([0,1,27]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(m){return D(m,0)}e.hash=r;function D(m,g){switch(typeof m){case"object":return m===null?L(349,g):Array.isArray(m)?E(m,g):b(m,g);case"string":return P(m,g);case"boolean":return A(m,g);case"number":return L(m,g);case"undefined":return L(937,g);default:return L(617,g)}}e.doHash=D;function L(m,g){return(g<<5)-g+m|0}e.numberHash=L;function A(m,g){return L(m?433:863,g)}function P(m,g){g=L(149417,g);for(let a=0,f=m.length;a<f;a++)g=L(m.charCodeAt(a),g);return g}e.stringHash=P;function E(m,g){return g=L(104579,g),m.reduce((a,f)=>D(f,a),g)}function b(m,g){return g=L(181387,g),Object.keys(m).sort().reduce((a,f)=>(a=P(f,a),D(m[f],a)),g)}class I{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=D(g,this._value),this._value}}e.Hasher=I;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(m,g,a=32){const f=a-g,l=~((1<<f)-1);return(m<<g|(l&m)>>>f)>>>0}function v(m,g=0,a=m.byteLength,f=0){for(let l=0;l<a;l++)m[g+l]=f}function h(m,g,a="0"){for(;m.length<g;)m=a+m;return m}function S(m,g=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),g/4)}e.toHexString=S;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const a=g.length;if(a===0)return;const f=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=g.charCodeAt(0),t=0);;){let n=s;if(R.isHighSurrogate(s))if(t+1<a){const o=g.charCodeAt(t+1);R.isLowSurrogate(o)?(t++,n=R.computeCodePoint(s,o)):n=65533}else{i=s;break}else R.isLowSurrogate(s)&&(n=65533);if(l=this._push(f,l,n),t++,t<a)s=g.charCodeAt(t);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(g,a,f){return f<128?g[a++]=f:f<2048?(g[a++]=192|(f&1984)>>>6,g[a++]=128|(f&63)>>>0):f<65536?(g[a++]=224|(f&61440)>>>12,g[a++]=128|(f&4032)>>>6,g[a++]=128|(f&63)>>>0):(g[a++]=240|(f&1835008)>>>18,g[a++]=128|(f&258048)>>>12,g[a++]=128|(f&4032)>>>6,g[a++]=128|(f&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=C._bigBlock32,a=this._buffDV;for(let c=0;c<64;c+=4)g.setUint32(c,a.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)g.setUint32(c,p(g.getUint32(c-12,!1)^g.getUint32(c-32,!1)^g.getUint32(c-56,!1)^g.getUint32(c-64,!1),1),!1);let f=this._h0,l=this._h1,i=this._h2,s=this._h3,t=this._h4,n,o,u;for(let c=0;c<80;c++)c<20?(n=l&i|~l&s,o=1518500249):c<40?(n=l^i^s,o=1859775393):c<60?(n=l&i|l&s|i&s,o=2400959708):(n=l^i^s,o=3395469782),u=p(f,5)+n+t+o+g.getUint32(c*4,!1)&4294967295,t=s,s=i,i=p(l,30),l=f,f=u;this._h0=this._h0+f&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,19,27]),function(Q,e,R,r){"use strict";var D,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,o){let u=t.get(n);return u===void 0&&(u=o,t.set(n,u)),u}e.getOrSet=P;function E(t){const n=[];return t.forEach((o,u)=>{n.push(`${u} => ${o}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=E;function b(t){const n=[];return t.forEach(o=>{n.push(o)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=b;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),u=this._value.charCodeAt(this._pos);return o-u}value(){return this._value[this._pos]}}e.StringIterator=I;class w{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class p{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const u=this._value.charCodeAt(o);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,r.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(C||(C={}));class m{static forUris(n=()=>!1,o=()=>!1){return new m(new h(n,o))}static forPaths(n=!1){return new m(new p(void 0,!n))}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new w)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,o){if(o){const u=o.slice(0);(0,R.shuffle)(u);for(const c of u)this.set(c,n)}else{const u=n.slice(0);(0,R.shuffle)(u);for(const c of u)this.set(c[0],c[1])}}set(n,o){const u=this._iter.reset(n);let c;this._root||(this._root=new S,this._root.segment=u.value());const d=[];for(c=this._root;;){const _=u.cmp(c.segment);if(_>0)c.left||(c.left=new S,c.left.segment=u.value()),d.push([-1,c]),c=c.left;else if(_<0)c.right||(c.right=new S,c.right.segment=u.value()),d.push([1,c]),c=c.right;else if(u.hasNext())u.next(),c.mid||(c.mid=new S,c.mid.segment=u.value()),d.push([0,c]),c=c.mid;else break}const y=c.value;c.value=o,c.key=n;for(let _=d.length-1;_>=0;_--){const F=d[_][1];F.updateHeight();const T=F.balanceFactor();if(T<-1||T>1){const O=d[_][0],k=d[_+1][0];if(O===1&&k===1)d[_][1]=F.rotateLeft();else if(O===-1&&k===-1)d[_][1]=F.rotateRight();else if(O===1&&k===-1)F.right=d[_+1][1]=d[_+1][1].rotateRight(),d[_][1]=F.rotateLeft();else if(O===-1&&k===1)F.left=d[_+1][1]=d[_+1][1].rotateLeft(),d[_][1]=F.rotateRight();else throw new Error;if(_>0)switch(d[_-1][0]){case-1:d[_-1][1].left=d[_][1];break;case 1:d[_-1][1].right=d[_][1];break;case 0:d[_-1][1].mid=d[_][1];break}else this._root=d[0][1]}}return y}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let u=this._root;for(;u;){const c=o.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else break}return u}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const u=this._iter.reset(n),c=[];let d=this._root;for(;d;){const y=u.cmp(d.segment);if(y>0)c.push([-1,d]),d=d.left;else if(y<0)c.push([1,d]),d=d.right;else if(u.hasNext())u.next(),c.push([0,d]),d=d.mid;else break}if(!!d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const y=this._min(d.right),{key:_,value:F,segment:T}=y;this._delete(y.key,!1),d.key=_,d.value=F,d.segment=T}else{const y=d.left??d.right;if(c.length>0){const[_,F]=c[c.length-1];switch(_){case-1:F.left=y;break;case 0:F.mid=y;break;case 1:F.right=y;break}}else this._root=y}for(let y=c.length-1;y>=0;y--){const _=c[y][1];_.updateHeight();const F=_.balanceFactor();if(F>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),c[y][1]=_.rotateLeft()):F<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),c[y][1]=_.rotateRight()),y>0)switch(c[y-1][0]){case-1:c[y-1][1].left=c[y][1];break;case 1:c[y-1][1].right=c[y][1];break;case 0:c[y-1][1].mid=c[y][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let u=this._root,c;for(;u;){const d=o.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(o.hasNext())o.next(),c=u.value||c,u=u.mid;else break}return u&&u.value||c}findSuperstr(n){const o=this._iter.reset(n);let u=this._root;for(;u;){const c=o.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(n){for(const[o,u]of this)n(u,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const u=o.balanceFactor();return u<-1||u>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=m;class g{constructor(n,o){this.uri=n,this.value=o}}class a{constructor(n,o){this[D]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=o??a.defaultToKey):(this.map=new Map,this.toKey=n??a.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new g(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[u,c]of this.map)n(c.value,c.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=a,a.defaultToKey=t=>t.toString();class f{constructor(n,o){this[L]="ResourceSet",!n||typeof n=="function"?this._map=new a(n):(this._map=new a(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((u,c)=>n.call(o,c,c,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class i{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const u=this._map.get(n);if(!!u)return o!==0&&this.touch(u,o),u.value}set(n,o,u=0){let c=this._map.get(n);if(c)c.value=o,u!==0&&this.touch(c,u);else{switch(c={key:n,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const u=this._state;let c=this._head;for(;c;){if(o?n.bind(o)(c.value,c.key,this):n(c.value,c.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,o=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.key,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}values(){const n=this,o=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.value,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}entries(){const n=this,o=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:[u.key,u.value],done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>n;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,u=n.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const u=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(u.previous=c,c.next=u),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const u=n.next,c=n.previous;n===this._head?(u.previous=void 0,this._head=u):(u.previous=c,c.next=u),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,u)=>{n.push([u,o])}),n}fromJSON(n){this.clear();for(const[o,u]of n)this.set(o,u)}}e.LinkedMap=i;class s extends i{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s}),define(ne[83],re([0,1,34]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new R.LRUCache(1e4);function D(b){return E(b,"NFC",r)}e.normalizeNFC=D;const L=new R.LRUCache(1e4);function A(b){return E(b,"NFD",L)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function E(b,I,w){if(!b)return b;const p=w.get(b);if(p)return p;let v;return P.test(b)?v=b.normalize(I):v=b,w.set(b,v),v}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return A(I).replace(b,"")}}()}),define(ne[84],re([0,1,27]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(r||(r={})),function(D){const L="error",A="warning",P="warn",E="info",b="ignore";function I(p){return p?R.equalsIgnoreCase(L,p)?D.Error:R.equalsIgnoreCase(A,p)||R.equalsIgnoreCase(P,p)?D.Warning:R.equalsIgnoreCase(E,p)?D.Info:D.Ignore:D.Ignore}D.fromValue=I;function w(p){switch(p){case D.Error:return L;case D.Warning:return A;case D.Info:return E;default:return b}}D.toString=w}(r||(r={})),e.default=r}),define(ne[7],re([0,1,12,4]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,n){return!t&&!n?"file":t}function b(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const I="",w="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(n){return n instanceof v?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,u,c,d,y=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=E(n,y),this.authority=o||I,this.path=b(this.scheme,u||I),this.query=c||I,this.fragment=d||I,P(this,y))}get fsPath(){return a(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:u,path:c,query:d,fragment:y}=n;return o===void 0?o=this.scheme:o===null&&(o=I),u===void 0?u=this.authority:u===null&&(u=I),c===void 0?c=this.path:c===null&&(c=I),d===void 0?d=this.query:d===null&&(d=I),y===void 0?y=this.fragment:y===null&&(y=I),o===this.scheme&&u===this.authority&&c===this.path&&d===this.query&&y===this.fragment?this:new S(o,u,c,d,y)}static parse(n,o=!1){const u=p.exec(n);return u?new S(u[2]||I,s(u[4]||I),s(u[5]||I),s(u[7]||I),s(u[9]||I),o):new S(I,I,I,I,I)}static file(n){let o=I;if(r.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const u=n.indexOf(w,2);u===-1?(o=n.substring(2),n=w):(o=n.substring(2,u),n=n.substring(u)||w)}return new S("file",o,n,I,I)}static from(n){const o=new S(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return r.isWindows&&n.scheme==="file"?u=v.file(R.win32.join(a(n,!0),...o)).path:u=R.posix.join(n.path,...o),n.with({path:u})}toString(n=!1){return f(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof v)return n;{const o=new S(n);return o._formatted=n.external,o._fsPath=n._sep===h?n.fsPath:null,o}}else return n}}e.URI=v;const h=r.isWindows?1:void 0;class S extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(n=!1){return n?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(t,n){let o,u=-1;for(let c=0;c<t.length;c++){const d=t.charCodeAt(c);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||n&&d===47)u!==-1&&(o+=encodeURIComponent(t.substring(u,c)),u=-1),o!==void 0&&(o+=t.charAt(c));else{o===void 0&&(o=t.substr(0,c));const y=C[d];y!==void 0?(u!==-1&&(o+=encodeURIComponent(t.substring(u,c)),u=-1),o+=y):u===-1&&(u=c)}}return u!==-1&&(o+=encodeURIComponent(t.substring(u))),o!==void 0?o:t}function g(t){let n;for(let o=0;o<t.length;o++){const u=t.charCodeAt(o);u===35||u===63?(n===void 0&&(n=t.substr(0,o)),n+=C[u]):n!==void 0&&(n+=t[o])}return n!==void 0?n:t}function a(t,n){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,r.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=a;function f(t,n){const o=n?g:m;let u="",{scheme:c,authority:d,path:y,query:_,fragment:F}=t;if(c&&(u+=c,u+=":"),(d||c==="file")&&(u+=w,u+=w),d){let T=d.indexOf("@");if(T!==-1){const O=d.substr(0,T);d=d.substr(T+1),T=O.indexOf(":"),T===-1?u+=o(O,!1):(u+=o(O.substr(0,T),!1),u+=":",u+=o(O.substr(T+1),!1)),u+="@"}d=d.toLowerCase(),T=d.indexOf(":"),T===-1?u+=o(d,!1):(u+=o(d.substr(0,T),!1),u+=d.substr(T))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const T=y.charCodeAt(1);T>=65&&T<=90&&(y=`/${String.fromCharCode(T+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const T=y.charCodeAt(0);T>=65&&T<=90&&(y=`${String.fromCharCode(T+32)}:${y.substr(2)}`)}u+=o(y,!0)}return _&&(u+="?",u+=o(_,!1)),F&&(u+="#",u+=n?F:m(F,!1)),u}function l(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+l(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(i)?t.replace(i,n=>l(n)):t}}),define(ne[130],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=r;function D(b){const I=[];let w;try{const p=JSON.parse(b.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),w=v.__$stack),I.push(...p)}catch{I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:w}}e.parse=D;function L(b){if(typeof b!="string")return L(D(b).stack);const I=b;if(I){const w=A(I),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:R.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function A(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function P(b,I){const{args:w,stack:p}=D(b),v=typeof w[0]=="string"&&w.length===1;let h=A(p);h&&(h=`(${h.trim()})`);let S=[];if(typeof w[0]=="string"?h&&v?S=[`%c[${I}] %c${w[0]} %c${h}`,E("blue"),E(""),E("grey")]:S=[`%c[${I}] %c${w[0]}`,E("blue"),E(""),...w.slice(1)]:S=[`%c[${I}]%`,E("blue"),...w],h&&!v&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=P;function E(b){return`color: ${b}`}}),define(ne[65],re([0,1,16,27,7]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(b){return JSON.stringify(b,P)}e.stringify=L;function A(b){let I=JSON.parse(b);return I=E(I),I}e.parse=A;function P(b,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,r.regExpFlags)(I)}:I}function E(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof R.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let w=0;w<b.length;++w)b[w]=E(b[w],I+1);else for(const w in b)Object.hasOwnProperty.call(b,w)&&(b[w]=E(b[w],I+1))}return b}e.revive=E}),define(ne[22],re([0,1,4,7]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${D.vscodeRemoteResource}`}set(b,I,w){this._hosts[b]=I,this._ports[b]=w}setConnectionToken(b,I){this._connectionTokens[b]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const I=b.authority;let w=this._hosts[I];w&&w.indexOf(":")!==-1&&(w=`[${w}]`);const p=this._ports[I],v=this._connectionTokens[I];let h=`path=${encodeURIComponent(b.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),r.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${w}:${p}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new L;class A{asBrowserUri(b,I){const w=this.toUri(b,I);return w.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===D.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${D.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?w.with({scheme:D.vscodeFileResource,authority:w.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(b,I){const w=this.toUri(b,I);return w.scheme===D.vscodeFileResource?w.with({scheme:D.file,authority:w.authority!==A.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(b,I){return r.URI.isUri(b)?b:r.URI.parse(I.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A;var P;(function(E){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(b.get("3"));const I="vscode-coi";function w(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:r.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const S=h?.get(I);if(!!S)return b.get(S)}E.getHeadersFromQuery=w;function p(v,h,S){if(!globalThis.crossOriginIsolated)return;const C=h&&S?"3":S?"2":"1";v instanceof URLSearchParams?v.set(I,C):v[I]=C}E.addSearchParam=p})(P=e.COI||(e.COI={}))}),define(ne[17],re([0,1,47,22,12,4,27,7]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=E;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,C=!1){return h===S?0:(0,A.compare)(this.getComparisonKey(h,C),this.getComparisonKey(S,C))}isEqual(h,S,C=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,C)===this.getComparisonKey(S,C)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,C=!1){if(h.scheme===S.scheme){if(h.scheme===r.Schemas.file)return R.isEqualOrParent(E(h),E(S),this._ignorePathCasing(h))&&h.query===S.query&&(C||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return R.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(C||h.fragment===S.fragment)}return!1}joinPath(h,...S){return P.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===r.Schemas.file?S=P.URI.file(D.dirname(E(h))).path:(S=D.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===r.Schemas.file?S=P.URI.file(D.normalize(E(h))).path:S=D.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===r.Schemas.file){const g=D.relative(E(h),E(S));return L.isWindows?R.toSlashes(g):g}let C=h.path||"/";const m=S.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const a=Math.min(C.length,m.length);g<a&&!(C.charCodeAt(g)!==m.charCodeAt(g)&&C.charAt(g).toLowerCase()!==m.charAt(g).toLowerCase());g++);C=m.substr(0,g)+C.substr(g)}return D.posix.relative(C,m)}resolvePath(h,S){if(h.scheme===r.Schemas.file){const C=P.URI.file(D.resolve(E(h),S));return h.with({authority:C.authority,path:C.path})}return S=R.toPosixPath(S),h.with({path:D.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=D.sep){if(h.scheme===r.Schemas.file){const C=E(h);return C.length>R.getRoot(C).length&&C[C.length-1]===S}else{const C=h.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=D.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=D.sep){let C=!1;if(h.scheme===r.Schemas.file){const m=E(h);C=m!==void 0&&m.length===R.getRoot(m).length&&m[m.length-1]===S}else{S="/";const m=h.path;C=m.length===1&&m.charCodeAt(m.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(v=>v.scheme===r.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(v,h){const S=[];for(let C=0;C<v.length;C++){const m=h(v[C]);v.some((g,a)=>a===C?!1:(0,e.isEqualOrParent)(m,h(g)))||S.push(v[C])}return S}e.distinctParents=I;var w;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(a=>{const[f,l]=a.split(":");f&&l&&C.set(f,l)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&C.set(v.META_DATA_MIME,g),C}v.parseMetaData=h})(w=e.DataUri||(e.DataUri={}));function p(v,h,S){if(h){let C=v.path;return C&&C[0]!==D.posix.sep&&(C=D.posix.sep+C),v.with({scheme:S,authority:h,path:C})}return v.with({scheme:S})}e.toLocalResource=p}),define(ne[6],re([0,1,24,9,3,2,17,4]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(V){return!!V&&typeof V.then=="function"}e.isThenable=E;function b(V){const U=new R.CancellationTokenSource,N=V(U.token),j=new Promise((B,Z)=>{const oe=U.token.onCancellationRequested(()=>{oe.dispose(),U.dispose(),Z(new r.CancellationError)});Promise.resolve(N).then(X=>{oe.dispose(),U.dispose(),B(X)},X=>{oe.dispose(),U.dispose(),Z(X)})});return new class{cancel(){U.cancel()}then(B,Z){return j.then(B,Z)}catch(B){return this.then(void 0,B)}finally(B){return j.finally(B)}}}e.createCancelablePromise=b;function I(V,U,N){return new Promise((j,B)=>{const Z=U.onCancellationRequested(()=>{Z.dispose(),j(N)});V.then(j,B).finally(()=>Z.dispose())})}e.raceCancellation=I;function w(V,U){return new Promise((N,j)=>{const B=U.onCancellationRequested(()=>{B.dispose(),j(new r.CancellationError)});V.then(N,j).finally(()=>B.dispose())})}e.raceCancellationError=w;async function p(V){let U=-1;const N=V.map((B,Z)=>B.then(oe=>(U=Z,oe))),j=await Promise.race(N);return V.forEach((B,Z)=>{Z!==U&&B.cancel()}),j}e.raceCancellablePromises=p;function v(V,U,N){let j;const B=setTimeout(()=>{j?.(void 0),N?.()},U);return Promise.race([V.finally(()=>clearTimeout(B)),new Promise(Z=>j=Z)])}e.raceTimeout=v;function h(V){return new Promise((U,N)=>{const j=V();E(j)?j.then(U,N):U(j)})}e.asPromise=h;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(N,N).then(j)})}return new Promise((N,j)=>{this.queuedPromise.then(N,j)})}return this.activePromise=U(),new Promise((N,j)=>{this.activePromise.then(B=>{this.activePromise=null,N(B)},B=>{this.activePromise=null,j(B)})})}}e.Throttler=S;class C{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=C;class m{constructor(){this.promiseMap=new Map}queue(U,N){const B=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(U)===B&&this.promiseMap.delete(U)});return this.promiseMap.set(U,B),B}}e.SequencerByKey=m;const g=(V,U)=>{let N=!0;const j=setTimeout(()=>{N=!1,U()},V);return{isTriggered:()=>N,dispose:()=>{clearTimeout(j),N=!1}}},a=V=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,V())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(U){this.defaultDelay=U,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,N=this.defaultDelay){this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,Z)=>{this.doResolve=B,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?a(j):g(N,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new r.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class l{constructor(U){this.delayer=new f(U),this.throttler=new S}trigger(U,N){return this.delayer.trigger(()=>this.throttler.queue(U),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this._isOpen=!1,this._promise=new Promise((U,N)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class s extends i{constructor(U){super(),this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(V,U){return U?new Promise((N,j)=>{const B=setTimeout(()=>{Z.dispose(),N()},V),Z=U.onCancellationRequested(()=>{clearTimeout(B),Z.dispose(),j(new r.CancellationError)})}):b(N=>t(V,N))}e.timeout=t;function n(V,U=0){const N=setTimeout(V,U);return(0,L.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=n;function o(V){const U=[];let N=0;const j=V.length;function B(){return N<j?V[N++]():null}function Z(oe){oe!=null&&U.push(oe);const X=B();return X?X.then(Z):Promise.resolve(U)}return Promise.resolve(null).then(Z)}e.sequence=o;function u(V,U=j=>!!j,N=null){let j=0;const B=V.length,Z=()=>{if(j>=B)return Promise.resolve(N);const oe=V[j++];return Promise.resolve(oe()).then(ie=>U(ie)?Promise.resolve(ie):Z())};return Z()}e.first=u;function c(V,U=j=>!!j,N=null){if(V.length===0)return Promise.resolve(N);let j=V.length;const B=()=>{j=-1;for(const Z of V)Z.cancel?.()};return new Promise((Z,oe)=>{for(const X of V)X.then(ie=>{--j>=0&&U(ie)?(B(),Z(ie)):j===0&&Z(N)}).catch(ie=>{--j>=0&&(B(),oe(ie))})})}e.firstParallel=c;class d{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(U){return this._size++,new Promise((N,j)=>{this.outstandingPromises.push({factory:U,c:N,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const N=U.factory();N.then(U.c,U.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class y extends d{constructor(){super(1)}}e.Queue=y;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const U=new z;return this.drainers.add(U),U.p}isDrained(){for(const[,U]of this.queues)if(U.size>0)return!1;return!0}queueFor(U,N=A.extUri){const j=N.getComparisonKey(U);let B=this.queues.get(j);return B||(B=new y,D.Event.once(B.onDrained)(()=>{B?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,B)),B}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const U of this.drainers)U.complete();this.drainers.clear()}dispose(){for(const[,U]of this.queues)U.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class F{constructor(U,N){this._token=-1,typeof U=="function"&&typeof N=="number"&&this.setIfNotSet(U,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},N)}setIfNotSet(U,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},N))}}e.TimeoutTimer=F;class T{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setInterval(()=>{U()},N)}}e.IntervalTimer=T;class O{constructor(U,N){this.timeoutToken=-1,this.runner=U,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=O;class k{constructor(U,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class M extends O{constructor(U,N){super(U,N),this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner?.(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class $ extends L.Disposable{constructor(U,N){super(),this.options=U,this.handler=N,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.options.maxBufferedWork)return!1}else if(this.pending+U.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,P.setTimeout0)(()=>{if(U)return;const N=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(V,U)=>{const N=requestIdleCallback(V,typeof U=="number"?{timeout:U}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(N))}}}}();class q{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function J(V,U,N){let j;for(let B=0;B<N;B++)try{return await V()}catch(Z){j=Z,await t(U)}throw j}e.retry=J;class H{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(U,N,j){return this._pending={taskId:U,cancel:()=>j?.(),promise:N},N.then(()=>this.donePending(U),()=>this.donePending(U)),N}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let N,j;const B=new Promise((Z,oe)=>{N=Z,j=oe});this._next={run:U,promise:B,promiseResolve:N,promiseReject:j}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class G{constructor(U,N=()=>Date.now()){this.interval=U,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const U=this.nowFn();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,N)=>{this.completeCallback=U,this.errorCallback=N})}complete(U){return new Promise(N=>{this.completeCallback(U),this.resolved=!0,N()})}error(U){return new Promise(N=>{this.errorCallback(U),this.rejected=!0,N()})}cancel(){new Promise(U=>{this.errorCallback(new r.CancellationError),this.rejected=!0,U()})}}e.DeferredPromise=z;var x;(function(V){async function U(j){let B;const Z=await Promise.all(j.map(oe=>oe.then(X=>X,X=>{B||(B=X)})));if(typeof B<"u")throw B;return Z}V.settled=U;function N(j){return new Promise(async(B,Z)=>{try{await j(B,Z)}catch(oe){Z(oe)}})}V.withAsyncBody=N})(x=e.Promises||(e.Promises={}));var Y;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(Y||(Y={}));class te{static fromArray(U){return new te(N=>{N.emitMany(U)})}static fromPromise(U){return new te(async N=>{N.emitMany(await U)})}static fromPromises(U){return new te(async N=>{await Promise.all(U.map(async j=>N.emitOne(await j)))})}static merge(U){return new te(async N=>{await Promise.all(U.map(async j=>{for await(const B of j)N.emitOne(B)}))})}constructor(U){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const N={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(U(N)),this.resolve()}catch(j){this.reject(j)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(U<this._results.length)return{done:!1,value:this._results[U++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(U,N){return new te(async j=>{for await(const B of U)j.emitOne(N(B))})}map(U){return te.map(this,U)}static filter(U,N){return new te(async j=>{for await(const B of U)N(B)&&j.emitOne(B)})}filter(U){return te.filter(this,U)}static coalesce(U){return te.filter(U,N=>!!N)}coalesce(){return te.coalesce(this)}static async toPromise(U){const N=[];for await(const j of U)N.push(j);return N}toPromise(){return te.toPromise(this)}emitOne(U){this._state===0&&(this._results.push(U),this._onStateChanged.fire())}emitMany(U){this._state===0&&(this._results=this._results.concat(U),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(U){this._state===0&&(this._state=2,this._error=U,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class ce extends te{constructor(U,N){super(N),this._source=U}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function W(V){const U=new R.CancellationTokenSource,N=V(U.token);return new ce(U,async j=>{const B=U.token.onCancellationRequested(()=>{B.dispose(),U.dispose(),j.reject(new r.CancellationError)});try{for await(const Z of N){if(U.token.isCancellationRequested)return;j.emitOne(Z)}B.dispose(),U.dispose()}catch(Z){B.dispose(),U.dispose(),j.reject(Z)}})}e.createCancelableAsyncIterable=W}),define(ne[85],re([0,1,19,6,47,34,12,4,27]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",w="[^/\\\\]",p=/\//g;function v(z,x){switch(z){case 0:return"";case 1:return`${w}*?`;default:return`(?:${I}|${w}+${I}${x?`|${I}${w}+`:""})*?`}}function h(z,x){if(!z)return[];const Y=[];let te=!1,ce=!1,W="";for(const V of z){switch(V){case x:if(!te&&!ce){Y.push(W),W="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}W+=V}return W&&Y.push(W),Y}e.splitGlobAware=h;function S(z){if(!z)return"";let x="";const Y=h(z,e.GLOB_SPLIT);if(Y.every(te=>te===e.GLOBSTAR))x=".*";else{let te=!1;Y.forEach((ce,W)=>{if(ce===e.GLOBSTAR){if(te)return;x+=v(2,W===Y.length-1)}else{let V=!1,U="",N=!1,j="";for(const B of ce){if(B!=="}"&&V){U+=B;continue}if(N&&(B!=="]"||!j)){let Z;B==="-"?Z=B:(B==="^"||B==="!")&&!j?Z="^":B===e.GLOB_SPLIT?Z="":Z=(0,E.escapeRegExpCharacters)(B),j+=Z;continue}switch(B){case"{":V=!0;continue;case"[":N=!0;continue;case"}":{x+=`(?:${h(U,",").map(X=>S(X)).join("|")})`,V=!1,U="";break}case"]":{x+="["+j+"]",N=!1,j="";break}case"?":x+=w;continue;case"*":x+=v(1);continue;default:x+=(0,E.escapeRegExpCharacters)(B)}}W<Y.length-1&&(Y[W+1]!==e.GLOBSTAR||W+2<Y.length)&&(x+=I)}te=ce===e.GLOBSTAR})}return x}const C=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.LRUCache(1e4),s=function(){return!1},t=function(){return null};function n(z,x){if(!z)return t;let Y;typeof z!="string"?Y=z.pattern:Y=z,Y=Y.trim();const te=`${Y}_${!!x.trimForExclusions}`;let ce=i.get(te);if(ce)return o(ce,z);let W;return C.test(Y)?ce=c(Y.substr(4),Y):(W=m.exec(u(Y,x)))?ce=d(W[1],Y):(x.trimForExclusions?a:g).test(Y)?ce=y(Y,x):(W=f.exec(u(Y,x)))?ce=_(W[1].substr(1),Y,!0):(W=l.exec(u(Y,x)))?ce=_(W[1],Y,!1):ce=F(Y),i.set(te,ce),o(ce,z)}function o(z,x){if(typeof x=="string")return z;const Y=function(te,ce){return(0,D.isEqualOrParent)(te,x.base,!P.isLinux)?z(te.substr(x.base.length+1),ce):null};return Y.allBasenames=z.allBasenames,Y.allPaths=z.allPaths,Y.basenames=z.basenames,Y.patterns=z.patterns,Y}function u(z,x){return x.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function c(z,x){return function(Y,te){return typeof Y=="string"&&Y.endsWith(z)?x:null}}function d(z,x){const Y=`/${z}`,te=`\\${z}`,ce=function(V,U){return typeof V!="string"?null:U?U===z?x:null:V===z||V.endsWith(Y)||V.endsWith(te)?x:null},W=[z];return ce.basenames=W,ce.patterns=[x],ce.allBasenames=W,ce}function y(z,x){const Y=H(z.slice(1,-1).split(",").map(U=>n(U,x)).filter(U=>U!==t),z),te=Y.length;if(!te)return t;if(te===1)return Y[0];const ce=function(U,N){for(let j=0,B=Y.length;j<B;j++)if(Y[j](U,N))return z;return null},W=Y.find(U=>!!U.allBasenames);W&&(ce.allBasenames=W.allBasenames);const V=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function _(z,x,Y){const te=A.sep===A.posix.sep,ce=te?z:z.replace(p,A.sep),W=A.sep+ce,V=A.posix.sep+z;let U;return Y?U=function(N,j){return typeof N=="string"&&(N===ce||N.endsWith(W)||!te&&(N===z||N.endsWith(V)))?x:null}:U=function(N,j){return typeof N=="string"&&(N===ce||!te&&N===z)?x:null},U.allPaths=[(Y?"*/":"./")+z],U}function F(z){try{const x=new RegExp(`^${S(z)}$`);return function(Y){return x.lastIndex=0,typeof Y=="string"&&x.test(Y)?z:null}}catch{return t}}function T(z,x,Y){return!z||typeof x!="string"?!1:O(z)(x,void 0,Y)}e.match=T;function O(z,x={}){if(!z)return s;if(typeof z=="string"||k(z)){const Y=n(z,x);if(Y===t)return s;const te=function(ce,W){return!!Y(ce,W)};return Y.allBasenames&&(te.allBasenames=Y.allBasenames),Y.allPaths&&(te.allPaths=Y.allPaths),te}return q(z,x)}e.parse=O;function k(z){const x=z;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=k;function M(z){return z.allBasenames||[]}e.getBasenameTerms=M;function $(z){return z.allPaths||[]}e.getPathTerms=$;function q(z,x){const Y=H(Object.getOwnPropertyNames(z).map(U=>J(U,z[U],x)).filter(U=>U!==t)),te=Y.length;if(!te)return t;if(!Y.some(U=>!!U.requiresSiblings)){if(te===1)return Y[0];const U=function(B,Z){let oe;for(let X=0,ie=Y.length;X<ie;X++){const se=Y[X](B,Z);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const X of oe){const ie=await X;if(typeof ie=="string")return ie}return null})():null},N=Y.find(B=>!!B.allBasenames);N&&(U.allBasenames=N.allBasenames);const j=Y.reduce((B,Z)=>Z.allPaths?B.concat(Z.allPaths):B,[]);return j.length&&(U.allPaths=j),U}const ce=function(U,N,j){let B,Z;for(let oe=0,X=Y.length;oe<X;oe++){const ie=Y[oe];ie.requiresSiblings&&j&&(N||(N=(0,A.basename)(U)),B||(B=N.substr(0,N.length-(0,A.extname)(U).length)));const se=ie(U,N,B,j);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(Z||(Z=[]),Z.push(se))}return Z?(async()=>{for(const oe of Z){const X=await oe;if(typeof X=="string")return X}return null})():null},W=Y.find(U=>!!U.allBasenames);W&&(ce.allBasenames=W.allBasenames);const V=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function J(z,x,Y){if(x===!1)return t;const te=n(z,Y);if(te===t)return t;if(typeof x=="boolean")return te;if(x){const ce=x.when;if(typeof ce=="string"){const W=(V,U,N,j)=>{if(!j||!te(V,U))return null;const B=ce.replace("$(basename)",N),Z=j(B);return(0,r.isThenable)(Z)?Z.then(oe=>oe?z:null):Z?z:null};return W.requiresSiblings=!0,W}}return te}function H(z,x){const Y=z.filter(U=>!!U.basenames);if(Y.length<2)return z;const te=Y.reduce((U,N)=>{const j=N.basenames;return j?U.concat(j):U},[]);let ce;if(x){ce=[];for(let U=0,N=te.length;U<N;U++)ce.push(x)}else ce=Y.reduce((U,N)=>{const j=N.patterns;return j?U.concat(j):U},[]);const W=function(U,N){if(typeof U!="string")return null;if(!N){let B;for(B=U.length;B>0;B--){const Z=U.charCodeAt(B-1);if(Z===47||Z===92)break}N=U.substr(B)}const j=te.indexOf(N);return j!==-1?ce[j]:null};W.basenames=te,W.patterns=ce,W.allBasenames=te;const V=z.filter(U=>!U.basenames);return V.push(W),V}function G(z,x){return(0,R.equals)(z,x,(Y,te)=>typeof Y=="string"&&typeof te=="string"?Y===te:typeof Y!="string"&&typeof te!="string"?Y.base===te.base&&Y.pattern===te.pattern:!1)}e.patternsEquals=G}),define(ne[131],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(I){return I.toJSON()}class D{constructor(w){this._uriTransformer=w}transformIncoming(w){const p=this._uriTransformer.transformIncoming(w);return p===w?w:r(R.URI.from(p))}transformOutgoing(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:r(R.URI.from(p))}transformOutgoingURI(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:R.URI.from(p)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,w,p){if(!I||p>200)return null;if(typeof I=="object"){if(I instanceof R.URI)return w.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const h=L(I[v],w,p+1);h!==null&&(I[v]=h)}}return null}function A(I,w){const p=L(I,w,0);return p===null?I:p}e.transformOutgoingURIs=A;function P(I,w,p,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return p?R.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const S=P(I[h],w,p,v+1);S!==null&&(I[h]=S)}}return null}function E(I,w){const p=P(I,w,!1,0);return p===null?I:p}e.transformIncomingURIs=E;function b(I,w){const p=P(I,w,!0,0);return p===null?I:p}e.transformAndReviveIncomingURIs=b}),define(ne[132],re([0,1,37,9,34,30,118]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,w=0;const p=(0,R.networkInterfaces)();for(const v in p){const h=p[v];if(h)for(const{mac:S,internal:C}of h)C||(w+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(I+=1))}this._value=w>0?I/w:0}return this._value}};let P;async function E(){return P||(P=(async()=>await b()||L.generateUuid())()),P}e.getMachineId=E;async function b(){try{const I=await new Promise((p,v)=>{Q(["crypto"],p,v)}),w=(0,A.getMac)();return I.createHash("sha256").update(w,"utf8").digest("hex")}catch(I){r.onUnexpectedError(I);return}}}),define(ne[28],re([0,1,53,37,274,6,47,83,12,4,17,7]),function(Q,e,R,r,D,L,A,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function v(q,J=p.UNLINK){if((0,A.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return J===p.UNLINK?S(q):h(q)}async function h(q){try{const J=(0,A.randomPath)((0,r.tmpdir)());try{await R.promises.rename(q,J)}catch(H){return H.code==="ENOENT"?void 0:S(q)}S(J).catch(H=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function S(q){return(0,D.promisify)(R.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function C(q){if((0,A.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function m(q,J){return f(await(J?g(q):(0,D.promisify)(R.readdir)(q)))}async function g(q){try{return await(0,D.promisify)(R.readdir)(q,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const J=[],H=await m(q);for(const G of H){let z=!1,x=!1,Y=!1;try{const te=await e.Promises.lstat((0,E.join)(q,G));z=te.isFile(),x=te.isDirectory(),Y=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}J.push({name:G,isFile:()=>z,isDirectory:()=>x,isSymbolicLink:()=>Y})}return J}function a(q){return f(R.readdirSync(q))}e.readdirSync=a;function f(q){return q.map(J=>typeof J=="string"?b.isMacintosh?(0,P.normalizeNFC)(J):J:(J.name=b.isMacintosh?(0,P.normalizeNFC)(J.name):J.name,J))}async function l(q){const J=await m(q),H=[];for(const G of J)await s.existsDirectory((0,E.join)(q,G))&&H.push(G);return H}function i(q,J=1e3){return new Promise(H=>{let G=!1;const z=setInterval(()=>{G||(G=!0,R.access(q,x=>{G=!1,x&&(clearInterval(z),H(void 0))}))},J)})}e.whenDeleted=i;var s;(function(q){async function J(z){let x;try{if(x=await e.Promises.lstat(z),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(b.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw te}throw Y}}q.stat=J;async function H(z){try{const{stat:x,symbolicLink:Y}=await q.stat(z);return x.isFile()&&Y?.dangling!==!0}catch{}return!1}q.existsFile=H;async function G(z){try{const{stat:x,symbolicLink:Y}=await q.stat(z);return x.isDirectory()&&Y?.dangling!==!0}catch{}return!1}q.existsDirectory=G})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function n(q,J,H){return t.queueFor(w.URI.file(q),I.extUriBiasedIgnorePathCase).queue(()=>{const G=y(H);return new Promise((z,x)=>c(q,J,G,Y=>Y?x(Y):z()))})}let o=!0;function u(q){o=q}e.configureFlushOnWrite=u;function c(q,J,H,G){if(!o)return R.writeFile(q,J,{mode:H.mode,flag:H.flag},G);R.open(q,H.flag,H.mode,(z,x)=>{if(z)return G(z);R.writeFile(x,J,Y=>{if(Y)return R.close(x,()=>G(Y));R.fdatasync(x,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),u(!1)),R.close(x,ce=>G(ce))))})})}function d(q,J,H){const G=y(H);if(!o)return R.writeFileSync(q,J,{mode:G.mode,flag:G.flag});const z=R.openSync(q,G.flag,G.mode);try{R.writeFileSync(z,J);try{R.fdatasyncSync(z)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),u(!1)}}finally{R.closeSync(z)}}e.writeFileSync=d;function y(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function _(q,J){if(q!==J)try{await e.Promises.rename(q,J)}catch(H){if(q.toLowerCase()!==J.toLowerCase()&&H.code==="EXDEV"||q.endsWith("."))await F(q,J,{preserveSymlinks:!1}),await v(q,p.MOVE);else throw H}}async function F(q,J,H){return O(q,J,{root:{source:q,target:J},options:H,handledSourcePaths:new Set})}const T=511;async function O(q,J,H){if(H.handledSourcePaths.has(q))return;H.handledSourcePaths.add(q);const{stat:G,symbolicLink:z}=await s.stat(q);if(z){if(H.options.preserveSymlinks)try{return await $(q,J,H)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(z.dangling)return}return G.isDirectory()?k(q,J,G.mode&T,H):M(q,J,G.mode&T)}async function k(q,J,H,G){await e.Promises.mkdir(J,{recursive:!0,mode:H});const z=await m(q);for(const x of z)await O((0,E.join)(q,x),(0,E.join)(J,x),G)}async function M(q,J,H){await e.Promises.copyFile(q,J),await e.Promises.chmod(J,H)}async function $(q,J,H){let G=await e.Promises.readlink(q);(0,A.isEqualOrParent)(G,H.root.source,!b.isLinux)&&(G=(0,E.join)(H.root.target,G.substr(H.root.source.length+1))),await e.Promises.symlink(G,J)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(q,J,H,G,z)=>new Promise((x,Y)=>{R.read(q,J,H,G,z,(te,ce,W)=>te?Y(te):x({bytesRead:ce,buffer:W}))})}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(q,J,H,G,z)=>new Promise((x,Y)=>{R.write(q,J,H,G,z,(te,ce,W)=>te?Y(te):x({bytesWritten:ce,buffer:W}))})}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return v}get move(){return _}get copy(){return F}}}),define(ne[133],re([0,1,53,12,4,27,28]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(p){if(D.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const C=(0,A.readdirSync)(v).filter(m=>m.toLowerCase()===h);if(C.length===1){const m=P(v);if(m)return(0,r.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(h);if(m>=0){const g=P(v);if(g)return(0,r.join)(g,C[m])}}}catch{}return null}e.realcaseSync=P;async function E(p){if(D.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const C=(await A.Promises.readdir(v)).filter(m=>m.toLowerCase()===h);if(C.length===1){const m=await E(v);if(m)return(0,r.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(h);if(m>=0){const g=await E(v);if(g)return(0,r.join)(g,C[m])}}}catch{}return null}e.realcase=E;async function b(p){try{return await A.Promises.realpath(p)}catch{const h=w(p);return await A.Promises.access(h,R.constants.R_OK),h}}e.realpath=b;function I(p){try{return R.realpathSync(p)}catch{const h=w(p);return R.accessSync(h,R.constants.R_OK),h}}e.realpathSync=I;function w(p){return(0,L.rtrim)((0,r.normalize)(p),r.sep)}}),define(ne[86],re([0,1,37,12,28]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var E;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(l,i,s){this.exePath=l,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:f=!1}={}){return f?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:f=!1,findPreview:l=!1}={}){const i=p({useAlternateBitness:f});if(!i)return null;const s=r.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let t=-1,n=null;for(const c of await D.Promises.readdir(s)){let d=-1;if(l){const _=c.indexOf("-");if(_<0)continue;const F=c.substring(0,_);if(!L.test(F)||c.substring(_+1)!=="preview")continue;d=parseInt(F,10)}else{if(!L.test(c))continue;d=parseInt(c,10)}if(d<=t)continue;const y=r.join(s,c,"pwsh.exe");!await D.SymlinkSupport.existsFile(y)||(n=y,t=d)}if(!n)return null;const o=i.includes("x86")?" (x86)":"",u=l?" Preview":"";return new w(n,`PowerShell${u}${o}`,!0)}async function h({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const l=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(l))if(i.test(t)){const n=r.join(l,t,"pwsh.exe");return new w(n,s)}return null}function S(){const f=r.join(R.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function C(){const f=r.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*m(){let f=await v();f&&(yield f),f=await v({useAlternateBitness:!0}),f&&(yield f),f=await h(),f&&(yield f),f=S(),f&&(yield f),f=await v({findPreview:!0}),f&&(yield f),f=await h({findPreview:!0}),f&&(yield f),f=await v({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=C(),f&&(yield f)}async function*g(){for await(const f of m())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function a(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=a}),define(ne[87],re([0,1,12,4,36,81,15,28]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(w=D.env){return w.comspec||"cmd.exe"}e.getWindowsShell=E;function b(w){let p=[],v=!1;const h=function(S){if(v){p.push(S);return}(!w.send(S,m=>{if(m&&console.error(m),v=!1,p.length>0){const g=p.slice(0);p=[],g.forEach(a=>h(a))}})||r.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=b;var I;(function(w){async function p(v,h,S){if(R.isAbsolute(v))return v;if(h===void 0&&(h=D.cwd()),R.dirname(v)!=="."||(S===void 0&&A.isString(D.env.PATH)&&(S=D.env.PATH.split(R.delimiter)),S===void 0||S.length===0))return R.join(h,v);async function m(g){if(await P.Promises.exists(g)){let a;try{a=await P.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(a=await P.Promises.lstat(g))}return a?!a.isDirectory():!1}return!1}for(const g of S){let a;if(R.isAbsolute(g)?a=R.join(g,v):a=R.join(h,g,v),await m(a))return a;let f=a+".com";if(await m(f)||(f=a+".exe",await m(f)))return f}return R.join(h,v)}w.findExecutable=p})(I=e.win32||(e.win32={}))}),define(ne[134],re([0,1,54,22]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(A){return new Promise((P,E)=>{let b;const I=new Map;function w(v,h,S,C,m){const g=I.get(h);if(v===A||g){const a={name:p(S),cmd:S,pid:v,ppid:h,load:C,mem:m};I.set(v,a),v===A&&(b=a),g&&(g.children||(g.children=[]),g.children.push(a),g.children.length>1&&(g.children=g.children.sort((f,l)=>f.pid-l.pid)))}}function p(v){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,a=/--crashes-directory/,f=/\\pipe\\winpty-control/,l=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(a.exec(v))return"electron-crash-reporter";if(f.exec(v))return"winpty-process";if(l.exec(v))return"console-window-host (Windows internal process)";let s=i.exec(v);if(s&&s.length===2){if(s[1]==="renderer")return h.exec(v)?"shared-process":S.exec(v)?"issue-reporter":C.exec(v)?"process-explorer":"window";if(s[1]==="utility"){if(m.exec(v))return"utility-network-service";if(g.exec(v))return"extension-host"}return s[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do s=t.exec(v),s&&(n+=s+" ");while(s);return n&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${n}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{Q(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(A,S=>{if(!S){E(new Error(`Root process ${A} not found`));return}h.getProcessCpuUsage(S,C=>{const m=new Map;C.forEach(g=>{const a=v(g.commandLine||"");m.set(g.pid,{name:p(a),cmd:a,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),b=m.get(A),b?(m.forEach(g=>{const a=m.get(g.ppid);a&&(a.children||(a.children=[]),a.children.push(g))}),m.forEach(g=>{g.children&&(g.children=g.children.sort((a,f)=>a.pid-f.pid))}),P(b)):E(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[b];const S=[];for(;h.length;){const m=h.shift();m&&(S.push(m.pid),m.children&&(h=h.concat(m.children)))}let C=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);C+=" "+S.join(" "),(0,R.exec)(C,{},(m,g,a)=>{if(m||a)E(m||new Error(a.toString()));else{const f=g.toString().split(`
`);for(let l=0;l<S.length;l++){const i=I.get(S[l]);i.load=parseFloat(f[l])}if(!b){E(new Error(`Root process ${A} not found`));return}P(b)}})};(0,R.exec)("which ps",{},(h,S,C)=>{if(h||C)if(process.platform!=="linux")E(h||new Error(C.toString()));else{const m=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,R.exec)(m,{},(g,a,f)=>{g||f?E(g||new Error(f.toString())):(L(a,w),v())})}else{const m=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${m} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,f,l)=>{a||l&&!l.includes("screen size is bogus")?E(a||new Error(l.toString())):(L(f,w),process.platform==="linux"?v():b?P(b):E(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=D;function L(A,P){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=A.toString().split(`
`);for(const I of b){const w=E.exec(I.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ne[135],re([0,1,37,4,86,87]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(v,h){return v===1?r.isWindows?w():L.getWindowsShell(h):b(v,h)}e.getSystemShell=A;function P(v,h){return v===1?r.isWindows?p(h):L.getWindowsShell(h):b(v,h)}e.getSystemShellSync=P;let E=null;function b(v,h){if(r.isLinux&&v===2||r.isMacintosh&&v===3)return"/bin/bash";if(!E){let S;if(r.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,R.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}E=S}return E}let I=null;async function w(){return I||(I=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),I}function p(v){if(I)return I;const h=r.isWindows&&parseFloat((0,R.release)())>=10,S=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${v.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?C:L.getWindowsShell(v)}});var pe=this&&this.__decorate||function(Q,e,R,r){var D=arguments.length,L=D<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,R):r,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,R,r);else for(var P=Q.length-1;P>=0;P--)(A=Q[P])&&(L=(D<3?A(L):D>3?A(e,R,L):A(e,R))||L);return D>3&&L&&Object.defineProperty(e,R,L),L};define(ne[39],re([0,1,19,6,16,24,62,9,3,2,65,27,15]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(m||(m={}));class g{constructor(x){this.buffer=x,this.pos=0}read(x){const Y=this.buffer.slice(this.pos,this.pos+x);return this.pos+=Y.byteLength,Y}}class a{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var f;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(f||(f={}));function l(z){const x=D.VSBuffer.alloc(4);return x.writeUInt32BE(z,0),x}function i(z){return z.read(4).readUInt32BE(0)}function s(z){const x=D.VSBuffer.alloc(1);return x.writeUInt8(z,0),x}const t={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},n=typeof Buffer<"u";function o(z,x){if(typeof x>"u")z.write(t.Undefined);else if(typeof x=="string"){const Y=D.VSBuffer.fromString(x);z.write(t.String),z.write(l(Y.byteLength)),z.write(Y)}else if(n&&Buffer.isBuffer(x)){const Y=D.VSBuffer.wrap(x);z.write(t.Buffer),z.write(l(Y.byteLength)),z.write(Y)}else if(x instanceof D.VSBuffer)z.write(t.VSBuffer),z.write(l(x.byteLength)),z.write(x);else if(Array.isArray(x)){z.write(t.Array),z.write(l(x.length));for(const Y of x)o(z,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(x));z.write(t.Object),z.write(l(Y.byteLength)),z.write(Y)}}function u(z){switch(z.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return z.read(i(z)).toString();case f.Buffer:return z.read(i(z)).buffer;case f.VSBuffer:return z.read(i(z));case f.Array:{const Y=i(z),te=[];for(let ce=0;ce<Y;ce++)te.push(u(z));return te}case f.Object:return JSON.parse(z.read(i(z)).toString())}}class c{constructor(x,Y,te=null,ce=1e3){this.protocol=x,this.ctx=Y,this.logger=te,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(x,Y){this.channels.set(x,Y),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const Y=this.send([x.type]);this.logger?.logOutgoing(Y,0,1,C(x.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(Y,x.id,1,C(x.type),x.data);return}}}send(x,Y=void 0){const te=new a;return o(te,x),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const Y=new g(x),te=u(Y),ce=u(Y),W=te[0];switch(W){case 100:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(W)}: ${te[2]}.${te[3]}`,ce),this.onPromise({type:W,id:te[1],channelName:te[2],name:te[3],arg:ce});case 102:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(W)}: ${te[2]}.${te[3]}`,ce),this.onEventListen({type:W,id:te[1],channelName:te[2],name:te[3],arg:ce});case 101:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:te[1]});case 103:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:te[1]})}}onPromise(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const te=new L.CancellationTokenSource;let ce;try{ce=Y.call(this.ctx,x.name,x.arg,te.token)}catch(U){ce=Promise.reject(U)}const W=x.id;ce.then(U=>{this.sendResponse({id:W,data:U,type:201}),this.activeRequests.delete(x.id)},U=>{U instanceof Error?this.sendResponse({id:W,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:W,data:U,type:203}),this.activeRequests.delete(x.id)});const V=(0,b.toDisposable)(()=>te.cancel());this.activeRequests.set(x.id,V)}onEventListen(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const te=x.id,W=Y.listen(this.ctx,x.name,x.arg)(V=>this.sendResponse({id:te,data:V,type:204}));this.activeRequests.set(x.id,W)}disposeActiveRequest(x){const Y=this.activeRequests.get(x.id);Y&&(Y.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let Y=this.pendingRequests.get(x.channelName);Y||(Y=[],this.pendingRequests.set(x.channelName,Y));const te=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:x,timeoutTimer:te})}flushPendingRequests(x){const Y=this.pendingRequests.get(x);if(Y){for(const te of Y)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var d;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(x,Y=null){this.protocol=x,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=Y}getChannel(x){const Y=this;return{call(te,ce,W){return Y.isDisposed?Promise.reject(new P.CancellationError):Y.requestPromise(x,te,ce,W)},listen(te,ce){return Y.isDisposed?E.Event.None:Y.requestEvent(x,te,ce)}}}requestPromise(x,Y,te,ce=L.CancellationToken.None){const W=this.lastRequestId++,U={id:W,type:100,channelName:x,name:Y,arg:te};if(ce.isCancellationRequested)return Promise.reject(new P.CancellationError);let N;return new Promise((B,Z)=>{if(ce.isCancellationRequested)return Z(new P.CancellationError);const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(W),B(he.data);break;case 202:{this.handlers.delete(W);const ve=new Error(he.data.message);ve.stack=he.data.stack,ve.name=he.data.name,Z(ve);break}case 203:this.handlers.delete(W),Z(he.data);break}};this.handlers.set(W,ue),this.sendRequest(U)};let X=null;this.state===m.Idle?oe():(X=(0,r.createCancelablePromise)(ue=>this.whenInitialized()),X.then(()=>{X=null,oe()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:W,type:101}),Z(new P.CancellationError)},se=ce.onCancellationRequested(ie);N=(0,b.combinedDisposable)((0,b.toDisposable)(ie),se),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(x,Y,te){const ce=this.lastRequestId++,V={id:ce,type:102,channelName:x,name:Y,arg:te};let U=null;const N=new E.Emitter({onFirstListenerAdd:()=>{U=(0,r.createCancelablePromise)(B=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(N),this.sendRequest(V)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(N),this.sendRequest({id:ce,type:103}))}}),j=B=>N.fire(B.data);return this.handlers.set(ce,j),N.event}sendRequest(x){switch(x.type){case 100:case 102:{const Y=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(Y,x.id,0,`${h(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const Y=this.send([x.type,x.id]);this.logger?.logOutgoing(Y,x.id,0,h(x.type));return}}}send(x,Y=void 0){const te=new a;return o(te,x),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const Y=new g(x),te=u(Y),ce=u(Y),W=te[0];switch(W){case 200:return this.logger?.logIncoming(x.byteLength,0,0,C(W)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,te[1],0,C(W),ce),this.onResponse({type:te[0],id:te[1],data:ce})}}onResponse(x){if(x.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([A.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class _{get connections(){const x=[];return this._connections.forEach(Y=>x.push(Y)),x}constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:Y,onDidClientDisconnect:te})=>{E.Event.once(Y.onMessage)(W=>{const V=new g(W),U=u(V),N=new c(Y,U),j=new y(Y);this.channels.forEach((Z,oe)=>N.registerChannel(oe,Z));const B={channelServer:N,channelClient:j,ctx:U};this._connections.add(B),this._onDidAddConnection.fire(B),te(()=>{N.dispose(),j.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}getChannel(x,Y){const te=this;return{call(ce,W,V){let U;if((0,p.isFunction)(Y)){const j=(0,R.getRandomElement)(te.connections.filter(Y));U=j?Promise.resolve(j):E.Event.toPromise(E.Event.filter(te.onDidAddConnection,Y))}else U=Y.routeCall(te,ce,W);const N=U.then(j=>j.channelClient.getChannel(x));return T(N).call(ce,W,V)},listen(ce,W){if((0,p.isFunction)(Y))return te.getMulticastEvent(x,Y,ce,W);const V=Y.routeEvent(te,ce,W).then(U=>U.channelClient.getChannel(x));return T(V).listen(ce,W)}}}getMulticastEvent(x,Y,te,ce){const W=this;let V=new b.DisposableStore;const U=new E.Emitter({onFirstListenerAdd:()=>{V=new b.DisposableStore;const N=new E.EventMultiplexer,j=new Map,B=oe=>{const ie=oe.channelClient.getChannel(x).listen(te,ce),se=N.add(ie);j.set(oe,se)},Z=oe=>{const X=j.get(oe);!X||(X.dispose(),j.delete(oe))};W.connections.filter(Y).forEach(B),E.Event.filter(W.onDidAddConnection,Y)(B,void 0,V),W.onDidRemoveConnection(Z,void 0,V),N.event(U.fire,U,V),V.add(N)},onLastListenerRemove:()=>{V.dispose()}});return U.event}registerChannel(x,Y){this.channels.set(x,Y),this._connections.forEach(te=>{te.channelServer.registerChannel(x,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class F{constructor(x,Y,te=null){const ce=new a;o(ce,Y),x.send(ce.buffer),this.channelClient=new y(x,te),this.channelServer=new c(x,Y,te)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,Y){this.channelServer.registerChannel(x,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function T(z){return{call(x,Y,te){return z.then(ce=>ce.call(x,Y,te))},listen(x,Y){const te=new E.Relay;return z.then(ce=>te.input=ce.listen(x,Y)),te.event}}}e.getDelayedChannel=T;function O(z){let x=!1;return{call(Y,te,ce){return x?z.call(Y,te,ce):(0,r.timeout)(0).then(()=>x=!0).then(()=>z.call(Y,te,ce))},listen(Y,te){if(x)return z.listen(Y,te);const ce=new E.Relay;return(0,r.timeout)(0).then(()=>x=!0).then(()=>ce.input=z.listen(Y,te)),ce.event}}}e.getNextTickChannel=O;class k{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const Y of x.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await E.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=k;var M;(function(z){function x(W,V){const U=W,N=V&&V.disableMarshalling,j=new Map;for(const B in U)te(B)&&j.set(B,E.Event.buffer(U[B],!0));return new class{listen(B,Z,oe){const X=j.get(Z);if(X)return X;if(ce(Z)){const ie=U[Z];if(typeof ie=="function")return ie.call(U,oe)}throw new Error(`Event not found: ${Z}`)}call(B,Z,oe){const X=U[Z];if(typeof X=="function"){if(!N&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,I.revive)(oe[ie]);return X.apply(U,oe)}throw new Error(`Method not found: ${Z}`)}}}z.fromService=x;function Y(W,V){const U=V&&V.disableMarshalling;return new Proxy({},{get(N,j){if(typeof j=="string")return V?.properties?.has(j)?V.properties.get(j):ce(j)?function(B){return W.listen(j,B)}:te(j)?W.listen(j):async function(...B){let Z;V&&!(0,p.isUndefinedOrNull)(V.context)?Z=[V.context,...B]:Z=B;const oe=await W.call(j,Z);return U?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(j)}`)}})}z.toService=Y;function te(W){return W[0]==="o"&&W[1]==="n"&&w.isUpperAsciiLetter(W.charCodeAt(2))}function ce(W){return/^onDynamic/.test(W)&&w.isUpperAsciiLetter(W.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const x=z.toString();if(x!=="[object Object]")return x}return z}function J(z){return Array.isArray(z)?z.map(q):q(z)}function H(z,x,Y,te,ce,W,V){V=J(V);const U=$[ce],N=U[te%U.length];let j=[`%c[${z}]%c[${String(x).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(W)?(j=j.concat(V),j.push(")")):j.push(V),console.log.apply(console,j)}e.logWithColors=H;class G{constructor(x,Y){this._outgoingPrefix=x,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,Y,te,ce,W){this._totalOutgoing+=x,H(this._outgoingPrefix,this._totalOutgoing,x,Y,te,ce,W)}logIncoming(x,Y,te,ce,W){this._totalIncoming+=x,H(this._incomingPrefix,this._totalIncoming,x,Y,te,ce,W)}}e.IPCLogger=G}),define(ne[136],re([0,1,16,3,39]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(E){this.port=E,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",b=>R.VSBuffer.wrap(b.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends D.IPCClient{constructor(E,b){const I=new L(E);super(I,b),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[88],re([0,1,16,3,2,39]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let u=0;function c(y,_){if(!o.has(y)){const F=String(++u);o.set(y,F)}return o.get(y)}function d(y,_,F,T){if(!n.enableDiagnostics)return;const O=c(y,_);if(T instanceof R.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const k=R.VSBuffer.alloc(T.byteLength);k.set(T),n.records.push({timestamp:Date.now(),id:O,label:_,type:F,buff:k})}else n.records.push({timestamp:Date.now(),id:O,label:_,type:F,data:T})}n.traceSocketEvent=d})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function I(){return b||(b=R.VSBuffer.alloc(0)),b}class w{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,u){if(o===0)return I();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const _=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=o),_}if(this._chunks[0].byteLength>o){const _=this._chunks[0].slice(0,o);return u&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),_}const c=R.VSBuffer.alloc(o);let d=0,y=0;for(;o>0;){const _=this._chunks[y];if(_.byteLength>o){const F=_.slice(0,o);c.set(F,d),d+=o,u&&(this._chunks[y]=_.slice(o),this._totalLength-=o),o-=o}else c.set(_,d),d+=_.byteLength,u?(this._chunks.shift(),this._totalLength-=_.byteLength):y++,o-=_.byteLength}return c}}e.ChunkStream=w;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function v(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(o,u,c,d){this.type=o,this.id=u,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends D.Disposable{constructor(o){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,d=this._state.id,y=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new S(c,d,y,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=R.VSBuffer.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(u,o.data)}_bufferAdd(o,u){const c=this._totalLength===0;return this._data.push(o,u),this._totalLength+=o.byteLength+u.byteLength,c}_bufferTake(){const o=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,u){this._bufferAdd(o,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends D.Disposable{constructor(o){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new S(1,0,0,o))}}e.Protocol=g;class a extends L.IPCClient{static fromSocket(o,u){return new a(new g(o),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(o,u,c=null){super(o,u,c),this.protocol=o}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=a;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class l{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let o=0,u=this._first;for(;u;)u=u.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let u=0,c=this._first;for(;c;)o[u++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const u=new l(o);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class s{static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}constructor(){this.lastRuns=[];const o=Date.now();for(let u=0;u<s._HISTORY_LENGTH;u++)this.lastRuns[u]=o-1e3*u;setInterval(()=>{for(let u=s._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const o=Date.now(),u=(1+s._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<s._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=u&&c++;return 1-c/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(o,u=null,c=s.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),u&&this._socketReader.acceptChunk(u),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new S(5,0,0,I());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new S(7,0,0,I());this._socketWriter.write(o)}sendResume(){const o=new S(8,0,0,I());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,I());this._socketWriter.write(o);const u=this._outgoingUnackMsg.toArray();for(let c=0,d=u.length;c<d;c++)this._socketWriter.write(u[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new S(6,0,0,I())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let c=0,d=u.length;c<d;c++)this._socketWriter.write(u[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new S(1,u,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const u=new S(2,0,0,o);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),u=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&c>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:c});return}const y=Math.max(2e4-u,2e4-c,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},y)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,I());this._socketWriter.write(o)}_sendKeepAlive(){const o=new S(9,0,0,I());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(ne[137],re([0,1,89,3,39,136]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends D.IPCServer{static getOnDidClientConnect(){const E=r.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return r.Event.map(E,b=>{const{port1:I,port2:w}=new MessageChannel,v={protocol:new L.Protocol(I),onDidClientDisconnect:r.Event.fromDOMEventEmitter(I,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[w]),v})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[66],re([0,1,54,6,16,24,130,9,3,2,32,87,81,39]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(m){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",g=>D.VSBuffer.wrap(Buffer.from(g,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=h;class S{constructor(m,g){this.modulePath=m,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new r.Delayer(a),this.child=null,this._client=null}getChannel(m){const g=this;return{call(a,f,l){return g.requestPromise(m,a,f,l)},listen(a,f){return g.requestEvent(m,a,f)}}}requestPromise(m,g,a,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(m),i=(0,r.createCancelablePromise)(n=>l.call(g,a,n)),s=f.onCancellationRequested(()=>i.cancel()),t=(0,b.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(m,g,a){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let f;const l=new E.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(m).listen(g,a)(l.fire,l),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(g.env),this.child=(0,R.fork)(this.modulePath,m,g);const a=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}a.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const l=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),s=a.event,t={send:i,onMessage:s};this._client=new v.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",n),this.activeRequests.forEach(c=>(0,b.dispose)(c)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(m){let g=this.channels.get(m);return g||(g=this.client.getChannel(m),this.channels.set(m,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[138],re([0,1,16,9,3,2,12,4,30,39,88]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class p{traceSocketEvent(c,d){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,d)}constructor(c,d=""){this.debugLabel=d,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=y=>{if(this.traceSocketEvent("error",{code:y?.code,message:y?.message}),y){if(y.code==="EPIPE")return;(0,r.onUnexpectedError)(y)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const d=y=>{this.traceSocketEvent("read",y),c(R.VSBuffer.wrap(y))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(c){const d=y=>{this.traceSocketEvent("close",{hadError:y}),c({type:0,hadError:y,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(c){const d=()=>{this.traceSocketEvent("nodeEndReceived"),c()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(c){if(!this.socket.destroyed)try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,r.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,r.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=p;var v;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(h||(h={}));class S extends L.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,d){this.socket.traceSocketEvent(c,d)}constructor(c,d,y,_){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:y?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new C(this,d,y,_,this._onData,(F,T)=>this._write(F,T))),this._register(this._flowManager.onError(F=>{console.error(F),(0,r.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let y=2;c.byteLength<126?y+=0:c.byteLength<2**16?y+=2:y+=8;const _=R.VSBuffer.alloc(y);if(d?_.writeUInt8(194,0):_.writeUInt8(130,0),c.byteLength<126)_.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){_.writeUInt8(126,1);let F=1;_.writeUInt8(c.byteLength>>>8&255,++F),_.writeUInt8(c.byteLength>>>0&255,++F)}else{_.writeUInt8(127,1);let F=1;_.writeUInt8(0,++F),_.writeUInt8(0,++F),_.writeUInt8(0,++F),_.writeUInt8(0,++F),_.writeUInt8(c.byteLength>>>24&255,++F),_.writeUInt8(c.byteLength>>>16&255,++F),_.writeUInt8(c.byteLength>>>8&255,++F),_.writeUInt8(c.byteLength>>>0&255,++F)}this.socket.write(R.VSBuffer.concat([_,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),y=d.readUInt8(0),_=(y&128)>>>7,F=(y&64)>>>6,T=d.readUInt8(1),O=(T&128)>>>7,k=T&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(k===126?2:0)+(k===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),y=d.readUInt8(1),_=(y&128)>>>7;let F=y&127,T=1;F===126?F=d.readUInt8(++T)*2**8+d.readUInt8(++T):F===127&&(F=d.readUInt8(++T)*0+d.readUInt8(++T)*0+d.readUInt8(++T)*0+d.readUInt8(++T)*0+d.readUInt8(++T)*2**24+d.readUInt8(++T)*2**16+d.readUInt8(++T)*2**8+d.readUInt8(++T));let O=0;_&&(O=d.readUInt8(++T)*2**24+d.readUInt8(++T)*2**16+d.readUInt8(++T)*2**8+d.readUInt8(++T)),this._state.state=3,this._state.readLen=F,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),a(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class C extends L.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(c,d,y,_,F,T){super(),this._tracer=c,this._onData=F,this._writeFn=T,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new m(this._tracer,_,y,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(d,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,d){return new Promise((y,_)=>{c.write(d),c.flush(F=>y(F))})}acceptFrame(c,d,y){this._readQueue.push({data:c,isCompressed:d,isLastFrameOfMessage:y}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,d,y){return new Promise((_,F)=>{c.write(d),y&&c.write(R.VSBuffer.fromByteArray([0,0,255,255])),c.flush(T=>_(T))})}}class m extends L.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(c,d,y,_){super(),this._tracer=c,this._recordInflateBytes=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(_),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(R.VSBuffer.wrap(F))}),y&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",y.buffer),this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(d)})}}class g extends L.Disposable{constructor(c,d){super(),this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",y=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibDeflate.on("data",y=>{this._tracer.traceSocketEvent("zlibDeflateData",y),this._pendingDeflateData.push(R.VSBuffer.wrap(y))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),c(d)})}}function a(u,c){if(c===0)return;const d=u.byteLength>>>2;for(let k=0;k<d;k++){const M=u.readUInt32BE(k*4);u.writeUInt32BE(M^c,k*4)}const y=d*4,_=u.byteLength-y,F=c>>>24&255,T=c>>>16&255,O=c>>>8&255;_>=1&&u.writeUInt8(u.readUInt8(y)^F,y),_>=2&&u.writeUInt8(u.readUInt8(y+1)^T,y+1),_>=3&&u.writeUInt8(u.readUInt8(y+2)^O,y+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function l(){const u=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):c=(0,A.join)(w().os.tmpdir(),`vscode-ipc-${u}.sock`),s(c),c}e.createRandomIPCHandle=l;function i(u,c,d){const y=w().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${d}-${c}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${d}-${c}.sock`):_=(0,A.join)(u,`${d}-${c}.sock`),s(_),_}e.createStaticIPCHandle=i;function s(u){const c=f[P.platform];typeof c=="number"&&u.length>=c&&console.warn(`WARNING: IPC handle "${u}" is longer than ${c} chars, try a shorter --user-data-dir`)}class t extends b.IPCServer{static toClientConnectionEvent(c){const d=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(d,y=>({protocol:new I.Protocol(new p(y,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(y,"close"))}))}constructor(c){super(t.toClientConnectionEvent(c)),this.server=c}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function n(u){return new Promise((c,d)=>{const y=w().net.createServer();y.on("error",d),y.listen(u,()=>{y.removeListener("error",d),c(new t(y))})})}e.serve=n;function o(u,c){return new Promise((d,y)=>{const _=w().net.createConnection(u,()=>{_.removeListener("error",y),d(I.Client.fromSocket(new p(_,`ipc-client${c}`),c))});_.once("error",y)})}e.connect=o}),define(ne[67],re([0,1,6,3,2,15]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function P(w){const p=w;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var E;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class b extends D.Disposable{constructor(p,v=Object.create(null)){super(),this.database=p,this.options=v,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((v,h)=>this.accept(h,v)),p.deleted?.forEach(v=>this.accept(v,void 0))}accept(p,v){if(this.state===E.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(v)?h=this.cache.delete(p):this.cache.get(p)!==v&&(this.cache.set(p,v),h=!0),h&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,v){const h=this.cache.get(p);return(0,L.isUndefinedOrNull)(h)?v:h}getBoolean(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:h==="true"}getNumber(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(p,v){if(this.state===E.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(p);const h=String(v);if(this.cache.get(p)!==h)return this.cache.set(p,h),this.pendingInserts.set(p,h),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===E.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((v,h)=>this.items.set(h,v)),p.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[139],re([10,11]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[140],re([10,11]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[141],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[142],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[143],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[144],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[145],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[146],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[147],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[148],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[149],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[150],re([10,11]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[151],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[152],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[153],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[154],re([10,11]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[155],re([10,11]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[156],re([10,11]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[157],re([10,11]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[158],re([10,11]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[159],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[160],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[161],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[162],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[163],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[164],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[165],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[166],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[167],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[168],re([10,11]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[90],re([0,1,63,62,22,12,36,17,7]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{get appRoot(){return(0,L.dirname)(D.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(E.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?E.URI.file((0,L.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(D.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const C=A.env.VSCODE_EXTENSIONS;if(C)return C;const m=A.env.VSCODE_PORTABLE;return m?(0,L.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(C=>/^[^:/?#]+?:\/\//.test(C)?E.URI.parse(C):E.URI.file((0,L.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?E.URI.parse(S):E.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?E.URI.file((0,L.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}constructor(S,C,m){this._args=S,this.paths=C,this.productService=m,this.editSessionId=this.args.editSessionId}}pe([r.memoize],b.prototype,"appRoot",null),pe([r.memoize],b.prototype,"userHome",null),pe([r.memoize],b.prototype,"userDataPath",null),pe([r.memoize],b.prototype,"appSettingsHome",null),pe([r.memoize],b.prototype,"tmpDir",null),pe([r.memoize],b.prototype,"cacheHome",null),pe([r.memoize],b.prototype,"stateResource",null),pe([r.memoize],b.prototype,"userRoamingDataHome",null),pe([r.memoize],b.prototype,"userDataSyncHome",null),pe([r.memoize],b.prototype,"userDataSyncLogResource",null),pe([r.memoize],b.prototype,"editSessionsLogResource",null),pe([r.memoize],b.prototype,"sync",null),pe([r.memoize],b.prototype,"machineSettingsResource",null),pe([r.memoize],b.prototype,"workspaceStorageHome",null),pe([r.memoize],b.prototype,"localHistoryHome",null),pe([r.memoize],b.prototype,"keyboardLayoutResource",null),pe([r.memoize],b.prototype,"argvResource",null),pe([r.memoize],b.prototype,"isExtensionDevelopment",null),pe([r.memoize],b.prototype,"untitledWorkspacesHome",null),pe([r.memoize],b.prototype,"installSourcePath",null),pe([r.memoize],b.prototype,"builtinExtensionsPath",null),pe([r.memoize],b.prototype,"extensionsPath",null),pe([r.memoize],b.prototype,"extensionDevelopmentLocationURI",null),pe([r.memoize],b.prototype,"extensionDevelopmentKind",null),pe([r.memoize],b.prototype,"extensionTestsLocationURI",null),pe([r.memoize],b.prototype,"debugExtensionHost",null),pe([r.memoize],b.prototype,"serviceMachineIdResource",null),pe([r.memoize],b.prototype,"telemetryLogResource",null),pe([r.memoize],b.prototype,"disableWorkspaceTrust",null),pe([r.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function I(h,S){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function w(h,S){return v(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=w;function p(h,S){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=p;function v(h,S,C,m,g,a){const l=Number(S||h)||(m?null:C),i=l?Boolean(!!S):!1;let s;if(a)try{s=JSON.parse(a)}catch{}return{port:l,break:i,debugId:g,env:s}}}),define(ne[169],re([0,1,275,4,141]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,S,C=A){const m={},g=["_"],a=[];for(const s in S){const t=S[s];t.alias&&(m[s]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(s),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(a.push(s),t.deprecates&&a.push(...t.deprecates))}const f=R(h,{string:g,boolean:a,alias:m}),l={},i=f;l._=f._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(const s in S){const t=S[s];t.alias&&delete i[t.alias];let n=i[s];if(t.deprecates)for(const o of t.deprecates)i.hasOwnProperty(o)&&(n||(n=i[o],n&&C.onDeprecatedOption(o,t.deprecationMessage||(0,D.localize)(35,null,s))),delete i[o]);if(typeof n<"u"){if(t.type==="string[]"){if(Array.isArray(n)||(n=[n]),!t.allowEmptyValue){const o=n.filter(u=>u.length>0);o.length!==n.length&&(C.onEmptyValue(s),n=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(n)?(n=n.pop(),C.onMultipleValues(s,n)):!n&&!t.allowEmptyValue&&(C.onEmptyValue(s),n=void 0));l[s]=n,t.deprecationMessage&&C.onDeprecatedOption(s,t.deprecationMessage)}delete i[s]}for(const s in i)C.onUnknownOption(s);return l}e.parseArgs=P;function E(h,S){let C="";return S.args&&(Array.isArray(S.args)?C=` <${S.args.join("> <")}>`:C=` <${S.args}>`),S.alias?`-${S.alias} --${h}${C}`:`--${h}${C}`}function b(h,S){let C=0;const m=[];for(const l in h){const i=h[l],s=E(l,i);C=Math.max(C,s.length),m.push([s,i.description])}const g=C+2+1;if(S-g<25)return m.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=S-g-1,f=[];for(const l of m){const i=l[0],s=w(l[1],a),t=I(g-i.length-2);f.push("  "+i+t+s[0]);for(let n=1;n<s.length;n++)f.push(I(g)+s[n])}return f}e.formatOptions=b;function I(h){return" ".repeat(h)}function w(h,S){const C=[];for(;h.length;){const m=h.length<S?h.length:h.lastIndexOf(" ",S),g=h.slice(0,m).trim();h=h.slice(m),C.push(g)}return C}function p(h,S,C,m,g){const a=process.stdout.isTTY&&process.stdout.columns||80,f=g?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",l=[`${h} ${C}`];l.push(""),l.push(`${(0,D.localize)(37,null)}: ${S} [${(0,D.localize)(38,null)}]${f}`),l.push(""),g?.noPipe!==!0&&(r.isWindows?l.push((0,D.localize)(39,null,S)):l.push((0,D.localize)(40,null,S)),l.push(""));const i={};for(const s in m){const t=m[s];if(t.description&&t.cat){let n=i[t.cat];n||(i[t.cat]=n={}),n[s]=t}}for(const s in i){const t=s,n=i[t];n&&(l.push(L[t]),l.push(...b(n,a)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=p;function v(h,S){return`${h||(0,D.localize)(41,null)}
${S||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(ne[170],re([0,1,276,142,169]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(p,v){const h={onUnknownOption:C=>{console.warn((0,r.localize)(0,null,C))},onMultipleValues:(C,m)=>{console.warn((0,r.localize)(1,null,C,m))},onEmptyValue:C=>{console.warn((0,r.localize)(2,null,C))},onDeprecatedOption:(C,m)=>{console.warn((0,r.localize)(3,null,C,m))}},S=(0,D.parseArgs)(p,D.OPTIONS,v?h:void 0);return S.goto&&S._.forEach(C=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,r.localize)(4,null))),S["max-memory"]&&R(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function P(p){const v=p.findIndex(h=>!/^-/.test(h));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function E(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=P(v)||[]);const h=!w(process.env);return A(v,h)}e.parseMainProcessArgv=E;function b(p){const[,,...v]=p;return A(v,!0)}e.parseCLIProcessArgv=b;function I(p,...v){const h=p.indexOf("--");return h===-1?p.push(...v):p.splice(h,0,...v),p}e.addArg=I;function w(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Q(e,R,r,D){function L(P){const E=A(P),b=[E];return e.isAbsolute(E)||b.unshift(D),e.resolve(...b)}function A(P){process.env.VSCODE_DEV&&(r="code-oss-dev");const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,r);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(w,"AppData","Roaming")}break;case"darwin":b=e.join(R.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,r)}return{getUserDataPath:L}}if(typeof define=="function")define(ne[171],re([0,277,37,22,17,36]),function(e,R,r,D,L,A){const P=L.dirname(D.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(L.joinPath(P,"package.json").fsPath);return Q(R,r,E.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),r=require("os");module.exports=Q(R,r,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[172],re([0,1,37,90,171]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends r.AbstractNativeEnvironmentService{constructor(P,E){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},E)}}e.NativeEnvironmentService=L}),define(ne[173],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const r=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(C){const m=C.match(A);return m?m[1]:null}function I(C){if(C.indexOf("://")===-1){const m=C.match(r);return m?b(m[2]):null}try{const m=R.URI.parse(C);if(m.authority)return b(m.authority)}catch{}return null}function w(C,m){const g=new Set;let a;for(;a=P.exec(C);){const l=I(a[1]);l&&g.add(l)}const f=new Set(m);return Array.from(g).map(l=>f.has(l)?l:l.replace(E,"a"))}e.getDomainsOfRemotes=w;function p(C){const m=C.match(L);return m?m[2]:null}function v(C,m,g){return C&&m?(g&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${C}${m}`:`${C}/${m}`):null}function h(C,m){if(C.indexOf("://")===-1){const g=C.match(D);if(g)return v(g[2],g[3],m)}try{const g=R.URI.parse(C);if(g.authority)return v(p(g.authority),g.path,m)}catch{}return null}function S(C,m=!1){const g=[];let a;for(;a=P.exec(C);){const f=h(a[1],m);f&&g.push(f)}return g}e.getRemotes=S}),define(ne[174],re([0,1,15,145]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(A,P,E){try{L(A,P,E)}catch{}return A}e.localizeManifest=D;function L(A,P,E){const b=(I,w,p)=>{const v=I[w];if((0,R.isString)(v)){const h=v,S=h.length;if(S>1&&h[0]==="%"&&h[S-1]==="%"){const C=h.substr(1,S-2);let m=P[C];m===void 0&&E&&(m=E[C]);const g=typeof m=="string"?m:m.message;if(g!==void 0){const a=E?.[C],f=typeof a=="string"?a:a?.message;if(p&&(w==="title"||w==="category")&&f&&f!==g){const l={value:g,original:f};I[w]=l}else I[w]=g}else console.warn(`[${A.name}]: ${(0,r.localize)(0,null,C)}`)}}else if((0,R.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?b(v,h,!0):b(v,h,p));else if(Array.isArray(v))for(let h=0;h<v.length;h++)b(v,h,p)};for(const I in A)A.hasOwnProperty(I)&&b(A,I)}}),define(ne[175],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,P,E){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,P,E])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class r{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=r}),define(ne[68],re([0,1,17,84,150,55]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function E(m){return m=m.trim(),m==="*"||A.test(m)}e.isValidVersionStr=E;function b(m){if(!E(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=m.match(A);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=b;function I(m){if(!m)return null;const g=m.majorBase,a=m.majorMustEqual,f=m.minorBase;let l=m.minorMustEqual;const i=m.patchBase;let s=m.patchMustEqual;m.hasCaret&&(g===0||(l=!1),s=!1);let t=0;if(m.preRelease){const n=P.exec(m.preRelease);if(n){const[,o,u,c]=n;t=Date.UTC(Number(o),Number(u)-1,Number(c))}}return{majorBase:g,majorMustEqual:a,minorBase:f,minorMustEqual:l,patchBase:i,patchMustEqual:s,isMinimum:m.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function w(m,g,a){let f;typeof m=="string"?f=I(b(m)):f=m;let l;g instanceof Date?l=g.getTime():typeof g=="string"&&(l=new Date(g).getTime());let i;if(typeof a=="string"?i=I(b(a)):i=a,!f||!i)return!1;const s=f.majorBase,t=f.minorBase,n=f.patchBase;let o=i.majorBase,u=i.minorBase,c=i.patchBase;const d=i.notBefore;let y=i.majorMustEqual,_=i.minorMustEqual,F=i.patchMustEqual;return i.isMinimum?s>o?!0:s<o?!1:t>u?!0:t<u||l&&l<d?!1:n>=c:(s===1&&o===0&&(!y||!_||!F)&&(o=1,u=0,c=0,y=!0,_=!1,F=!1),s<o?!1:s>o?!y:t<u?!1:t>u?!_:n<c?!1:n>c?!F:!(l&&l<d))}e.isValidVersion=w;function p(m,g,a,f,l){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([r.default.Error,D.localize(0,null)]),i;if(typeof f.name!="string")return i.push([r.default.Error,D.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([r.default.Error,D.localize(2,null,"version")]),i;if(!f.engines)return i.push([r.default.Error,D.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([r.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!C(f.extensionDependencies))return i.push([r.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!C(f.activationEvents))return i.push([r.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([r.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([r.default.Warning,D.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([r.default.Error,D.localize(9,null,"main")]),i;{const n=(0,R.joinPath)(a,f.main);(0,R.isEqualOrParent)(n,a)||i.push([r.default.Warning,D.localize(10,null,n.path,a.path)])}if(typeof f.activationEvents>"u")return i.push([r.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([r.default.Error,D.localize(12,null,"browser")]),i;{const n=(0,R.joinPath)(a,f.browser);(0,R.isEqualOrParent)(n,a)||i.push([r.default.Warning,D.localize(13,null,n.path,a.path)])}if(typeof f.activationEvents>"u")return i.push([r.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(f.version))return i.push([r.default.Error,D.localize(15,null)]),i;const s=[];if(!v(m,g,f,l,s))for(const n of s)i.push([r.default.Error,n]);return i}e.validateExtensionManifest=p;function v(m,g,a,f,l){return f||typeof a.main>"u"&&typeof a.browser>"u"?!0:S(m,g,a.engines.vscode,l)}e.isValidExtensionVersion=v;function h(m,g,a){return m==="*"||S(g,a,m)}e.isEngineValid=h;function S(m,g,a,f=[]){const l=I(b(a));if(!l)return f.push(D.localize(16,null,a)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return f.push(D.localize(17,null,a)),!1}else if(!l.majorMustEqual)return f.push(D.localize(18,null,a)),!1;return w(m,g,l)?!0:(f.push(D.localize(19,null,m,a)),!1)}function C(m){if(!Array.isArray(m))return!1;for(let g=0,a=m.length;g<a;g++)if(typeof m[g]!="string")return!1;return!0}}),define(ne[48],re([0,1,16,30]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(L,A,P){let E=P&&P.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const I=(await A.readFile(L.serviceMachineIdResource)).value.toString();E=(0,r.isUUID)(I)?I:null}catch{E=null}if(!E){E=(0,r.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,R.VSBuffer.fromString(E))}catch{}}return P?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=D}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,L=[],A=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(ne[91],re([0,1,56]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const r=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function L(P,E,b){E instanceof R.SyncDescriptor||(E=new R.SyncDescriptor(E,[],Boolean(b))),r.push([P,E])}e.registerSingleton=L;function A(){return r}e.getSingletonServiceDescriptors=A}),define(ne[176],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class r{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const P=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(A);P.outgoing.set(E.key,E),E.incoming.set(P.key,P)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(const P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let P=this._nodes.get(A);return P||(P=new R(A,L),this._nodes.set(A,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[A,P]of this._nodes)L.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this._nodes){const P=new Set([L]),E=this._findCycle(A,P);if(E)return E}}_findCycle(L,A){for(const[P,E]of L.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const b=this._findCycle(E,A);if(b)return b;A.delete(P)}}}e.Graph=r}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function r(A,P,E){P[R.DI_TARGET]===P?P[R.DI_DEPENDENCIES].push({id:A,index:E}):(P[R.DI_DEPENDENCIES]=[{id:A,index:E}],P[R.DI_TARGET]=P)}function D(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const P=function(E,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(P,E,I)};return P.toString=()=>A,R.serviceIds.set(A,P),P}e.createDecorator=D;function L(A){return A}e.refineServiceDecorator=L}),define(ne[177],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(ne[18],re([0,1,15,7,5]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function L(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof r.URI)}e.isConfigurationOverrides=L;function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(m,g){const a=Object.create(null);for(const f in m)I(a,f,m[f],g);return a}e.toValuesTree=b;function I(m,g,a,f){const l=g.split("."),i=l.pop();let s=m;for(let t=0;t<l.length;t++){const n=l[t];let o=s[n];switch(typeof o){case"undefined":o=s[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${l.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{f(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=I;function w(m,g){const a=g.split(".");p(m,a)}e.removeFromValueTree=w;function p(m,g){const a=g.shift();if(g.length===0){delete m[a];return}if(Object.keys(m).indexOf(a)!==-1){const f=m[a];typeof f=="object"&&!Array.isArray(f)&&(p(f,g),Object.keys(f).length===0&&delete m[a])}}function v(m,g,a){function f(s,t){let n=s;for(const o of t){if(typeof n!="object"||n===null)return;n=n[o]}return n}const l=g.split("."),i=f(m,l);return typeof i>"u"?a:i}e.getConfigurationValue=v;function h(m,g,a){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in m?R.isObject(m[f])&&R.isObject(g[f])?h(m[f],g[f],a):a&&(m[f]=g[f]):m[f]=g[f])})}e.merge=h;function S(m,g,a){const f=m.inspect(g),l=m.inspect(a);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:f.defaultValue}e.getMigratedSettingValue=S;function C(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(ne[178],re([0,1,4,27,5]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",R.isMacintosh),L.set("isLinux",R.isLinux),L.set("isWindows",R.isWindows),L.set("isWeb",R.isWeb),L.set("isMacNative",R.isMacintosh&&!R.isWeb),L.set("isEdge",R.isEdge),L.set("isFirefox",R.isFirefox),L.set("isChrome",R.isChrome),L.set("isSafari",R.isSafari);const A=Object.prototype.hasOwnProperty;var P;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(k){return v.create(k)}static equals(k,M){return h.create(k,M)}static notEquals(k,M){return m.create(k,M)}static regex(k,M){return t.create(k,M)}static in(k,M){return S.create(k,M)}static notIn(k,M){return C.create(k,M)}static not(k){return g.create(k)}static and(...k){return u.create(k,null)}static or(...k){return c.create(k,null,!0)}static greater(k,M){return f.create(k,M)}static greaterEquals(k,M){return l.create(k,M)}static smaller(k,M){return i.create(k,M)}static smallerEquals(k,M){return s.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){const $=k.split("||");return c.create($.map(q=>this._deserializeAndExpression(q,M)),null,!0)}static _deserializeAndExpression(k,M){const $=k.split("&&");return u.create($.map(q=>this._deserializeOne(q,M)),null)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){const $=k.split("!=");return m.create($[0].trim(),this._deserializeValue($[1],M))}if(k.indexOf("==")>=0){const $=k.split("==");return h.create($[0].trim(),this._deserializeValue($[1],M))}if(k.indexOf("=~")>=0){const $=k.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],M))}if(k.indexOf(" not in ")>=0){const $=k.split(" not in ");return C.create($[0].trim(),$[1].trim())}if(k.indexOf(" in ")>=0){const $=k.split(" in ");return S.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const $=k.split(">=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const $=k.split(">");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const $=k.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const $=k.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):v.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const $=/^'([^']*)'$/.exec(k);return $?$[1].trim():k}static _deserializeRegexValue(k,M){if((0,r.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=k.indexOf("/"),q=k.lastIndexOf("/");if($===q||$<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const J=k.slice($+1,q),H=k[q+1]==="i"?"i":"";try{return new RegExp(J,H)}catch(G){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${G}`);return console.warn(`bad regexp-value '${k}', parse error: ${G}`),null}}}e.ContextKeyExpr=E;function b(O,k){const M=O?O.substituteConstants():void 0,$=k?k.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}e.expressionsAreEqualWithConstantSubstitution=b;function I(O,k){return O.cmp(k)}class w{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class p{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class v{static create(k,M=null){const $=L.get(k);return typeof $=="boolean"?$?p.INSTANCE:w.INSTANCE:new v(k,M)}constructor(k,M){this.key=k,this.negated=M,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?p.INSTANCE:w.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{static create(k,M,$=null){if(typeof M=="boolean")return M?v.create(k,$):g.create(k,$);const q=L.get(k);return typeof q=="boolean"?M===(q?"true":"false")?p.INSTANCE:w.INSTANCE:new h(k,M,$)}constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?p.INSTANCE:w.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class S{static create(k,M){return new S(k,M)}constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),$=k.getValue(this.key);return Array.isArray(M)?M.includes($):typeof $=="string"&&typeof M=="object"&&M!==null?A.call(M,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class C{static create(k,M){return new C(k,M)}constructor(k,M){this.key=k,this.valueKey=M,this.type=11,this._negated=S.create(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class m{static create(k,M,$=null){if(typeof M=="boolean")return M?g.create(k,$):v.create(k,$);const q=L.get(k);return typeof q=="boolean"?M===(q?"true":"false")?w.INSTANCE:p.INSTANCE:new m(k,M,$)}constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?w.INSTANCE:p.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class g{static create(k,M=null){const $=L.get(k);return typeof $=="boolean"?$?w.INSTANCE:p.INSTANCE:new g(k,M)}constructor(k,M){this.key=k,this.negated=M,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?w.INSTANCE:p.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function a(O,k){if(typeof O=="string"){const M=parseFloat(O);isNaN(M)||(O=M)}return typeof O=="string"||typeof O=="number"?k(O):w.INSTANCE}class f{static create(k,M,$=null){return a(M,q=>new f(k,q,$))}constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class l{static create(k,M,$=null){return a(M,q=>new l(k,q,$))}constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class i{static create(k,M,$=null){return a(M,q=>new i(k,q,$))}constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class s{static create(k,M,$=null){return a(M,q=>new s(k,q,$))}constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class t{static create(k,M){return new t(k,M)}constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return M<$?-1:M>$?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return this.key===k.key&&M===$}return!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class n{static create(k){return new n(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new n(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(O){let k=null;for(let M=0,$=O.length;M<$;M++){const q=O[M].substituteConstants();if(O[M]!==q&&k===null){k=[];for(let J=0;J<M;J++)k[J]=O[J]}k!==null&&(k[M]=q)}return k===null?O:k}class u{static create(k,M){return u._normalizeArr(k,M)}constructor(k,M){this.expr=k,this.negated=M,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const q=I(this.expr[M],k.expr[M]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:u.create(k,this.negated)}evaluate(k){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M){const $=[];let q=!1;for(const J of k)if(!!J){if(J.type===1){q=!0;continue}if(J.type===0)return w.INSTANCE;if(J.type===6){$.push(...J.expr);continue}$.push(J)}if($.length===0&&q)return p.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(I);for(let J=1;J<$.length;J++)$[J-1].equals($[J])&&($.splice(J,1),J--);if($.length===1)return $[0];for(;$.length>1;){const J=$[$.length-1];if(J.type!==9)break;$.pop();const H=$.pop(),G=$.length===0,z=c.create(J.expr.map(x=>u.create([x,H],null)),null,G);z&&($.push(z),$.sort(I))}return $.length===1?$[0]:new u($,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new u(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());this.negated=c.create(k,this,!0)}return this.negated}}class c{static create(k,M,$){return c._normalizeArr(k,M,$)}constructor(k,M){this.expr=k,this.negated=M,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const q=I(this.expr[M],k.expr[M]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:c.create(k,this.negated,!1)}evaluate(k){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,$){let q=[],J=!1;if(k){for(let H=0,G=k.length;H<G;H++){const z=k[H];if(!!z){if(z.type===0){J=!0;continue}if(z.type===1)return p.INSTANCE;if(z.type===9){q=q.concat(z.expr);continue}q.push(z)}}if(q.length===0&&J)return w.INSTANCE;q.sort(I)}if(q.length!==0){if(q.length===1)return q[0];for(let H=1;H<q.length;H++)q[H-1].equals(q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0];if($){for(let H=0;H<q.length;H++)for(let G=H+1;G<q.length;G++)F(q[H],q[G])&&(q.splice(G,1),G--);if(q.length===1)return q[0]}return new c(q,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new c(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),$=k.shift(),q=[];for(const H of T(M))for(const G of T($))q.push(u.create([H,G],null));const J=k.length===0;k.unshift(c.create(q,null,J))}this.negated=k[0]}return this.negated}}class d extends v{static all(){return d._info.values()}constructor(k,M,$){super(k,null),this._defaultValue=M,typeof $=="object"?d._info.push({...$,key:k}):$!==!0&&d._info.push({key:k,description:$,type:M!=null?typeof M:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return h.create(this.key,k)}notEqualsTo(k){return m.create(this.key,k)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(O,k){return O<k?-1:O>k?1:0}function _(O,k,M,$){return O<M?-1:O>M?1:k<$?-1:k>$?1:0}function F(O,k){if(k.type===6&&O.type!==9&&O.type!==6){for(const q of k.expr)if(O.equals(q))return!0}const M=O.negate(),$=T(M).concat(T(k));$.sort(I);for(let q=0;q<$.length;q++){const H=$[q].negate();for(let G=q+1;G<$.length;G++){const z=$[G];if(H.equals(z))return!0}}return!1}e.implies=F;function T(O){return O.type===9?O.expr:[O]}}),define(ne[92],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function r(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=r;class D{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=D}),define(ne[93],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ne[14],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,144,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function L(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(m,g){switch(m){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(m,g){return g==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function E(m,g,a){return P(g,a)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===a?!0:b(a).includes(m)}e.isTargetPlatformCompatible=E;function b(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function I(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=I;var w;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var p;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var v;(function(m){m.Install="install",m.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,r.createDecorator)("extensionGalleryService");var S;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,r.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,r.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,r.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[179],re([0,1,3,2,65,32,7,131,29]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(C,m){return A.URI.revive(m?m.transformIncoming(C):C)}function I(C,m){return m?m.transformOutgoingURI(C):C}function w(C,m){m=m||P.DefaultURITransformer;const g=C.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...C,manifest:void 0},m),manifest:g}}function p(C,m){return m?(0,L.cloneAndChange)(C,g=>g instanceof A.URI?m.transformOutgoingURI(g):void 0):C}class v{constructor(m,g){this.service=m,this.getUriTransformer=g,this.onInstallExtension=R.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,g){const a=this.getUriTransformer(m);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,f=>f.map(l=>({...l,local:l.local?p(l.local,a):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,g,a){const f=this.getUriTransformer(m);switch(g){case"zip":return this.service.zip(w(a[0],f)).then(l=>I(l,f));case"unzip":return this.service.unzip(b(a[0],f));case"install":return this.service.install(b(a[0],f),(0,D.revive)(a[1]));case"getManifest":return this.service.getManifest(b(a[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(a[0]);case"installFromGallery":return this.service.installFromGallery(a[0],(0,D.revive)(a[1]));case"uninstall":return this.service.uninstall(w(a[0],f),(0,D.revive)(a[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(w(a[0],f));case"getInstalled":return this.service.getInstalled(a[0],A.URI.revive(a[1])).then(l=>l.map(i=>p(i,f)));case"getMetadata":return this.service.getMetadata(w(a[0],f));case"updateMetadata":return this.service.updateMetadata(w(a[0],f),a[1]).then(l=>p(l,f));case"updateExtensionScope":return this.service.updateExtensionScope(w(a[0],f),a[1]).then(l=>p(l,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends r.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(m){super(),this.channel=m,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(a=>({...a,local:a.local?w(a.local,null):a.local,source:this.isUriComponents(a.source)?A.URI.revive(a.source):a.source,profileLocation:A.URI.revive(a.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:A.URI.revive(g.profileLocation)})))}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const g=await this.getTargetPlatform();return m.allTargetPlatforms.some(a=>(0,E.isTargetPlatformCompatible)(a,m.allTargetPlatforms,g))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(g=>A.URI.revive(g)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,g){return Promise.resolve(this.channel.call("install",[m,g])).then(a=>w(a,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,g){return Promise.resolve(this.channel.call("installFromGallery",[m,g])).then(a=>w(a,null))}uninstall(m,g){return Promise.resolve(this.channel.call("uninstall",[m,g]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null,g){return Promise.resolve(this.channel.call("getInstalled",[m,g])).then(a=>a.map(f=>w(f,null)))}getMetadata(m){return Promise.resolve(this.channel.call("getMetadata",[m]))}updateMetadata(m,g){return Promise.resolve(this.channel.call("updateMetadata",[m,g])).then(a=>w(a,null))}updateExtensionScope(m,g){return Promise.resolve(this.channel.call("updateExtensionScope",[m,g])).then(a=>w(a,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class S{constructor(m){this.service=m}listen(m,g){throw new Error("Invalid listen")}call(m,g,a){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(a[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[94],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var r;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(r=e.RecommendationSource||(e.RecommendationSource={}));function D(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,27,15,7,152,5]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function b(H){return H.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var w;(function(H){H[H.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var p;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=v;function h(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=S;function C(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function g(H){return v(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(G,z){super(G),this.code=z}}e.FileSystemProviderError=f;function l(H,G){const z=new f(H.toString(),G);return s(z,G),z}e.createFileSystemProviderError=l;function i(H){return H||l((0,P.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=i;function s(H,G){return H.name=G?`${G} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=s;function t(H){if(!H)return a.Unknown;if(H instanceof f)return H.code;const G=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!G)return a.Unknown;switch(G[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=t;function n(H){if(H instanceof _)return H.fileOperationResult;switch(t(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class u{constructor(G,z,x){this.resource=G,this.operation=z,this.target=x}isOperation(G){return this.operation===G}}e.FileOperationEvent=u;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class d{constructor(G,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const x=new Map;for(const Y of G){const te=x.get(Y.type);switch(te?te.push([Y.resource,Y]):x.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,te]of x)switch(Y){case 1:this.added=R.TernarySearchTree.forUris(()=>z),this.added.fill(te);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>z),this.updated.fill(te);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>z),this.deleted.fill(te);break}}contains(G,...z){return this.doContains(G,{includeChildren:!1},...z)}affects(G,...z){return this.doContains(G,{includeChildren:!0},...z)}doContains(G,z,...x){if(!G)return!1;const Y=x.length>0;return!!((!Y||x.includes(1))&&(this.added?.get(G)||z.includeChildren&&this.added?.findSuperstr(G))||(!Y||x.includes(0))&&(this.updated?.get(G)||z.includeChildren&&this.updated?.findSuperstr(G))||(!Y||x.includes(2))&&(this.deleted?.findSubstr(G)||z.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function y(H,G,z){return!H||!G||H===G||G.length>H.length?!1:(G.charAt(G.length-1)!==r.sep&&(G+=r.sep),z?(0,D.startsWithIgnoreCase)(H,G):H.indexOf(G)===0)}e.isParent=y;class _ extends Error{constructor(G,z,x){super(G),this.fileOperationResult=z,this.options=x}}e.FileOperationError=_;class F extends _{constructor(G,z,x){super(G,2,x),this.stat=z}}e.NotModifiedSinceFileOperationError=F;var T;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=k;async function M(H,G){if(!G.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(z=>{const x=G.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===H.scheme&&Y.added&&(x.dispose(),z())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(G){return(0,L.isNumber)(G)||(G=0),G<$.KB?(0,P.localize)(1,null,G.toFixed(0)):G<$.MB?(0,P.localize)(2,null,(G/$.KB).toFixed(2)):G<$.GB?(0,P.localize)(3,null,(G/$.MB).toFixed(2)):G<$.TB?(0,P.localize)(4,null,(G/$.GB).toFixed(2)):(0,P.localize)(5,null,(G/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var q;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function J(H){return{maxFileSize:H===0?300*$.MB:16*$.GB,maxHeapSize:H===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=J});var K=this&&this.__param||function(Q,e){return function(R,r){e(R,r,Q)}};define(ne[180],re([0,1,95,42,13]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const E=(await this.fileService.readFileStream(P)).value;return new Promise((b,I)=>{const w=(0,R.createHash)("md5");(0,r.listenStream)(E,{onData:p=>w.update(p.buffer),onError:p=>I(p),onEnd:()=>b(w.digest("base64").replace(/=+$/,""))})})}};L=pe([K(0,D.IFileService)],L),e.ChecksumService=L}),define(ne[181],re([0,1,16,38,9,3,2,42,7,30,13]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends A.Disposable{constructor(v,h){super(),this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:S}=await this.channel.call("readFile",[v,h]);return S}readFileStream(v,h,S){const C=(0,P.newWriteableStream)(g=>R.VSBuffer.concat(g.map(a=>R.VSBuffer.wrap(a))).buffer),m=this.channel.listen("readFileStream",[v,h])(g=>{if(g instanceof R.VSBuffer)C.write(g.buffer);else{if(g==="end")C.end();else{let a=g;a instanceof Error||(a=(0,I.createFileSystemProviderError)((0,r.toErrorMessage)(a),I.FileSystemProviderErrorCode.Unknown)),C.error(a),C.end()}m.dispose()}});return S.onCancellationRequested(()=>{C.error((0,D.canceled)()),C.end(),m.dispose()}),C}writeFile(v,h,S){return this.channel.call("writeFile",[v,R.VSBuffer.wrap(h),S])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,S,C,m){const[g,a]=await this.channel.call("read",[v,h,m]);return S.set(g.buffer.slice(0,a),C),a}write(v,h,S,C,m){return this.channel.call("write",[v,h,R.VSBuffer.wrap(S),C,m])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,S){return this.channel.call("rename",[v,h,S])}copy(v,h,S){return this.channel.call("copy",[v,h,S])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(S=>({resource:E.URI.revive(S.resource),type:S.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const S=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,S,v,h]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=w}),define(ne[96],re([0,1,16,9,153,13]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(I,w,p,v,h,S){let C;try{await P(I,w,p,v,h,S)}catch(m){C=m}finally{C&&h.errorTransformer&&(C=h.errorTransformer(C)),typeof C<"u"&&p.error(C),p.end()}}e.readFileIntoStream=A;async function P(I,w,p,v,h,S){E(S);const C=await I.open(w,{create:!1});try{E(S);let m=0,g=0,a=h&&typeof h.length=="number"?h.length:void 0,f=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,i=0;do g=await I.read(C,l,f.buffer,i,f.byteLength-i),l+=g,i+=g,m+=g,typeof a=="number"&&(a-=g),i===f.byteLength&&(await p.write(v(f)),f=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),i=0);while(g>0&&(typeof a!="number"||a>0)&&E(S)&&b(m,h));if(i>0){let s=i;typeof a=="number"&&(s=Math.min(i,a)),p.write(v(f.slice(0,s)))}}catch(m){throw(0,L.ensureFileSystemProviderError)(m)}finally{await I.close(C)}}function E(I){if(I.isCancellationRequested)throw(0,r.canceled)();return!0}function b(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,L.createFileSystemProviderError)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,L.createFileSystemProviderError)((0,D.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,85,2,12,4,7,13]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(m){return m.recursive===!0}e.isRecursiveWatchRequest=E;class b extends r.Disposable{constructor(g,a,f,l){super(),this.onFileChanges=g,this.onLogMessage=a,this.verboseLogging=f,this.options=l,this.watcherDisposables=this._register(new r.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new r.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),g.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),g.add(this.watcher.onDidError(a=>this.onError(a)))}onError(g){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class I extends b{constructor(g,a,f){super(g,a,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class w extends b{constructor(g,a,f){super(g,a,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function p(m){return m.map(g=>({type:g.type,resource:A.URI.file(g.path)}))}e.toFileChanges=p;function v(m){const g=new C;for(const a of m)g.processEvent(a);return g.coalesce()}e.coalesceEvents=v;function h(m,g){return typeof g=="string"&&!g.startsWith(R.GLOBSTAR)&&!(0,D.isAbsolute)(g)?{base:m,pattern:g}:g}e.normalizeWatcherPattern=h;function S(m,g){const a=[];for(const f of g)a.push((0,R.parse)(h(m,f)));return a}e.parseWatcherPatterns=S;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return L.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const a=this.mapPathToChange.get(this.toKey(g));let f=!1;if(a){const l=a.type,i=g.type;a.path!==g.path&&(g.type===2||g.type===1)?f=!0:l===1&&i===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(a)):l===2&&i===1?a.type=0:l===1&&i===0||(a.type=i)}else f=!0;f&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],a=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,l)=>f.path.length-l.path.length).filter(f=>a.some(l=>(0,P.isParent)(f.path,l,!L.isLinux))?!1:(a.push(f.path),!0)).concat(g)}}}),define(ne[182],re([0,1,53,6,24,47,2,83,12,4,133,28,57]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends A.Disposable{constructor(C,m,g,a){super(),this.request=C,this.onDidFilesChange=m,this.onLogMessage=g,this.verboseLogging=a,this.throttledFileChangesWorker=new r.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new r.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await w.Promises.stat(C);this._register(await this.doWatch(C,m.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let m=C.path;try{m=await w.Promises.realpath(C.path),C.path===m&&(m=await(0,I.realcase)(C.path)??C.path),C.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${m})`)}catch{}return m}async doWatch(C,m){if(b.isMacintosh&&(0,L.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const g=new D.CancellationTokenSource(this.cts.token),a=new A.DisposableStore;try{const f=(0,E.basename)(C),l=(0,R.watch)(C);a.add((0,A.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${C}'`);const i=new Set;if(m)try{for(const t of await w.Promises.readdir(C))i.add(t)}catch(t){this.error(t)}const s=new Map;a.add((0,A.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),l.on("error",(t,n)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),l.on("change",(t,n)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${n}`);let o="";if(n&&(o=n.toString(),b.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(m)if(t==="rename"){s.get(o)?.dispose();const u=setTimeout(async()=>{if(s.delete(o),o===f&&!await w.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,E.join)(C,o));if(g.token.isCancellationRequested)return;let d;c?i.has(o)?d=0:(d=1,i.add(o)):(i.delete(o),d=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:d})},v.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,A.toDisposable)(()=>clearTimeout(u)))}else{let u;i.has(o)?u=0:(u=1,i.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:u})}else if(t==="rename"||o!==f){const u=setTimeout(async()=>{const c=await w.Promises.exists(C);g.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),a.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,A.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await w.Promises.exists(C)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{g.dispose(!0),a.dispose()})}async onFileChange(C,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!m&&this.excludes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const a=(0,p.coalesceEvents)(g);if(a.length>0){if(this.verboseLogging)for(const l of a)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(a)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(b.isLinux)return w.Promises.exists(C);try{const m=(0,E.basename)(C);return(await w.Promises.readdir((0,E.dirname)(C))).some(a=>a===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(S,C,m,g,a=512){const f=await w.Promises.open(S,"r"),l=Buffer.allocUnsafe(a),i=new D.CancellationTokenSource(g);let s,t=!1;const n={path:S,excludes:[],recursive:!1},o=new v(n,u=>{(async()=>{for(const{type:c}of u)if(c===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:d}=await w.Promises.read(f,l,0,a,null);if(!d||i.token.isCancellationRequested)break;C(l.slice(0,d))}}catch(d){s=new Error(d),i.dispose(!0)}finally{t=!1}}})()});return await o.ready,m(),new Promise((u,c)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await w.Promises.close(f)}catch(d){s=new Error(d)}s?c(s):u()})})}e.watchFileContents=h}),define(ne[183],re([0,1,3,85,2,4,182]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const I=this.normalizeRequests(b),w=I.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,r.patternsEquals)(h.request.excludes,v.excludes)||!(0,r.patternsEquals)(h.request.includes,v.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:v})=>!I.find(h=>h.path===v.path&&(0,r.patternsEquals)(h.excludes,v.excludes)&&(0,r.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);w.length&&this.trace(`Request to start watching: ${w.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const v of p)this.stopWatching(v);for(const v of w)this.startWatching(v)}startWatching(b){const I=new A.NodeJSFileWatcherLibrary(b,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),w={request:b,instance:I};this.watchers.set(b.path,w)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const I=this.watchers.get(b);I&&(this.watchers.delete(b),I.instance.dispose())}normalizeRequests(b){const I=new Map;for(const w of b){const p=L.isLinux?w.path:w.path.toLowerCase();I.set(p,w)}return Array.from(I.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,I]of this.watchers)I.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,I){return I?`[File Watcher (node.js)] ${b} (path: ${I.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=P}),define(ne[184],re([0,1,57,183]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends R.AbstractNonRecursiveWatcherClient{constructor(A,P,E){super(A,P,E),this.init()}createWatcher(){return new r.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ne[185],re([0,1,22,39,66,57]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(E,b,I){super(E,b,I),this.init()}createWatcher(E){const b=E.add(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:I,signal:w})=>this.onError(`terminated by itself with code ${I}, signal: ${w}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[97],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(const[L,A]of D)this.set(L,A)}set(D,L){const A=this._entries.get(D);return this._entries.set(D,L),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(ne[186],re([0,1,6,9,56,176,5,97]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,S=!1,C,m=E){this._services=h,this._strict=S,this._parent=C,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=m?C?._globalGraph??new L.Graph(g=>g):void 0}createChild(h){return new I(h,this._strict,this,this._enableTracing)}invokeFunction(h,...S){const C=p.traceInvocation(this._enableTracing,h);let m=!1;try{return h({get:a=>{if(m)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(a,C);if(!f)throw new Error(`[invokeFunction] unknown service '${a}'`);return f}},...S)}finally{m=!0,C.stop()}}createInstance(h,...S){let C,m;return h instanceof D.SyncDescriptor?(C=p.traceCreation(this._enableTracing,h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(S),C)):(C=p.traceCreation(this._enableTracing,h),m=this._createInstance(h,S,C)),C.stop(),m}_createInstance(h,S=[],C){const m=A._util.getServiceDependencies(h).sort((f,l)=>f.index-l.index),g=[];for(const f of m){const l=this._getOrCreateServiceInstance(f.id,C);l||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${f.id}.`,!1),g.push(l)}const a=m.length>0?m[0].index:S.length;if(S.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${S.length} static arguments`);const f=a-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,a)}return new h(...S,...g)}_setServiceInstance(h,S){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const C=this._getServiceInstanceOrDescriptor(h);return C instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,C,S.branch(h,!0)):(S.branch(h,!1),C)}_safeCreateAndCacheServiceInstance(h,S,C){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,C)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,C){const m=new L.Graph(f=>f.id.toString());let g=0;const a=[{id:h,desc:S,_trace:C}];for(;a.length;){const f=a.pop();if(m.lookupOrInsertNode(f),g++>1e3)throw new b(m);for(const l of A._util.getServiceDependencies(f.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(l.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(f.id),String(l.id)),i instanceof D.SyncDescriptor){const s={id:l.id,desc:i,_trace:f._trace.branch(l.id,!0)};m.insertEdge(f,s),a.push(s)}}}for(;;){const f=m.roots();if(f.length===0){if(!m.isEmpty())throw new b(m);break}for(const{data:l}of f){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,C=[],m,g){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(h,S,C,m,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,C,m,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S,C=[],m,g){if(m){const a=new I(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(h);const f=new R.IdleValue(()=>a._createInstance(S,C,g));return new Proxy(Object.create(null),{get(l,i){if(i in l)return l[i];const s=f.value;let t=s[i];return typeof t!="function"||(t=t.bind(s),l[i]=t),t},set(l,i,s){return f.value[i]=s,!0}})}else return this._createInstance(S,C,g)}_throwIfStrict(h,S){if(S&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=I;var w;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(w||(w={}));class p{static traceInvocation(h,S){return h?new p(1,S.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(h,S){return h?new p(0,S.name):p._None}constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}branch(h,S){const C=new p(2,h.toString());return this._dep.push([h,S,C]),C}stop(){const h=Date.now()-this._start;p._totals+=h;let S=!1;function C(g,a){const f=[],l=new Array(g+1).join("	");for(const[i,s,t]of a._dep)if(s&&t){S=!0,f.push(`${l}CREATES -> ${i}`);const n=C(g+1,t);n&&f.push(n)}else f.push(`${l}uses -> ${i}`);return f.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(h>2||S)&&p.all.add(m.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ne[187],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,L){this.server=D,this.router=L}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,L){this.server.registerChannel(D,L)}}e.MessagePortMainProcessService=R}),define(ne[58],re([0,1,39,56,91,5]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(v,h,S,C){const m=S.getChannel(v);return P(h)?C.createInstance(new r.SyncDescriptor(h.channelClientCtor,[m])):R.ProxyChannel.toService(m,h?.proxyOptions)}}function P(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let E=class extends A{constructor(v,h,S,C){super(v,h,S,C)}};E=pe([K(2,e.IMainProcessService),K(3,L.IInstantiationService)],E);function b(p,v,h){(0,D.registerSingleton)(p,new r.SyncDescriptor(E,[v,h],!0))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends A{constructor(v,h,S,C){super(v,h,S,C)}};I=pe([K(2,e.ISharedProcessService),K(3,L.IInstantiationService)],I);function w(p,v,h){(0,D.registerSingleton)(p,new r.SyncDescriptor(I,[v,h],!0))}e.registerSharedProcessRemoteService=w}),define(ne[69],re([0,1,24,2,4,155,29,5]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let E=class extends r.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new R.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const v=w.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(S=>S.startsWith("lp-"))).map(h=>{const S=h.properties.localizedLanguages?.[0],C=this.getLocale(h);return{...this.createQuickPickItem(C,S,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(I){return I.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I,w,p){const v=w??I;let h;if(v!==I&&(h=`(${I})`),I.toLowerCase()===D.language.toLowerCase()&&(h??="",h+=(0,L.localize)(0,null)),p?.installCount){h??="";const S=p.installCount;let C;S>1e6?C=`${Math.floor(S/1e5)/10}M`:S>1e3?C=`${Math.floor(S/1e3)}K`:C=String(S),h+=` $(cloud-download) ${C}`}return{id:I,label:v,description:h}}};E=pe([K(0,A.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(ne[188],re([0,1,2,69]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(A){super(),this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=pe([K(0,r.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(ne[8],re([0,1,38,3,2,4,5]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var E;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(s,t,n){switch(t){case E.Trace:s.trace(n);break;case E.Debug:s.debug(n);break;case E.Info:s.info(n);break;case E.Warning:s.warn(n);break;case E.Error:s.error(n);break;case E.Critical:s.critical(n);break;default:throw new Error("Invalid log level")}}e.log=b;function I(s){let t="";for(let n=0;n<s.length;n++){let o=s[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(n>0?" ":"")+o}return t}e.format=I;class w extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class p extends w{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,I([t,...n]))}debug(t,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,I([t,...n]))}info(t,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,I([t,...n]))}warn(t,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,I([t,...n]))}error(t,...n){if(this.checkLogLevel(E.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(E.Error,I(o))}else this.log(E.Error,I([t,...n]))}critical(t,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,I([t,...n]))}flush(){}}e.AbstractMessageLogger=p;class v extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!L.isWindows}trace(t,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class S extends w{constructor(t,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class C extends w{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=C;class m extends D.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=m;class g extends D.Disposable{constructor(t,n){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,n?.always?E.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class a{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=a;function f(s){if(s.verbose)return E.Trace;if(typeof s.logLevel=="string"){const t=l(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function l(s){switch(s){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=l;function i(s){switch(s){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=i}),define(ne[189],re([0,1,6,9,2,12,28,14,8]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(w,p){super(),this.environmentService=w,this.logService=p,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,L.basename)(this.environmentService.logsPath),p=(0,L.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(p)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==w),C=S.slice(0,Math.max(0,S.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(m=>A.Promises.rm((0,L.join)(p,m)))))}catch(w){(0,r.onUnexpectedError)(w)}}};b=pe([K(0,P.IEnvironmentService),K(1,E.ILogService)],b),e.LogsDataCleaner=b}),define(ne[190],re([0,1,19,6,9,3,2,12,57,8]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends A.Disposable{constructor(p,v){super(),this.logService=p,this.options=v,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new r.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(p,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,v):this.watchNonRecursive(p,v)}watchUniversal(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:v.recursive},S=(0,R.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,D.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,E.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&p.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:!1},S=(0,R.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,D.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,E.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[191],re([0,1,19,6,16,24,3,64,52,2,34,22,192,17,42,151,13,96,8]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends b.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(l,i){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${l}`);const s=new b.DisposableStore;return this.provider.set(l,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:i}),s.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new C.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&s.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:l}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:i}),this.provider.delete(l),(0,b.dispose)(s)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(s){i.push(s)}}),!this.provider.has(l)&&await r.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,i){const s=this.provider.get(l.scheme);return!!(s&&s.capabilities&i)}listCapabilities(){return E.Iterable.map(this.provider,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async withProvider(l){if(!(0,v.isAbsolutePath)(l))throw new C.FileOperationError((0,S.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const i=this.provider.get(l.scheme);if(!i){const s=new Error;throw s.name="ENOPRO",s.message=(0,S.localize)(1,null,l.toString()),s}return i}async withReadProvider(l){const i=await this.withProvider(l);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i)||(0,C.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const i=await this.withProvider(l);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.doResolveFile(l,i)}catch(s){throw(0,C.toFileSystemProviderErrorCode)(s)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,S.localize)(2,null,this.resourceForError(l)),1):(0,C.ensureFileSystemProviderError)(s)}}async doResolveFile(l,i){const s=await this.withProvider(l),t=this.isPathCaseSensitive(s),n=i?.resolveTo,o=i?.resolveSingleChildDescendants,u=i?.resolveMetadata,c=await s.stat(l);let d;return this.toFileStat(s,l,c,void 0,!!u,(y,_)=>(d||(d=I.TernarySearchTree.forUris(()=>!t),d.set(l,!0),n&&d.fill(!0,n)),d.get(y.resource)||d.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&o?_===1:!1))}async toFileStat(l,i,s,t,n,o){const{providerExtUri:u}=this.getExtUri(l),c={resource:i,name:u.basename(i),isFile:(s.type&C.FileType.File)!==0,isDirectory:(s.type&C.FileType.Directory)!==0,isSymbolicLink:(s.type&C.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&C.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,C.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(c.isDirectory&&o(c,t)){try{const d=await l.readdir(i),y=await r.Promises.settled(d.map(async([_,F])=>{try{const T=u.joinPath(i,_),O=n?await l.stat(T):{type:F};return await this.toFileStat(l,T,O,d.length,n,o)}catch(T){return this.logService.trace(T),null}}));c.children=(0,R.coalesce)(y)}catch(d){this.logService.trace(d),c.children=[]}return c}return c}async resolveAll(l){return r.Promises.settled(l.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(l){const i=await this.withProvider(l),s=await i.stat(l);return this.toFileStat(i,l,s,void 0,!0,()=>!1)}async exists(l){const i=await this.withProvider(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.doValidateCreateFile(l,i)}catch(s){return s}return!0}async doValidateCreateFile(l,i){if(!i?.overwrite&&await this.exists(l))throw new C.FileOperationError((0,S.localize)(3,null,this.resourceForError(l)),3,i)}async createFile(l,i=D.VSBuffer.fromString(""),s){await this.doValidateCreateFile(l,s);const t=await this.writeFile(l,i);return this._onDidRunOperation.fire(new C.FileOperationEvent(l,0,t)),t}async writeFile(l,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,l,s)||await this.mkdirp(t,n.dirname(l));let u;if((0,C.hasReadWriteCapability)(t)&&!(i instanceof D.VSBuffer))if((0,h.isReadableStream)(i)){const c=await(0,h.peekStream)(i,3);c.ended?u=D.VSBuffer.concat(c.buffer):u=c}else u=(0,h.peekReadable)(i,c=>D.VSBuffer.concat(c),3);else u=i;!(0,C.hasOpenReadWriteCloseCapability)(t)||(0,C.hasReadWriteCapability)(t)&&u instanceof D.VSBuffer?await this.doWriteUnbuffered(t,l,s,u):await this.doWriteBuffered(t,l,s,u instanceof D.VSBuffer?(0,D.bufferToReadable)(u):u),this._onDidRunOperation.fire(new C.FileOperationEvent(l,4))}catch(o){throw new C.FileOperationError((0,S.localize)(4,null,this.resourceForError(l),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),s)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,i,s){if(!!s?.unlock&&!(l.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(i)));let n;try{n=await l.stat(i)}catch{return}if((n.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,S.localize)(6,null,this.resourceForError(i)),0,s);if(this.throwIfFileIsReadonly(i,n),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==C.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&s.mtime<n.mtime&&s.etag!==(0,C.etag)({mtime:s.mtime,size:n.size}))throw new C.FileOperationError((0,S.localize)(7,null),3,s);return n}async readFile(l,i,s){const t=await this.withReadProvider(l);return i?.atomic?this.doReadFileAtomic(t,l,i,s):this.doReadFile(t,l,i,s)}async doReadFileAtomic(l,i,s,t){return new Promise((n,o)=>{this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(l,i,s,t);n(u)}catch(u){o(u)}})})}async doReadFile(l,i,s,t){const n=await this.doReadFileStream(l,i,{...s,preferUnbuffered:!0},t);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(l,i,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,i,s)}async doReadFileStream(l,i,s,t){const n=new L.CancellationTokenSource(t),o=this.validateReadFile(i,s).then(c=>c,c=>{throw n.cancel(),c});let u;try{return typeof s?.etag=="string"&&s.etag!==C.ETAG_DISABLED&&await o,s?.atomic&&(0,C.hasFileAtomicReadCapability)(l)||!((0,C.hasOpenReadWriteCloseCapability)(l)||(0,C.hasFileReadStreamCapability)(l))||(0,C.hasReadWriteCapability)(l)&&s?.preferUnbuffered?u=this.readFileUnbuffered(l,i,s):(0,C.hasFileReadStreamCapability)(l)?u=this.readFileStreamed(l,i,n.token,s):u=this.readFileBuffered(l,i,n.token,s),{...await o,value:u}}catch(c){u&&await(0,h.consumeStream)(u);const d=(0,S.localize)(8,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(c).toString());throw c instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(d,c.stat,s):new C.FileOperationError(d,(0,C.toFileOperationResult)(c),s)}}readFileStreamed(l,i,s,t=Object.create(null)){const n=l.readFileStream(i,t,s);return(0,h.transform)(n,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new C.FileOperationError((0,S.localize)(9,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},o=>D.VSBuffer.concat(o))}readFileBuffered(l,i,s,t=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,m.readFileIntoStream)(l,i,n,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new C.FileOperationError((0,S.localize)(10,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},s),n}readFileUnbuffered(l,i,s){const t=(0,h.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n;s?.atomic&&(0,C.hasFileAtomicReadCapability)(l)?n=await l.readFile(i,{atomic:!0}):n=await l.readFile(i),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(i,n.byteLength,s),t.end(D.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(l,i){const s=await this.resolve(l,{resolveMetadata:!0});if(s.isDirectory)throw new C.FileOperationError((0,S.localize)(11,null,this.resourceForError(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==C.ETAG_DISABLED&&i.etag===s.etag)throw new C.NotModifiedSinceFileOperationError((0,S.localize)(12,null),s,i);return this.validateReadFileLimits(l,s.size,i),s}validateReadFileLimits(l,i,s){if(s?.limits){let t;if(typeof s.limits.memory=="number"&&i>s.limits.memory&&(t=9),typeof s.limits.size=="number"&&i>s.limits.size&&(t=7),typeof t=="number")throw new C.FileOperationError((0,S.localize)(13,null,this.resourceForError(l)),t)}}async canMove(l,i,s){return this.doCanMoveCopy(l,i,"move",s)}async canCopy(l,i,s){return this.doCanMoveCopy(l,i,"copy",s)}async doCanMoveCopy(l,i,s,t){if(l.toString()!==i.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,l,o,i,s,t)}catch(n){return n}return!0}async move(l,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,l,n,i,"move",!!s),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(l,o==="move"?2:3,u)),u}async copy(l,i,s){const t=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,l,n,i,"copy",!!s),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(l,o==="copy"?3:2,u)),u}async doMoveCopy(l,i,s,t,n,o){if(i.toString()===t.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,i,s,t,n,o);if(u&&!c&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),n==="copy"){if(l===s&&(0,C.hasFileFolderCopyCapability)(l))await l.copy(i,t,{overwrite:o});else{const d=await this.resolve(i);d.isDirectory?await this.doCopyFolder(l,d,s,t):await this.doCopyFile(l,i,s,t)}return n}else return l===s?(await l.rename(i,t,{overwrite:o}),n):(await this.doMoveCopy(l,i,s,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(l,i,s,t){if((0,C.hasOpenReadWriteCloseCapability)(l)&&(0,C.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(l,i,s,t);if((0,C.hasOpenReadWriteCloseCapability)(l)&&(0,C.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(l,i,s,t);if((0,C.hasReadWriteCapability)(l)&&(0,C.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(l,i,s,t);if((0,C.hasReadWriteCapability)(l)&&(0,C.hasReadWriteCapability)(s))return this.doPipeUnbuffered(l,i,s,t)}async doCopyFolder(l,i,s,t){await s.mkdir(t),Array.isArray(i.children)&&await r.Promises.settled(i.children.map(async n=>{const o=this.getExtUri(s).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),s,o):this.doCopyFile(l,n.resource,s,o)}))}async doValidateMoveCopy(l,i,s,t,n,o){let u=!1;if(l===s){const{providerExtUri:d,isPathCaseSensitive:y}=this.getExtUri(l);if(y||(u=d.isEqual(i,t)),u&&n==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!u&&d.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const c=await this.exists(t);if(c&&!u){if(!o)throw new C.FileOperationError((0,S.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(l===s){const{providerExtUri:d}=this.getExtUri(l);if(d.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:c,isSameResourceWithDifferentPathCase:u}}getExtUri(l){const i=this.isPathCaseSensitive(l);return{providerExtUri:i?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(i,l);const s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(l,0,s)),s}async mkdirp(l,i){const s=[],{providerExtUri:t}=this.getExtUri(l);for(;!t.isEqual(i,t.dirname(i));)try{if(((await l.stat(i)).type&C.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,C.toFileSystemProviderErrorCode)(n)!==C.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(t.basename(i)),i=t.dirname(i)}for(let n=s.length-1;n>=0;n--){i=t.joinPath(i,s[n]);try{await l.mkdir(i)}catch(o){if((0,C.toFileSystemProviderErrorCode)(o)!==C.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,i){try{await this.doValidateDelete(l,i)}catch(s){return s}return!0}async doValidateDelete(l,i){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!i?.useTrash&&!(s.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(l)));let n;try{n=await s.stat(l)}catch{}if(n)this.throwIfFileIsReadonly(l,n);else throw new C.FileOperationError((0,S.localize)(20,null,this.resourceForError(l)),1);if(!!!i?.recursive){const u=await this.resolve(l);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(l)))}return s}async del(l,i){const s=await this.doValidateDelete(l,i),t=!!i?.useTrash,n=!!i?.recursive;await s.delete(l,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new C.FileOperationEvent(l,1))}async cloneFile(l,i){const s=await this.withProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(s===t&&this.getExtUri(s).providerExtUri.isEqual(l,i))return;if(s===t&&(0,C.hasFileCloneCapability)(s))return s.cloneFile(l,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const n=this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri);return s===t&&(0,C.hasFileFolderCopyCapability)(s)?n.queue(()=>s.copy(l,i,{overwrite:!0})):n.queue(()=>this.doCopyFile(s,l,t,i))}watch(l,i={recursive:!1,excludes:[]}){const s=new b.DisposableStore;let t=!1,n=()=>{t=!0};return s.add((0,b.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(l,i);t?(0,b.dispose)(o):n=()=>(0,b.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(l,i){const s=await this.withProvider(l),t=(0,P.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(l),i]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:s.watch(l,i)},this.activeWatchers.set(t,n)),n.count+=1,(0,b.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,b.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{const n=await l.open(i,{create:!0,unlock:s?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(l,n,t):await this.doWriteReadableBufferedQueued(l,n,t)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await l.close(n)}})}async doWriteStreamBufferedQueued(l,i,s){let t=0,n;if((0,h.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=D.VSBuffer.concat(s.buffer);await this.doWriteBuffer(l,i,o,o.byteLength,t,0),t+=o.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((o,u)=>{(0,h.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(l,i,c,c.byteLength,t,0)}catch(d){return u(d)}t+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>u(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,i,s){let t=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(l,i,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(l,i,s,t,n,o){let u=0;for(;u<t;)u+=await l.write(i,n+u,s.buffer,o+u,t-u)}async doWriteUnbuffered(l,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,i,s,t))}async doWriteUnbufferedQueued(l,i,s,t){let n;t instanceof D.VSBuffer?n=t:(0,h.isReadableStream)(t)?n=await(0,D.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?n=await(0,D.bufferedStreamToBuffer)(t):n=(0,D.readableToBuffer)(t),await l.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,i,s,t))}async doPipeBufferedQueued(l,i,s,t){let n,o;try{n=await l.open(i,{create:!1}),o=await s.open(t,{create:!0,unlock:!1});const u=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,d=0,y=0;do y=await l.read(n,c,u.buffer,d,u.byteLength-d),await this.doWriteBuffer(s,o,u,y,c,d),c+=y,d+=y,d===u.byteLength&&(d=0);while(y>0)}catch(u){throw(0,C.ensureFileSystemProviderError)(u)}finally{await r.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,i,s,t))}async doPipeUnbufferedQueued(l,i,s,t){return s.writeFile(t,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,i,s,t))}async doPipeUnbufferedToBufferedQueued(l,i,s,t){const n=await s.open(t,{create:!0,unlock:!1});try{const o=await l.readFile(i);await this.doWriteBuffer(s,n,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(l,i,s,t){const n=await(0,D.streamToBuffer)(this.readFileBuffered(l,i,L.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,n)}throwIfFileSystemIsReadonly(l,i){if(l.capabilities&2048)throw new C.FileOperationError((0,S.localize)(22,null,this.resourceForError(i)),6);return l}throwIfFileIsReadonly(l,i){if((i.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,S.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===w.Schemas.file?l.fsPath:l.toString(!0)}};a=pe([K(0,g.ILogService)],a),e.FileService=a}),define(ne[193],re([0,1,53,278,6,34,16,3,47,2,12,4,17,42,28,154,13,96,190,38,185,184]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(R)}catch(s){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(s)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await h.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async u=>{try{let c;u.isSymbolicLink()?c=(await this.stat((0,p.joinPath)(t,u.name))).type:c=this.toType(u),o.push([u.name,c])}catch(c){this.logService.trace(c)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let o;return n?.dangling?o=C.FileType.Unknown:t.isFile()?o=C.FileType.File:t.isDirectory()?o=C.FileType.Directory:o=C.FileType.Unknown,n&&(o|=C.FileType.SymbolicLink),o}async createResourceLock(t){const n=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const u=new D.Barrier;return this.resourceLocks.set(t,u),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===u&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(t,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const u=this.toFilePath(t);return await h.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}readFileStream(t,n,o){const u=(0,v.newWriteableStream)(c=>A.VSBuffer.concat(c.map(d=>A.VSBuffer.wrap(d))).buffer);return(0,m.readFileIntoStream)(this,t,u,c=>c.buffer,{...n,bufferSize:256*1024},o),u}async writeFile(t,n,o){let u;try{const c=this.toFilePath(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(c)){if(!o.overwrite)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,n,0,n.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(t,c)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n){const o=this.toFilePath(t);let u;(0,C.isFileOpenForWriteOptions)(n)&&(u=await this.createResourceLock(t));let c;try{if((0,C.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:y}=await h.SymlinkSupport.stat(o);y.mode&128||await h.Promises.chmod(o,y.mode|128)}catch(y){this.logService.trace(y)}let d;if((0,C.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await h.Promises.truncate(o,0),d="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}d||(d="w")}else d="r";c=await h.Promises.open(o,d)}catch(d){throw u?.dispose(),(0,C.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(c,0),(0,C.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(c,t),u){const d=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${o})`),this.mapHandleToLock.set(c,u),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${o})`),d.dispose())}return c}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await h.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await h.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,o,u,c){const d=this.normalizePos(t,n);let y=null;try{y=(await h.Promises.read(t,o,u,c,d)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(t,d,y)}return y}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,o){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,u+o):this.mapHandleToPos.delete(t)))}async write(t,n,o,u,c){return(0,D.retry)(()=>this.doWrite(t,n,o,u,c),100,3)}async doWrite(t,n,o,u,c){const d=this.normalizePos(t,n);let y=null;try{y=(await h.Promises.write(t,o,u,c,d)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),_)}finally{this.updatePos(t,d,y)}return y}async mkdir(t){try{await h.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const o=this.toFilePath(t);n.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,n,o){const u=this.toFilePath(t),c=this.toFilePath(n);if(u!==c)try{await this.validateTargetDeleted(t,n,"move",o.overwrite),await h.Promises.move(u,c)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(2,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(c)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(t,n,o){const u=this.toFilePath(t),c=this.toFilePath(n);if(u!==c)try{await this.validateTargetDeleted(t,n,"copy",o.overwrite),await h.Promises.copy(u,c,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(3,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(c)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(t,n,o,u){const c=this.toFilePath(t),d=this.toFilePath(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,E.isEqual)(c,d,!0)),y&&o==="copy")throw(0,C.createFileSystemProviderError)((0,S.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!y&&await h.Promises.exists(d)){if(!u)throw(0,C.createFileSystemProviderError)((0,S.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,o){const u=this.toFilePath(t),c=this.toFilePath(n),d=!!(this.capabilities&1024);if((0,E.isEqual)(u,c,!d))return;const y=new b.DisposableStore;try{const[_,F]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);y.add(_),y.add(F),o&&await h.Promises.mkdir((0,I.dirname)(c),{recursive:!0}),await h.Promises.copyFile(u,c)}catch(_){if(_.code==="ENOENT"&&!o)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(_)}finally{y.dispose()}}createUniversalWatcher(t,n,o){return new f.UniversalWatcherClient(u=>t(u),u=>n(u),o)}createNonRecursiveWatcher(t,n,o){return new l.NodeJSWatcherClient(u=>t(u),u=>n(u),o)}toFileSystemProviderError(t){if(t instanceof C.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=C.FileSystemProviderErrorCode.NoPermissions;break;default:n=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let o=this.toFileSystemProviderError(n);if(t&&o.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await h.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(o=(0,C.createFileSystemProviderError)(n,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(ne[98],re([0,1,3,7,8]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(p){this.service=p,this.onDidChangeLogLevel=R.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class A{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){A.setLevel(this.channel,p)}static setLevel(p,v){return p.call("setLevel",v)}}e.LogLevelChannelClient=A;class P{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,v){throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"createLogger":this.createLogger(r.URI.revive(h[0]),h[1]);return;case"log":return this.log(r.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(p,v){this.loggers.set(p.toString(),this.loggerService.createLogger(p,v))}consoleLog(p,v){let h=console.log;switch(p){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(p,v){const h=this.loggers.get(p.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,C]of v)(0,D.log)(h,S,C)}}e.LoggerChannel=P;class E extends D.AbstractLoggerService{constructor(p,v,h){super(p,v),this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}doCreateLogger(p,v,h){return new b(this.channel,p,v,h)}}e.LoggerChannelClient=E;class b extends D.AbstractMessageLogger{constructor(p,v,h,S){super(S?.always),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const h=[[p,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(p){this.channel.call("log",[this.file,p])}}class I extends D.LogService{constructor(p,v){super(v),this.parent=p,this._register(p.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=I}),define(ne[59],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(ne[60],re([0,1,3,52,2,5]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class A extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),r.Iterable.reduce(this.policies.entries(),(w,[p,v])=>({...w,[p]:v}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return r.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[I,w])=>({...b,[I]:{definition:w,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=A;class P{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[194],re([0,1,3,2,60]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(E){this.service=E,this.disposables=new r.DisposableStore}listen(E,b){switch(b){case"onDidChange":return R.Event.map(this.service.onDidChange,I=>I.reduce((w,p)=>({...w,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${b}`)}call(E,b,I){switch(b){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${b}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class A extends D.AbstractPolicyService{constructor(E,b){super(),this.channel=b;for(const I in E){const{definition:w,value:p}=E[I];this.policyDefinitions[I]=w,p!==void 0&&this.policies.set(I,p)}this.channel.listen("onDidChange")(I=>{for(const w in I){const p=I[w];p===null?this.policies.delete(w):this.policies.set(w,p)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(E){const b=await this.channel.call("registerPolicyDefinitions",E);for(const I in b)this.policies.set(I,b[I])}}e.PolicyChannelClient=A}),define(ne[99],re([0,1,22,4,36,17]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof r.globals.vscode<"u"&&typeof r.globals.vscode.context<"u"){const P=r.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,L.dirname)(R.FileAccess.asFileUri("",Q));A=Q.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath);const E=Q.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[25],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[195],re([0,1,6,9,2,12,28,8,25]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(w,p,v){super(),this.productService=p,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},3e4)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),v=(0,L.dirname)(w),h=(0,L.basename)(w),S=await A.Promises.readdir(v);await Promise.all(S.map(async C=>{if(C===h)return;const m=(0,L.join)(v,C),g=await A.Promises.stat(m);if(g.isDirectory()&&p-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),A.Promises.rm(m)}))}catch(p){(0,r.onUnexpectedError)(p)}}};b=pe([K(1,E.IProductService),K(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(ne[196],re([0,1,6,9,2,12,28,14,8,25]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends D.Disposable{constructor(p,v,h){super(),this.environmentService=p,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),v=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(v)){const a=v[g];p[`${a.hash}.${g}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(h))return;const C=await A.Promises.readdir(h);for(const g of C){if(p[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,L.join)(h,g))}const m=Date.now();for(const g of Object.keys(p)){const a=(0,L.join)(h,g),f=await A.Promises.readdir(a);for(const l of f){if(l==="tcf.json")continue;const i=(0,L.join)(a,l),s=await A.Promises.stat(i);s.isDirectory()&&m-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(g,l)}`),await A.Promises.rm(i))}}}catch(p){(0,r.onUnexpectedError)(p)}}};I=pe([K(0,P.INativeEnvironmentService),K(1,E.ILogService),K(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[197],re([0,1,12,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,r.createDecorator)("IV8InspectProfilingService");var D;(function(L){function A(P,E="noAbsolutePaths"){for(const b of P.nodes)b.callFrame&&b.callFrame.url&&((0,R.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(b.callFrame.url))&&(b.callFrame.url=(0,R.join)(E,(0,R.basename)(b.callFrame.url)));return P}L.rewriteAbsolutePaths=A})(D=e.Utils||(e.Utils={}))}),define(ne[198],re([0,1,30]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class r{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((b,I)=>{Q(["v8-inspect-profiler"],b,I)})).startProfiling({port:L.port,checkForPaused:!0}),E=(0,R.generateUuid)();return this._sessions.set(E,P),E}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const P=await A.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=r}),define(ne[40],re([0,1,114,15]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(A,P){R.ok(r.isString(A)),R.ok(r.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new D}),define(ne[100],re([0,1,3,40]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[D(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;r.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[43],re([0,1,19,3,15,140,18,100,40]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=E.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=this.doRegisterConfigurations(i,s);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=this.doDeregisterConfigurations(i);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=[];t.push(...this.doDeregisterConfigurations(s)),t.push(...this.doRegisterConfigurations(i,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(i){const s=[],t=[];for(const{overrides:n,source:o}of i)for(const u in n)if(s.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const c=this.configurationDefaultsOverrides.get(u),d=c?.valuesSources??new Map;if(o)for(const T of Object.keys(n[u]))d.set(T,o);const y={...c?.value||{},...n[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:y,valuesSources:d});const _=(0,A.getLanguageTagSettingPlainKey)(u),F={type:"object",default:y,description:L.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(u)),this.configurationProperties[u]=F,this.defaultLanguageConfigurationOverridesNode.properties[u]=F}else{this.configurationDefaultsOverrides.set(u,{value:n[u],source:o});const c=this.configurationProperties[u];c&&(this.updatePropertyDefaultValue(u,c),this.updateSchema(u,c))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const s=[];for(const{overrides:t,source:n}of i)for(const o in t){const u=this.configurationDefaultsOverrides.get(o),c=D.isString(n)?n:n?.id,d=D.isString(u?.source)?u?.source:u?.source?.id;if(c===d)if(s.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const y=this.configurationProperties[o];y&&(this.updatePropertyDefaultValue(o,y),this.updateSchema(o,y))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s){const t=[];return i.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(i){const s=[],t=n=>{if(n.properties)for(const o in n.properties){s.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>t(o))};for(const n of i){t(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return s}validateAndRegisterProperties(i,s=!0,t,n,o=3){o=D.isUndefinedOrNull(i.scope)?o:i.scope;const u=[],c=i.properties;if(c)for(const y in c){const _=c[y];if(s&&a(y,_)){delete c[y];continue}if(_.source=t,_.defaultDefaultValue=c[y].default,this.updatePropertyDefaultValue(y,_),e.OVERRIDE_PROPERTY_REGEX.test(y)?_.scope=void 0:(_.scope=D.isUndefinedOrNull(_.scope)?o:_.scope,_.restricted=D.isUndefinedOrNull(_.restricted)?!!n?.includes(y):_.restricted),c[y].hasOwnProperty("included")&&!c[y].included){this.excludedConfigurationProperties[y]=c[y],delete c[y];continue}else this.configurationProperties[y]=c[y],c[y].policy?.name&&this.policyConfigurations.set(c[y].policy.name,y);!c[y].deprecationMessage&&c[y].markdownDeprecationMessage&&(c[y].deprecationMessage=c[y].markdownDeprecationMessage),u.push(y)}const d=i.allOf;if(d)for(const y of d)u.push(...this.validateAndRegisterProperties(y,s,t,n,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const n=t.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,o=t?.source;D.isUndefined(n)&&(n=s.defaultDefaultValue,o=void 0),D.isUndefined(n)&&(n=m(s.type)),s.default=n,s.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(l){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let s=h.exec(l);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=h.exec(l)}}return(0,R.distinct)(i)}e.overrideIdentifiersFromKey=S;function C(l){return l.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=C;function m(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const g=new p;E.Registry.add(e.Extensions.Configuration,g);function a(l,i){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):g.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,l,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=a;function f(){const l=[],i=g.getConfigurationProperties();for(const s of Object.keys(i))l.push([s,i[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=f}),define(ne[70],re([0,1,19,3,35,2,34,32,15,7,18,43,40]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(i={},s=[],t=[]){this._contents=i,this._keys=s,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const t=this.getContentsForOverrideIdentifer(s);return t?i?(0,I.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const t of this.overrides)t.identifiers.includes(i)&&s.push(...t.keys);return R.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return R.distinct(i)}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=P.deepClone(this.contents),t=P.deepClone(this.overrides),n=[...this.keys];for(const o of i)if(!o.isEmpty()){this.mergeContents(s,o.contents);for(const u of o.overrides){const[c]=t.filter(d=>R.equals(d.identifiers,u.identifiers));c?(this.mergeContents(c.contents,u.contents),c.keys.push(...u.keys),c.keys=R.distinct(c.keys)):t.push(P.deepClone(u))}for(const u of o.keys)n.indexOf(u)===-1&&n.push(u)}return new v(s,n,t)}freeze(){return this.frozen=!0,this}clone(){return new v(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const n of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[n];const u=s[n];u&&(typeof o=="object"&&typeof u=="object"?(o=P.deepClone(o),this.mergeContents(o,u)):o=u),t[n]=o}return new v(t,this.keys,this.overrides)}mergeContents(i,s){for(const t of Object.keys(s)){if(t in i&&E.isObject(i[t])&&E.isObject(s[t])){this.mergeContents(i[t],s[t]);continue}i[t]=P.deepClone(s[t])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let s=null,t=null;const n=o=>{o&&(t?this.mergeContents(t,o):t=P.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[i])?s=o.contents:o.identifiers.includes(i)&&n(o.contents);return n(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,I.addToValueTree)(this.contents,i,s,t=>{throw new Error(t)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let t=0;t<s;t++)i.indexOf(this.keys[t])===0&&(s=t);this.keys.splice(s,1,i)}removeKey(i){const s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!E.isUndefinedOrNull(i)){const t=this.doParseContent(i);this.parseRaw(t,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:t,keys:n,overrides:o,restricted:u}=this.doParseRaw(i,s);this._configurationModel=new v(t,n,o),this._restrictedConfigurations=u||[]}doParseContent(i){let s={},t=null,n=[];const o=[],u=[];function c(y){Array.isArray(n)?n.push(y):t!==null&&(n[t]=y)}const d={onObjectBegin:()=>{const y={};c(y),o.push(n),n=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const y=[];c(y),o.push(n),n=y,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:c,onError:(y,_,F)=>{u.push({error:y,offset:_,length:F})}};if(i)try{D.visit(i,d),s=n[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return s}doParseRaw(i,s){const t=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,t,!0,s);i=n.raw;const o=(0,I.toValuesTree)(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),u=Object.keys(i),c=this.toOverrides(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:o,keys:u,overrides:c,restricted:n.restricted}}filter(i,s,t,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[]};const o={},u=[];for(const c in i)if(w.OVERRIDE_PROPERTY_REGEX.test(c)&&t){const d=this.filter(i[c],s,!1,n);o[c]=d.raw,u.push(...d.restricted)}else{const d=s[c],y=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&u.push(c),(y===void 0||n.scopes===void 0||n.scopes.includes(y))&&(n.skipRestricted&&d?.restricted||(o[c]=i[c]))}return{raw:o,restricted:u}}toOverrides(i,s){const t=[];for(const n of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const u in i[n])o[u]=i[n][u];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,I.toValuesTree)(o,s)})}return t}}e.ConfigurationModelParser=h;class S extends L.Disposable{constructor(i,s,t,n){super(),this.userSettingsResource=i,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.any(r.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),r.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class C{constructor(i,s,t,n,o=new v,u=new v,c=new A.ResourceMap,d=new v,y=new A.ResourceMap,_=!0){this._defaultConfiguration=i,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=c,this._memoryConfiguration=d,this._memoryConfigurationByResource=y,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,s,t){return this.getConsolidatedConfigurationModel(i,s,t).getValue(i)}updateValue(i,s,t={}){let n;t.resource?(n=this._memoryConfigurationByResource.get(t.resource),n||(n=new v,this._memoryConfigurationByResource.set(t.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(i):n.setValue(i,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,t){const n=this.getConsolidatedConfigurationModel(i,s,t),o=this.getFolderConfigurationModelForResource(s.resource,t),u=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,c=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),y=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),_=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),F=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),T=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),O=t?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,k=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(i):o.freeze().getValue(i):void 0,M=s.overrideIdentifier?u.override(s.overrideIdentifier).getValue(i):u.getValue(i),$=n.getValue(i),q=R.distinct(n.overrides.map(J=>J.identifiers).flat()).filter(J=>n.getOverrideValue(i,J)!==void 0);return{defaultValue:c,policyValue:d,applicationValue:y,userValue:_,userLocalValue:F,userRemoteValue:T,workspaceValue:O,workspaceFolderValue:k,memoryValue:M,value:$,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,policy:d!==void 0?{value:d}:void 0,application:y!==void 0?{value:y,override:s.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:o?.freeze().getValue(i),override:s.overrideIdentifier?o?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:u.getValue(i),override:s.overrideIdentifier?u.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const t=[];if(!s){const{added:n,updated:o,removed:u}=a(this._defaultConfiguration,i);s=[...n,...o,...u]}for(const n of s)for(const o of(0,w.overrideIdentifiersFromKey)(n)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(o),c=i.getKeysForOverrideIdentifier(o),d=[...c.filter(y=>u.indexOf(y)===-1),...u.filter(y=>c.indexOf(y)===-1),...u.filter(y=>!P.equals(this._defaultConfiguration.override(o).getValue(y),i.override(o).getValue(y)))];t.push([o,d])}return this.updateDefaultConfiguration(i),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:t,removed:n}=a(this._policyConfiguration,i),o=[...s,...t,...n];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.applicationConfiguration,i),u=[...s,...t,...n];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.localUserConfiguration,i),u=[...s,...t,...n];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.remoteUserConfiguration,i),u=[...s,...t,...n];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.workspaceConfiguration,i),u=[...s,...t,...n];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:o}}compareAndUpdateFolderConfiguration(i,s){const t=this.folderConfigurations.get(i),{added:n,updated:o,removed:u,overrides:c}=a(t,s),d=[...n,...o,...u];return(d.length||!t)&&this.updateFolderConfiguration(i,s),{keys:d,overrides:c}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:n,removed:o,overrides:u}=a(s,void 0);return{keys:[...t,...n,...o],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,s,t){let n=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(n=n.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const n=s.getFolder(i);n&&(t=this.getFolderConsolidatedConfiguration(n.uri)||t);const o=this._memoryConfigurationByResource.get(i);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(s=t.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=t}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const t=s.getFolder(i);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:t,overrides:n,keys:o}=this._folderConfigurations.get(s);return i.push([s,{contents:t,overrides:n,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(t=>i.add(t))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),t=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),u=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((d,y)=>(d.set(b.URI.revive(y[0]),this.parseConfigurationModel(y[1])),d),new A.ResourceMap);return new C(s,t,n,o,new v,u,c,new v,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function m(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,s=new Map;for(const n of l)n.keys.forEach(o=>i.add(o)),n.overrides.forEach(([o,u])=>{const c=(0,A.getOrSet)(s,o,new Set);u.forEach(d=>c.add(d))});const t=[];return s.forEach((n,o)=>t.push([o,[...n.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=m;class g{constructor(i,s,t,n){this.change=i,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(c=>o.add(c)),i.overrides.forEach(([,c])=>c.forEach(d=>o.add(d))),this.affectedKeys=[...o.values()];const u=new v;this.affectedKeys.forEach(c=>u.setValue(c,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const t=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!P.equals(t,n)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let t=(0,I.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof t=="object"&&(n=Object.keys(t)[0]);){if(i=i[n],!i)return!1;t=t[n]}return!0}}e.ConfigurationChangeEvent=g;function a(l,i){const{added:s,removed:t,updated:n}=f(i,l),o=[],u=l?.getAllOverrideIdentifiers()||[],c=i?.getAllOverrideIdentifiers()||[];if(i){const d=c.filter(y=>!u.includes(y));for(const y of d)o.push([y,i.getKeysForOverrideIdentifier(y)])}if(l){const d=u.filter(y=>!c.includes(y));for(const y of d)o.push([y,l.getKeysForOverrideIdentifier(y)])}if(i&&l){for(const d of u)if(c.includes(d)){const y=f({contents:l.getOverrideValue(void 0,d)||{},keys:l.getKeysForOverrideIdentifier(d)},{contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)});o.push([d,[...y.added,...y.removed,...y.updated]])}}return{added:s,removed:t,updated:n,overrides:o}}function f(l,i){const s=l?i?l.keys.filter(o=>i.keys.indexOf(o)===-1):[...l.keys]:[],t=i?l?i.keys.filter(o=>l.keys.indexOf(o)===-1):[...i.keys]:[],n=[];if(l&&i){for(const o of i.keys)if(l.keys.indexOf(o)!==-1){const u=(0,I.getConfigurationValue)(i.contents,o),c=(0,I.getConfigurationValue)(l.contents,o);P.equals(u,c)||n.push(o)}}return{added:s,removed:t,updated:n}}}),define(ne[199],re([0,1,19,3,2,32,15,18,70,43,8,60,40]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:a})=>this.onDidUpdateConfiguration(g,a))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,a){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends E.ConfigurationModel{constructor(g={}){const a=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(a),l=Object.create(null),i=[];for(const s in a){const t=g[s],n=t!==void 0?t:a[s].default;(0,P.addToValueTree)(l,s,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const s of Object.keys(l))b.OVERRIDE_PROPERTY_REGEX.test(s)&&i.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(l[s]),contents:(0,P.toValuesTree)(l[s],t=>console.error(`Conflict in default settings file: ${t}`))});super(l,f,i)}}e.DefaultConfigurationModel=h;class S{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let C=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(g,a,f){super(),this.defaultConfiguration=g,this.policyService=a,this.logService=f,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const a={},f=[],l=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const i of g){const s=l[i];if(!s){f.push(i);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}f.push(i),a[s.policy.name]={type:s.type}}}return(0,A.isEmptyObject)(a)||await this.policyService.registerPolicyDefinitions(a),f}onDidChangePolicies(g){const a=p.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(g.map(l=>a.get(l)));this.update(f,!0)}update(g,a){const f=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=[],i=this._configurationModel.isEmpty();for(const s of g){const t=f[s]?.policy?.name;if(t){const n=this.policyService.getPolicyValue(t);(i?n!==void 0:!(0,L.equals)(this._configurationModel.getValue(s),n))&&l.push([s,n])}else this._configurationModel.getValue(s)!==void 0&&l.push([s,void 0])}if(l.length){const s=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of s.keys)this._configurationModel.setValue(t,s.getValue(t));for(const[t,n]of l)n===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,n);a&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=pe([K(1,w.IPolicyService),K(2,I.ILogService)],C),e.PolicyConfiguration=C}),define(ne[200],re([0,1,6,3,2,17,18,70,199,60]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends D.Disposable{constructor(p,v,h,S){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=h instanceof b.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,h,S)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:m})=>this.onDidDefaultConfigurationChange(C,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(p,v,new P.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(p,v){const h=typeof p=="string"?p:void 0,S=(0,A.isConfigurationOverrides)(p)?p:(0,A.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,S,void 0)}updateValue(p,v,h,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(h,v,2)}onDidDefaultConfigurationChange(p,v){const h=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(p,v);this.trigger(S,h,7)}onDidPolicyConfigurationChange(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(h,v,7)}trigger(p,v,h){const S=new P.ConfigurationChangeEvent(p,{data:v},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[201],re([0,1,9,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var D;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends R.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===D.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===D.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}constructor(P,E=D.Unknown,b){super(P),this._message=P,this._code=E,this._detail=b,this.isHandled=E===D.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(ne[101],re([0,1,22]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function r(b){return b.scheme===R.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=r;function D(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=D;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=L;function A(b){const{host:I,port:w}=E(b);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:w}}e.parseAuthorityWithPort=A;function P(b,I){let{host:w,port:p}=E(b);return typeof p>"u"&&(p=I),{host:w,port:p}}e.parseAuthorityWithOptionalPort=P;function E(b){const I=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const w=b.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=b.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:b,port:void 0}}}),define(ne[44],re([0,1,27,5,101]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function A(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var E;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,C){if(typeof S>"u"||S===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof S=="string"||typeof C=="string"){const m=typeof S=="string"?S:S.value,g=typeof C=="string"?C:C.value;return R.equalsIgnoreCase(m,g)}return S._lower===C._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;function I(h){return w(h)}e.isApplicationScopedExtension=I;function w(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function v(h,S){if(S){const C=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return h.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],re([0,1,27,29,44,4,7,9,36]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,R.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=b;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,n,o)}static parse(t){const n=I.exec(t);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?b(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const t=p.exec(s);return t&&t[1]?[S(t[1]),t[2]]:[S(s),void 0]}e.getIdAndVersion=v;function h(s,t){return`${s}.${t}`}e.getExtensionId=h;function S(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function C(s,t){return S(h(s,t))}e.getGalleryExtensionId=C;function m(s,t){const n=[],o=u=>{for(const c of n)if(c.some(d=>b(t(d),t(u))))return c;return null};for(const u of s){const c=o(u);c?c.push(u):n.push([u])}return n}e.groupByExtension=m;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function a(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=a,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function f(s,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&n.every(c=>!b(c.identifier,{id:u}))){const c=s.filter(d=>b(d.identifier,{id:u}));c.length===1&&(n.push(c[0]),o.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=f;async function l(s,t){if(!L.isLinux)return!1;let n;try{n=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function i(s,t){const n=await l(s,t),o=(0,r.getTargetPlatform)(n?"alpine":L.platform,E.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(ne[49],re([0,1,6,16,2,34,7,33,13,5,8]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let w=class extends D.Disposable{constructor(v,h){super(),this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,S=>(S=S.filter(C=>v.some(([m])=>!(0,P.areSameExtensions)(C.identifier,m.identifier))),S.push(...v.map(([C,m])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:m}))),S))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,S=>S.filter(C=>!(0,P.areSameExtensions)(C.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let S=[];try{const C=await this.fileService.readFile(v),m=JSON.parse(C.value.toString());for(const g of m){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}S.push({identifier:g.identifier,location:A.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(h){S=h(S);const C=S.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(v,r.VSBuffer.fromString(JSON.stringify(C)))}return S})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new R.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};w=pe([K(0,E.IFileService),K(1,I.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(ne[202],re([0,1,24,33]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(L,A,P,E,b){try{const I=await L.getExtensionsControlManifest();if(!I.deprecated)return;const w=await L.getInstalled(1);for(const[p,v]of Object.entries(I.deprecated)){if(!v?.extension)continue;const{id:h,autoMigrate:S,preRelease:C}=v.extension;if(!S)continue;const m=w.find(a=>(0,r.areSameExtensions)(a.identifier,{id:p}));if(!m)continue;const g=(await A.getExtensions([{id:h,preRelease:C}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){b.info(`Skipping migrating '${m.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{b.info(`Migrating '${m.identifier.id}' extension to '${h}' extension...`);const a=!E.getDisabledExtensions().some(l=>(0,r.areSameExtensions)(l,m.identifier));await L.uninstall(m),b.info(`Uninstalled the unsupported extension '${m.identifier.id}'`);let f=w.find(l=>(0,r.areSameExtensions)(l.identifier,{id:h}));(!f||!f.isPreReleaseVersion&&a)&&(f=await L.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:m.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${f.identifier.id}'`),a||(await E.disableExtension(f.identifier),b.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${m.identifier.id}' is disabled`)),S.storage&&(P.addToMigrationList((0,r.getExtensionId)(m.manifest.publisher,m.manifest.name),(0,r.getExtensionId)(f.manifest.publisher,f.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${m.identifier.id}' extension to '${h}' extension.`)}catch(a){b.error(a)}}}catch(I){b.error(I)}}e.migrateUnsupportedExtensions=D}),define(ne[203],re([0,1,6,9,2,4,17,55,7,30,28,14,29,33,13,8]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let C=class extends D.Disposable{constructor(g,a,f,l){super(),this.fileService=a,this.extensionGalleryService=f,this.logService=l,this.extensionsDownloadDir=E.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const f=this.getName(g),l=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(l)){const i=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,a);try{await this.rename(i,l,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(i)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,r.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,i.path),s}}return l}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,a,f){try{await I.Promises.rename(g.fsPath,a.fsPath)}catch(l){if(L.isWindows&&l&&l.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,f);throw l}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],f=[];for(const s of g.children){const t=v.ExtensionKey.parse(s.name);t&&f.push([t,s])}const l=(0,v.groupByExtension)(f,([s])=>s),i=[];for(const s of l)s.sort((t,n)=>P.rcompare(t[0].version,n[0].version)),a.push(...s.slice(1).map(t=>t[1].resource)),i.push(s[0][1]);i.sort((s,t)=>s.mtime-t.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(s=>s.resource)),await R.Promises.settled(a.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?v.ExtensionKey.create(g).toString().toLowerCase():(0,b.generateUuid)()}};C=pe([K(0,w.INativeEnvironmentService),K(1,h.IFileService),K(2,p.IExtensionGalleryService),K(3,S.ILogService)],C),e.ExtensionsDownloader=C}),define(ne[204],re([0,1,2,12,28,44]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(E,b){super(),this.environmentService=E,this.extensionsManifestCache=(0,r.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(b.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(E){E.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[205],re([0,1,95,19,6,2,22,12,28,14,29,33,8,69]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(g,a,f,l){super(f),this.extensionManagementService=g,this.logService=l,this.cache=this._register(new S(a,l)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),a=Object.keys(g).map(f=>{const l=g[f];return{...this.createQuickPickItem(f,l.label),extensionId:l.extensions[0].extensionIdentifier.id}});return a.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),a.sort((f,l)=>f.label.localeCompare(l.label)),a}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const a=await this.cache.getLanguagePacks();Object.keys(a).some(f=>a[f]&&a[f].extensions.some(l=>(0,w.areSameExtensions)(l.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(a);return!(0,r.equals)(Object.keys(g),Object.keys(f))}};h=pe([K(0,I.IExtensionManagementService),K(1,b.INativeEnvironmentService),K(2,I.IExtensionGalleryService),K(3,p.ILogService)],h),e.NativeLanguagePackService=h;let S=class extends L.Disposable{constructor(g,a){super(),this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(a=>{Object.keys(a).forEach(f=>delete a[f]),this.createLanguagePacksFromExtensions(a,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...a){for(const f of a)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,a){const f=a.identifier,l=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const i of l)if(a.location.scheme===A.Schemas.file&&C(i)){let s=g[i.languageId];s||(s={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=s);const t=s.extensions.filter(n=>(0,w.areSameExtensions)(n.extensionIdentifier,f))[0];t?t.version=a.manifest.version:s.extensions.push({extensionIdentifier:f,version:a.manifest.version});for(const n of i.translations)s.translations[n.id]=(0,P.join)(a.location.fsPath,n.path)}}updateHash(g){if(g){const a=(0,R.createHash)("md5");for(const f of g.extensions)a.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=a.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(a=g(f),f)).then(f=>{for(const i of Object.keys(f))f[i]||delete f[i];this.languagePacks=f,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),E.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>a,f=>this.logService.error(f))})}};S=pe([K(0,b.INativeEnvironmentService),K(1,p.ILogService)],S);function C(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const g of m.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(ne[206],re([0,1,6,16,24,9,3,2,30,88,201,101]),function(Q,e,R,r,D,L,A,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var v;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function h(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(W){const V=new D.CancellationTokenSource;return setTimeout(()=>V.cancel(),W),V.token}function C(W,V){if(W.isCancellationRequested||V.isCancellationRequested)return D.CancellationToken.Cancelled;const U=new D.CancellationTokenSource;return W.onCancellationRequested(()=>U.cancel()),V.onCancellationRequested(()=>U.cancel()),U.token}class m{get didTimeout(){return this._state==="timedout"}constructor(V){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((U,N)=>{this._resolvePromise=U,this._rejectPromise=N}),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function g(W,V){const U=new m(V);return U.registerDisposable(W.onControlMessage(N=>{const j=JSON.parse(N.toString()),B=z(j);B?U.reject(B):U.resolve(j)})),U.promise}function a(W,V,U,N,j,B,Z,oe){const X=new m(oe);return V.connect(U,N,j,B,Z,(ie,se)=>{X.didTimeout?(ie&&W.error(ie),se?.dispose()):ie||!se?X.reject(ie):X.resolve(se)}),X.promise}function f(W,V){const U=new m(V);return W.then(N=>{U.didTimeout||U.resolve(N)},N=>{U.didTimeout||U.reject(N)}),U.promise}async function l(W,V,U,N){const j=te(W,V);W.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await a(W.logService,W.socketFactory,W.host,W.port,(0,w.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,`renderer-${h(V)}-${W.reconnectionToken}`,N)}catch(se){throw W.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),W.logService.error(se),se}W.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let Z,oe;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(B,null),Z=W.reconnectionProtocol,oe=!1):(Z=new b.PersistentProtocol(B,null),oe=!0),W.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const X=await f(W.signService.createNewMessage((0,E.generateUuid)()),N),ie={type:"auth",auth:W.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await g(Z,C(N,S(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(W.logService.trace(`${j} 4/6. received SignRequest control message.`),!await f(W.signService.validate(X,se.signedData),N)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const he=await f(W.signService.sign(se.data),N),ve={type:"connectionType",commit:W.commit,signedData:he,desiredConnectionType:V};return U&&(ve.args=U),W.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(W.logService.error(`${j} the handshake timed out. Error:`),W.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${j} received error control message when negotiating connection. Error:`),W.logService.error(se)),oe&&G(Z),se}}async function i(W,V,U,N){const j=Date.now(),B=te(W,V),{protocol:Z,ownsProtocol:oe}=await l(W,V,U,N),X=new m(N);return X.registerDisposable(Z.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=z(se);ue?(W.logService.error(`${B} received error control message when negotiating connection. Error:`),W.logService.error(ue),oe&&G(Z),X.reject(ue)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ce(j)}!`),X.resolve({protocol:Z,firstMessage:se}))})),X.promise}async function s(W,V){const{protocol:U}=await i(W,1,void 0,V);return{protocol:U}}async function t(W,V,U){const{protocol:N,firstMessage:j}=await i(W,2,V,U),B=j&&j.debugPort;return{protocol:N,debugPort:B}}async function n(W,V,U){const N=Date.now(),j=te(W,3),{protocol:B}=await l(W,3,V,U);return W.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ce(N)}!`),B}async function o(W,V,U){const{host:N,port:j,connectionToken:B}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:N,port:j,connectionToken:B,reconnectionToken:V,reconnectionProtocol:U,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function u(W,V,U){return d(W,async N=>{const{protocol:j}=await s(N,D.CancellationToken.None);return new J(W,V,U,N.reconnectionToken,j)})}e.connectRemoteAgentManagement=u;async function c(W,V){return d(W,async U=>{const{protocol:N,debugPort:j}=await t(U,V,D.CancellationToken.None);return new H(W,V,U.reconnectionToken,N,j)})}e.connectRemoteAgentExtensionHost=c;async function d(W,V){for(let N=1;;N++)try{const j=(0,E.generateUuid)(),B=await o(W,j,null);return await V(B)}catch(j){if(N<5)W.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(j);else throw W.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(j),q.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(j)),j}}async function y(W,V,U){const N=await o(W,(0,E.generateUuid)(),null);return await n(N,{host:V,port:U},D.CancellationToken.None)}e.connectRemoteAgentTunnel=y;function _(W){return(0,R.createCancelablePromise)(V=>new Promise((U,N)=>{const j=setTimeout(U,W*1e3);V.onCancellationRequested(()=>{clearTimeout(j),U()})}))}var F;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(V,U){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=T;class O{constructor(V,U,N,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.durationSeconds=N,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class k{constructor(V,U,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=k;class M{constructor(V,U,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=4}}e.ConnectionGainEvent=M;class ${constructor(V,U,N,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class q extends P.Disposable{static triggerPermanentFailure(V,U,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=U,this._permanentFailureHandled=N,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(V=>V._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(V=>V._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||q._permanentFailure}constructor(V,U,N,j,B){super(),this._connectionType=V,this._options=U,this.reconnectionToken=N,this.protocol=j,this._reconnectionFailureIsFatal=B,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new M(this.reconnectionToken,0,0)),this._register(j.onSocketClose(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),q._instances.push(this),this._register((0,P.toDisposable)(()=>{const Z=q._instances.indexOf(this);Z>=0&&q._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(q._permanentFailureMillisSinceLastIncomingData,q._permanentFailureAttempt,q._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const V=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const j=N<U.length?U[N]:U[U.length-1];try{if(j>0){const Z=_(j);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,Z)),this._options.logService.info(`${V} waiting for ${j} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${V} resolving connection...`);const B=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,S(p)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,L.isCancellationError)(B)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,I.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(V,U,N){this._reconnectionFailureIsFatal?q.triggerPermanentFailure(V,U,N):this._gotoPermanentFailure(V,U,N)}_gotoPermanentFailure(V,U,N){this._onDidStateChange.fire(new $(this.reconnectionToken,V,U,N)),G(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=q,q._permanentFailure=!1,q._permanentFailureMillisSinceLastIncomingData=0,q._permanentFailureAttempt=0,q._permanentFailureHandled=!1,q._instances=[];class J extends q{constructor(V,U,N,j,B){super(1,V,j,B,!0),this.client=this._register(new b.Client(B,{remoteAuthority:U,clientId:N},V.ipcLogger))}async _reconnect(V,U){await s(V,U)}}e.ManagementPersistentConnection=J;class H extends q{constructor(V,U,N,j,B){super(2,V,N,j,!1),this._startArguments=U,this.debugPort=B}async _reconnect(V,U){await t(V,this._startArguments,U)}}e.ExtensionHostPersistentConnection=H;function G(W){try{W.acceptDisconnect();const V=W.getSocket();W.dispose(),V.dispose()}catch(V){(0,L.onUnexpectedError)(V)}}function z(W){if(W&&W.type==="error"){const V=new Error(`Connection error: ${W.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function x(W,V){for(;W.length<V;)W+=" ";return W}function Y(W,V,U){return`[remote-connection][${x(h(W),13)}][${V.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function te(W,V){return`${Y(V,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function ce(W){return`${Date.now()-W} ms`}}),define(ne[207],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[208],re([0,1,80,138]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,L,A,P,E,b){const I=p=>b(p,void 0),w=R.createConnection({host:D,port:L},()=>{w.removeListener("error",I);const p=Buffer.alloc(16);for(let C=0;C<16;C++)p[C]=Math.round(Math.random()*256);const v=p.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${L}${A}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];w.write(h.join(`\r
`)+`\r
\r
`);const S=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),b(void 0,new r.NodeSocket(w,E)))};w.on("data",S)});w.setNoDelay(!0),w.once("error",I)}}}),define(ne[209],re([0,1,121,18,8]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,E){this.configurationService=P,this.logService=E}async request(P,E){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const b=await(0,R.request)(P,E);return this.logService.trace("RequestService#request (browser) - success",P.url),b}catch(b){throw this.logService.error("RequestService#request (browser) - error",P.url,b),b}}async resolveProxy(P){}};L=pe([K(0,r.IConfigurationService),K(1,D.ILogService)],L),e.RequestService=L}),define(ne[45],re([0,1,16,156,43,5,40]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function E(S){return S.res.statusCode===204}async function b(S){return E(S)?null:(await(0,R.streamToBuffer)(S.stream)).toString()}e.asText=b;async function I(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return b(S)}e.asTextOrError=I;async function w(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(E(S))return null;const m=(await(0,R.streamToBuffer)(S.stream)).toString();try{return JSON.parse(m)}catch(g){throw g.message+=`:
`+m,g}}e.asJson=w;function p(S){h(S)}e.updateProxyConfigurationsScope=p;let v;function h(S){const C=A.Registry.as(D.Extensions.Configuration),m=v;v={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[v],remove:m?[m]:[]})}h(2)}),define(ne[210],re([0,1,24,22,13,45]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(E,b){this.requestService=E,this.fileService=b}async download(E,b,I=R.CancellationToken.None){if(E.scheme===r.Schemas.file||E.scheme===r.Schemas.vscodeRemote){await this.fileService.copy(E,b);return}const w={type:"GET",url:E.toString(!0)},p=await this.requestService.request(w,I);if(p.res.statusCode===200)await this.fileService.writeFile(b,p.stream);else{const v=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${v}`)}}};A=pe([K(0,L.IRequestService),K(1,D.IFileService)],A),e.DownloadService=A}),define(ne[211],re([0,1,19,24,2,17,173,13,8,25,45]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends D.Disposable{constructor(v,h,S,C){super(),this.fileService=v,this.productService=h,this.requestService=S,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,m])=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const h=[];for(const[S,C]of this.allConfigBasedTips)if(!(C.configScheme&&C.configScheme!==v.scheme))try{const m=await this.fileService.readFile((0,L.joinPath)(v,S)),g=new Map;Object.entries(C.recommendations).forEach(([f,l])=>{if((0,R.isNonEmptyArray)(l.remotes))for(const i of l.remotes)g.set(i,{extensionId:f,extensionName:l.name,configName:C.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled});else h.push({extensionId:f,extensionName:l.name,configName:C.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})});const a=(0,A.getDomainsOfRemotes)(m.value.toString(),[...g.keys()]);for(const f of a){const l=g.get(f);l&&h.push(l)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},r.CancellationToken.None);if(v.res.statusCode!==200)return[];const h=await(0,I.asJson)(v);return h?h.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};w=pe([K(0,P.IFileService),K(1,b.IProductService),K(2,I.IRequestService),K(3,E.ILogService)],w),e.ExtensionTipsService=w}),define(ne[212],re([0,1,16,24]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(P){this.service=P}listen(P,E){throw new Error("Invalid listen")}call(P,E,b,I=r.CancellationToken.None){switch(E){case"request":return this.service.request(b[0],I).then(async({res:w,stream:p})=>{const v=await(0,R.streamToBuffer)(p);return[{statusCode:w.statusCode,headers:w.headers},v]});case"resolveProxy":return this.service.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class L{constructor(P){this.channel=P}async request(P,E){const[b,I]=await this.channel.call("request",[P],E);return{res:b,stream:(0,R.bufferToStream)(I)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=L}),define(ne[213],re([0,1,209,212]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class D{constructor(A,P,E){this.configurationService=P,this.logService=E,this.browserRequestService=new R.RequestService(P,E),this.mainRequestService=new r.RequestChannelClient(A.getChannel("request"))}request(A,P){return this.getRequestService().request(A,P)}async resolveProxy(A){return this.getRequestService().resolveProxy(A)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=D}),define(ne[102],re([0,1,64,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(L){return(0,R.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,r.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[214],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(r){r.Spawn="vscode:shared-process->shared-process-worker=spawn",r.Terminate="vscode:shared-process->shared-process-worker=terminate",r.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",r.Ready="vscode:shared-process-worker->shared-process=ready",r.Ack="vscode:shared-process-worker->shared-process=ack",r.Trace="vscode:shared-process-worker->shared-process=trace",r.Info="vscode:shared-process-worker->shared-process=info",r.Warn="vscode:shared-process-worker->shared-process=warn",r.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[215],re([0,1,89,6,24,3,2,22,30,8,102,214]),function(Q,e,R,r,D,L,A,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const C=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${C})`);const m=(0,I.hash)(S);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${C})`),this.doDisposeWorker(S));const g=new D.CancellationTokenSource;let a,f,l;this.processeDisposables.set(m,n=>{g.dispose(!0),a?.terminate(S,D.CancellationToken.None),f?.close(),l?.close(),this.processeDisposables.delete(m);const o=this.processResolvers.get(m);o&&(this.processResolvers.delete(m),o({reason:n}))}),a=await this.getOrCreateWebWorker(S);const i=new Promise(n=>{this.processResolvers.set(m,n)});if(g.token.isCancellationRequested)return i;const{port1:s,port2:t}=new MessageChannel;return f=s,l=t,await a.spawn(S,l,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${C})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),i}getOrCreateWebWorker(S){let C=this.workers.get(S.process.moduleId);if(!C){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const m=new v(S.process.type,this.logService);C=m.init(),m.onDidProcessSelfTerminate(({configuration:g,reason:a})=>{this.doDisposeWorker(g,a)}),this.workers.set(S.process.moduleId,C)}return C}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,C){const m=this.processeDisposables.get((0,I.hash)(S));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),m(C))}};p=pe([K(0,b.ILogService)],p),e.SharedProcessWorkerService=p;class v extends A.Disposable{constructor(S,C){super(),this.type=S,this.logService=C,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new r.DeferredPromise,C=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return C.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},C.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},C.onmessage=m=>{const{id:g,message:a,configuration:f,nonce:l}=m.data;switch(g){case w.SharedProcessWorkerMessages.Ready:S.complete(C);break;case w.SharedProcessWorkerMessages.Ack:if(l){const i=this.mapMessageNonceToPendingMessageResolve.get(l);i&&(this.mapMessageNonceToPendingMessageResolve.delete(l),i())}break;case w.SharedProcessWorkerMessages.SelfTerminated:f&&a&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(a)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},C.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,C,m){const g=await this.workerReady;if(!C.isCancellationRequested)return new Promise(a=>{const f=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,a);const l={...S,nonce:f};m?g.postMessage(l,[m]):g.postMessage(l),C.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&a()})})}spawn(S,C,m){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(g,m,C)}terminate(S,C){const m={id:w.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(m,C)}}}),define(ne[216],re([0,1,62,22,172]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}}pe([R.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[217],re([0,1,54,12,157,24,38,9,4,30,135,170,6]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function S(m,g,a){return g["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(a)&&!g["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(a)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=p.Promises.withAsyncBody(async(f,l)=>{const i=new L.CancellationTokenSource,s=setTimeout(()=>{i.dispose(!0),l(new Error((0,D.localize)(0,null)))},v);try{f(await C(m,i.token))}catch(t){!(0,P.isCancellationError)(t)&&!i.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,A.toErrorMessage)(t)))):f({})}finally{clearTimeout(s),i.dispose()}})),h)}e.getResolvedShellEnv=S;async function C(m,g){const a=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",a);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",f);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",s);const t=await(0,I.getSystemShell)(E.OS,s);return m.trace("getUnixShellEnvironment#shell",t),new Promise((n,o)=>{if(g.isCancellationRequested)return o((0,P.canceled)());const u=(0,r.basename)(t);let c,d;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(c=`& '${process.execPath}' ${y} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,d=["-Login","-Command"]):(c=`'${process.execPath}' ${y} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,u==="tcsh"?d=["-ic"]:d=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),c);const _=(0,R.spawn)(t,[...d,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(_.kill(),o((0,P.canceled)()))),_.on("error",O=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(O)),o(O)});const F=[];_.stdout.on("data",O=>F.push(O));const T=[];_.stderr.on("data",O=>T.push(O)),_.on("close",(O,k)=>{const M=Buffer.concat(F).toString("utf8");m.trace("getUnixShellEnvironment#raw",M);const $=Buffer.concat(T).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),O||k)return o(new Error((0,D.localize)(2,null,O,k)));const q=i.exec(M),J=q?q[1]:"{}";try{const H=JSON.parse(J);a?H.ELECTRON_RUN_AS_NODE=a:delete H.ELECTRON_RUN_AS_NODE,f?H.ELECTRON_NO_ATTACH_CONSOLE=f:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",H),n(H)}catch(H){m.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(H)),o(H)}})})}}),define(ne[103],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[218],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((D,L)=>Q(["vsda"],D,L))}async createNewMessage(D){try{const L=await this.vsda(),A=new L.validator;if(A){const P=String(R._nextId++);return this.validators.set(P,A),{id:P,data:A.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const A=this.validators.get(D.id);if(!A)return!1;this.validators.delete(D.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(D){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(D)}catch{}return D}}e.SignService=R,R._nextId=1}),define(ne[71],re([0,1,3,2]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends r.Disposable{constructor(w,p,v){super(),this.channel=w,this.profile=p,this.workspace=v}async getItems(){const w={profile:this.profile,workspace:this.workspace},p=await this.channel.call("getItems",w);return new Map(p)}updateItems(w){const p={profile:this.profile,workspace:this.workspace};return w.insert&&(p.insert=Array.from(w.insert.entries())),w.delete&&(p.delete=Array.from(w.delete.values())),this.channel.call("updateItems",p)}}class L extends D{constructor(w,p){super(w,p,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(w=>this.onDidChangeStorage(w)))}onDidChangeStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class A extends L{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class P extends L{constructor(w,p){super(w,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class E extends D{constructor(w,p){super(w,void 0,p),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=E;class b{constructor(w){this.channel=w}isUsed(w){const p={payload:w,profile:void 0,workspace:void 0};return this.channel.call("isUsed",p)}}e.StorageClient=b}),define(ne[104],re([0,1,4,36,7,30]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(b){if(R.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,I,w,p,v,h,S,C,m,g){const a=Object.create(null);a["common.machineId"]=S,a.sessionID=(0,L.generateUuid)()+Date.now(),a.commitHash=v,a.version=h,a["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,R.PlatformToString)(R.platform),a["common.nodePlatform"]=r.platform,a["common.nodeArch"]=p,a["common.product"]=g||"desktop",C&&(a["common.msftInternal"]=C);let f=0;const l=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),R.isLinuxSnap&&(a["common.snap"]="true");const i=A(w);i&&(a["common.platformDetail"]=i);try{const s=await b.readFile(D.URI.file(m));a["common.source"]=s.value.toString().slice(0,30)}catch{}return a}e.resolveCommonProperties=P;function E(b){const I=r.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return b.some(p=>w===p)}e.verifyMicrosoftInternalDomain=E}),define(ne[23],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[219],re([0,1,37,52,6,35,22,12,4,7,132,28,134,92,13,25,23]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function g(s,t){const n=`${s}::${t.join(":")}`,o=m.get(n);if(o)return o;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,d=new Map,y=2e4;function _(T,O,k,M){const $=O.substring(T.length+1);return D.Promises.withAsyncBody(async q=>{let J;try{J=await w.Promises.readdir(O,{withFileTypes:!0})}catch{q();return}if(M.count>=y){M.count+=J.length,M.maxReached=!0,q();return}let H=J.length;if(H===0){q();return}let G=J;M.count+J.length>y&&(M.maxReached=!0,H=y-M.count,G=J.slice(0,H)),M.count+=J.length;for(const z of G)if(z.isDirectory()){if(k.includes(z.name)||await _(T,(0,P.join)(O,z.name),k,M),--H===0){q();return}}else{const x=z.name.lastIndexOf(".");if(x>=0){const Y=z.name.substring(x+1);Y&&c.set(Y,(c.get(Y)??0)+1)}for(const Y of u)Y.relativePathPattern?.test($)!==!1&&Y.filePattern.test(z.name)&&d.set(Y.tag,(d.get(Y.tag)??0)+1);if(--H===0){q();return}}})}const F=D.Promises.withAsyncBody(async T=>{const O={count:0,maxReached:!1};await _(s,s,t,O);const k=await l(s);T({configFiles:a(d),fileTypes:a(c),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:k})});return m.set(n,F),F}e.collectWorkspaceStats=g;function a(s){return[...r.Iterable.map(s.entries(),([t,n])=>({name:t,count:n}))].sort((t,n)=>n.count-t.count)}function f(){const s={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=f;async function l(s){try{const t=new Map,n=(0,P.join)(s,".vscode","launch.json"),o=await w.Promises.readFile(n),u=[],c=(0,L.parse)(o.toString(),u);if(u.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(c)==="object"&&c.configurations)for(const d of c.configurations){const y=d.type;y&&(t.has(y)?t.set(y,t.get(y)+1):t.set(y,1))}return a(t)}catch{return[]}}e.collectLaunchConfigs=l;let i=class{constructor(t,n){this.telemetryService=t,this.productService=n}formatMachineInfo(t){const n=[];return n.push(`OS Version:       ${t.os}`),n.push(`CPUs:             ${t.cpus}`),n.push(`Memory (System):  ${t.memory}`),n.push(`VM:               ${t.vmHint}`),n.join(`
`)}formatEnvironment(t){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const o=R.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||n.push(`Load (avg):       ${R.loadavg().map(u=>Math.round(u)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${t.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(t,n){return Promise.all([(0,p.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[u,c]=o,d=this.formatProcessList(t,u);return n.forEach(y=>{if((0,v.isRemoteDiagnosticError)(y))d+=`
${y.errorMessage}`,c+=`
${y.errorMessage}`;else if(d+=`

Remote: ${y.hostName}`,y.processes&&(d+=`
${this.formatProcessList(t,y.processes)}`),y.workspaceMetadata){c+=`
|  Remote: ${y.hostName}`;for(const _ of Object.keys(y.workspaceMetadata)){const F=y.workspaceMetadata[_];let T=`${F.fileCount} files`;F.maxFilesReached&&(T=`more than ${T}`),c+=`|    Folder (${_}): ${T}`,c+=this.formatWorkspaceStats(F)}}}),{processInfo:d,workspaceInfo:c}})}async getSystemInfo(t,n){const{memory:o,vmHint:u,os:c,cpus:d}=f(),y={os:c,memory:o,cpus:d,vmHint:u,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:n};return E.isWindows||(y.load=`${R.loadavg().map(_=>Math.round(_)).join(", ")}`),E.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(t,n){const o=[];return(0,p.listProcesses)(t.mainPID).then(async u=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,u)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),n.forEach(c=>{if((0,v.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const d of Object.keys(c.workspaceMetadata)){const y=c.workspaceMetadata[d];let _=`${y.fileCount} files`;y.maxFilesReached&&(_=`more than ${_}`),o.push(`Folder (${d}): ${_}`),o.push(this.formatWorkspaceStats(y))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const n=[];let u=0;const c=(F,T)=>{const O=` ${F}(${T})`;u+O.length>60?(n.push(d),d="|                 ",u=d.length):u+=O.length,d+=O};let d="|      File types:";const y=10,_=t.fileTypes.length>y?y:t.fileTypes.length;for(let F=0;F<_;F++){const T=t.fileTypes[F];c(T.name,T.count)}if(n.push(d),t.configFiles.length>=0&&(d="|      Conf files:",u=0,t.configFiles.forEach(F=>{c(F.name,F.count)}),n.push(d)),t.launchConfigFiles.length>0){let F="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{F+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),n.push(F)}return n.join(`
`)}expandGPUFeatures(t){const n=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const n=[],o=[];return t.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(n.push(`|  Window (${u.title})`),u.folderURIs.forEach(c=>{const d=b.URI.revive(c);if(d.scheme===A.Schemas.file){const y=d.fsPath;o.push(g(y,["node_modules",".git"]).then(_=>{let F=`${_.fileCount} files`;_.maxFilesReached&&(F=`more than ${F}`),n.push(`|    Folder (${(0,P.basename)(y)}): ${F}`),n.push(this.formatWorkspaceStats(_))}).catch(_=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${_.toString()})`)}))}else n.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(u=>n.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(t,n){const o=new Map;t.windows.forEach(c=>o.set(c.pid,c.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(t.mainPID,o,u,n,0),u.join(`
`)}formatProcessItem(t,n,o,u,c){const d=c===0;let y;d?y=u.pid===t?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(c)} ${u.name}`,u.name==="window"&&(y=`${y} (${n.get(u.pid)})`));const _=process.platform==="win32"?u.mem:R.totalmem()*(u.mem/100);o.push(`${u.load.toFixed(0).padStart(5," ")}	${(_/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(u.children)&&u.children.forEach(F=>this.formatProcessItem(t,n,o,F,c+1))}async getWorkspaceFileExtensions(t){const n=new Set;for(const{uri:o}of t.folders){const u=b.URI.revive(o);if(u.scheme!==A.Schemas.file)continue;const c=u.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(t){for(const{uri:n}of t.folders){const o=b.URI.revive(n);if(o.scheme!==A.Schemas.file)continue;const u=o.fsPath;try{const c=await g(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})}),c.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})}),c.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};i=pe([K(0,C.ITelemetryService),K(1,S.IProductService)],i),e.DiagnosticsService=i}),define(ne[105],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:P,data:E}){return this.appenders.forEach(b=>b.log(P,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class r{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(ne[50],re([0,1,32,82,15,18,104,23]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,r.staticObservableValue)(0)}publicLog(i,s){return Promise.resolve(void 0)}publicLog2(i,s){return this.publicLog(i,s)}publicLogError(i,s){return Promise.resolve(void 0)}publicLogError2(i,s){return this.publicLogError(i,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class b{async publicLog(i,s,t){}async publicLogError(i,s,t){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(l,i){return i.onDidChangeConfiguration(s=>{s.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(s.source),configurationKeys:m(s.sourceConfig)})})}e.configurationTelemetry=I;function w(l,i){return!(i.disableTelemetry||!l.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=w;function p(l){const i=l.getValue(P.TELEMETRY_SETTING_ID),s=l.getValue("telemetry.enableCrashReporter");if(l.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function v(l){const i={},s={},t={};C(l,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const o=t[n];typeof o=="number"?s[n]=o:typeof o=="boolean"?s[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),i[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(i[n]=o)}return{properties:i,measurements:s}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(l){if(!l)return"none";for(const i of h)if(l.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=S;function C(l,i,s=0,t){if(!!l)for(const n of Object.getOwnPropertyNames(l)){const o=l[n],u=t?t+n:n;Array.isArray(o)?i[u]=(0,R.safeStringify)(o):o instanceof Date?i[u]=o.toISOString():(0,D.isObject)(o)?s<2?C(o,i,s+1,u+"."):i[u]=(0,R.safeStringify)(o):i[u]=o}}function m(l){if(!l)return[];const i=[];return g(i,"",l),i}function g(l,i,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(t=>g(l,i?`${i}.${t}`:t,s[t])):l.push(i)}function a(l,i){const s=l.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(s)||t}e.isInternalTelemetry=a;function f(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(ne[220],re([0,1,48,50]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(L,A,P,E,b,I,w){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`};if((0,r.supportsTelemetry)(A,P)&&(0,r.getTelemetryLevel)(E)===3){const v=await(0,R.getServiceMachineId)(P,b,I),{sessionId:h}=await w.getTelemetryInfo();p["X-Market-User-Id"]=v,p["VSCode-SessionId"]=h}return p}e.resolveMarketplaceHeaders=D}),define(ne[221],re([0,1,9,32,50]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(E,b,I){const w=await new Promise((C,m)=>{Q(["@microsoft/1ds-core-js"],C,m)}),p=await new Promise((C,m)=>{Q(["@microsoft/1ds-post-js"],C,m)}),v=new w.AppInsightsCore,h=new p.PostChannel,S={instrumentationKey:E,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(I){S.extensionConfig={};const C={alwaysUseXhrOverride:!0,httpXHROverride:I};S.extensionConfig[h.identifier]=C}return v.initialize(S,[]),v.addTelemetryInitializer(C=>{b&&(C.ext=C.ext??{},C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),v}class P{constructor(b,I,w,p,v){this._isInternalTelemetry=b,this._eventPrefix=I,this._defaultData=w,this._xhrOverride=v,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(b){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{b(I)},I=>{(0,R.onUnexpectedError)(I),console.error(I)})}}log(b,I){if(!this._aiCoreOrKey)return;I=(0,r.mixin)(I,this._defaultData),I=(0,D.validateTelemetryData)(I);const w=this._eventPrefix+"/"+b;try{this._withAIClient(p=>{p.pluginVersionString=I?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ne[106],re([0,1,2,14,8,50]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(E,b,I=""){super(),this.prefix=I;const w=E.getLogger(b.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(E.createLogger(b.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,b){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,L.validateTelemetryData)(b))}};A=pe([K(0,D.ILoggerService),K(1,r.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[107],re([0,1,2,32,82,4,27,158,18,43,99,25,40,23,50]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(g,a,f){this._configurationService=a,this._productService=f,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,a){this._experimentProperties[g]=a}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const f=a.usage?3:a.error?2:0;g=Math.min(g,f)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,a=g.sessionID,f=g["common.machineId"],l=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:a,machineId:f,firstSessionDate:l,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,a,f,l){return this.telemetryLevel.value<a?Promise.resolve(void 0):this._commonProperties.then(i=>{f=(0,r.mixin)(f,i),f=(0,r.mixin)(f,this._experimentProperties),f=(0,r.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,l)}),this._appenders.forEach(s=>s.log(g,f))},i=>{console.error(i)})}publicLog(g,a,f){return this._log(g,3,a,f)}publicLog2(g,a,f){return this.publicLog(g,a,f)}publicLogError(g,a){return this._sendErrorTelemetry?this._log(g,2,a,!0):Promise.resolve(void 0)}publicLogError2(g,a){return this.publicLogError(g,a)}_anonymizeFilePaths(g){let a=g;const f=[];for(const t of this._cleanupPatterns)for(;;){const n=t.exec(g);if(!n)break;f.push([n.index,t.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(a="";;){const t=i.exec(g);if(!t)break;!l.test(t[0])&&f.every(([n,o])=>t.index<n||t.index>=o)&&(a+=g.substring(s,t.index)+"<REDACTED: user-file-path>",s=i.lastIndex)}return s<g.length&&(a+=g.substr(s)),a}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const a=g.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of f)if(l.regex.test(a))return`<REDACTED: ${l.label}>`;return g}_cleanupInfo(g,a){let f=g;a&&(f=this._anonymizeFilePaths(f));for(const l of this._cleanupPatterns)f=f.replace(l,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=pe([K(1,E.IConfigurationService),K(2,w.IProductService)],S),e.TelemetryService=S;function C(){const m=(0,P.localize)(0,null,I.default.nameLong),g=I.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=L.isWeb?"":(0,P.localize)(3,null),f=(0,P.localize)(4,null),l=(0,P.localize)(5,null),i=(0,P.localize)(6,null),s=(0,P.localize)(7,null),t=`
|       | ${f} | ${l} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,P.localize)(8,null);return`
${m} ${g} ${a}

&nbsp;

${s}
${t}

&nbsp;

${n}
`}p.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,P.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,P.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[222],re([0,1,279,221]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends r.AbstractOneDataSystemAppender{constructor(A,P,E,b){const I={sendPOST:(w,p)=>{const v={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const h=R.request(w.urlString,v,S=>{S.on("data",function(C){p(S.statusCode??200,S.headers,C.toString())}),S.on("error",function(C){p(0,{})})});h.write(w.data),h.end()}catch{p(0,{})}}};super(A,P,E,b,I)}}e.OneDataSystemAppender=D}),define(ne[223],re([0,1,22,66,18,14,8,25,23,105,106,107]),function(Q,e,R,r,D,L,A,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(h,S,C,m,g){this.configurationService=h,this.telemetryService=S,this.loggerService=C,this.environmentService=m,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:S,sessionId:C}=await this.telemetryService.getTelemetryInfo(),m=Object.create(null);m["common.vscodemachineid"]=S,m["common.vscodesessionid"]=C;const g=[h.id,JSON.stringify(m),h.aiKey],f=new r.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new b.TelemetryAppenderClient(f),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new w.TelemetryService({appenders:l,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,S,C){await(await this.getCustomTelemetryService(h)).publicLog(S,C)}async publicLogError(h,S,C){await(await this.getCustomTelemetryService(h)).publicLogError(S,C)}};p=pe([K(0,D.IConfigurationService),K(1,E.ITelemetryService),K(2,A.ILoggerService),K(3,L.IEnvironmentService),K(4,P.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(ne[224],re([0,1,6,24,3,2,8]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(b,I){super(),this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((I,w)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,I),this._onCreateRequest.fire({requestId:p,...b});const v=new r.CancellationTokenSource;(0,R.timeout)(this._timeout,v.token).then(()=>w(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(b,I){const w=this._pendingRequests.get(b);w?(this._pendingRequests.delete(b),(0,L.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),w(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=pe([K(1,A.ILogService)],P),e.RequestStore=P}),define(ne[108],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var r;(function(a){a.Shell="terminal.integrated.shell.",a.ShellArgs="terminal.integrated.shellArgs.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(r=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(a){a.ShellLinux="terminal.integrated.shell.linux",a.ShellMacOs="terminal.integrated.shell.osx",a.ShellWindows="terminal.integrated.shell.windows",a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationShellLinux="terminal.integrated.automationShell.linux",a.AutomationShellMacOs="terminal.integrated.automationShell.osx",a.AutomationShellWindows="terminal.integrated.automationShell.windows",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ShellArgsLinux="terminal.integrated.shellArgs.linux",a.ShellArgsMacOs="terminal.integrated.shellArgs.osx",a.ShellArgsWindows="terminal.integrated.shellArgs.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(a){a.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var P;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.Log="log",a.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var I;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(a){a.TerminalView="view",a.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}));var m;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(m=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[225],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(ne[226],re([0,1,37,22,32,12,4,36,27,15,28]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let l=0;return f&&f.length===4&&(l=parseInt(f[3])),l}e.getWindowsBuildNumber=w;async function p(f,l,i,s=P.env,t=I.Promises.exists){if(L.isAbsolute(f))return await t(f)?f:void 0;if(l===void 0&&(l=P.cwd()),L.dirname(f)!=="."){const c=L.join(l,f);return await t(c)?c:void 0}const o=(0,D.getCaseInsensitive)(s,"PATH");if(i===void 0&&(0,b.isString)(o)&&(i=o.split(L.delimiter)),i===void 0||i.length===0){const c=L.join(l,f);return await t(c)?c:void 0}for(const c of i){let d;if(L.isAbsolute(c)?d=L.join(c,f):d=L.join(l,c,f),await t(d))return d;if(A.isWindows){let y=d+".com";if(await t(y)||(y=d+".exe",await t(y)))return y}}const u=L.join(l,f);return await t(u)?u:void 0}e.findExecutable=p;function v(f,l,i,s){if(!l.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const t=f.args,n=P.platform==="win32"?L.basename(f.executable).toLowerCase():L.basename(f.executable),o=L.dirname(r.FileAccess.asFileUri("",Q).fsPath);let u;const c={VSCODE_INJECTION:"1"};if(A.isWindows){if(n==="pwsh.exe")return!t||g(t)?u=e.shellIntegrationArgs.get(h.WindowsPwsh):m(t)&&(u=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),u?(u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],o,""),{newArgs:u,envMixin:c}):void 0;s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(n){case"bash":return!t||t.length===0?u=e.shellIntegrationArgs.get(h.Bash):a(t)&&(c.VSCODE_SHELL_LOGIN="1",u=e.shellIntegrationArgs.get(h.Bash)),u?(u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],o),{newArgs:u,envMixin:c}):void 0;case"pwsh":return!t||g(t)?u=e.shellIntegrationArgs.get(h.Pwsh):m(t)&&(u=e.shellIntegrationArgs.get(h.PwshLogin)),u?(u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],o,""),{newArgs:u,envMixin:c}):void 0;case"zsh":{if(!t||t.length===0?u=e.shellIntegrationArgs.get(h.Zsh):a(t)?u=e.shellIntegrationArgs.get(h.ZshLogin):(t===e.shellIntegrationArgs.get(h.Zsh)||t===e.shellIntegrationArgs.get(h.ZshLogin))&&(u=t),!u)return;u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],o);const d=L.join(R.tmpdir(),`${R.userInfo().username}-vscode-zsh`);c.ZDOTDIR=d;const y=i?.ZDOTDIR??R.homedir()??"~";c.USER_ZDOTDIR=y;const _=[];return _.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(d,".zshrc")}),_.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(d,".zprofile")}),_.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(d,".zshenv")}),_.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(d,".zlogin")}),{newArgs:u,envMixin:c,filesToCopy:_}}}s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=v;var h;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],C=["-nol","-nologo"];function m(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(C.includes(f[0].toLowerCase())||C.includes(f[1].toLowerCase()))}function g(f){return typeof f=="string"?C.includes(f.toLowerCase()):f.length===0||f?.length===1&&C.includes(f[0].toLowerCase())}function a(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(ne[227],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function r(L){return L===R.HIGH_CONTRAST_DARK||L===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=r;function D(L){return L===R.DARK||L===R.HIGH_CONTRAST_DARK}e.isDark=D}),define(ne[109],re([0,1,51,3,2,5,40,227]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(C){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=m})(E=e.ThemeColor||(e.ThemeColor={}));function b(C){return{id:C}}e.themeColorFromId=b;var I;(function(C){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||E.isThemeColor(n.color))}C.isThemeIcon=m;const g=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function a(n){const o=g.exec(n);if(!o)return;const[,u]=o;return{id:u}}C.fromString=a;function f(n){return{id:n}}C.fromId=f;function l(n,o){let u=n.id;const c=u.lastIndexOf("~");return c!==-1&&(u=u.substring(0,c)),o&&(u=`${u}~${o}`),{id:u}}C.modify=l;function i(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}C.getModifier=i;function s(n,o){return n.id===o.id&&n.color?.id===o.color?.id}C.isEqual=s;function t(n,o){return{id:n.id,color:o?b(o):void 0}}C.asThemeIcon=t,C.asClassNameArray=R.CSSIcon.asClassNameArray,C.asClassName=R.CSSIcon.asClassName,C.asCSSSelector=R.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function w(C){switch(C){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const g=this.themingParticipants.indexOf(m);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new p;A.Registry.add(e.Extensions.ThemingContribution,v);function h(C){return v.onColorThemeChange(C)}e.registerThemingParticipant=h;class S extends D.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,g){let a=this.theme.getColor(m);return a&&g&&(a=g(a,this.theme)),a?a.toString():null}}e.Themable=S}),define(ne[228],re([0,1,51,7,160,109]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(p,v){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...p.map(S=>({name:S.profileName,description:P(S)}))),v&&h.push(...v.map(S=>({name:S.title,description:E(S)}))),{values:h.map(S=>S.name),markdownDescriptions:h.map(S=>S.description)}}e.createProfileSchemaEnums=A;function P(p){let v=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:R.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?v+=`
- args: "${p.args}"`:v+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(v+=`
- overrideName: ${p.overrideName}`),p.color&&(v+=`
- color: ${p.color}`),p.env&&(v+=`
- env: ${JSON.stringify(p.env)}`),v}function E(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:R.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function b(p,v){if(!p&&!v)return!0;if(typeof p=="string"&&typeof v=="string")return p===v;if(Array.isArray(p)&&Array.isArray(v)){if(p.length!==v.length)return!1;for(let h=0;h<p.length;h++)if(p[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function I(p,v){if(!p&&!v)return!0;if(!p||!v)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(v))return p.id===v.id&&p.color===v.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof v=="object"&&"light"in v&&"dark"in v){const h=p,S=v;if((r.URI.isUri(h.light)||w(h.light))&&(r.URI.isUri(h.dark)||w(h.dark))&&(r.URI.isUri(S.light)||w(S.light))&&(r.URI.isUri(S.dark)||w(S.dark)))return h.light.path===S.light.path&&h.dark.path===S.dark.path}if(r.URI.isUri(p)&&r.URI.isUri(v)||w(p)||w(v)){const h=p,S=v;return h.path===S.path&&h.scheme===S.scheme}return!1}e.terminalIconsEqual=I;function w(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=w}),define(ne[229],re([0,1,51,159,43,40,228]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(R.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),f=>`$(${f.id})`)};const P={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...P}},I=(0,r.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,r.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,r.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,r.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,r.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(26,null)}},{type:"string",markdownDescription:(0,r.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(34,null),type:"string"},id:{description:(0,r.localize)(35,null),type:"string"},title:{description:(0,r.localize)(36,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(38,null),type:"string"},id:{description:(0,r.localize)(39,null),type:"string"},title:{description:(0,r.localize)(40,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){L.Registry.as(D.Extensions.Configuration).registerConfiguration(C),a()}e.registerTerminalPlatformConfiguration=m;let g;function a(f,l){const i=L.Registry.as(D.Extensions.Configuration);let s;f&&(s=(0,A.createProfileSchemaEnums)(f?.profiles,l));const t=g;g={id:"terminal",order:100,title:(0,r.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?s?.values:void 0,markdownEnumDescriptions:f?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?s?.values:void 0,markdownEnumDescriptions:f?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?s?.values:void 0,markdownEnumDescriptions:f?.os===1?s?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=a}),define(ne[230],re([0,1,54,51,12,4,28,86,226,109]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,w=!0;function p(s,t,n,o,u=process.env,c,d,y,_){return c=c||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?v(n,c,u,d,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),_,y):f(c,d,n,s&&typeof s=="object"?{...s}:o.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,y,u)}e.detectAvailableProfiles=p;async function v(s,t,n,o,u,c,d,y,_){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let O=!1;(0,E.getWindowsBuildNumber)()>=16299&&(O=!0),await C(y);const k=new Map;s&&(k.set("PowerShell",{source:"PowerShell",icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:r.Codicon.terminalCmd,isAutoDetected:!0})),l(c,k);const M=await h(k.entries(),d,t,n,o,_);if(s||u)try{const $=await g(`${T}\\${O?"wsl":"bash"}.exe`,d);for(const q of $)(!c||!(q.profileName in c))&&M.push(q)}catch{w&&(o?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return M}async function h(s,t,n,o=process.env,u,c){const d=[];for(const[y,_]of s){if(_===null)continue;let F,T,O;if("source"in _){const $=I?.get(_.source);if(!$)continue;F=$.paths,T=_.args||$.args,_.icon?O=S(_.icon):$.icon&&(O=$.icon)}else F=Array.isArray(_.path)?_.path:[_.path],T=L.isWindows||Array.isArray(_.args)?_.args:void 0,O=S(_.icon);const k=await c?.(F)||F.slice(),M=await i(y,t,k,n,o,T,_.env,_.overrideName,_.isAutoDetected,u);M?(M.isAutoDetected=_.isAutoDetected,M.icon=O,M.color=_.color,d.push(M)):u?.debug("Terminal profile not validated",y,F)}return u?.debug("Validated terminal profiles",d),d}function S(s){return typeof s=="string"?{id:s}:s}async function C(s){I&&!s||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:s||await m(),icon:b.ThemeIcon.asThemeIcon(r.Codicon.terminalPowershell)}))}async function m(){const s=[];for await(const t of(0,P.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function g(s,t){const n=[],o=await new Promise((d,y)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,F)=>{if(_)return y("Problem occurred when getting wsl distros");d(F)})});if(!o)return[];const u=new RegExp(/[\r?\n]/),c=o.split(u).filter(d=>d.trim().length>0&&d!=="");for(const d of c){if(d===""||d.startsWith("docker-desktop"))continue;const y=`${d} (WSL)`,_={profileName:y,path:s,args:["-d",`${d}`],isDefault:y===t,icon:a(d),isAutoDetected:!1};n.push(_)}return n}function a(s){return s.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(r.Codicon.terminalUbuntu):s.includes("Debian")?b.ThemeIcon.asThemeIcon(r.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(r.Codicon.terminalLinux)}async function f(s,t,n,o,u,c,d,y){const _=new Map;if(n){const F=(await s.readFile("/etc/shells")).toString(),T=c||F.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),O=new Map;for(const k of T){let M=(0,D.basename)(k),$=O.get(M)||0;$++,$>1&&(M=`${M} (${$})`),O.set(M,$),_.set(M,{path:k,isAutoDetected:!0})}}return l(o,_),await h(_.entries(),u,s,y,t,d)}function l(s,t){if(!!s)for(const[n,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?t.delete(n):(o.icon=o.icon||t.get(n)?.icon,t.set(n,o))}async function i(s,t,n,o,u,c,d,y,_,F){if(n.length===0)return Promise.resolve(void 0);const T=n.shift();if(T==="")return i(s,t,n,o,u,c,d,y,_);const O={profileName:s,path:T,args:c,env:d,overrideName:y,isAutoDetected:_,isDefault:s===t};if((0,D.basename)(T)===T){const M=u.PATH?u.PATH.split(D.delimiter):void 0,$=await(0,E.findExecutable)(T,void 0,M,void 0,o.existsFile);return $?(O.path=$,O.isFromPath=!0,O):i(s,t,n,o,u,c)}return await o.existsFile((0,D.normalize)(T))?O:i(s,t,n,o,u,c,d,y,_)}}),define(ne[231],re([0,1,3,2,22,4,39,66,18,14,90,217,8,98,224,108,229,230]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let a=0,f=class extends r.Disposable{constructor(i,s,t,n){super(),this._reconnectConstants=i,this._configurationService=s,this._environmentService=t,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,C.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,r.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?i.debugBrk=s.port:!s.break&&s.port&&(i.debug=s.port));const t=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,i);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(c=>{this._onPtyHostExit.fire(c.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const o=t.getChannel(S.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(c=>this._onProcessData.fire(c))),this._register(u.onProcessReady(c=>this._onProcessReady.fire(c))),this._register(u.onProcessExit(c=>this._onProcessExit.fire(c))),this._register(u.onDidChangeProperty(c=>this._onDidChangeProperty.fire(c))),this._register(u.onProcessReplay(c=>this._onProcessReplay.fire(c))),this._register(u.onProcessOrphanQuestion(c=>this._onProcessOrphanQuestion.fire(c))),this._register(u.onDidRequestDetach(c=>this._onDidRequestDetach.fire(c))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,s,t,n,o,u,c,d,y,_,F){const T=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(i,s,t,n,o,u,c,d,y,_,F);return clearTimeout(T),a=Math.max(a,O),O}updateTitle(i,s,t){return this._proxy.updateTitle(i,s,t)}updateIcon(i,s,t,n){return this._proxy.updateIcon(i,s,t,n)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,s){return this._proxy.detachFromProcess(i,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,s){return this._proxy.shutdown(i,s)}input(i,s){return this._proxy.input(i,s)}processBinary(i,s){return this._proxy.processBinary(i,s)}resize(i,s,t){return this._proxy.resize(i,s,t)}acknowledgeDataEvent(i,s){return this._proxy.acknowledgeDataEvent(i,s)}setUnicodeVersion(i,s){return this._proxy.setUnicodeVersion(i,s)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,s){return this._proxy.installAutoReply(i,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,s,t,n=!1){const o=await this._shellEnv;return(0,m.detectAvailableProfiles)(s,t,n,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,s){return this._proxy.requestDetachInstance(i,s)}async acceptDetachInstanceReply(i,s){return this._proxy.acceptDetachInstanceReply(i,s)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,s){return this._proxy.reviveTerminalProcesses(i,s)}async refreshProperty(i,s){return this._proxy.refreshProperty(i,s)}async updateProperty(i,s,t){return this._proxy.updateProperty(i,s,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:s})}async acceptPtyHostResolvedVariables(i,s){this._resolveVariablesRequestStore.acceptReply(i,s)}};f=pe([K(1,E.IConfigurationService),K(2,b.IEnvironmentService),K(3,p.ILogService)],f),e.PtyHostService=f}),define(ne[72],re([0,1,3,4,5,8]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=w;function p(S,C){return C?C!==1&&S<1024:!r.isWindows&&S<1024}e.isPortPrivileged=p;class v{constructor(C,m,g){this.remoteAddress=C,this.localAddress=m,this._dispose=g,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let h=class{constructor(C){this.logService=C,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],m=Array.from(this._tunnels.values());for(const g of m){const a=Array.from(g.values());for(const f of a){const l=await f.value;l&&C.push(l)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:m}of C.values())await m.then(g=>g?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,m,g,a,f=!1,l,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${g} on local port ${a}.`),!C)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(C,m,g,a,f,l,i);return s?s.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(t);return(t.tunnelRemoteHost!==m||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const m=this._tunnels.get(C.tunnelRemoteHost);if(m){const g=m.get(C.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,g))}}}}async tryDisposeTunnel(C,m,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${m}.`);const a=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(m),a}}async closeTunnel(C,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${m} `);const g=this._tunnels.get(C);if(g&&g.has(m)){const a=g.get(m);a.refcount=0,await this.tryDisposeTunnel(C,m,a)}}addTunnelToMap(C,m,g){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(m,{refcount:1,value:g})}async removeEmptyTunnelFromMap(C,m){const g=this._tunnels.get(C);g&&(await g.get(m)||g.delete(m),g.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,m){const g=[C];I(C)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(C)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const a=g.map(f=>this._tunnels.get(f));for(const f of a){const l=f?.get(m);if(l)return l}}canTunnel(C){return!!b(C)}createWithProvider(C,m,g,a,f,l,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${g} on local port ${a}.`);const s=g;this._factoryInProgress.add(s);const n={elevationRequired:f?p(a===void 0?g:a):!1},o={remoteAddress:{host:m,port:g},localAddressPort:a,privacy:l,public:l?l!==P.Private:void 0,protocol:i},u=C.forwardPort(o,n);return u?(this.addTunnelToMap(m,g,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),u}};h=pe([K(0,L.ILogService)],h),e.AbstractTunnelService=h}),define(ne[232],re([0,1,8,72,2,9,6]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let E=class It extends D.Disposable{constructor(I,w){super(),this._tunnelService=I,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(I,w,p,v,h,S){const C=new P,m=await Promise.resolve(this._tunnelService.openTunnel(I,C,p,v,h,S));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${v} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),C.dispose(),await m.dispose(),(0,L.canceled)();return C.setTunnel(m),this._tunnels.set(w,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${p}:${v} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,w){const p=this._tunnels.get(I);!p||p.setAddress(w)}async destroyTunnel(I){const w=this._tunnels.get(I);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await w.dispose();return}this._disposedTunnels.add(I)}};E._lastId=0,E=pe([K(0,r.ISharedTunnelsService),K(1,R.ILogService)],E),e.SharedProcessTunnelService=E}),define(ne[233],re([0,1,80,119,208,6,2,18,8,25,206,72,103]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(g,a,f,l,i){let s;for(let t=3;t&&(s?.dispose(),s=await new h(g,a,f,l,i).waitForReady(),!(i&&r.BROWSER_RESTRICTED_PORTS[i]||!r.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));t--);return s}class h extends A.Disposable{constructor(a,f,l,i,s){super(),this.defaultTunnelHost=f,this.suggestedLocalPort=s,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=R.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let a=await(0,r.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(a){a.pause();const f=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),i=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&a.write(s.buffer),a.on("end",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.destroy()}),i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),a.pipe(i),i.pipe(a),a.localAddress&&this._socketsDispose.set(a.localAddress,()=>{a.end(),i.end()})}}let S=class extends w.AbstractTunnelService{constructor(a,f,l,i,s){super(f),this.socketFactory=a,this.signService=l,this.productService=i,this.configurationService=s}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(a,f,l,i,s,t,n){const o=this.getTunnelFromMap(f,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,l,i,s,t,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${l} on local port ${i}.`);const u={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:a,signService:this.signService,logService:this.logService,ipcLogger:null},c=v(u,this.defaultTunnelHost,f,l,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,l,c),c}}};S=pe([K(1,E.ILogService),K(2,p.ISignService),K(3,b.IProductService),K(4,P.IConfigurationService)],S),e.BaseTunnelService=S;let C=class extends S{constructor(a,f,l,i){super(D.nodeSocketFactory,a,f,l,i)}};C=pe([K(0,E.ILogService),K(1,p.ISignService),K(2,b.IProductService),K(3,P.IConfigurationService)],C),e.TunnelService=C;let m=class extends A.Disposable{constructor(a,f,l,i){super(),this.logService=a,this.productService=f,this.signService=l,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(a,f,l,i,s,t,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${s}.`),!this._tunnelServices.has(a)){const u=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(u),this._tunnelServices.set(a,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(f,l,i,s,t,n,o)}};m=pe([K(0,E.ILogService),K(1,b.IProductService),K(2,p.ISignService),K(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(ne[31],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ne[234],re([0,1,3,2,7,14,33,13,8,31]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends r.Disposable{constructor(p,v,h,S,C){super(),this.extensionsManagementService=p,this.logService=S,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(g=>this.onInstallExtension(g))),this._register(p.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(p.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const m=D.URI.file(h.extensionsPath);this._register(v.watch(m)),this._register(R.Event.filter(v.onDidFilesChange,g=>g.rawChanges.some(a=>this.doesChangeAffects(a,m)))(()=>this.onDidChange()))}doesChangeAffects(p,v){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),v)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const v of p)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(v=>!(0,A.areSameExtensions)(v,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,A.areSameExtensions)(v,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),v=p.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,A.areSameExtensions)(C,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(C=>(0,A.areSameExtensions)(C,S))?!1:p.every(C=>!(0,A.areSameExtensions)(C.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=p.map(S=>S.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};I=pe([K(1,P.IFileService),K(2,L.INativeEnvironmentService),K(3,E.ILogService),K(4,b.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[235],re([0,1,31,91,13,17,117,3,2]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(p){this.uri=p,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(p){this._fileService=p,this._dispooables=new E.DisposableStore,this._limit=2**16;const v=new Map,h=S=>{let C=v.get(S.scheme);return C===void 0&&(C=p.hasProvider(S)&&!this._fileService.hasCapability(S,1024),v.set(S.scheme,C)),C};this._dispooables.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{v.delete(S.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new A.SkipList((S,C)=>this.extUri.compare(S,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,L.normalizePath)(p));const v=this._canonicalUris.get(p);return v?v.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new b(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(p[h][0],p[h][1].touch())}};I=pe([K(0,D.IFileService)],I),e.UriIdentityService=I,(0,r.registerSingleton)(R.IUriIdentityService,I,!0)}),define(ne[236],re([0,1,3,2,13,42,34,16]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class E extends r.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(I,w,p,v){super(),this.fileSystemScheme=I,this.fileSystemProvider=w,this.userDataScheme=p,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}watch(I,w){this.watchResources.set(I,I);const p=this.fileSystemProvider.watch(this.toFileSystemResource(I),w);return(0,r.toDisposable)(()=>{this.watchResources.delete(I),p.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,w,p){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(w),p)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,w,p){const v=(0,L.newWriteableStream)(h=>P.VSBuffer.concat(h.map(S=>P.VSBuffer.wrap(S))).buffer);return(async()=>{try{const h=await this.readFile(I);v.end(h)}catch(h){v.error(h),v.end()}})(),v}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,w,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),w,p)}delete(I,w){return this.fileSystemProvider.delete(this.toFileSystemResource(I),w)}copy(I,w,p){if((0,D.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(w),p);throw new Error("copy not supported")}handleFileChanges(I){const w=[];for(const p of I){if(p.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(p.resource);this.watchResources.findSubstr(v)&&w.push({resource:v,type:p.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=E}),define(ne[61],re([0,1,79]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function r(A,P,E,b){const I=(0,R.setProperty)(A,P,E,b)[0];return I&&(A=A.substring(0,I.offset)+I.content+A.substring(I.offset+I.length)),A}e.edit=r;function D(A,P,E){let b=E;for(;b>=0;){if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&A.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function L(A,P,E){let b=E;for(;b>=0;)if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&A.charAt(b)===P.charAt(1)))return b;return A.length-1}e.getLineEndOffset=L}),define(ne[237],re([0,1,32,55,15]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(p,v,h,S,C){const m=[],g=[],a=[];if(!v){const T=p.filter(({identifier:O})=>C.every(k=>k.toLowerCase()!==O.id.toLowerCase()));return{local:{added:m,removed:g,updated:a},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}p=p.map(I),v=v.map(I),h=h?h.map(I):null;const f=new Map,l=T=>{T.uuid&&f.set(T.id.toLowerCase(),T.uuid)};p.forEach(({identifier:T})=>l(T)),v.forEach(({identifier:T})=>l(T)),h?.forEach(({identifier:T})=>l(T));const i=T=>{const O=T.identifier.uuid||f.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},s=(T,O)=>(T.set(i(O),O),T),t=p.reduce(s,new Map),n=v.reduce(s,new Map),o=v.reduce((T,O)=>{const k=i(O);O=(0,R.deepClone)(O);const M=t.get(k);return M&&(M.installed&&(O.installed=!0),O.version||(O.version=M.version)),s(T,O)},new Map),u=h?h.reduce(s,new Map):null,c=S.reduce(s,new Map),d=C.reduce((T,O)=>{const k=f.get(O.toLowerCase());return T.add(k?`uuid:${k}`:`id:${O.toLowerCase()}`)},new Set),y=A(t,n,d);if(y.added.size>0||y.removed.size>0||y.updated.size>0){const T=A(u,t,d),O=A(u,n,d),k=(M,$)=>{const q=t.get(M);if(q){const J=n.get(M),H=$?J:q;return{...H,version:J.version&&(!q.installed||r.gt(J.version,q.version))?J.version:q.version,state:P(q,J,u?.get(M)),preRelease:(0,D.isUndefined)(H.preRelease)?q.preRelease:q.installed?H.preRelease:J.preRelease}}};for(const M of O.removed.values()){const $=t.get(M);$&&g.push($.identifier)}for(const M of O.added.values())if(T.added.has(M)){if(y.updated.has(M)){const $=k(M,!0);$&&(a.push(w($,M)),o.set(M,$))}}else{const $=n.get(M);$.installed&&m.push(w($,M))}for(const M of O.updated.values()){const $=k(M,!0);$&&(a.push(w($,M)),o.set(M,$))}for(const M of T.added.values())O.added.has(M)||o.set(M,t.get(M));for(const M of T.updated.values())if(!O.removed.has(M)&&!O.updated.has(M)){const $=k(M,!1);$&&(o.get(M)?.installed&&($.installed=!0),o.set(M,$))}for(const M of T.removed.values())!c.has(M)&&!O.updated.has(M)&&u?.get(M)?.installed&&o.delete(M)}const _=[],F=A(n,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(F.added.size>0||F.updated.size>0||F.removed.size>0)&&o.forEach((T,O)=>_.push(w(T,O))),{local:{added:m,removed:g,updated:a},remote:_.length?{added:[...F.added].map(T=>o.get(T)),updated:[...F.updated].map(T=>o.get(T)),removed:[...F.removed].map(T=>n.get(T)),all:_}:null}}e.merge=L;function A(p,v,h,{checkInstalledProperty:S,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=p?[...p.keys()].filter(i=>!h.has(i)):[],g=[...v.keys()].filter(i=>!h.has(i)),a=g.filter(i=>m.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),f=m.filter(i=>g.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),l=new Set;for(const i of m){if(f.has(i))continue;const s=p.get(i),t=v.get(i);(!t||s.disabled!==t.disabled||s.installed&&t.installed&&s.preRelease!==t.preRelease||!b(s.state,t.state)||C&&s.version!==t.version||S&&s.installed!==t.installed)&&l.add(i)}return{added:a,removed:f,updated:l}}function P(p,v,h){const S=p.state,C=v.state,m=h?.state;if(!v.version||S&&r.gt(p.version,v.version))return S;if(C&&r.gt(v.version,p.version)||!S)return C;if(!C)return S;const g=(0,R.deepClone)(S),a=m?E(m,C):{added:Object.keys(C).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set},f=m?E(m,S):{added:Object.keys(S).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set};for(const l of[...a.added.values(),...a.updated.values()])g[l]=C[l];for(const l of a.removed.values())f.updated.has(l)||delete g[l];return g}function E(p,v){const h=Object.keys(p),S=Object.keys(v),C=S.filter(a=>h.indexOf(a)===-1).reduce((a,f)=>(a.add(f),a),new Set),m=h.filter(a=>S.indexOf(a)===-1).reduce((a,f)=>(a.add(f),a),new Set),g=new Set;for(const a of h){if(m.has(a))continue;const f=p[a],l=v[a];(0,R.equals)(f,l)||g.add(a)}return{added:C,removed:m,updated:g}}function b(p={},v={}){const{added:h,removed:S,updated:C}=E(p,v);return h.size===0&&S.size===0&&C.size===0}function I(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function w(p,v){const h={identifier:{id:p.identifier.id,uuid:v.startsWith("uuid:")?v.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(h.version=p.version),p.disabled&&(h.disabled=!0),p.installed&&(h.installed=!0),p.state&&(h.state=p.state),h}}),define(ne[110],re([0,1,19,18,5]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),E&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),E&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(P){const E=P.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),I=[],w=[];if(Array.isArray(b))for(const p of b)p.startsWith("-")?w.push(p.substring(1)):I.push(p);return(0,R.distinct)([...E,...I].filter(p=>w.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};L=pe([K(0,r.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[238],re([0,1,19,35,32,178,61]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(f){return(0,r.parse)(f)||[]}e.parseKeybindings=P;async function E(f,l,i,s,t){const n=P(f),o=P(l),u=i?P(i):null,c=[...n,...o,...u||[]].map(J=>J.key),d=await t.resolveUserBindings(c),y=I(n,o,u,d);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const _=p(n),F=p(o),T=u?p(u):null,O=h(_,F,d),k=T?h(T,_,d):{added:[..._.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},M=T?h(T,F,d):{added:[...F.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},$=b(O,k,M);let q=f;for(const J of $.removed.values())$.conflicts.has(J)||(q=g(q,J,s));for(const J of $.added.values()){if($.conflicts.has(J))continue;const H=F.get(J);if(H.some(G=>G.command!==`-${J}`&&y.conflicts.has(d[G.key]))){$.conflicts.add(J);continue}q=m(q,H,s)}for(const J of $.updated.values()){if($.conflicts.has(J))continue;const H=F.get(J);if(H.some(G=>G.command!==`-${J}`&&y.conflicts.has(d[G.key]))){$.conflicts.add(J);continue}q=a(q,J,H,s)}return{mergeContent:q,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=E;function b(f,l,i){const s=new Set,t=new Set,n=new Set,o=new Set;for(const u of l.removed.values())i.updated.has(u)&&o.add(u);for(const u of i.removed.values())o.has(u)||(l.updated.has(u)?o.add(u):t.add(u));for(const u of l.added.values())o.has(u)||i.added.has(u)&&f.updated.has(u)&&o.add(u);for(const u of i.added.values())o.has(u)||(l.added.has(u)?f.updated.has(u)&&o.add(u):s.add(u));for(const u of l.updated.values())o.has(u)||i.updated.has(u)&&f.updated.has(u)&&o.add(u);for(const u of i.updated.values())o.has(u)||(l.updated.has(u)?f.updated.has(u)&&o.add(u):n.add(u));return{added:s,removed:t,updated:n,conflicts:o}}function I(f,l,i,s){const t=new Set,n=w(f,s),o=w(l,s),u=i?w(i,s):null,c=v(n,o);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const d=u?v(u,n):{added:[...n.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const y=u?v(u,o):{added:[...o.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:_,removed:F,updated:T,conflicts:O}=b(c,d,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:_,removed:F,updated:T,conflicts:O}}function w(f,l){const i=new Map;for(const s of f){const t=l[s.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(s)}return i}function p(f){const l=new Map;for(const i of f){const s=i.command[0]==="-"?i.command.substring(1):i.command;let t=l.get(s);t||(t=[],l.set(s,t)),t.push(i)}return l}function v(f,l){const i=[...f.keys()],s=[...l.keys()],t=s.filter(u=>i.indexOf(u)===-1).reduce((u,c)=>(u.add(c),u),new Set),n=i.filter(u=>s.indexOf(u)===-1).reduce((u,c)=>(u.add(c),u),new Set),o=new Set;for(const u of i){if(n.has(u))continue;const c=f.get(u).map(y=>({...y,key:u})),d=l.get(u).map(y=>({...y,key:u}));(0,R.equals)(c,d,(y,_)=>C(y,_))||o.add(u)}return{added:t,removed:n,updated:o}}function h(f,l,i){const s=[...f.keys()],t=[...l.keys()],n=t.filter(c=>s.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),o=s.filter(c=>t.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),u=new Set;for(const c of s){if(o.has(c))continue;const d=f.get(c).map(_=>({..._,key:i[_.key]})),y=l.get(c).map(_=>({..._,key:i[_.key]}));S(d,y)||u.add(c)}return{added:n,removed:o,updated:u}}function S(f,l){return!(!(0,R.equals)(f.filter(({command:i})=>i[0]!=="-"),l.filter(({command:i})=>i[0]!=="-"),(i,s)=>C(i,s))||!(0,R.equals)(f.filter(({command:i})=>i[0]==="-"),l.filter(({command:i})=>i[0]==="-"),(i,s)=>C(i,s)))}function C(f,l){if(f.command!==l.command||f.key!==l.key)return!1;const i=L.ContextKeyExpr.deserialize(f.when),s=L.ContextKeyExpr.deserialize(l.when);return!(i&&!s||!i&&s||i&&s&&!i.equals(s)||!D.equals(f.args,l.args))}function m(f,l,i){for(const s of l)f=A.edit(f,[-1],s,i);return f}function g(f,l,i){const s=P(f);for(let t=s.length-1;t>=0;t--)(s[t].command===l||s[t].command===`-${l}`)&&(f=A.edit(f,[t],void 0,i));return f}function a(f,l,i,s){const t=P(f),n=t.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=t.length-1;o>=0;o--)(t[o].command===l||t[o].command===`-${l}`)&&(f=A.edit(f,[o],void 0,s));for(let o=i.length-1;o>=0;o--)f=A.edit(f,[n],i[o],s);return f}}),define(ne[239],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(L,A,P){const E={},b={},I=new Set;if(!A)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const w=r(L,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=r(P,L),v=r(P,A),h={},S={},C=new Set,m=new Set;for(const g of p.removed.values())v.updated.has(g)?E[g]=A[g]:C.add(g);for(const g of v.removed.values())m.has(g)||(p.updated.has(g)?m.add(g):I.add(g));for(const g of p.updated.values())m.has(g)||(v.updated.has(g)?w.updated.has(g)&&m.add(g):S[g]=L[g]);for(const g of v.updated.values())m.has(g)||(p.updated.has(g)?w.updated.has(g)&&m.add(g):L[g]!==void 0&&(b[g]=A[g]));for(const g of p.added.values())m.has(g)||(v.added.has(g)?w.updated.has(g)&&m.add(g):h[g]=L[g]);for(const g of v.added.values())m.has(g)||(p.added.has(g)?w.updated.has(g)&&m.add(g):E[g]=A[g]);return{local:{added:E,removed:[...I.values()],updated:b},remote:{added:h,removed:[...C.values()],updated:S},conflicts:[...m.values()]}}e.merge=R;function r(L,A){const P=L?Object.keys(L):[],E=A?Object.keys(A):[],b=E.filter(p=>P.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),I=P.filter(p=>E.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),w=new Set;for(const p of P){if(I.has(p))continue;const v=L[p],h=A[p];v!==h&&w.add(p)}return{added:b,removed:I,updated:w}}function D(L,A){const{added:P,removed:E,updated:b}=r(L,A);return P.size===0&&E.size===0&&b.size===0}e.areSame=D}),define(ne[240],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(D,L,A,P){const E={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!L){const I=D.filter(({id:w})=>!P.includes(w));return I.length?E.remote.added=I:E.remote=null,E}const b=r(D,L,P);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const I=r(A,D,P),w=r(A,L,P);for(const p of w.removed){const v=D.find(h=>h.id===p);v&&E.local.removed.push(v)}for(const p of w.added){const v=L.find(h=>h.id===p);I.added.includes(p)?b.updated.includes(p)&&E.local.updated.push(v):E.local.added.push(v)}for(const p of w.updated)E.local.updated.push(L.find(v=>v.id===p));for(const p of I.added)w.added.includes(p)||E.remote.added.push(D.find(v=>v.id===p));for(const p of I.updated)w.removed.includes(p)||w.updated.includes(p)||E.remote.updated.push(D.find(v=>v.id===p));for(const p of I.removed)E.remote.removed.push(L.find(v=>v.id===p))}return E.remote.added.length===0&&E.remote.removed.length===0&&E.remote.updated.length===0&&(E.remote=null),E}e.merge=R;function r(D,L,A){D=D?D.filter(({id:p})=>!A.includes(p)):[],L=L.filter(({id:p})=>!A.includes(p));const P=D.map(({id:p})=>p),E=L.map(({id:p})=>p),b=E.filter(p=>P.indexOf(p)===-1),I=P.filter(p=>E.indexOf(p)===-1),w=[];for(const{id:p,name:v}of D){if(I.includes(p))continue;const h=L.find(S=>S.id===p);(!h||h.name!==v)&&w.push(p)}return{added:b,removed:I,updated:w}}}),define(ne[26],re([0,1,19,17,15,166,43,29,5,100,40]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const c=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(d=>!!c[d].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function p(){const c=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(c).filter(F=>!!c[F].ignoreSync),y=Object.keys(c).filter(F=>c[F].scope===2||c[F].scope===6),_=w();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...d,...y,..._])}e.getDefaultIgnoredSettings=p,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function v(){const c="vscode://schemas/ignoredSettings",d=I.Registry.as(A.Extensions.Configuration);d.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=I.Registry.as(b.Extensions.JSONContribution),_=()=>{const F=w(),T=p().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter($=>T.indexOf($)===-1),k=T.filter($=>F.indexOf($)===-1),M={items:{type:"string",enum:[...O,...k.map($=>`-${$}`)]}};y.registerSchema(c,M)};return d.onDidUpdateConfiguration(()=>_())}e.registerConfiguration=v;function h(c){return c&&(0,D.isObject)(c)&&(0,D.isString)(c.id)&&Array.isArray(c.scopes)}e.isAuthenticationProvider=h;var S;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState",c.Profiles="profiles"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function C(c,...d){return c?[c,...d]:d}e.getPathSegments=C;function m(c,d,y,_){return _.joinPath(y.userDataSyncHome,...C(c,d,`lastSync${d}.json`))}e.getLastSyncResourceUri=m,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(c){const d={};return d[e.HEADER_EXECUTION_ID]=c,d}e.createSyncHeaders=g;var a;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoCollection="NoCollection",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(a=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(d,y,_,F){super(d),this.code=y,this.resource=_,this.operationId=F,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class l extends f{constructor(d,y,_,F,T){super(d,_,void 0,T),this.url=y,this.serverCode=F}}e.UserDataSyncStoreError=l;class i extends f{constructor(d,y){super(d,y)}}e.UserDataAutoSyncError=i,function(c){function d(y){if(y instanceof c)return y;const _=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(_&&_[1]){const F=_[2]==="unknown"?void 0:_[2],T=_[3]==="unknown"?void 0:_[3];return new c(y.message,_[1],F,T)}return new c(y.message,"Unknown")}c.toUserDataSyncError=d}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var t;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var n;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(c){return`sync.enable.${c}`}e.getEnablementKey=o,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(c,d,y){if(c.scheme===e.USER_DATA_SYNC_SCHEME)return;c=c.with({scheme:y.userDataSyncHome.scheme});const _=e.ALL_SYNC_RESOURCES.find(F=>(0,r.isEqualOrParent)(c,(0,r.joinPath)(y.userDataSyncHome,F,e.PREVIEW_DIR_NAME)));if(_)return{syncResource:_,profile:d.defaultProfile};for(const F of d.profiles.slice(1)){const T=e.ALL_SYNC_RESOURCES.find(O=>(0,r.isEqualOrParent)(c,(0,r.joinPath)(y.userDataSyncHome,F.id,O,e.PREVIEW_DIR_NAME)));if(T)return{syncResource:T,profile:F}}}e.getSyncResourceFromLocalPreview=u}),define(ne[241],re([0,1,32,26]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,E,b,I,w){if(!E)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const p=L(P,E);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=b?L(b,E):{added:Object.keys(E).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},h=b?L(b,P):{added:Object.keys(P).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},C=R.deepClone(E),m=!b;for(const g of h.added.values())g!==r.SYNC_SERVICE_URL_TYPE&&m&&v.added.has(g)||(C[g]=P[g]);for(const g of h.updated.values())C[g]=P[g];for(const g of h.removed.values())I.unregistered.includes(g)||delete C[g];for(const g of v.added.values()){const a=E[g];if(I.machine.includes(g)){w.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(g))continue;const f=P[g];f&&f.value===a.value||g===r.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(g)||(f?S.updated[g]=a:S.added[g]=a)}for(const g of v.updated.values()){const a=E[g];if(I.machine.includes(g)){w.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(g)||h.removed.has(g))continue;const f=P[g];f&&f.value===a.value||(S.updated[g]=a)}for(const g of v.removed.values()){if(I.machine.includes(g)){w.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}h.updated.has(g)||h.removed.has(g)||S.removed.push(g)}return{local:S,remote:A(C,E)?null:C}}e.merge=D;function L(P,E){const b=Object.keys(P),I=Object.keys(E),w=I.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),p=b.filter(h=>I.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),v=new Set;for(const h of b){if(p.has(h))continue;const S=P[h],C=E[h];R.equals(S,C)||v.add(h)}return{added:w,removed:p,updated:v}}function A(P,E){const{added:b,removed:I,updated:w}=L(P,E);return b.size===0&&I.size===0&&w.size===0}}),define(ne[242],re([0,1,19,35,79,46,32,61,26]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function b(c,d,y){let _=[];y?_=w(y):_=I(d);const F=[],T=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(_))for(const O of _)O.startsWith("-")?T.push(O.substring(1)):F.push(O);return(0,R.distinct)([...c,...F].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=b;function I(c){let d=c.inspect("settingsSync.ignoredSettings").userValue;return d!==void 0||(d=c.inspect("sync.ignoredSettings").userValue,d!==void 0)?d:c.getValue("settingsSync.ignoredSettings")||[]}function w(c){const d=(0,r.parse)(c);return d?d["settingsSync.ignoredSettings"]||d["sync.ignoredSettings"]||[]:[]}function p(c,d){const y=(0,r.parse)(c)||{};let _="{}";for(const F of Object.keys(y)){const T=(0,D.setProperty)(_,[F],y[F],d);_=(0,D.applyEdits)(_,T)}return _}e.removeComments=p;function v(c,d,y,_){if(y.length){const F=u(d),T=(0,r.parse)(d)||{},O=(0,r.parse)(c);if(!O)return c;const k=[];for(const M of y){const $=T[M],q=O[M];$===void 0?c=P.edit(c,[M],void 0,_):q!==void 0?c=P.edit(c,[M],$,_):k.push(i(M,F))}k.sort((M,$)=>M.startOffset-$.startOffset),k.forEach(M=>c=g(M.setting.key,d,c,_))}return c}e.updateIgnoredSettings=v;function h(c,d,y,_,F,T){const O=v(c,d,_,T),k=y!==O,M=y!==d;if(!k&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!M)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(M&&!k)return{conflictsSettings:[],localContent:v(d,c,_,T),remoteContent:null,hasConflicts:!1};if(y===null&&C(c)){const B=S(c,d,_)?null:v(d,c,_,T);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let $=c,q=d;const J=(0,r.parse)(c),H=(0,r.parse)(d),G=y?(0,r.parse)(y):null,z=_.reduce((B,Z)=>(B.add(Z),B),new Set),x=m(J,H,z),Y=m(G,J,z),te=m(G,H,z),ce=new Map,W=new Set,V=B=>{W.add(B);const Z=F.filter(({key:oe})=>oe===B)[0];Z?($=P.edit($,[B],Z.value,T),q=P.edit(q,[B],Z.value,T)):ce.set(B,{key:B,localValue:J[B],remoteValue:H[B]})};for(const B of Y.removed.values())te.updated.has(B)?V(B):q=P.edit(q,[B],void 0,T);for(const B of te.removed.values())W.has(B)||(Y.updated.has(B)?V(B):$=P.edit($,[B],void 0,T));for(const B of Y.updated.values())W.has(B)||(te.updated.has(B)?x.updated.has(B)&&V(B):q=P.edit(q,[B],J[B],T));for(const B of te.updated.values())W.has(B)||(Y.updated.has(B)?x.updated.has(B)&&V(B):$=P.edit($,[B],H[B],T));for(const B of Y.added.values())W.has(B)||(te.added.has(B)?x.updated.has(B)&&V(B):q=g(B,$,q,T));for(const B of te.added.values())W.has(B)||(Y.added.has(B)?x.updated.has(B)&&V(B):$=g(B,q,$,T));const U=ce.size>0||!S($,q,_),N=U||!S($,c,[]),j=U||!S(q,d,[]);return{localContent:N?$:null,remoteContent:j?q:null,conflictsSettings:[...ce.values()],hasConflicts:U}}e.merge=h;function S(c,d,y){if(c===d)return!0;const _=(0,r.parse)(c),F=(0,r.parse)(d),T=y.reduce((M,$)=>(M.add($),M),new Set),O=u(c).filter(M=>!(M.setting&&T.has(M.setting.key))),k=u(d).filter(M=>!(M.setting&&T.has(M.setting.key)));if(O.length!==k.length)return!1;for(let M=0;M<O.length;M++){const $=O[M],q=k[M];if($.setting&&q.setting){if($.setting.key!==q.setting.key||!A.equals(_[$.setting.key],F[$.setting.key]))return!1}else if(!$.setting&&!q.setting){if($.value!==q.value)return!1}else return!1}return!0}e.areSame=S;function C(c){return c?u(c).length===0:!0}e.isEmpty=C;function m(c,d,y){const _=c?Object.keys(c).filter(M=>!y.has(M)):[],F=Object.keys(d).filter(M=>!y.has(M)),T=F.filter(M=>_.indexOf(M)===-1).reduce((M,$)=>(M.add($),M),new Set),O=_.filter(M=>F.indexOf(M)===-1).reduce((M,$)=>(M.add($),M),new Set),k=new Set;if(c)for(const M of _){if(O.has(M))continue;const $=c[M],q=d[M];A.equals($,q)||k.add(M)}return{added:T,removed:O,updated:k}}function g(c,d,y,_){const F=(0,r.parse)(d),T=u(d),O=u(y),k=a(c,T,O);return f(y,c,F[c],k,O,_)}e.addSetting=g;function a(c,d,y){const _=d.findIndex(T=>T.setting?.key===c),F=d[_-1];if(F){if(F.setting){const O=i(F.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!0}}else{const O=s(_,d);if(O){const k=i(O.setting.key,y);if(k){const M=t(y.indexOf(k),y),$=n(d,O,d[_]);if(M){const q=n(y,k,M),J=o($,q);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.indexOf(M),insertAfter:!1}}else{const q=n(y,k,y[y.length-1]),J=o($,q);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const T=d[_+1];if(T)if(T.setting){const O=i(T.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!1}}else{const O=t(_,d);if(O){const k=i(O.setting.key,y);if(k){const M=s(y.indexOf(k),y),$=n(d,d[_],O);if(M){const q=n(y,M,k),J=o($.reverse(),q.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:y.indexOf(M),insertAfter:!0}}else{const q=n(y,y[0],k),J=o($.reverse(),q.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function f(c,d,y,_,F,T){let O;return _.index===-1?O=(0,D.setProperty)(c,[d],y,T):O=l(c,d,y,_,F,T).map(k=>(0,D.withFormatting)(c,k,T)[0]),(0,D.applyEdits)(c,O)}function l(c,d,y,_,F,T){const O=`${JSON.stringify(d)}: ${JSON.stringify(y)}`,k=(0,L.getEOL)(T,c),M=F[_.index];if(_.insertAfter){const $=[];if(M.setting)$.push({offset:M.endOffset,length:0,content:","+O});else{const q=t(_.index,F),J=s(_.index,F),H=J?.setting?.commaOffset;J&&H===void 0&&$.push({offset:J.endOffset,length:0,content:","});const G=H!==void 0&&H>M.endOffset;$.push({offset:G?H+1:M.endOffset,length:0,content:q?k+O+",":k+O})}return $}else{if(M.setting)return[{offset:M.startOffset,length:0,content:O+","}];const $=(F[_.index-1]&&!F[_.index-1].setting?k:"")+O+(t(_.index,F)?",":"")+k;return[{offset:M.startOffset,length:0,content:$}]}}function i(c,d){return d.filter(y=>y.setting?.key===c)[0]}function s(c,d){for(let y=c-1;y>=0;y--)if(d[y].setting)return d[y]}function t(c,d){for(let y=c+1;y<d.length;y++)if(d[y].setting)return d[y]}function n(c,d,y){const _=c.indexOf(d),F=c.indexOf(y);return c.filter((T,O)=>_<O&&O<F)}function o(c,d){if(c.length&&d.length){let y=0;for(;y<d.length&&y<c.length;y++)if(c[y].value!==d[y].value)return d[y-1];return d[y-1]}}function u(c){const d=[];let y=-1,_,F;const T={onObjectBegin:O=>{y++},onObjectProperty:(O,k,M)=>{y===0&&(_=k,F=O)},onObjectEnd:(O,k)=>{y--,y===0&&d.push({startOffset:_,endOffset:O+k,value:c.substring(_,O+k),setting:{key:F,commaOffset:void 0}})},onArrayBegin:(O,k)=>{y++},onArrayEnd:(O,k)=>{y--,y===0&&d.push({startOffset:_,endOffset:O+k,value:c.substring(_,O+k),setting:{key:F,commaOffset:void 0}})},onLiteralValue:(O,k,M)=>{y===0&&d.push({startOffset:_,endOffset:k+M,value:c.substring(_,k+M),setting:{key:F,commaOffset:void 0}})},onSeparator:(O,k,M)=>{if(y===0&&O===","){let $=d.length-1;for(;$>=0&&!d[$].setting;$--);const q=d[$];q&&d.splice($,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:k}})}},onComment:(O,k)=>{y===0&&d.push({startOffset:O,endOffset:O+k,value:c.substring(O,O+k)})}};return(0,r.visit)(c,T),d}}),define(ne[73],re([0,1,3,2,5,26]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let A=class extends r.Disposable{get account(){return this._account}constructor(E,b){super(),this.userDataSyncStoreService=E,this.logService=b,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};A=pe([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[243],re([0,1,2,7]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(p){this.service=p}listen(p,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class L{constructor(p){this.service=p}listen(p,v){throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(r.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class E{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class b{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends R.Disposable{constructor(p){super(),this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:r.URI.revive(p.url),type:p.type,defaultUrl:r.URI.revive(p.defaultUrl),insidersUrl:r.URI.revive(p.insidersUrl),stableUrl:r.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[244],re([0,1,14,8]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends r.AbstractLogger{constructor(A,P){super(),this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};D=pe([K(0,r.ILoggerService),K(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(ne[245],re([0,1,6,3,2]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:E,getActiveWindowId:b}){super(),this.disposables=this._register(new D.DisposableStore),r.Event.latch(r.Event.any(P,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>b()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[111],re([0,1,168,12,34,17,7,5,22]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function b(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=s;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=I;function w(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=w;function p(s){const t=s;if(t?.uri)return{id:t.id,uri:A.URI.revive(t.uri)};const n=s;if(n?.configPath)return{id:n.id,configPath:A.URI.revive(n.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=p;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function S(s){const t=s;return!!(t&&typeof t=="object"&&A.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(t,n,o,u,c){this._id=t,this._transient=o,this._configuration=u,this._ignorePathCasing=c,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class m{constructor(t,n){this.raw=n,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function g(s){return new m({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(s,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function f(s){let t;return A.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=f;function l(s,t){return!a(s,t)&&!f(s)}e.isSavedWorkspace=l;function i(s){return(typeof s=="string"?(0,r.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[20],re([0,1,64,3,2,17,15,7,161,14,13,5,8,111,34,31,6,30,27]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function a(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&P.URI.isUri(n.location)&&P.URI.isUri(n.globalStorageHome)&&P.URI.isUri(n.settingsResource)&&P.URI.isUri(n.keybindingsResource)&&P.URI.isUri(n.tasksResource)&&P.URI.isUri(n.snippetsHome)&&((0,A.isUndefined)(n.extensionsResource)||P.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=a,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function f(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,location:P.URI.revive(t.location).with({scheme:n}),globalStorageHome:P.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:P.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:P.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:P.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:P.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:P.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(t,n,o,u,c){return{id:t,name:n,location:o,isDefault:!1,globalStorageHome:(0,L.joinPath)(o,"globalStorage"),settingsResource:(0,L.joinPath)(o,"settings.json"),keybindingsResource:(0,L.joinPath)(o,"keybindings.json"),tasksResource:(0,L.joinPath)(o,"tasks.json"),snippetsHome:(0,L.joinPath)(o,"snippets"),extensionsResource:(0,L.joinPath)(o,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:u,isTransient:c}}e.toUserDataProfile=l;let i=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,u,c){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=u,this.logService=c,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new r.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new r.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new r.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new r.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(d=>l((0,L.basename)(d.location),d.name,d.location,d.useDefaultFlags)):[];let o;const u=new h.ResourceMap,c=l((0,R.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...c,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?c.extensionsResource:void 0}),n.length){const d=this.getStoredProfileAssociations();if(d.workspaces)for(const[y,_]of Object.entries(d.workspaces)){const F=P.URI.parse(y),T=P.URI.parse(_),O=n.find(k=>this.uriIdentityService.extUri.isEqual(k.location,T));O&&u.set(F,O)}if(d.emptyWindow){const y=P.URI.parse(d.emptyWindow);o=n.find(_=>this.uriIdentityService.extUri.isEqual(_.location,y))}}this._profilesObject={profiles:n,workspaces:u,emptyWindow:o}}return this._profilesObject}async createTransientProfile(n){const o="Temp",u=new RegExp(`${(0,g.escapeRegExpCharacters)(o)}\\s(\\d+)`);let c=0;for(const y of this.profiles){const _=u.exec(y.name),F=_?parseInt(_[1]):0;c=F>c?F:c}const d=`${o} ${c+1}`;return this.createProfile((0,R.hash)((0,m.generateUuid)()).toString(16),d,void 0,!0,n)}async createNamedProfile(n,o,u){return this.createProfile((0,R.hash)((0,m.generateUuid)()).toString(16),n,o,!1,u)}async createProfile(n,o,u,c,d){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const y=await this.doCreateProfile(n,o,u,!!c);return d&&await this.setProfileForWorkspace(d,y),y}async doCreateProfile(n,o,u,c){let d=this.profileCreationPromises.get(o);return d||(d=(async()=>{try{const y=this.profiles.find(T=>T.name===o||T.id===n);if(y)return y;const _=l(n,o,(0,L.joinPath)(this.profilesHome,n),u,c);await this.fileService.createFolder(_.location);const F=[];return this._onWillCreateProfile.fire({profile:_,join(T){F.push(T)}}),await C.Promises.settled(F),this.updateProfiles([_],[],[]),_}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,d)),d}async updateProfile(n,o,u,c){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let d=this.profiles.find(y=>y.id===n.id);if(!d)throw new Error(`Profile '${n.name}' does not exist`);return d=l(d.id,o,d.location,u,c??d.isTransient),this.updateProfiles([],[],[d]),d}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(c=>c.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:o,join(c){u.push(c)}}),await C.Promises.settled(u),o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const c of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(c){this.logService.error(c)}}getOrSetProfileForWorkspace(n,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let u=this.getProfileForWorkspace(n);return u||(u=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,u)),u}async setProfileForWorkspace(n,o){this.setProfileForWorkspaceSync(n,o)}setProfileForWorkspaceSync(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=this.profiles.find(c=>c.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,u)}unsetWorkspace(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return P.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,u){const c=[...this.profiles,...n],d=[];this.transientProfilesObject.profiles=[];for(let y of c)y.isDefault||o.some(_=>y.id===_.id)||(y=u.find(_=>y.id===_.id)??y,y.isTransient?this.transientProfilesObject.profiles.push(y):d.push({location:y.location,name:y.name,useDefaultFlags:y.useDefaultFlags}));this.saveStoredProfiles(d),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,u)}triggerProfilesChanges(n,o,u){this._onDidChangeProfiles.fire({added:n,removed:o,updated:u,all:this.profiles})}updateWorkspaceAssociation(n,o,u){u=o?.isTransient?!0:u,u||this.updateWorkspaceAssociation(n,void 0,!0);const c=this.getWorkspace(n),d=u?this.transientProfilesObject:this.profilesObject;P.URI.isUri(c)?(d.workspaces.delete(c),o&&d.workspaces.set(c,o)):d.emptyWindow=o,u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[u,c]of this.profilesObject.workspaces.entries())n[u.toString()]=c.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=pe([K(0,b.IEnvironmentService),K(1,I.IFileService),K(2,S.IUriIdentityService),K(3,p.ILogService)],i),e.UserDataProfilesService=i;class s extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(ne[246],re([0,1,6,2,20]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends r.Disposable{constructor(P){super(),this._register(new R.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};L=pe([K(0,D.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[247],re([0,1,19,6,24,9,3,2,4,7,143,29,33,44,8,25,23,20]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{constructor(t,n,o,u,c){super(),this.galleryService=t,this.telemetryService=n,this.logService=o,this.productService=u,this.userDataProfilesService=c,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:d})=>d.cancel()),this.uninstallingExtensions.forEach(d=>d.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(I.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,n)}catch(o){throw l(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,n={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,n)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const n=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:n,compatible:!0},D.CancellationToken.None);if(!o)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,n,o){const u=T=>`${p.ExtensionKey.create(T).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!b.URI.isUri(n)){const T=this.installingExtensions.get(u(n));if(T){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:O}=await T.task.waitUntilTaskIsFinished();return O}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const c=[],d=[],y=[],_=this.createInstallExtensionTask(t,n,o);b.URI.isUri(n)||this.installingExtensions.set(u(n),{task:_,waitingTasks:[]}),this._onInstallExtension.fire({identifier:_.identifier,source:n,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",_.identifier.id),c.push({task:_,manifest:t});let F=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const O=await this.getAllDepsAndPackExtensions(_.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),k=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:M,manifest:$}of O){F=F||!!$.extensionDependencies?.some(H=>(0,p.areSameExtensions)({id:H},_.identifier));const q=u(M),J=this.installingExtensions.get(q);if(J){if(this.canWaitForTask(_,J.task)){this.logService.info("Waiting for already requested installing extension",M.identifier.id,_.identifier.id),J.waitingTasks.push(_);const H=J.task.identifier;d.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,G=>G.some(z=>(0,p.areSameExtensions)(z.identifier,H)))).then(G=>{if(!G.find(x=>(0,p.areSameExtensions)(x.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!k.some(({identifier:H})=>(0,p.areSameExtensions)(H,M.identifier))){const H=this.createInstallExtensionTask($,M,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(q,{task:H,waitingTasks:[_]}),this._onInstallExtension.fire({identifier:H.identifier,source:M,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",H.identifier.id,_.identifier.id),c.push({task:H,manifest:$})}}}catch(O){if(b.URI.isUri(_.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",_.identifier.id,O.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",_.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),O}const T=c.reduce((O,{task:k,manifest:M})=>(O.set(k.identifier.id.toLowerCase(),{task:k,manifest:M}),O),new Map);for(;T.size;){let O;const k=[...T.values()].filter(({manifest:M})=>!M.extensionDependencies?.some($=>T.has($.toLowerCase())));k.length?O=T.size===1?k:k.filter(({task:M})=>!(M===_&&!F)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:M})=>M.identifier.id)),O=[...T.values()]),await this.joinAllSettled(O.map(async({task:M})=>{const $=new Date().getTime();try{const{local:q}=await M.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(q,M.source,o,D.CancellationToken.None))),!b.URI.isUri(M.source)){const J=M.operation===3,H=J?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(l(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-$,durationSinceUpdate:H}),E.isWeb&&M.operation!==3)try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch{}}y.push({local:q,identifier:M.identifier,operation:M.operation,source:M.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:q.isApplicationScoped})}catch(q){throw b.URI.isUri(M.source)||l(this.telemetryService,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-$,error:q}),this.logService.error("Error while installing the extension:",M.identifier.id),q}finally{T.delete(M.identifier.id.toLowerCase())}}))}return d.length&&await this.joinAllSettled(d),y.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(y),y.filter(({identifier:O})=>(0,p.areSameExtensions)(O,_.identifier))[0].local}catch(T){if(c.forEach(({task:O})=>O.cancel()),y.length)try{const O=await Promise.allSettled(y.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let k=0;k<O.length;k++){const M=O[k],{identifier:$}=y[k];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,L.getErrorMessage)(M.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(O),y.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(c.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source,context:o.context,profileLocation:o.profileLocation}))),T}finally{for(const[T,{task:O,waitingTasks:k}]of this.installingExtensions.entries()){const M=k.indexOf(_);M!==-1&&k.splice(M,1),k.length===0&&(O===_||M!==-1)&&this.installingExtensions.delete(T)}}}canWaitForTask(t,n){for(const[,{task:o,waitingTasks:u}]of this.installingExtensions.entries())if(o===t&&(u.includes(n)||u.some(c=>this.canWaitForTask(c,n)))||o===n&&u[0]&&!this.canWaitForTask(t,u[0]))return!1;return!0}async joinAllSettled(t){const n=[],o=[],u=await Promise.allSettled(t);for(const c of u)c.status==="fulfilled"?n.push(c.value):o.push(c.reason);if(o.length)throw a(o);return n}async getAllDepsAndPackExtensions(t,n,o,u,c){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,c),y=[t],_=[],F=async(T,O)=>{const k=O.extensionDependencies||[],M=[...k];if(O.extensionPack){const $=o?d.find(q=>(0,p.areSameExtensions)(q.identifier,T)):void 0;for(const q of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:q}))||M.every(J=>!(0,p.areSameExtensions)({id:J},{id:q}))&&M.push(q)}if(M.length){const $=[...y,..._.map(J=>J.gallery.identifier)],q=M.filter(J=>$.every(H=>!(0,p.areSameExtensions)(H,{id:J})));if(q.length){const J=await this.galleryService.getExtensions(q.map(H=>({id:H,preRelease:u})),D.CancellationToken.None);for(const H of J){if($.find(x=>(0,p.areSameExtensions)(x,H.identifier)))continue;const G=k.some(x=>(0,p.areSameExtensions)({id:x},H.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(H,!1,u)}catch(x){if(x instanceof w.ExtensionManagementError&&x.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!G){this.logService.info("Skipping the packed extension as it cannot be installed",H.identifier.id);continue}else throw x}_.push({gallery:z.extension,manifest:z.manifest}),await F(z.extension.identifier,z.manifest)}}}};return await F(t,n),_}async checkAndGetCompatibleVersion(t,n,o){if((await this.getExtensionsControlManifest()).malicious.some(y=>(0,p.areSameExtensions)(t.identifier,y)))throw new w.ExtensionManagementError(I.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const y=await this.getTargetPlatform();throw new w.ExtensionManagementError(I.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(y)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(t,n,o);if(c){if(o&&!n&&t.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],D.CancellationToken.None))[0]?new w.ExtensionManagementError(I.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(I.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const d=await this.galleryService.getManifest(c,D.CancellationToken.None);if(d===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(d.version!==c.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:d}}async getCompatibleVersion(t,n,o){const u=await this.getTargetPlatform();let c=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(c=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:u,compatible:!0},D.CancellationToken.None))[0]||null),!c&&await this.galleryService.isExtensionCompatible(t,o,u)&&(c=t),c||(n?c=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},D.CancellationToken.None))[0]||null:c=await this.galleryService.getCompatibleExtension(t,o,u)),c}async uninstallExtension(t,n){const o=F=>`${F.id.toLowerCase()}${n.versionOnly?`-${t.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,u=this.uninstallingExtensions.get(o(t.identifier));if(u)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),u.waitUntilTaskIsFinished();const c=(F,T)=>{const O=this.createUninstallExtensionTask(F,T);return this.uninstallingExtensions.set(o(O.extension.identifier),O),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:n.profileLocation,applicationScoped:F.isApplicationScoped}),O},d=(F,T)=>{T?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,n.profileLocation.toString(),T.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,T.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),l(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(F),error:T}),this._onDidUninstallExtension.fire({identifier:F.identifier,version:F.manifest.version,error:T?.code,profileLocation:n.profileLocation,applicationScoped:F.isApplicationScoped})},y=[],_=[];try{y.push(c(t,n));const F=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const T=this.getAllPackExtensionsToUninstall(t,F);for(const O of T)this.uninstallingExtensions.has(o(O.identifier))?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):y.push(c(O,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(y.map(T=>T.extension),F,t),await this.joinAllSettled(y.map(async T=>{try{if(await T.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(T.extension,n,D.CancellationToken.None))),T.extension.identifier.uuid)try{await this.galleryService.reportStatistic(T.extension.manifest.publisher,T.extension.manifest.name,T.extension.manifest.version,"uninstall")}catch{}d(T.extension)}catch(O){const k=O instanceof w.ExtensionManagementError?O:new w.ExtensionManagementError((0,L.getErrorMessage)(O),w.ExtensionManagementErrorCode.Internal);throw d(T.extension,k),k}finally{_.push(T)}}))}catch(F){const T=F instanceof w.ExtensionManagementError?F:new w.ExtensionManagementError((0,L.getErrorMessage)(F),w.ExtensionManagementErrorCode.Internal);for(const O of y){try{O.cancel()}catch{}_.includes(O)||d(O.extension,T)}throw T}finally{for(const F of y)this.uninstallingExtensions.delete(o(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(t,n,o){for(const u of t){const c=this.getDependents(u,n);if(c.length){const d=c.filter(y=>!t.some(_=>(0,p.areSameExtensions)(_.identifier,y.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(u,d,o))}}}getDependentsErrorMessage(t,n,o){return o===t?n.length===1?I.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(9,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(10,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?I.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const c=n.filter(y=>!y.isBuiltin&&u.some(_=>(0,p.areSameExtensions)({id:_},y.identifier))),d=[];for(const y of c)d.push(...this.getAllPackExtensionsToUninstall(y,n,o));return[...c,...d]}return[]}getDependents(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,p.areSameExtensions)({id:u},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,n,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,n,o)}createUninstallExtensionTask(t,n){return n.profileLocation&&t.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,n)}};g=pe([K(0,w.IExtensionGalleryService),K(1,C.ITelemetryService),K(2,h.ILogService),K(3,S.IProductService),K(4,m.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function a(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((n,o)=>new Error(`${n.message}${n.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=a;function f(s){if(s instanceof w.ExtensionManagementError)return s;const t=new w.ExtensionManagementError(s.message,w.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function l(s,t,{extensionData:n,duration:o,error:u,durationSinceUpdate:c}){const d=u?u instanceof w.ExtensionManagementError?u.code:w.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(t,{...n,success:!u,duration:o,errorcode:d,durationSinceUpdate:c})}e.reportTelemetry=l;class i{constructor(){this.barrier=new r.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>new Promise((n,o)=>{const u=t.onCancellationRequested(()=>{u.dispose(),o(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[74],re([0,1,19,6,32,16,9,35,125,2,22,12,4,17,55,84,15,7,146,14,33,44,68,13,5,8,25,3,65,49,20,31,174]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l,i,s,t,n,o,u,c,d,y,_,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(H){function G(z,x){if(z===x)return!0;const Y=Object.keys(z),te=new Set;for(const ce of Object.keys(x))te.add(ce);if(Y.length!==te.size)return!1;for(const ce of Y){if(z[ce]!==x[ce])return!1;te.delete(ce)}return te.size===0}H.equals=G})(T=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let O=class extends b.Disposable{constructor(G,z,x,Y,te,ce,W,V,U,N,j){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=z,this.extensionsControlLocation=x,this.cacheLocation=Y,this.userDataProfilesService=te,this.extensionsProfileScannerService=ce,this.fileService=W,this.logService=V,this.environmentService=U,this.productService=N,this.instantiationService=j,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(M,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,z,x){const[Y,te]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(z)]),ce=x?await this.scanExtensionsUnderDevelopment(G,[...Y,...te]):[];return this.dedupExtensions(Y,te,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const z=[];z.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),z.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[x,Y]=await Promise.all(z);return this.applyScanOptions([...x,...Y],0,G,!1)}async scanUserExtensions(G){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(G.profileLocation??this.userExtensionsLocation,!!G.profileLocation,1,!G.includeUninstalled,G.language);let Y=await(G.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return Y=await this.applyScanOptions(Y,1,G,!0),this.logService.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(G,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===I.Schemas.file).map(async Y=>{const te=await this.createExtensionScannerInput(Y,!1,1,!0,G.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(W=>(W.type=z.find(V=>(0,f.areSameExtensions)(V.identifier,W.identifier))?.type??W.type,this.extensionsScanner.validate(W,te)))}))).flat();return this.applyScanOptions(x,"development",G,!0)}return[]}async scanExistingExtension(G,z,x){const Y=await this.createExtensionScannerInput(G,!1,z,!0,x.language),te=await this.extensionsScanner.scanExtension(Y);return!te||!x.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(G,z,x){const Y=await this.createExtensionScannerInput(G,!1,z,!0,x.language),te=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(te,z,x,!0)}async scanMetadata(G){const z=(0,v.joinPath)(G,"package.json"),x=(await this.fileService.readFile(z)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(G,z){const x=(0,v.joinPath)(G,"package.json"),Y=(await this.fileService.readFile(x)).value.toString(),te=JSON.parse(Y);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,te.__metadata={...te.__metadata,...z},await this.fileService.writeFile((0,v.joinPath)(G,"package.json"),L.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async applyScanOptions(G,z,x,Y){return x.includeAllVersions||(G=this.dedupExtensions(z===0?G:void 0,z===1?G:void 0,z==="development"?G:void 0,await this.getTargetPlatform(),Y)),x.includeInvalid||(G=G.filter(te=>te.isValid)),G.sort((te,ce)=>{const W=w.basename(te.location.fsPath),V=w.basename(ce.location.fsPath);return W<V?-1:W>V?1:0})}dedupExtensions(G,z,x,Y,te){const ce=(V,U,N)=>{if(V.isValid&&!U.isValid)return!1;if(V.isValid===U.isValid){if(te&&h.gt(V.manifest.version,U.manifest.version))return this.logService.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(h.eq(V.manifest.version,U.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${U.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===Y)return this.logService.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${V.location.path} with ${U.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${U.location.path}.`),!0},W=new Map;return G?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),N=W.get(U);(!N||ce(N,V,!1))&&W.set(U,V)}),z?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),N=W.get(U);if(!N&&G&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!N||ce(N,V,!1))&&W.set(U,V)}),x?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),N=W.get(U);(!N||ce(N,V,!0))&&W.set(U,V),W.set(U,V)}),[...W.values()]}async scanDefaultSystemExtensions(G,z){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),te=await(G&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(G,z){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=z?await this.getBuiltInExtensionControl():{},te=[],ce=m.URI.file(w.normalize(w.join(I.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const V of x){const U=Y[V.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":te.push((0,v.joinPath)(ce,V.name));break;default:te.push(m.URI.file(U));break}}const W=await Promise.all(te.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,G))));return this.logService.trace("Scanned dev system extensions:",W.length),(0,R.coalesce)(W)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,z,x,Y,te,ce=!0){const W=await this.getTranslations(te??p.language),V=await this.getMtime(G),U=z?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=U?await this.getMtime(U):void 0;return new k(G,V,U,N,z,x,Y,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,W)}async getMtime(G){try{const z=await this.fileService.stat(G);if(typeof z.mtime=="number")return z.mtime}catch{}}};O=pe([K(4,y.IUserDataProfilesService),K(5,d.IExtensionsProfileScannerService),K(6,s.IFileService),K(7,n.ILogService),K(8,a.IEnvironmentService),K(9,o.IProductService),K(10,t.IInstantiationService)],O),e.AbstractExtensionsScannerService=O;class k{constructor(G,z,x,Y,te,ce,W,V,U,N,j,B,Z,oe){this.location=G,this.mtime=z,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=Y,this.profile=te,this.type=ce,this.excludeObsolete=W,this.validate=V,this.productVersion=U,this.productDate=N,this.productCommit=j,this.devMode=B,this.language=Z,this.translations=oe}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,z){return(0,v.isEqual)(G.location,z.location)&&G.mtime===z.mtime&&(0,v.isEqual)(G.applicationExtensionslocation,z.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&G.profile===z.profile&&G.type===z.type&&G.excludeObsolete===z.excludeObsolete&&G.validate===z.validate&&G.productVersion===z.productVersion&&G.productDate===z.productDate&&G.productCommit===z.productCommit&&G.devMode===z.devMode&&G.language===z.language&&T.equals(G.translations,z.translations)}}let M=class extends b.Disposable{constructor(G,z,x,Y,te){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=z,this.uriIdentityService=x,this.fileService=Y,this.logService=te}async scanExtensions(G){const z=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let x={};if(G.excludeObsolete&&G.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(Y)}catch{}return(0,C.isEmptyObject)(x)?z:z.filter(Y=>!x[f.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(G){const z=await this.fileService.resolve(G.location);if(!z.children?.length)return[];const x=await Promise.all(z.children.map(async Y=>{if(!Y.isDirectory||G.type===1&&(0,v.basename)(Y.resource).indexOf(".")===0)return null;const te=new k(Y.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te)}));return(0,R.coalesce)(x).sort((Y,te)=>Y.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(G){let z=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){z=z.filter(Y=>!Y.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,G);z.push(...x)}return z}async scanExtensionsFromProfileResource(G,z,x){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(G);if(!Y.length)return[];const te=await Promise.all(Y.map(async ce=>{if(z(ce)){const W=new k(ce.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(W,ce.metadata)}return null}));return(0,R.coalesce)(te)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,v.joinPath)(G.location,"package.json"))){const z=await this.scanExtension(G);return z?[z]:[]}else return await this.scanExtensions(G)}catch(z){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,A.getErrorMessage)(z)),[]}}async scanExtension(G,z){try{let x=await this.scanExtensionManifest(G.location);if(x){x.publisher||(x.publisher=l.UNDEFINED_PUBLISHER),z=z??x.__metadata,delete x.__metadata;const Y=(0,f.getGalleryExtensionId)(x.publisher,x.name),te=z?.id?{id:Y,uuid:z.id}:{id:Y},ce=z?.isSystem?0:G.type,W=ce===0||!!z?.isBuiltin;x=await this.translateManifest(G.location,x,k.createNlsConfiguration(G));const V={type:ce,identifier:te,manifest:x,location:G.location,isBuiltin:W,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return G.validate?this.validate(V,G):V}}catch(x){G.type!==0&&this.logService.error(x)}return null}validate(G,z){let x=!0;const Y=(0,i.validateExtensionManifest)(z.productVersion,z.productDate,z.location,G.manifest,G.isBuiltin);for(const[te,ce]of Y)te===S.default.Error&&(x=!1,this.logService.error(this.formatMessage(z.location,ce)));return G.isValid=x,G.validations=Y,G}async scanExtensionManifest(G){const z=(0,v.joinPath)(G,"package.json");let x;try{x=(await this.fileService.readFile(z)).value.toString()}catch(te){return(0,s.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(G,(0,g.localize)(0,null,z.path,te.message))),null}let Y;try{Y=JSON.parse(x)}catch{const ce=[];(0,P.parse)(x,ce);for(const W of ce)this.logService.error(this.formatMessage(G,(0,g.localize)(1,null,z.path,W.offset,W.length,(0,E.getParseErrorMessage)(W.error))));return null}return(0,P.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(G,(0,g.localize)(2,null,z.path))),null):Y}async translateManifest(G,z,x){const Y=await this.getLocalizedMessages(G,z,x);if(Y)try{const te=[],ce=await this.resolveOriginalMessageBundle(Y.default,te);if(te.length>0)return te.forEach(V=>{this.logService.error(this.formatMessage(G,(0,g.localize)(3,null,Y.default?.path,(0,E.getParseErrorMessage)(V.error))))}),z;if((0,P.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(G,(0,g.localize)(4,null,Y.default?.path))),z;const W=Y.values||Object.create(null);return(0,F.localizeManifest)(z,W,ce)}catch{}return z}async getLocalizedMessages(G,z,x){const Y=(0,v.joinPath)(G,"package.nls.json"),te=(U,N)=>{N.forEach(j=>{this.logService.error(this.formatMessage(G,(0,g.localize)(5,null,U?.path,(0,E.getParseErrorMessage)(j.error))))})},ce=U=>{this.logService.error(this.formatMessage(G,(0,g.localize)(6,null,U?.path)))},W=`${z.publisher}.${z.name}`,V=x.translations[W];if(V)try{const U=m.URI.file(V),N=(await this.fileService.readFile(U)).value.toString(),j=[],B=(0,P.parse)(N,j);return j.length>0?(te(U,j),{values:void 0,default:Y}):(0,P.getNodeType)(B)!=="object"?(ce(U),{values:void 0,default:Y}):{values:B.contents?B.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let N;try{N=await this.findMessageBundles(G,x)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const j=(await this.fileService.readFile(N.localized)).value.toString(),B=[],Z=(0,P.parse)(j,B);return B.length>0?(te(N.localized,B),{values:void 0,default:N.original}):(0,P.getNodeType)(Z)!=="object"?(ce(N.localized),{values:void 0,default:N.original}):{values:Z,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(G,z){if(G)try{const x=(await this.fileService.readFile(G)).value.toString();return(0,P.parse)(x,z)}catch{}}findMessageBundles(G,z){return new Promise((x,Y)=>{const te=ce=>{const W=(0,v.joinPath)(G,`package.nls.${ce}.json`);this.fileService.exists(W).then(V=>{V&&x({localized:W,original:(0,v.joinPath)(G,"package.nls.json")});const U=ce.lastIndexOf("-");U===-1?x({localized:(0,v.joinPath)(G,"package.nls.json"),original:null}):(ce=ce.substring(0,U),te(ce))})};if(z.devMode||z.pseudo||!z.language)return x({localized:(0,v.joinPath)(G,"package.nls.json"),original:null});te(z.language)})}formatMessage(G,z){return`[${G.path}]: ${z}`}};M=pe([K(1,d.IExtensionsProfileScannerService),K(2,_.IUriIdentityService),K(3,s.IFileService),K(4,n.ILogService)],M);let $=class extends M{constructor(G,z,x,Y,te,ce){super(z,x,Y,te,ce),this.cacheFile=G,this.cacheValidatorThrottler=this._register(new r.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const z=await this.readExtensionCache();if(this.input=G,z&&z.input&&k.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(Y=>(Y.location=m.URI.revive(Y.location),Y));const x=await super.scanExtensions(G);return await this.writeExtensionCache({input:G,result:x}),x}async readExtensionCache(){try{const G=await this.fileService.readFile(this.cacheFile),z=JSON.parse(G.value.toString());return{result:z.result,input:(0,c.revive)(z.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(G))}return null}async writeExtensionCache(G){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(G)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const G=await this.readExtensionCache();if(!G)return;const z=G.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(x,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};$=pe([K(2,d.IExtensionsProfileScannerService),K(3,_.IUriIdentityService),K(4,s.IFileService),K(5,n.ILogService)],$);function q(H,G){const z=(0,f.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:z,identifier:new l.ExtensionIdentifier(z),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:G,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=q;class J extends O{constructor(G,z,x,Y,te,ce,W,V,U,N,j){super(G,z,(0,v.joinPath)(x,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(Y,l.MANIFEST_CACHE_FOLDER),te,ce,W,V,U,N,j),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const B=await this.fileService.readFile(m.URI.file(p.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[248],re([0,1,54,6,38,3,2,22,12,28,8,20]),function(Q,e,R,r,D,L,A,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends A.Disposable{constructor(h,S){super(),this.userDataProfilesService=h,this.logService=S,this.processesLimiter=new r.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${C}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(h,S){const C=`vscode:${S}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[C]=="string"){const m=h.manifest.scripts[C].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${C} should be a node script`),null):{script:(0,E.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,S,C,m,g){return new Promise((a,f)=>{const l=this.start(h,S,C,g);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?f(t):a(void 0)};l.on("error",t=>{s((0,D.toErrorMessage)(t)||"Unknown")}),l.on("exit",(t,n)=>{s(t?`post-${S} process exited with code ${t}`:void 0)}),m&&(i=setTimeout(()=>{i=null,l.kill(),f("timed out")},5e3))})}start(h,S,C,m){const g={silent:!0,execArgv:void 0},a=(0,R.fork)(h,[`--type=extension-post-${S}`,...C],g);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(a.stdout,"data"),l=L.Event.fromNodeEventEmitter(a.stderr,"data");f(t=>this.logService.info(m.identifier.id,m.manifest.version,`post-${S}`,t)),l(t=>this.logService.error(m.identifier.id,m.manifest.version,`post-${S}`,t));const i=L.Event.any(L.Event.map(f,t=>({data:`%c${t}`,format:[""]})),L.Event.map(l,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(m.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),a}getExtensionStoragePath(h){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};p=pe([K(0,w.IUserDataProfilesService),K(1,I.ILogService)],p),e.ExtensionsLifecycle=p}),define(ne[249],re([0,1,7,14,49,74,13,5,8,25,20]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends L.NativeExtensionsScannerService{constructor(v,h,S,C,m,g,a){super(R.URI.file(m.builtinExtensionsPath),R.URI.file(m.extensionsPath),m.userHome,R.URI.file(m.userDataPath),v,h,S,C,m,g,a)}};w=pe([K(0,I.IUserDataProfilesService),K(1,D.IExtensionsProfileScannerService),K(2,A.IFileService),K(3,E.ILogService),K(4,r.INativeEnvironmentService),K(5,b.IProductService),K(6,P.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(ne[21],re([0,1,6,3,2,192,15,67,5,20]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var I;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var p;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function v(g){const a=g.get(e.TARGET_KEY);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.loadKeyTargets=v;class h extends D.Disposable{constructor(a={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=a,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,f){if(f===e.TARGET_KEY){switch(a){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:a})}else this._onDidChangeValue.fire({scope:a,key:f,target:this.getKeyTargets(a)[f]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,f,l){return this.getStorage(f)?.get(a,l)}getBoolean(a,f,l){return this.getStorage(f)?.getBoolean(a,l)}getNumber(a,f,l){return this.getStorage(f)?.getNumber(a,l)}store(a,f,l,i){if((0,A.isUndefinedOrNull)(f)){this.remove(a,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,l,i),this.getStorage(l)?.set(a,f)})}remove(a,f){this.withPausedEmitters(()=>{this.updateKeyTarget(a,f,void 0),this.getStorage(f)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,f){const l=[],i=this.getKeyTargets(a);for(const s of Object.keys(i))i[s]===f&&l.push(s);return l}updateKeyTarget(a,f,l){const i=this.getKeyTargets(f);typeof l=="number"?i[a]!==l&&(i[a]=l,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[a]=="number"&&(delete i[a],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(a){switch(a){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(a){const f=this.getStorage(a);return f?v(f):Object.create(null)}isNew(a){return this.getBoolean(e.IS_NEW_KEY,a)===!0}async flush(a=I.NONE){this._onWillSaveState.fire({reason:a});const f=this.getStorage(-1),l=this.getStorage(0),i=this.getStorage(1);switch(a){case I.NONE:await R.Promises.settled([f?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await R.Promises.settled([f?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return m(a,f,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(a,f){return this.emitWillSaveState(I.NONE),(0,b.isUserDataProfile)(a)?this.switchToProfile(a,f):this.switchToWorkspace(a,f)}canSwitchProfile(a,f){return!(a.id===f.id||S(f)&&S(a))}switchData(a,f,l,i){this.withPausedEmitters(()=>{if(i)for(const[s,t]of a)f.set(s,t);else{const s=new Set;for(const[t,n]of a)s.add(t),f.get(t)!==n&&this.emitDidChangeValue(l,t);for(const[t]of f.items)s.has(t)||this.emitDidChangeValue(l,t)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class C extends h{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.profileStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a))),this._register(this.applicationStorage.onDidChangeStorage(a=>this.emitDidChangeValue(-1,a)))}getStorage(a){switch(a){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(a){return!1}}e.InMemoryStorageService=C;async function m(g,a,f,l,i,s){const t=T=>{try{return JSON.parse(T)}catch{return T}},n=new Map,o=new Map;g.forEach((T,O)=>{n.set(O,T),o.set(O,t(T))});const u=new Map,c=new Map;a.forEach((T,O)=>{u.set(O,T),c.set(O,t(T))});const d=new Map,y=new Map;f.forEach((T,O)=>{d.set(O,T),y.set(O,t(T))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const _=[];if(n.forEach((T,O)=>{_.push({key:O,value:T})}),console.table(_),console.groupEnd(),console.log(o),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const T=[];u.forEach((O,k)=>{T.push({key:k,value:O})}),console.table(T),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${s})`);const F=[];d.forEach((T,O)=>{F.push({key:O,value:T})}),console.table(F),console.groupEnd(),console.log(y)}e.logStorage=m}),define(ne[250],re([0,1,3,2,15,29,33,21]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends r.Disposable{constructor(w,p){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(w)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(p.onDidInstallExtensions(v=>v.forEach(({local:h,operation:S})=>{h&&S===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(w,p){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}async disableExtension(w,p){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const p=this.getDisabledExtensions();return p.every(v=>!(0,A.areSameExtensions)(v,w))?(p.push(w),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(w){const p=this.getDisabledExtensions();for(let v=0;v<p.length;v++){const h=p[v];if((0,A.areSameExtensions)(h,w))return p.splice(v,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(w){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,p){this.storageManger.set(w,p,0)}};E=pe([K(0,P.IStorageService),K(1,L.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class b extends r.Disposable{constructor(w){super(),this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(w,p){let v;return p===0?((0,D.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,p)),v=this.storage[w]):v=this._get(w,p),JSON.parse(v)}set(w,p,v){const h=JSON.stringify(p.map(({id:C,uuid:m})=>({id:C,uuid:m})));this._get(w,v)!==h&&(v===0&&(p.length?this.storage[w]=h:delete this.storage[w]),this._set(w,p.length?h:void 0,v))}onDidStorageChange(w){if(w.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const v=this.get(w.key,w.scope);delete this.storage[w.key];const h=this.get(w.key,w.scope),S=v.filter(m=>!h.some(g=>(0,A.areSameExtensions)(m,g))),C=h.filter(m=>!v.some(g=>(0,A.areSameExtensions)(g,m)));(S.length||C.length)&&this._onDidChange.fire([...S,...C])}}_get(w,p){return this.storageService.get(w,p,"[]")}_set(w,p,v){p?this.storageService.store(w,p,v,1):this.storageService.remove(w,v)}}e.StorageManager=b}),define(ne[251],re([0,1,19,24,9,4,36,15,7,18,14,29,33,68,13,8,25,45,220,21,23]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=L.isWeb?"web":(0,w.getTargetPlatform)(L.platform,A.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...U){return String(U.reduce((N,j)=>N|j,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class d{constructor(N=c){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,j=this.state.pageSize){return new d({...this.state,pageNumber:N,pageSize:j})}withFilter(N,...j){const B=[...this.state.criteria,...j.length?j.map(Z=>({filterType:N,value:Z})):[{filterType:N}]];return new d({...this.state,criteria:B})}withSortBy(N){return new d({...this.state,sortBy:N})}withSortOrder(N){return new d({...this.state,sortOrder:N})}withFlags(...N){return new d({...this.state,flags:N.reduce((j,B)=>j|B,0)})}withAssetTypes(...N){return new d({...this.state,assetTypes:N})}withSource(N){return new d({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:j,pageSize:B,sortBy:Z,sortOrder:oe,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:N,pageNumber:j,pageSize:B,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:X}}get searchText(){const N=this.state.criteria.filter(j=>j.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function y(U,N){const j=(U||[]).filter(B=>B.statisticName===N)[0];return j?j.value:0}function _(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(B=>B.assetType.indexOf(N)===0).reduce((B,Z)=>{const oe=O(U,Z.assetType);return oe&&B.push([Z.assetType.substring(N.length),oe]),B},[])}function F(U){if(U.properties){const N=U.properties.filter(Z=>Z.key===n.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=N.filter(Z=>j.test(Z.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return O(U,n.Repository)}function T(U){return{uri:`${U.fallbackAssetUri}/${n.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${n.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function O(U,N){return U.files.filter(B=>B.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function k(U,N){const j=U.properties?U.properties.filter(Z=>Z.key===N):[],B=j.length>0&&j[0].value;return B?B.split(",").map(Z=>(0,p.adoptToGalleryExtensionId)(Z)):[]}function M(U){const N=U.properties?U.properties.filter(j=>j.key===o.Engine):[];return N.length>0&&N[0].value||""}function $(U){const N=U.properties?U.properties.filter(j=>j.key===o.PreRelease):[];return N.length>0&&N[0].value==="true"}function q(U){const N=U.properties?U.properties.filter(B=>B.key===o.LocalizedLanguages):[],j=N.length>0&&N[0].value||"";return j?j.split(","):[]}function J(U){return U.properties?.find(N=>N.key===o.SponsorLink)?.value}function H(U){return U.indexOf("preview")!==-1}function G(U){return U.targetPlatform?(0,w.toTargetPlatform)(U.targetPlatform):"undefined"}function z(U){const N=(0,R.distinct)(U.versions.map(G)),j=!!U.tags?.includes(w.WEB_EXTENSION_TAG),B=N.indexOf("web");return j?B===-1&&N.push("web"):B!==-1&&N.splice(B,1),N}function x(U,N){const j=(0,w.getFallbackTargetPlarforms)(N);for(let B=0;B<U.length;B++){const Z=U[B];if(Z.version===U[B-1]?.version){let oe=B;const X=G(Z);if(X===N)for(;oe>0&&U[oe-1].version===Z.version;)oe--;else if(j.includes(X))for(;oe>0&&U[oe-1].version===Z.version&&G(U[oe-1])!==N;)oe--;oe!==B&&(U.splice(B,1),U.splice(oe,0,Z))}}return U}e.sortExtensionVersions=x;function Y(U,N,j){U.telemetryData={index:N,querySource:j}}function te(U,N,j){const B=U.versions[0],Z={manifest:O(N,n.Manifest),readme:O(N,n.Details),changelog:O(N,n.Changelog),license:O(N,n.License),repository:F(N),download:T(N),icon:O(N,n.Icon),coreTranslations:_(N)};return{identifier:{id:(0,p.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(B),description:U.shortDescription||"",installCount:y(U.statistics,"install"),rating:y(U.statistics,"averagerating"),ratingCount:y(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:j,assets:Z,properties:{dependencies:k(N,o.Dependency),extensionPack:k(N,o.ExtensionPack),engine:M(N),localizedLanguages:q(N),targetPlatform:G(N),isPreReleaseVersion:$(N)},hasPreReleaseVersion:$(B),hasReleaseVersion:!0,preview:H(U.flags)}}let ce=class{constructor(N,j,B,Z,oe,X,ie,se){this.requestService=j,this.logService=B,this.environmentService=Z,this.telemetryService=oe,this.fileService=X,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,N,this.telemetryService)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,j,B){const Z=r.CancellationToken.isCancellationToken(j)?{}:j,oe=r.CancellationToken.isCancellationToken(j)?j:B,X=[],ie=[],se=[],ue=[];let he=!0;for(const Ee of N){Ee.uuid?ie.push(Ee.uuid):X.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),he=he&&!!Ee.hasPreRelease&&!Pe}if(!ie.length&&!X.length)return[];let ve=new d().withPage(1,N.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),X.length&&(ve=ve.withFilter(t.ExtensionName,...X)),(Z.queryAllVersions||he)&&(ve=ve.withFlags(ve.flags,i.IncludeVersions)),Z.source&&(ve=ve.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:Z.targetPlatform??l,includePreRelease:se,versions:ue,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Pe)=>Y(Ee,Pe,Z.source)),we}async getCompatibleExtension(N,j,B){if((0,w.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(N,j,B))return N;const Z=new d().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:B,compatible:!0,includePreRelease:j},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(N,j,B){if(!(0,w.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,B)||!j&&N.properties.isPreReleaseVersion)return!1;let Z=N.properties.engine;if(!Z){const oe=await this.getManifest(N,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,v.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(N,j,B,Z,oe){if(!(0,w.isTargetPlatformCompatible)(G(N),Z,oe)||j!=="any"&&$(N)!==(j==="prerelease"))return!1;if(B)try{const X=await this.getEngine(N);if(!(0,v.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,D.getErrorMessage)(X)),!1}return!0}async query(N,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=N.text||"";const Z=N.pageSize??50;let oe=new d().withPage(1,Z);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),oe=oe.withFilter(t.SearchText,B)),oe=oe.withSortBy(0)):N.ids?oe=oe.withFilter(t.ExtensionId,...N.ids):N.names?oe=oe.withFilter(t.ExtensionName,...N.names):oe=oe.withSortBy(4),typeof N.sortBy=="number"&&(oe=oe.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(oe=oe.withSortOrder(N.sortOrder)),N.source&&(oe=oe.withSource(N.source));const X=async(he,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:l,compatible:!1,includePreRelease:!!N.includePreRelease},ve);return we.forEach((Pe,Ue)=>Y(Pe,(he.pageNumber-1)*he.pageSize+Ue,N.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await X(oe,j),ue=async(he,ve)=>{if(ve.isCancellationRequested)throw new D.CancellationError;const{extensions:we}=await X(oe.withPage(he+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(N,j,B){const Z=N.flags;!!(N.flags&i.IncludeLatestVersionOnly)&&!!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(N.flags&i.IncludeLatestVersionOnly)&&!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags,i.IncludeLatestVersionOnly)),j.versions?.length&&(N=N.withFlags(N.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),N=N.withFlags(N.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:X}=await this.queryRawGalleryExtensions(N,B);if(!(N.flags&i.IncludeLatestVersionOnly)){const he=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,j);we&&he.push(we)}return{extensions:he,total:X}}const se=[],ue=new Map;for(let he=0;he<oe.length;he++){const ve=oe[he],we={id:(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,P.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Ue=>(0,p.areSameExtensions)(Ue,we))?.includePreRelease;if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(z(ve),j.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,j);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==j.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,he):se.push([he,Pe])}if(ue.size){const he=new Date().getTime(),ve=new d().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,j,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);se.push([Pe,Ee])}}return{extensions:se.sort((he,ve)=>he[0]-ve[0]).map(([,he])=>he),total:X}}async toGalleryExtensionWithCriteria(N,j){const B={id:(0,p.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},Z=j.versions?.find(se=>(0,p.areSameExtensions)(se,B))?.version,oe=(0,P.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(se=>(0,p.areSameExtensions)(se,B))?.includePreRelease,X=z(N),ie=x(N.versions,j.targetPlatform);if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(X,j.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(Z&&ue.version!==Z)){if(await this.isValidVersion(ue,oe?"any":"release",j.compatible,X,j.targetPlatform))return te(N,ue,X);if(Z&&ue.version===Z)return null}}return Z||j.compatible?null:te(N,N.versions[0],X)}async queryRawGalleryExtensions(N,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(i.Unpublished));const B=await this.commonHeadersPromise,Z=JSON.stringify(N.raw),oe={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},X=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:oe},j),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,m.asJson)(ie);if(he){const ve=he.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw se=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-X,success:!!ie&&(0,m.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(N,j,B,Z){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${N}.${j}/version/${B}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${j}/${B}/stats?statType=${Z}`),X=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:oe,headers:se},r.CancellationToken.None)}catch{}}async download(N,j,B){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const Z=(0,p.getGalleryExtensionTelemetryData)(N),oe=new Date().getTime(),X=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:he}),ie=B===2?"install":B===3?"update":"",se=ie?{uri:`${N.assets.download.uri}${E.URI.parse(N.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${N.assets.download.fallbackUri}${E.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:N.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(j,ue.stream),X(new Date().getTime()-oe)}async getReadme(N,j){if(N.assets.readme){const B=await this.getAsset(N.assets.readme,{},j);return await(0,m.asTextOrError)(B)||""}return""}async getManifest(N,j){if(N.assets.manifest){const B=await this.getAsset(N.assets.manifest,{},j),Z=await(0,m.asTextOrError)(B);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(N,j){const B=O(N,n.Manifest);if(!B)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(B,{headers:Z});return await(0,m.asJson)(oe)}async getCoreTranslation(N,j){const B=N.assets.coreTranslations.filter(Z=>Z[0]===j.toUpperCase())[0];if(B){const Z=await this.getAsset(B[1]),oe=await(0,m.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(N,j){if(N.assets.changelog){const B=await this.getAsset(N.assets.changelog,{},j);return await(0,m.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(N,j,B){let Z=new d().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?Z=Z.withFilter(t.ExtensionId,N.identifier.uuid):Z=Z.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,r.CancellationToken.None);if(!oe.length)return[];const X=z(oe[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(X,B))return[];const ie=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,j?"any":"release",!0,X,B)&&ie.push(he)}catch{}}));const se=[],ue=new Set;for(const he of x(ie,B))ue.has(he.version)||(ue.add(he.version),se.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)}));return se}async getAsset(N,j={},B=r.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},X={...Z,...j.headers||{}};j={...j,...oe,headers:X};const ie=N.uri,se=N.fallbackUri,ue={...j,url:ie};try{const he=await this.requestService.request(ue,B);if(he.res.statusCode===200)return he;const ve=await(0,m.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ve}`)}catch(he){if((0,D.isCancellationError)(he))throw he;const ve=(0,D.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...j,url:se};return this.requestService.request(we,B)}}async getEngine(N){let j=M(N);if(!j){const B=await this.getManifestFromRawExtensionVersion(N,r.CancellationToken.None);if(!B)throw new Error("Manifest was not found");j=B.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,m.asJson)(N),B=[],Z={};if(j){for(const oe of j.malicious)B.push({id:oe});if(j.migrateToPreRelease)for(const[oe,X]of Object.entries(j.migrateToPreRelease))(!X.engine||(0,v.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[oe,X]of Object.entries(j.deprecated))X&&(Z[oe.toLowerCase()]=(0,P.isBoolean)(X)?{}:X)}return{malicious:B,deprecated:Z}}};ce=pe([K(1,m.IRequestService),K(2,S.ILogService),K(3,I.IEnvironmentService),K(4,f.ITelemetryService),K(5,h.IFileService),K(6,C.IProductService),K(7,b.IConfigurationService)],ce);let W=class extends ce{constructor(N,j,B,Z,oe,X,ie,se){super(N,j,B,Z,oe,X,ie,se)}};W=pe([K(0,a.IStorageService),K(1,m.IRequestService),K(2,S.ILogService),K(3,I.IEnvironmentService),K(4,f.ITelemetryService),K(5,h.IFileService),K(6,C.IProductService),K(7,b.IConfigurationService)],W),e.ExtensionGalleryService=W;let V=class extends ce{constructor(N,j,B,Z,oe,X,ie){super(void 0,N,j,B,Z,oe,X,ie)}};V=pe([K(0,m.IRequestService),K(1,S.ILogService),K(2,I.IEnvironmentService),K(3,f.ITelemetryService),K(4,h.IFileService),K(5,C.IProductService),K(6,b.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(ne[75],re([0,1,5,3,2,21,33,25,19,8,15]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Qe extends D.Disposable{static toKey(h){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const S=w.exec(h);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(h,S){const C=await h.getInstalled(),m=[];for(const[g,a]of Qe.readAllExtensionsWithKeysForSync(S)){const f=C.find(l=>(0,A.areSameExtensions)(l.identifier,{id:g}))?.manifest.version;for(const l of a)f!==l&&m.push(Qe.toKey({id:g,version:l}))}for(const g of m)S.remove(g,0)}static readAllExtensionsWithKeysForSync(h){const S=new Map,C=h.keys(0,1);for(const m of C){const g=Qe.fromKey(m);if(g){let a=S.get(g.id.toLowerCase());a||S.set(g.id.toLowerCase(),a=[]),a.push(g.version)}}return S}constructor(h,S,C){super(),this.storageService=h,this.productService=S,this.logService=C,this._onDidChangeExtensionStorageToSync=this._register(new r.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Qe.fromKey(h.key);if(S){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let C=this.extensionsWithKeysForSync.get(S.id.toLowerCase());C||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),C=[]),C.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,I.isString)(h))return h;const S=h.manifest?h.manifest.publisher:h.publisher,C=h.manifest?h.manifest.name:h.name;return(0,A.getExtensionId)(S,C)}getExtensionState(h,S){const C=this.getExtensionId(h),m=this.storageService.get(C,S?0:1);if(m)try{return JSON.parse(m)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${C}, global: ${S}): ${g}`)}}setExtensionState(h,S,C){const m=this.getExtensionId(h);S===void 0?this.storageService.remove(m,C?0:1):this.storageService.store(m,JSON.stringify(S),C?0:1,1)}setKeysForSync(h,S){this.storageService.store(Qe.toKey(h),JSON.stringify(S),0,1)}getKeysForSync(h){const S=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],C=this.storageService.get(Qe.toKey(h),0),m=C?JSON.parse(C):void 0;return m&&S?(0,E.distinct)([...m,...S]):m||S}addToMigrationList(h,S){if(h!==S){const C=this.migrationList.filter(m=>!m.includes(h)&&!m.includes(S));C.push([h,S]),this.migrationList=C}}getSourceExtensionToMigrate(h){const S=this.migrationList.find(([,C])=>h===C);return S?S[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(h);if(Array.isArray(S))return S}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=pe([K(0,L.IStorageService),K(1,P.IProductService),K(2,b.ILogService)],p),e.ExtensionStorageService=p}),define(ne[252],re([0,1,19,6,3,12,4,36,7,147,14,29,33,211,94,13,8,59,25,45,21,23]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let t=class extends v.ExtensionTipsService{constructor(o,u,c,d,y,_,F,T,O,k){super(F,T,O,k),this.environmentService=o,this.telemetryService=u,this.extensionManagementService=c,this.storageService=d,this.nativeHostService=y,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,T.exeBasedExtensionTips&&Object.entries(T.exeBasedExtensionTips).forEach(([M,$])=>{const q=[],J=[],H=[];Object.entries($.recommendations).forEach(([G,z])=>{z.important?$.important?q.push({extensionId:G,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):J.push({extensionId:G,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):H.push({extensionId:G,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),q.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:q}),J.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:J}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,r.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...u]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(u,c)}groupImportantTipsByExe(o,u){const c=new Map;o.forEach(T=>c.set(T.extensionId.toLowerCase(),T));const{installed:d,uninstalled:y}=this.groupByInstalled([...c.keys()],u);for(const T of d){const O=c.get(T);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:T,exeName:O.exeName})}for(const T of y){const O=c.get(T);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:T,exeName:O.exeName})}const _=this.getPromptedExecutableTips(),F=new Map;for(const T of y){const O=c.get(T);if(O&&(!_[O.exeName]||!_[O.exeName].includes(O.extensionId))){let k=F.get(O.exeName);k||(k=[],F.set(O.exeName,k)),k.push(O)}}return F}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,u]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(u).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(u[0].exeName,u);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const d=D.Event.once(D.Event.latch(D.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const d=this._register((0,r.disposableTimeout)(()=>{d.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),u=Date.now()-o,c=7*24*60*60*1e3;if(u<c){const _=this._register((0,r.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},c-u));return}const[d,y]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(y[0].exeName,y);const F=this._register((0,r.disposableTimeout)(()=>{F.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const F=D.Event.once(D.Event.latch(D.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const F=this._register((0,r.disposableTimeout)(()=>{F.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(o){const u=await this.extensionManagementService.getInstalled(1),c=o.filter(y=>!y.whenNotInstalled||y.whenNotInstalled.every(_=>u.every(F=>!(0,p.areSameExtensions)(F.identifier,{id:_})))).map(({extensionId:y})=>y.toLowerCase()),d=(0,b.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,d,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,-1,"{}"))}addToRecommendedExecutables(o,u){const c=this.getPromptedExecutableTips();c[o]=u.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(i,JSON.stringify(c),-1,0)}groupByInstalled(o,u){const c=[],d=[],y=u.reduce((_,F)=>(_.add(F.identifier.id.toLowerCase()),_),new Set);return o.forEach(_=>{y.has(_.toLowerCase())?c.push(_):d.push(_)}),{installed:c,uninstalled:d}}async getValidExecutableBasedExtensionTips(o){const u=[],c=new Map;for(const d of o.keys()){const y=o.get(d);if(!y||!(0,R.isNonEmptyArray)(y.recommendations))continue;const _=[];A.isWindows?y.windowsPath&&_.push(y.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(_.push((0,L.join)("/usr/local/bin",d)),_.push((0,L.join)("/usr/bin",d)),_.push((0,L.join)(this.environmentService.userHome.fsPath,d)));for(const F of _){let T=c.get(F);if(T===void 0&&(T=await this.fileService.exists(E.URI.file(F)),c.set(F,T)),T)for(const{extensionId:O,extensionName:k,isExtensionPack:M,whenNotInstalled:$}of y.recommendations)u.push({extensionId:O,extensionName:k,isExtensionPack:M,exeName:d,exeFriendlyName:y.exeFriendlyName,windowsPath:y.windowsPath,whenNotInstalled:$})}}return u}};t=pe([K(0,I.INativeEnvironmentService),K(1,l.ITelemetryService),K(2,w.IExtensionManagementService),K(3,f.IStorageService),K(4,m.INativeHostService),K(5,h.IExtensionRecommendationNotificationService),K(6,S.IFileService),K(7,g.IProductService),K(8,a.IRequestService),K(9,C.ILogService)],t),e.ExtensionTipsService=t}),define(ne[253],re([0,1,6,2,17,67,21,71,20]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(w,p,v,h){super(),this.initialWorkspace=w,this.initialProfiles=p,this.mainProcessService=v,this.environmentService=h,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new r.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new r.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const w=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),p=this._register(new L.Storage(w));return this._register(p.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),p}createProfileStorage(w){this.profileStorageDisposables.clear(),this.profileStorageProfile=w;let p;if((0,A.isProfileUsingDefaultStorage)(w))p=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),w));p=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(p.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),p}createWorkspaceStorage(w){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=w?.id;let p;if(w){const v=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),w));p=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(p.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)))}return p}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(w,p){if(!this.canSwitchProfile(this.profileStorageProfile,w))return;const v=this.profileStorage,h=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(w),await this.profileStorage.init(),this.switchData(h,this.profileStorage,0,p)}async switchToWorkspace(w,p){const v=this.workspaceStorage,h=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(w),await this.workspaceStorage.init(),this.switchData(h,this.workspaceStorage,1,p)}hasScope(w){return(0,E.isUserDataProfile)(w)?this.profileStorageProfile.id===w.id:this.workspaceStorageId===w.id}}e.NativeStorageService=b}),define(ne[254],re([0,1,3,2,17,14,58,20]),function(Q,e,R,r,D,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let E=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(I,w,p){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=w.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(p.userRoamingDataHome,"profiles"),this._profiles=I.map(v=>(0,P.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const h=v.added.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),S=v.removed.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),C=v.updated.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme));this._profiles=v.all.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:S,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}async createNamedProfile(I,w,p){const v=await this.channel.call("createNamedProfile",[I,w,p]);return(0,P.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(I,w,p,v,h){const S=await this.channel.call("createProfile",[I,w,p,v,h]);return(0,P.reviveProfile)(S,this.profilesHome.scheme)}async createTransientProfile(I){const w=await this.channel.call("createTransientProfile",[I]);return(0,P.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(I,w){await this.channel.call("setProfileForWorkspace",[I,w])}removeProfile(I){return this.channel.call("removeProfile",[I])}async updateProfile(I,w,p,v){const h=await this.channel.call("updateProfile",[I,w,p,v]);return(0,P.reviveProfile)(h,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};E=pe([K(1,A.IMainProcessService),K(2,L.IEnvironmentService)],E),e.UserDataProfilesNativeService=E}),define(ne[41],re([0,1,19,6,16,24,3,35,2,27,15,7,162,18,14,13,8,48,21,23,31,26,20]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=s;let t=class extends E.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(d,y,_,F,T,O,k,M,$,q,J,H){super(),this.syncResource=d,this.collection=y,this.fileService=_,this.environmentService=F,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=k,this.userDataSyncEnablementService=M,this.telemetryService=$,this.logService=q,this.configurationService=J,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new r.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=`${(0,b.uppercaseFirstLetter)(this.resource)}${d.profile.isDefault?"":` (${d.profile.name})`}`,this.extUri=H.extUri,this.syncFolder=this.extUri.joinPath(F.userDataSyncHome,...(0,l.getPathSegments)(d.profile.isDefault?void 0:d.profile.id,d.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(d.profile.isDefault?void 0:d.profile.id,d.syncResource,F,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(F,_,T)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const d=await this.syncPreviewPromise;this.syncPreviewPromise=null;const y=await this.performSync(d.remoteUserData,d.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(y)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const d=await this.getLastSyncUserData();(d?await this.hasRemoteChanged(d):!0)&&this._onDidChangeLocal.fire()}}setStatus(d){this._status!==d&&(this._status=d,this._onDidChangStatus.fire(d))}async sync(d,y={}){await this._sync(d,!0,this.getUserDataSyncConfiguration(),y)}async preview(d,y,_={}){return this._sync(d,!1,y,_)}async apply(d,y={}){try{this.syncHeaders={...y};const _=await this.doApply(d);return this.setStatus(_),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(d,y,_,F){try{if(this.syncHeaders={...F},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let T="idle";try{const O=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(d,O);return T=await this.performSync(k,O,y,_),T==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(T)}}finally{this.syncHeaders={}}}async replace(d){const y=await this.resolveContent(d);if(!y)return!1;const _=this.parseSyncData(y);if(!_)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const F=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,F),O=await this.isRemoteDataFromCurrentMachine(T),k=await this.generateSyncPreview({ref:T.ref,syncData:_},F,O,this.getUserDataSyncConfiguration(),L.CancellationToken.None),M=[];for(const $ of k){const q=await this.getAcceptResult($,$.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult($,$.previewResource,$.remoteContent,L.CancellationToken.None);M.push([$,{...q,remoteChange:J!==0?J:2}])}await this.applyResult(T,F,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(d){const y=await this.currentMachineIdPromise;return!!d.syncData?.machineId&&d.syncData.machineId===y}async getLatestRemoteUserData(d,y){if(y){const _=d?d[this.resource]:void 0;if(y.ref===_||_===void 0&&y.syncData===null)return y}return this.getRemoteUserData(y)}async performSync(d,y,_,F){if(d.syncData&&d.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,d.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(d,y,_,F)}catch(T){if(T instanceof l.UserDataSyncError)switch(T.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(d,y,_,F);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),d=await this.getRemoteUserData(null),y=await this.getLastSyncUserData(),this.performSync(d,y,_,F)}throw T}}async doSync(d,y,_,F){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,r.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(d,y,_,F,O)));const T=await this.syncPreviewPromise;return this.updateConflicts(T.resourcePreviews),T.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":_?await this.doApply(!1):"syncing"}catch(T){throw this.syncPreviewPromise=null,T}}async merge(d){return await this.updateSyncResourcePreview(d,async y=>{const _=await this.getMergeResult(y,L.CancellationToken.None);await this.fileService.writeFile(y.previewResource,D.VSBuffer.fromString(_?.content||""));const F=_&&!_.hasConflicts?await this.getAcceptResult(y,y.previewResource,void 0,L.CancellationToken.None):void 0;return y.acceptResult=F,y.mergeState=_.hasConflicts?"conflict":F?"accepted":"preview",y.localChange=F?F.localChange:_.localChange,y.remoteChange=F?F.remoteChange:_.remoteChange,y}),this.syncPreviewPromise}async accept(d,y){return await this.updateSyncResourcePreview(d,async _=>{const F=await this.getAcceptResult(_,d,y,L.CancellationToken.None);return _.acceptResult=F,_.mergeState="accepted",_.localChange=F.localChange,_.remoteChange=F.remoteChange,_}),this.syncPreviewPromise}async discard(d){return await this.updateSyncResourcePreview(d,async y=>{const _=await this.getMergeResult(y,L.CancellationToken.None);return await this.fileService.writeFile(y.previewResource,D.VSBuffer.fromString(_.content||"")),y.acceptResult=void 0,y.mergeState="preview",y.localChange=_.localChange,y.remoteChange=_.remoteChange,y}),this.syncPreviewPromise}async updateSyncResourcePreview(d,y){if(!this.syncPreviewPromise)return;let _=await this.syncPreviewPromise;const F=_.resourcePreviews.findIndex(({localResource:T,remoteResource:O,previewResource:k})=>this.extUri.isEqual(T,d)||this.extUri.isEqual(O,d)||this.extUri.isEqual(k,d));F!==-1&&(this.syncPreviewPromise=(0,r.createCancelablePromise)(async T=>{const O=[..._.resourcePreviews];return O[F]=await y(O[F]),{..._,resourcePreviews:O}}),_=await this.syncPreviewPromise,this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(d){if(!this.syncPreviewPromise)return"idle";const y=await this.syncPreviewPromise;return y.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":y.resourcePreviews.some(({mergeState:_})=>_!=="accepted")?"syncing":(await this.applyResult(y.remoteUserData,y.lastSyncUserData,y.resourcePreviews.map(_=>[_,_.acceptResult]),d),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(d){const y=d.filter(({mergeState:_})=>_==="conflict");(0,R.equals)(this._conflicts,y,(_,F)=>this.extUri.isEqual(_.previewResource,F.previewResource))||(this._conflicts=y,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const d=await this.getLastSyncUserData();return!!d&&d.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource,this.collection)).map(({created:y,ref:_})=>({created:y,uri:this.toRemoteBackupResource(_)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.syncResource.profile,this.resource)).map(({created:y,ref:_})=>({created:y,uri:this.toLocalBackupResource(_)}))}toRemoteBackupResource(d){return w.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.syncResource.profile.isDefault?"":`${this.syncResource.profile.id}/`}${this.resource}/${d}`})}toLocalBackupResource(d){return w.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.syncResource.profile.id}/${this.resource}/${d}`})}async getMachineId({uri:d}){const y=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(y))){const{content:_}=await this.getUserData(y);if(_)return this.parseSyncData(_)?.machineId}}async resolveContent(d){const y=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(y))){const{content:_}=await this.getUserData(y);return _}return this.extUri.isEqual(d,this.toLocalBackupResource(y))?this.userDataSyncBackupStoreService.resolveContent(this.syncResource.profile,this.resource,y):null}async resolvePreviewContent(d){const y=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(y)for(const _ of y.resourcePreviews){if(this.extUri.isEqual(_.acceptedResource,d))return _.acceptResult?_.acceptResult.content:null;if(this.extUri.isEqual(_.remoteResource,d))return _.remoteContent;if(this.extUri.isEqual(_.localResource,d))return _.localContent;if(this.extUri.isEqual(_.baseResource,d))return _.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(d,y,_,F,T){const O=await this.isRemoteDataFromCurrentMachine(d),k=await this.generateSyncPreview(d,y,O,F,T),M=[];for(const $ of k){const q=$.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)M.push({...$,acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=_?await this.getMergeResult($,T):void 0;if(T.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,D.VSBuffer.fromString(J?.content||""));const H=J&&!J.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,T):void 0;M.push({...$,acceptResult:H,mergeState:J?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:J?J.localChange:$.localChange,remoteChange:H?H.remoteChange:J?J.remoteChange:$.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:d,lastSyncUserData:y,resourcePreviews:M,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const d=await this.fileService.readFile(this.lastSyncResource),y=JSON.parse(d.value.toString()),_=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=y.version&&_&&y.version!==_,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${y.version} is not compatible with current sync state version ${_}.`),await this.resetLocal(),null;const F=y;if(F.content===null)return{ref:y.ref,syncData:null};const T=JSON.parse(F.content);if(s(T))return{...y,syncData:T,content:void 0}}catch(d){d instanceof S.FileOperationError&&d.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(d)}return null}async updateLastSyncUserData(d,y={}){if(y.ref||y.content||y.version)throw new Error("Cannot have core properties as additional");const _=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),F={ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null,version:_,...y};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(F)))}async getRemoteUserData(d){const{ref:y,content:_}=await this.getUserData(d);let F=null;return _!==null&&(F=this.parseSyncData(_)),{ref:y,syncData:F}}parseSyncData(d){try{const y=JSON.parse(d);if(s(y))return y}catch(y){this.logService.error(y)}throw new l.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(d){if((0,I.isString)(d)){const y=await this.userDataSyncStoreService.resolveResourceContent(this.resource,d,this.collection);return{ref:d,content:y}}else{const y=d?{ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,y,this.collection,this.syncHeaders)}}async updateRemoteUserData(d,y){const _=await this.currentMachineIdPromise,F={version:this.version,machineId:_,content:d};try{return y=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(F),y,this.collection,this.syncHeaders),{ref:y,syncData:F}}catch(T){throw T instanceof l.UserDataSyncError&&T.code==="TooLarge"&&(T=new l.UserDataSyncError(T.message,T.code,this.resource)),T}}async backupLocal(d){const y={version:this.version,content:d};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(y))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([K(2,S.IFileService),K(3,h.IEnvironmentService),K(4,g.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncEnablementService),K(8,a.ITelemetryService),K(9,l.IUserDataSyncLogService),K(10,v.IConfigurationService),K(11,f.IUriIdentityService)],t),e.AbstractSynchroniser=t;let n=class extends t{constructor(d,y,_,F,T,O,k,M,$,q,J,H,G){super(y,_,F,T,O,k,M,$,q,J,H,G),this.file=d,this._register(this.fileService.watch(this.extUri.dirname(d))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(d,y,_){try{y?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(d),_?void 0:y):await this.fileService.createFile(this.file,D.VSBuffer.fromString(d),{overwrite:_})}catch(F){throw F instanceof S.FileOperationError&&F.fileOperationResult===1||F instanceof S.FileOperationError&&F.fileOperationResult===3?new l.UserDataSyncError(F.message,"LocalPreconditionFailed"):F}}onFileChanges(d){!d.contains(this.file)||this.triggerLocalChange()}};n=pe([K(3,S.IFileService),K(4,h.IEnvironmentService),K(5,g.IStorageService),K(6,l.IUserDataSyncStoreService),K(7,l.IUserDataSyncBackupStoreService),K(8,l.IUserDataSyncEnablementService),K(9,a.ITelemetryService),K(10,l.IUserDataSyncLogService),K(11,v.IConfigurationService),K(12,f.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let o=class extends n{constructor(d,y,_,F,T,O,k,M,$,q,J,H,G,z){super(d,y,_,F,T,O,k,M,$,q,J,G,z),this.userDataSyncUtilService=H,this._formattingOptions=void 0}hasErrors(d,y){const _=[],F=(0,P.parse)(d,_,{allowEmptyContent:!0,allowTrailingComma:!0});return _.length>0||!(0,I.isUndefined)(F)&&y!==Array.isArray(F)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=pe([K(3,S.IFileService),K(4,h.IEnvironmentService),K(5,g.IStorageService),K(6,l.IUserDataSyncStoreService),K(7,l.IUserDataSyncBackupStoreService),K(8,l.IUserDataSyncEnablementService),K(9,a.ITelemetryService),K(10,l.IUserDataSyncLogService),K(11,l.IUserDataSyncUtilService),K(12,v.IConfigurationService),K(13,f.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let u=class{constructor(d,y,_,F,T,O){this.resource=d,this.userDataProfilesService=y,this.environmentService=_,this.logService=F,this.fileService=T,this.extUri=O.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(void 0,this.resource,_,this.extUri)}async initialize({ref:d,content:y}){if(!y){this.logService.info("Remote content does not exist.",this.resource);return}const _=this.parseSyncData(y);if(!!_)try{await this.doInitialize({ref:d,syncData:_})}catch(F){this.logService.error(F)}}parseSyncData(d){try{const y=JSON.parse(d);if(s(y))return y}catch(y){this.logService.error(y)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(d,y={}){const _={ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null,...y};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(_)))}};u=pe([K(1,i.IUserDataProfilesService),K(2,h.IEnvironmentService),K(3,C.ILogService),K(4,S.IFileService),K(5,f.IUriIdentityService)],u),e.AbstractInitializer=u}),define(ne[255],re([0,1,6,24,9,3,46,27,7,18,14,29,33,75,13,8,21,23,31,20,41,237,110,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(u,c){const d=JSON.parse(u.content);if(u.version===1||u.version===2){const y=(await c.getInstalled(0)).filter(_=>_.isBuiltin);for(const _ of d)u.version===1&&(_.enabled===!1&&(_.disabled=!0),delete _.enabled),u.version===2&&y.every(F=>!(0,p.areSameExtensions)(F.identifier,_.identifier))&&(_.installed=!0)}return d}let n=class gt extends f.AbstractSynchroniser{constructor(c,d,y,_,F,T,O,k,M,$,q,J,H,G,z,x,Y){super({syncResource:"extensions",profile:c},d,_,y,F,T,O,G,z,q,H,Y),this.extensionManagementService=k,this.extensionEnablementService=M,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=J,this.extensionStorageService=x,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.profileLocation=c.extensionsResource,this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,te=>te.some(({local:ce})=>!!ce)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,te=>!te.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(c,d){const y=c.syncData?await t(c.syncData,this.extensionManagementService):null,_=d?.skippedExtensions||[],F=d?.syncData?await t(d.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),O=this.getLocalExtensions(T),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:$}=(0,l.merge)(O,y,F,_,k),q={local:M,remote:$,content:this.getPreviewContent(O,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:$!==null?2:0},J=this.stringify(O,!1);return[{skippedExtensions:_,baseResource:this.baseResource,baseContent:F?this.stringify(F,!1):J,localResource:this.localResource,localContent:J,localExtensions:O,remoteResource:this.remoteResource,remoteContent:y?this.stringify(y,!1):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(c){const d=c.syncData?await t(c.syncData,this.extensionManagementService):null,y=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),_=this.getLocalExtensions(y),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),{remote:T}=(0,l.merge)(_,d,d,c.skippedExtensions||[],F);return T!==null}getPreviewContent(c,d,y,_){const F=[...d,...y],T=new Set,O=k=>{T.add(k.id.toLowerCase()),k.uuid&&T.add(k.uuid)};F.forEach(({identifier:k})=>O(k)),_.forEach(O);for(const k of c)T.has(k.identifier.id.toLowerCase())||k.identifier.uuid&&T.has(k.identifier.uuid)||F.push(k);return this.stringify(F,!1)}async getMergeResult(c,d){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,d,y,_){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(d,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(c){const d=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),_=(0,l.merge)(c.localExtensions,null,null,c.skippedExtensions,y),{local:F,remote:T}=_;return{content:c.localContent,local:F,remote:T,localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(c){const d=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),_=c.remoteContent?JSON.parse(c.remoteContent):null;if(_!==null){const F=(0,l.merge)(c.localExtensions,_,c.localExtensions,[],y),{local:T,remote:O}=F;return{content:c.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,d,y,_){let{skippedExtensions:F,localExtensions:T}=y[0][0];const{local:O,remote:k,localChange:M,remoteChange:$}=y[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(T)),F=await this.updateLocalExtensions(O.added,O.removed,O.updated,F)),k){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(k.all);c=await this.updateRemoteUserData(q,_?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${k.added.length?` Added: ${JSON.stringify(k.added.map(J=>J.identifier.id))}.`:""}${k.updated.length?` Updated: ${JSON.stringify(k.updated.map(J=>J.identifier.id))}.`:""}${k.removed.length?` Removed: ${JSON.stringify(k.removed.map(J=>J.identifier.id))}.`:""}`)}d?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:F}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${F.length?` Skipped: ${JSON.stringify(F.map(q=>q.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,gt.EXTENSIONS_DATA_URI)){const y=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),_=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),F=this.getLocalExtensions(y).filter(T=>!_.some(O=>(0,p.areSameExtensions)({id:O},T.identifier)));return this.stringify(F,!0)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.baseResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c)){const y=await this.resolvePreviewContent(c);return y&&this.stringify(JSON.parse(y),!0)}let d=await super.resolveContent(c);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(c)),d){const y=this.parseSyncData(d);if(y)switch(this.extUri.basename(c)){case"extensions.json":return this.stringify(this.parseExtensions(y),!0)}}return null}stringify(c,d){return c.sort((y,_)=>!y.identifier.uuid&&_.identifier.uuid?-1:y.identifier.uuid&&!_.identifier.uuid?1:(0,P.compare)(y.identifier.id,_.identifier.id)),d?(0,A.toFormattedString)(c,{}):JSON.stringify(c)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(this.getLocalExtensions(c).some(y=>y.installed||y.disabled))return!0}catch{}return!1}async updateLocalExtensions(c,d,y,_){const F=[],T=[],O=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(d.length){const M=O.filter(({identifier:$,isBuiltin:q})=>!q&&d.some(J=>(0,p.areSameExtensions)($,J)));await R.Promises.settled(M.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),F.push($.identifier)}))}(c.length||y.length)&&await R.Promises.settled([...c,...y].map(async M=>{const $=O.find(J=>(0,p.areSameExtensions)(J.identifier,M.identifier));if($&&$.isBuiltin){M.state&&$.manifest.version===M.version&&this.updateExtensionState(M.state,$,$.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),F.push(M.identifier);return}const q=(await this.extensionGalleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],r.CancellationToken.None))[0];if(M.state&&($?$.manifest.version===M.version:!!q)&&this.updateExtensionState(M.state,$||q,$?.manifest.version),q)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,q.version),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,q.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,q.version),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,q.version))),(!$||$.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(q)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,q.version),await this.extensionManagementService.installFromGallery(q,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,q.version),F.push(q.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),T.push(M)))}catch(J){T.push(M),J instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,q.displayName||q.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,q.displayName||q.identifier.id))}else T.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const k=[];for(const M of _)F.some($=>(0,p.areSameExtensions)($,M.identifier))||k.push(M);for(const M of T)k.some($=>(0,p.areSameExtensions)($.identifier,M.identifier))||k.push(M);return k}updateExtensionState(c,d,y){const _=this.extensionStorageService.getExtensionState(d,!0)||{},F=y?this.extensionStorageService.getKeysForSync({id:d.identifier.id,version:y}):void 0;F?F.forEach(T=>{_[T]=c[T]}):Object.keys(c).forEach(T=>_[T]=c[T]),this.extensionStorageService.setExtensionState(d,_,!0)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const d=this.extensionEnablementService.getDisabledExtensions();return c.map(y=>{const{identifier:_,isBuiltin:F,manifest:T,preRelease:O}=y,k={identifier:_,preRelease:O,version:T.version};d.some(M=>(0,p.areSameExtensions)(M,_))&&(k.disabled=!0),F||(k.installed=!0);try{const M=this.extensionStorageService.getKeysForSync({id:_.id,version:T.version});if(M){const $=this.extensionStorageService.getExtensionState(y,!0)||{};k.state=Object.keys($).reduce((q,J)=>(M.includes(J)&&(q[J]=$[J]),q),{})}}catch(M){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(M))}return k})}};n.EXTENSIONS_DATA_URI=E.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=pe([K(2,I.IEnvironmentService),K(3,h.IFileService),K(4,C.IStorageService),K(5,s.IUserDataSyncStoreService),K(6,s.IUserDataSyncBackupStoreService),K(7,w.IExtensionManagementService),K(8,w.IGlobalExtensionEnablementService),K(9,i.IIgnoredExtensionsManagementService),K(10,s.IUserDataSyncLogService),K(11,w.IExtensionGalleryService),K(12,b.IConfigurationService),K(13,s.IUserDataSyncEnablementService),K(14,m.ITelemetryService),K(15,v.IExtensionStorageService),K(16,g.IUriIdentityService)],n),e.ExtensionsSynchroniser=n;let o=class extends f.AbstractInitializer{constructor(c,d,y,_,F,T,O){super("extensions",_,F,T,y,O),this.extensionManagementService=c,this.ignoredExtensionsManagementService=d}async parseExtensions(c){return c.syncData?await t(c.syncData,this.extensionManagementService):null}generatePreview(c,d){const y=[],_=[],F=[];for(const T of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=d.find(k=>(0,p.areSameExtensions)(k.identifier,T.identifier));O?(y.push(O),T.disabled&&F.push(T.identifier)):T.installed&&(_.push({...T.identifier,preRelease:!!T.preRelease}),T.disabled&&F.push(T.identifier))}return{installedExtensions:y,newExtensions:_,disabledExtensions:F,remoteExtensions:c}}};o=pe([K(0,w.IExtensionManagementService),K(1,i.IIgnoredExtensionsManagementService),K(2,h.IFileService),K(3,a.IUserDataProfilesService),K(4,I.IEnvironmentService),K(5,S.ILogService),K(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[256],re([0,1,19,16,3,35,4,15,163,18,14,13,21,23,31,20,41,238,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function a(i,s,t){try{const n=JSON.parse(i);if(!s)return(0,P.isUndefined)(n.all)?null:n.all;switch(A.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=a;let f=class extends C.AbstractJsonFileSynchroniser{constructor(s,t,n,o,u,c,d,y,_,F,T,O,k){super(s.keybindingsResource,{syncResource:"keybindings",profile:s},t,y,_,F,n,o,d,O,u,T,c,k),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(c.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,n,o){const u=s.syncData?a(s.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&n?s:t;const c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,d=await this.getLocalFileContent(),y=await this.getFormattingOptions();let _=null,F=!1,T=!1,O=!1;if(u){let $=d?d.value.toString():"[]";if($=$||"[]",this.hasErrors($,!0))throw new g.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==$||c!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,m.merge)($,u,c,y,this.userDataSyncUtilService);q.hasChanges&&(_=q.mergeContent,O=q.hasConflicts,F=O||q.mergeContent!==$,T=O||q.mergeContent!==u)}}else d&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),_=d.value.toString(),T=!0);const k={content:O?c:_,localChange:F?d?2:1:0,remoteChange:T?2:0,hasConflicts:O},M=d?d.value.toString():null;return[{fileContent:d,baseResource:this.baseResource,baseContent:c,localResource:this.localResource,localContent:M,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getKeybindingsContentFromLastSyncUserData(s);if(t===null)return!0;const n=await this.getLocalFileContent(),o=n?n.value.toString():"",u=await this.getFormattingOptions(),c=await(0,m.merge)(o||"[]",t,t,u,this.userDataSyncUtilService);return c.hasConflicts||c.mergeContent!==t}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,n,o){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,n,o){const{fileContent:u}=n[0][0];let{content:c,localChange:d,remoteChange:y}=n[0][1];if(d===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c,!0)))throw new g.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),u&&await this.backupLocal(this.toSyncContent(u.value.toString())),await this.updateLocalFileContent(c||"[]",u,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const _=this.toSyncContent(c||"[]",s.syncData?.content);s=await this.updateRemoteUserData(_,o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,L.parse)(s.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(s)){case"keybindings.json":return a(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:a(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,t){let n={};try{n=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=s,A.OS){case 2:n.mac=s;break;case 3:n.linux=s;break;case 1:n.windows=s;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=pe([K(2,g.IUserDataSyncStoreService),K(3,g.IUserDataSyncBackupStoreService),K(4,g.IUserDataSyncLogService),K(5,b.IConfigurationService),K(6,g.IUserDataSyncEnablementService),K(7,w.IFileService),K(8,I.IEnvironmentService),K(9,p.IStorageService),K(10,g.IUserDataSyncUtilService),K(11,v.ITelemetryService),K(12,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let l=class extends C.AbstractInitializer{constructor(s,t,n,o,u){super("keybindings",t,n,o,s,u)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,r.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(s.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return a(s,!0,this.logService)}catch(t){return this.logService.error(t),null}}};l=pe([K(0,w.IFileService),K(1,S.IUserDataProfilesService),K(2,I.IEnvironmentService),K(3,g.IUserDataSyncLogService),K(4,h.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ne[257],re([0,1,16,3,164,18,70,14,29,13,21,23,31,20,41,61,242,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function a(i){const s=JSON.parse(i);return g(s)?s:{settings:i}}e.parseSettingsSyncContent=a;let f=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,n,o,u,c,d,y,_,F,T,O,k,M){super(s.settingsResource,{syncResource:"settings",profile:s},t,n,o,u,c,d,T,O,y,_,F,M),this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(s,t),o=this.getSettingsSyncContent(n),u=new A.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&u.parse(o.settings),u.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,t,n){const o=await this.getLocalFileContent(),u=await this.getFormattingOptions(),c=this.getSettingsSyncContent(s);t=t===null&&n?s:t;const d=t?this.getSettingsSyncContent(t):null,y=await this.getIgnoredSettings();let _=null,F=!1,T=!1,O=!1;if(c){let q=o?o.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,C.merge)(q,c.settings,d?d.settings:null,y,[],u);_=J.localContent||J.remoteContent,F=J.localContent!==null,T=J.remoteContent!==null,O=J.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),_=o.value.toString().trim()||"{}",this.validateContent(_),T=!0);const k=o?o.value.toString():null,M=d?.settings??null,$={content:O?M:_,localChange:F?2:0,remoteChange:T?2:0,hasConflicts:O};return[{fileContent:o,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:k,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getSettingsSyncContent(s);if(t===null)return!0;const n=await this.getLocalFileContent(),o=n?n.value.toString().trim():"",u=await this.getIgnoredSettings(),c=await this.getFormattingOptions();return(0,C.merge)(o||"{}",t.settings,t.settings,u,[],c).remoteContent!==null}async getMergeResult(s,t){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,C.updateIgnoredSettings)(s.previewResult.content,"{}",o,n):null}}async getAcceptResult(s,t,n,o){const u=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?(0,C.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",c,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,C.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,C.updateIgnoredSettings)(n,s.fileContent?s.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,n,o){const{fileContent:u}=n[0][0];let{content:c,localChange:d,remoteChange:y}=n[0][1];if(d===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(c,u,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),y!==0){const _=await this.getFormattingOptions(),F=this.getSettingsSyncContent(s),T=await this.getIgnoredSettings(c);c=(0,C.updateIgnoredSettings)(c,F?F.settings:"{}",T,_),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=await this.getFormattingOptions(),n=(0,S.edit)(s.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,C.isEmpty)(n)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const n=this.parseSyncData(t);if(n){const o=this.parseSettingsSyncContent(n.content);if(o)switch(this.extUri.basename(s)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(s){let t=await super.resolvePreviewContent(s);if(t){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,C.updateIgnoredSettings)(t,"{}",o,n)}return t}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=r.Event.any(r.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:u})=>!!u)),r.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,C.getIgnoredSettings)(t,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new m.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};f=pe([K(2,b.IFileService),K(3,P.IEnvironmentService),K(4,I.IStorageService),K(5,m.IUserDataSyncStoreService),K(6,m.IUserDataSyncBackupStoreService),K(7,m.IUserDataSyncLogService),K(8,m.IUserDataSyncUtilService),K(9,L.IConfigurationService),K(10,m.IUserDataSyncEnablementService),K(11,w.ITelemetryService),K(12,E.IExtensionManagementService),K(13,p.IUriIdentityService)],f),e.SettingsSynchroniser=f;let l=class extends h.AbstractInitializer{constructor(s,t,n,o,u){super("settings",t,n,o,s,u)}async doInitialize(s){const t=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,C.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}};l=pe([K(0,b.IFileService),K(1,v.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,p.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ne[258],re([0,1,16,3,32,18,14,13,21,23,31,20,41,239,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends p.AbstractSynchroniser{constructor(g,a,f,l,i,s,t,n,o,u,c,d){super({syncResource:"snippets",profile:g},a,l,f,i,s,t,u,c,n,o,d),this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(r.Event.filter(this.fileService.onDidFilesChange,y=>y.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,a,f){const l=await this.getSnippetsFileContents(),i=this.toSnippetsContents(l),s=g.syncData?this.parseSnippets(g.syncData):null;a=a===null&&f?g:a;const t=a&&a.syncData?this.parseSnippets(a.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,v.merge)(i,s,t);return this.getResourcePreviews(n,l,s||{},t||{})}async hasRemoteChanged(g){const a=g.syncData?this.parseSnippets(g.syncData):null;if(a===null)return!0;const f=await this.getSnippetsFileContents(),l=this.toSnippetsContents(f),i=(0,v.merge)(l,a,a);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(g,a){return g.previewResult}async getAcceptResult(g,a,f,l){if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder))return f===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:f,localChange:f===null?g.fileContent!==null?3:0:2,remoteChange:f===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(g,a,f,l){const i=f.map(([s,t])=>({...s,acceptResult:t}));i.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,l)),i.some(({remoteChange:s})=>s!==0)&&(g=await this.updateRemoteSnippets(i,g,l)),a?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of i)try{await this.fileService.del(s)}catch{}}getResourcePreviews(g,a,f,l){const i=new Map;for(const s of Object.keys(g.local.added)){const t={content:g.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.local.updated)){const t={content:g.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.added)){const t={content:g.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.updated)){const t={content:g.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.conflicts){const t={content:l[s]??null,hasConflicts:!0,localChange:a[s]?2:1,remoteChange:f[s]?2:1},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(a))if(!i.has(s)){const t={content:a[s]?a[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async getAssociatedResources({uri:g}){const a=await super.resolveContent(g);if(a){const f=this.parseSyncData(a);if(f){const l=this.parseSnippets(f),i=[];for(const s of Object.keys(l)){const t=this.extUri.joinPath(g,s),n=this.extUri.joinPath(this.snippetsFolder,s),o=await this.fileService.exists(n);i.push({resource:t,comparableResource:o?n:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return i}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let a=await super.resolveContent(g);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(g)),a){const f=this.parseSyncData(a);if(f)return this.parseSnippets(f)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const a={};for(const f of g)f.fileContent&&(a[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(a)))}async updateLocalSnippets(g,a){for(const{fileContent:f,acceptResult:l,localResource:i,remoteResource:s,localChange:t}of g)if(t!==0){const n=s?this.extUri.basename(s):this.extUri.basename(i),o=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,R.VSBuffer.fromString(l.content),{overwrite:a}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,R.VSBuffer.fromString(l.content),a?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,a,f){const l=a.syncData?this.parseSnippets(a.syncData):{},i=(0,D.deepClone)(l);for(const{acceptResult:s,localResource:t,remoteResource:n,remoteChange:o}of g)if(o!==0){const u=t?this.extUri.basename(t):this.extUri.basename(n);o===3?delete i[u]:i[u]=s.content}return(0,v.areSame)(l,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),a=await this.updateRemoteUserData(JSON.stringify(i),f?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),a}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const a={};for(const f of Object.keys(g))a[f]=g[f].value.toString();return a}async getSnippetsFileContents(){const g={};let a;try{a=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof P.FileOperationError&&f.fileOperationResult===1)return g;throw f}for(const f of a.children||[]){const l=f.resource,i=this.extUri.extname(l);if(i===".json"||i===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,l),t=await this.fileService.readFile(l);g[s]=t}}return g}};S=pe([K(2,A.IEnvironmentService),K(3,P.IFileService),K(4,E.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncLogService),K(8,L.IConfigurationService),K(9,h.IUserDataSyncEnablementService),K(10,b.ITelemetryService),K(11,I.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let C=class extends p.AbstractInitializer{constructor(g,a,f,l,i){super("snippets",a,f,l,g,i)}async doInitialize(g){const a=g.syncData?JSON.parse(g.syncData.content):null;if(!a){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(a)){const i=a[l];if(i){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,l);await this.fileService.createFile(s,R.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};C=pe([K(0,P.IFileService),K(1,w.IUserDataProfilesService),K(2,A.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,I.IUriIdentityService)],C),e.SnippetsInitializer=C}),define(ne[259],re([0,1,16,18,14,13,21,23,31,20,41,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(C,m){try{return JSON.parse(C).tasks}catch(g){return m.error(g),null}}e.getTasksContentFromSyncContent=p;let v=class extends I.AbstractFileSynchroniser{constructor(m,g,a,f,l,i,s,t,n,o,u,c){super(m.tasksResource,{syncResource:"tasks",profile:m},g,t,n,o,a,f,s,u,l,i,c),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(m,g,a,f){const l=m.syncData?p(m.syncData.content,this.logService):null;g=g===null&&a?m:g;const i=g?.syncData?p(g.syncData.content,this.logService):null,s=await this.getLocalFileContent();let t=null,n=!1,o=!1,u=!1;if(l){const y=s?s.value.toString():null;if(!i||i!==y||i!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const _=S(y,l,i);t=_.content,u=_.hasConflicts,n=_.hasLocalChanged,o=_.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),o=!0);const c={content:u?i:t,localChange:n?s?2:1:0,remoteChange:o?2:0,hasConflicts:u},d=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:d,localChange:c.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:c.remoteChange,previewResource:this.previewResource,previewResult:c,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(m){const g=m?.syncData?p(m.syncData.content,this.logService):null;if(g===null)return!0;const a=await this.getLocalFileContent(),f=a?a.value.toString():null,l=S(f,g,g);return l.hasLocalChanged||l.hasRemoteChanged}async getMergeResult(m,g){return m.previewResult}async getAcceptResult(m,g,a,f){if(this.extUri.isEqual(g,this.localResource))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:m.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return a===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(m,g,a,f){const{fileContent:l}=a[0][0],{content:i,localChange:s,remoteChange:t}=a[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),l&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(l.value.toString()))),await this.updateLocalFileContent(i||"{}",l,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const n=JSON.stringify(this.toTasksSyncContent(i||"{}"));m=await this.updateRemoteUserData(n,f?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:m}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(m,"tasks.json"),comparableResource:g}]}async resolveContent(m){if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.baseResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(m)){case"tasks.json":return p(a.content,this.logService)}}return null}toTasksSyncContent(m){return{tasks:m}}};v=pe([K(2,w.IUserDataSyncStoreService),K(3,w.IUserDataSyncBackupStoreService),K(4,w.IUserDataSyncLogService),K(5,r.IConfigurationService),K(6,w.IUserDataSyncEnablementService),K(7,L.IFileService),K(8,D.IEnvironmentService),K(9,A.IStorageService),K(10,P.ITelemetryService),K(11,E.IUriIdentityService)],v),e.TasksSynchroniser=v;let h=class extends I.AbstractInitializer{constructor(m,g,a,f,l){super("tasks",g,a,f,m,l),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(m){const g=m.syncData?p(m.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(g)),await this.updateLastSyncUserData(m)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=pe([K(0,L.IFileService),K(1,b.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,w.IUserDataSyncLogService),K(4,E.IUriIdentityService)],h),e.TasksInitializer=h;function S(C,m,g){if(C===null&&m===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(C===m)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const a=g!==C,f=g!==m;return!a&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:a&&!f?{content:C,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!a?{content:m,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:C,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[260],re([0,1,46,7,18,14,13,21,23,31,20,41,240,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let h=class mt extends w.AbstractSynchroniser{constructor(m,g,a,f,l,i,s,t,n,o,u,c,d){super({syncResource:"profiles",profile:m},g,f,l,i,s,t,u,c,n,o,d),this.userDataProfilesService=a,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const m=await this.getLastSyncUserData();return m?.syncData?S(m.syncData):null}async getRemoteSyncedProfiles(m){const g=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(m,g);return a?.syncData?S(a.syncData):null}async generateSyncPreview(m,g,a){const f=m.syncData?S(m.syncData):null,l=g?.syncData?S(g.syncData):null,i=this.getLocalUserDataProfiles(),{local:s,remote:t}=(0,p.merge)(i,f,l,[]),n={local:s,remote:t,content:l?this.stringifyRemoteProfiles(l):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:t!==null?2:0},o=this.stringifyLocalProfiles(i,!1);return[{baseResource:this.baseResource,baseContent:l?this.stringifyRemoteProfiles(l):null,localResource:this.localResource,localContent:o,remoteResource:this.remoteResource,remoteContent:f?this.stringifyRemoteProfiles(f):null,remoteProfiles:f,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(m){const g=m?.syncData?S(m.syncData):null,a=this.getLocalUserDataProfiles(),{remote:f}=(0,p.merge)(a,g,g,[]);return!!f?.added.length||!!f?.removed.length||!!f?.updated.length}async getMergeResult(m,g){return{...m.previewResult,hasConflicts:!1}}async getAcceptResult(m,g,a,f){if(this.extUri.isEqual(g,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(g,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(g,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async acceptLocal(m){const g=this.getLocalUserDataProfiles(),a=(0,p.merge)(g,null,null,[]),{local:f,remote:l}=a;return{content:m.localContent,local:f,remote:l,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:l!==null?2:0}}async acceptRemote(m){const g=m.remoteContent?JSON.parse(m.remoteContent):null,a=[],f=[];for(const l of this.getLocalUserDataProfiles()){const i=g?.find(s=>s.id===l.id);i&&(a.push({id:l.id,name:l.name,collection:i.collection}),f.push(l))}if(g!==null){const l=(0,p.merge)(f,g,a,[]),{local:i,remote:s}=l;return{content:m.remoteContent,local:i,remote:s,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:s!==null?2:0}}else return{content:m.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(m,g,a,f){const{local:l,remote:i,localChange:s,remoteChange:t}=a[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),s!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const n=[];for(const o of l.added)n.push(this.userDataProfilesService.createProfile(o.id,o.name));for(const o of l.removed)n.push(this.userDataProfilesService.removeProfile(o));for(const o of l.updated){const u=this.userDataProfilesService.profiles.find(c=>c.id===o.id);u?n.push(this.userDataProfilesService.updateProfile(u,o.name)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(n)}if(t!==0){const n=a[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const o of i?.added||[]){const u=await this.userDataSyncStoreService.createCollection(this.syncHeaders);n.push({id:o.id,name:o.name,collection:u})}for(const o of i?.removed||[])n.splice(n.findIndex(({id:u})=>o.id===u),1);for(const o of i?.updated||[]){const u=n.find(({id:c})=>o.id===c);u&&n.splice(n.indexOf(u),1,{id:o.id,name:o.name,collection:u.collection})}m=await this.updateRemoteUserData(this.stringifyRemoteProfiles(n),f?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${i?.added.length?` Added: ${JSON.stringify(i.added.map(o=>o.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(o=>o.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(o=>o.name))}.`:""}`);for(const o of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(o.collection,this.syncHeaders)}g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"profiles.json"),comparableResource:mt.PROFILES_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,mt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.baseResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m)){const a=await this.resolvePreviewContent(m);return a&&(0,R.toFormattedString)(JSON.parse(a),{})}let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(m)){case"profiles.json":return(0,R.toFormattedString)(S(a),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(m=>!m.isDefault&&!m.isTransient)}stringifyRemoteProfiles(m){return JSON.stringify([...m].sort((g,a)=>g.name.localeCompare(a.name)))}stringifyLocalProfiles(m,g){const a=[...m].sort((f,l)=>f.name.localeCompare(l.name)).map(f=>({id:f.id,name:f.name}));return g?(0,R.toFormattedString)(a,{}):JSON.stringify(a)}};h.PROFILES_DATA_URI=r.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),h=pe([K(2,I.IUserDataProfilesService),K(3,A.IFileService),K(4,L.IEnvironmentService),K(5,P.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncLogService),K(9,D.IConfigurationService),K(10,v.IUserDataSyncEnablementService),K(11,E.ITelemetryService),K(12,b.IUriIdentityService)],h),e.UserDataProfilesManifestSynchroniser=h;function S(C){return JSON.parse(C.content)}}),define(ne[261],re([0,1,6,16,63,2,17,18,14,13,20,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends L.Disposable{constructor(h,S,C,m,g){super(),this.environmentService=h,this.fileService=S,this.configurationService=C,this.logService=m,this.userDataProfilesService=g;for(const a of this.userDataProfilesService.profiles)for(const f of w.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(a,f))}async getAllRefs(h,S){const C=this.getResourceBackupHome(h,S),m=await this.fileService.resolve(C);return m.children?m.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort().reverse().map(a=>({ref:a.name,created:this.getCreationTime(a)})):[]}async resolveContent(h,S,C){if(!C){const m=await this.getAllRefs(h,S);m.length&&(C=m[m.length-1].ref)}if(C){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,S,C);return(await this.fileService.readFile(m)).value.toString()}return null}async backup(h,S,C){const m=this.getResourceBackupHome(h,S),g=(0,A.joinPath)(m,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,r.VSBuffer.fromString(C))}catch(a){this.logService.error(a)}try{this.cleanUpBackup(m)}catch{}}getResourceBackupHome(h,S){return(0,A.joinPath)(this.environmentService.userDataSyncHome,...h.isDefault?[S]:[h.id,S])}async cleanUpBackup(h){try{try{if(!await this.fileService.exists(h))return}catch{return}const S=await this.fileService.resolve(h);if(S.children){const C=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=C.filter(f=>Date.now()-this.getCreationTime(f)>m);const a=C.length-g.length;a<10&&(g=g.slice(10-a)),await R.Promises.settled(g.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};p=pe([K(0,E.IEnvironmentService),K(1,b.IFileService),K(2,P.IConfigurationService),K(3,w.IUserDataSyncLogService),K(4,I.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(ne[262],re([0,1,3,2,4,14,21,23,26]),function(Q,e,R,r,D,L,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let I=class extends r.Disposable{constructor(p,v,h,S){super(),this.storageService=p,this.telemetryService=v,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:p}),this.storageService.store(b,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,E.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,v){if(this.isResourceEnabled(p)!==v){const h=(0,E.getEnablementKey)(p);this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,v){this.storageService.store(p,v,-1,D.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(b===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=E.ALL_SYNC_RESOURCES.filter(h=>(0,E.getEnablementKey)(h)===p.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};I=pe([K(0,A.IStorageService),K(1,P.ITelemetryService),K(2,L.IEnvironmentService),K(3,E.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[76],re([0,1,3,2,4,27,167,14,13,5,25,48,21,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",S="Safari",C="Chrome",m="Edge",g="Firefox",a="Android";function f(s){switch(s){case S:case C:case m:case g:case a:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function l(){return D.isSafari?S:D.isChrome?C:D.isEdge?m:D.isFirefox?g:D.isAndroid?a:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let i=class nt extends r.Disposable{constructor(t,n,o,u,c,d){super(),this.storageService=o,this.userDataSyncStoreService=u,this.logService=c,this.productService=d,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,n,o)}async getMachines(t){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(u=>({...u,isCurrent:u.id===n}))}async addCurrentMachine(t){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:u})=>u===n)||(o.machines.push({id:n,name:this.computeCurrentMachineName(o.machines),platform:l()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(t),u=o.machines.filter(({id:c})=>c!==n);u.length!==o.machines.length&&(o.machines=u,await this.writeMachinesData(o))}async renameMachine(t,n,o){const u=await this.readMachinesData(o),c=u.machines.find(({id:d})=>d===t);if(c){c.name=n,await this.writeMachinesData(u);const d=await this.currentMachineIdPromise;t===d&&this.storageService.store(h,n,-1,1)}}async setEnablements(t){const n=await this.readMachinesData();for(const[o,u]of t){const c=n.machines.find(d=>d.id===o);c&&(c.disabled=u?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(t){const n=this.storageService.get(h,-1);if(n)return n;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,u=new RegExp(`${(0,L.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let c=0;for(const d of t){const y=u.exec(d.name),_=y?parseInt(y[1]):0;c=_>c?_:c}return`${o} #${c+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const n=this.parse(this.userData);if(n.version!==nt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(t){const n=JSON.stringify(t),o=await this.userDataSyncStoreService.writeResource(nt.RESOURCE,n,this.userData?.ref||null);this.userData={ref:o,content:n},this._onDidChange.fire()}async readUserData(t){if(this.userData){const n=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.logService.error(n)}return{version:nt.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=pe([K(0,P.IEnvironmentService),K(1,E.IFileService),K(2,p.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncLogService),K(5,I.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ne[263],re([0,1,6,63,38,9,3,2,4,17,7,165,25,21,23,26,73,76]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",a="sync.sessionId",f="sync.storeUrl",l="sync.productQuality";let i=class extends P.Disposable{get syncUrl(){const n=this.storageService.get(f,-1);return n?I.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(f,n.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(l,-1)}set productQuality(n){n?this.storageService.store(l,n,-1,1):this.storageService.remove(l,-1)}constructor(n,o,u,c,d,y,_,F,T,O){super(),this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=u,this.userDataSyncEnablementService=c,this.userDataSyncService=d,this.logService=y,this.userDataSyncAccountService=_,this.telemetryService=F,this.userDataSyncMachinesService=T,this.storageService=O,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(u.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(d.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:n,message:o}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(u=>this.onDidFinishSync(u))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,r.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,o,u){try{this.userDataSyncAccountService.account&&!u&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,-1),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(o)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const o=S.UserDataSyncError.toUserDataSyncError(n);o instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?E.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(n,o,u){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",u)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=pe([K(0,p.IProductService),K(1,S.IUserDataSyncStoreManagementService),K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncEnablementService),K(4,S.IUserDataSyncService),K(5,S.IUserDataSyncLogService),K(6,C.IUserDataSyncAccountService),K(7,h.ITelemetryService),K(8,m.IUserDataSyncMachinesService),K(9,v.IStorageService)],i),e.UserDataAutoSyncService=i;class s extends P.Disposable{constructor(n,o,u,c,d,y,_,F){super(),this.lastSyncUrl=n,this.interval=o,this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=c,this.userDataSyncService=d,this.userDataSyncMachinesService=y,this.logService=_,this.storageService=F,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(n,o){const u=(0,R.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,L.isCancellationError)(d))return}return this.doSync(n,o,c)});return this.syncPromise=u,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!n&&(!(0,b.isEqual)(o.defaultUrl,n.defaultUrl)||!(0,b.isEqual)(o.insidersUrl,n.insidersUrl)||!(0,b.isEqual)(o.stableUrl,n.stableUrl))}async doSync(n,o,u){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),u.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const d=this.storageService.get(a,-1);if(d&&this.manifest&&d!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const y=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(u.isCancellationRequested)return;const _=y.find(F=>F.isCurrent);if(_?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(F){throw new S.UserDataAutoSyncError((0,D.toErrorMessage)(F),F instanceof S.UserDataSyncError?F.code:"Unknown")}if(this.manifest&&this.manifest.session!==d&&this.storageService.store(a,this.manifest.session,-1,1),u.isCancellationRequested)return;_||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(d){this.logService.error(d),c=d}this._onDidFinishSync.fire(c)}register(n){return super._register(n)}}s.INTERVAL_SYNCING="Interval"}),define(ne[77],re([0,1,2,67,5,21]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,D.createDecorator)("IUserDataSyncProfilesStorageService");let A=class extends R.Disposable{constructor(b){super(),this.storageService=b}async readStorageData(b){if(this.storageService.hasScope(b))return this.getItems(this.storageService);const I=await this.createStorageDatabase(b),w=new P(I);try{return await w.initialize(),this.getItems(w)}finally{w.dispose(),await this.closeAndDispose(I)}}async updateStorageData(b,I,w){if(this.storageService.hasScope(b))return this.writeItems(this.storageService,I,w);const p=await this.createStorageDatabase(b),v=new P(p);try{await v.initialize(),this.writeItems(v,I,w),await v.flush()}finally{v.dispose(),await this.closeAndDispose(p)}}getItems(b){const I=new Map,w=p=>{for(const v of b.keys(0,p))I.set(v,{value:b.get(v,0),target:p})};return w(0),w(1),I}writeItems(b,I,w){for(const[p,v]of I)b.store(p,v,0,w)}async closeAndDispose(b){try{await b.close()}finally{(0,R.isDisposable)(b)&&b.dispose()}}};A=pe([K(0,L.IStorageService)],A),e.AbstractUserDataSyncProfilesStorageService=A;class P extends L.AbstractStorageService{constructor(b){super({flushInterval:100}),this.profileStorage=this._register(new r.Storage(b))}doInitialize(){return this.profileStorage.init()}getStorage(b){return b===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[264],re([0,1,16,9,3,35,46,4,7,30,18,14,13,8,48,21,23,31,41,61,241,26,20,77]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",n=["locale"];function o(_,F){const T=_.storage?Object.keys(_.storage).sort():[],O={};return T.forEach(k=>O[k]=_.storage[k]),_.storage=O,F?(0,A.toFormattedString)(_,{}):JSON.stringify(_)}const u=1;let c=class pt extends g.AbstractSynchroniser{constructor(F,T,O,k,M,$,q,J,H,G,z,x,Y){super({syncResource:"globalState",profile:F},T,k,J,x,M,$,H,G,q,z,Y),this.userDataSyncProfilesStorageService=O,this.version=u,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(k.onDidFilesChange,te=>te.contains(this.environmentService.argvResource)),D.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,te=>!!(te.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||te.valueChanges.some(({profile:ce,changes:W})=>this.syncResource.profile.id===ce.id&&W.some(V=>V.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(F,T,O){const k=F.syncData?JSON.parse(F.syncData.content):null;T=T===null&&O?F:T;const M=T&&T.syncData?JSON.parse(T.syncData.content):null,$=await this.getLocalGlobalState();k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=await this.getStorageKeys(M),{local:J,remote:H}=(0,f.merge)($.storage,k?k.storage:null,M?M.storage:null,q,this.logService),G={content:null,local:J,remote:H,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:H!==null?2:0},z=o($,!1);return[{baseResource:this.baseResource,baseContent:M?o(M,!1):z,localResource:this.localResource,localContent:z,localUserData:$,remoteResource:this.remoteResource,remoteContent:k?o(k,!1):null,previewResource:this.previewResource,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async hasRemoteChanged(F){const T=F.syncData?JSON.parse(F.syncData.content):null;if(T===null)return!0;const O=await this.getLocalGlobalState(),k=await this.getStorageKeys(T),{remote:M}=(0,f.merge)(O.storage,T.storage,T.storage,k,this.logService);return M!==null}async getMergeResult(F,T){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,T,O,k){if(this.extUri.isEqual(T,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(T,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(T,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async acceptLocal(F){return{content:F.localContent,local:{added:{},removed:[],updated:{}},remote:F.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(F){if(F.remoteContent!==null){const T=JSON.parse(F.remoteContent),{local:O,remote:k}=(0,f.merge)(F.localUserData.storage,T.storage,null,F.storageKeys,this.logService);return{content:F.remoteContent,local:O,remote:k,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:F.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(F,T,O,k){const{localUserData:M}=O[0][0],{local:$,remote:q,localChange:J,remoteChange:H}=O[0][1];if(J===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),H!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const G=JSON.stringify({storage:q});F=await this.updateRemoteUserData(G,k?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}T?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(F),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:F}){return[{resource:this.extUri.joinPath(F,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(F){if(this.extUri.isEqual(F,pt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return o(O,!0)}if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const O=await this.resolvePreviewContent(F);return O&&o(JSON.parse(O),!0)}let T=await super.resolveContent(F);if(T)return T;if(T=await super.resolveContent(this.extUri.dirname(F)),T){const O=this.parseSyncData(T);if(O)switch(this.extUri.basename(F)){case"globalState.json":return o(JSON.parse(O.content),!0)}}return null}async hasLocalData(){try{const{storage:F}=await this.getLocalGlobalState();if(Object.keys(F).length>1||F[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const F={};if(this.syncResource.profile.isDefault){const O=await this.getLocalArgvContent(),k=(0,L.parse)(O);for(const M of n)k[M]!==void 0&&(F[`${t}${M}`]={version:1,value:k[M]})}const T=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile);for(const[O,k]of T)k.value&&k.target===0&&(F[O]={version:1,value:k.value});return{storage:F}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const F=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),F.value.toString()}catch(F){this.logService.debug((0,r.getErrorMessage)(F))}return"{}"}async writeLocalGlobalState({added:F,removed:T,updated:O}){const k={},M=new Map,$=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),q=(J,H)=>{for(const G of J){if(G.startsWith(t)){k[G.substring(t.length)]=H?H[G].value:void 0;continue}if(H){const z=H[G];z.value!==$.get(G)?.value&&M.set(G,z.value)}else $.get(G)!==void 0&&M.set(G,void 0)}};q(Object.keys(F),F),q(Object.keys(O),O),q(T),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),M.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.syncResource.profile,M,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...M.keys()]))}async updateArgv(F){const T=await this.getLocalArgvContent();let O=T;for(const k of Object.keys(F))O=(0,a.edit)(O,[k],F[k],{});T!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys(F){const T=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),O=[],k=[];for(const[q,J]of T)J.target===0?O.push(q):J.target===1&&k.push(q);const M=[...O,...k],$=F?.storage?Object.keys(F.storage).filter(q=>!q.startsWith(t)&&!M.includes(q)&&T.get(q)!==void 0):[];if(!P.isWeb){const q=[...l.ALL_SYNC_RESOURCES.map(J=>(0,l.getEnablementKey)(J)),l.SYNC_SERVICE_URL_TYPE];$.push(...q),k.push(...q)}return{user:O,machine:k,unregistered:$}}};c.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=pe([K(2,s.IUserDataSyncProfilesStorageService),K(3,p.IFileService),K(4,l.IUserDataSyncStoreService),K(5,l.IUserDataSyncBackupStoreService),K(6,l.IUserDataSyncLogService),K(7,w.IEnvironmentService),K(8,l.IUserDataSyncEnablementService),K(9,C.ITelemetryService),K(10,I.IConfigurationService),K(11,S.IStorageService),K(12,m.IUriIdentityService)],c),e.GlobalStateSynchroniser=c;let d=class extends g.AbstractInitializer{constructor(F,T,O,k,M,$){super("globalState",O,k,M,T,$),this.storageService=F}async doInitialize(F){const T=F.syncData?JSON.parse(F.syncData.content):null;if(!T){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},k={};for(const M of Object.keys(T.storage))M.startsWith(t)?O[M.substring(t.length)]=T.storage[M].value:this.storageService.get(M,0)===void 0&&(k[M]=T.storage[M].value);if(Object.keys(O).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(O))M=(0,a.edit)(M,[$],O[$],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(M))}if(Object.keys(k).length)for(const M of Object.keys(k))this.storageService.store(M,k[M],0,0)}};d=pe([K(0,S.IStorageService),K(1,p.IFileService),K(2,i.IUserDataProfilesService),K(3,w.IEnvironmentService),K(4,l.IUserDataSyncLogService),K(5,m.IUriIdentityService)],d),e.GlobalStateInitializer=d;let y=class{constructor(F,T,O,k,M){this.userDataSyncStoreClient=F,this.storageService=T,this.environmentService=O,this.fileService=k,this.logService=M}getSyncStoreType(F){return this.parseGlobalState(F)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(F){const T=(0,l.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(F,T)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(F,T)}throw O}}async doSync(F,T){const O=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,T),k=this.parseGlobalState(O)||{storage:{}};k.storage[l.SYNC_SERVICE_URL_TYPE]={value:F,version:u};const M=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:u,machineId:M,content:o(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify($),O.ref,void 0,T)}parseGlobalState({content:F}){if(!F)return null;const T=JSON.parse(F);if((0,g.isSyncData)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};y=pe([K(1,S.IStorageService),K(2,w.IEnvironmentService),K(3,p.IFileService),K(4,v.ILogService)],y),e.UserDataSyncStoreTypeSynchronizer=y}),define(ne[265],re([0,1,19,6,38,3,2,17,15,30,18,29,5,25,21,23,20,255,264,256,257,258,259,260,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l,i,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let o=class extends A.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(T,O,k,M,$,q,J,H,G,z){super(),this.userDataSyncStoreService=T,this.userDataSyncStoreManagementService=O,this.instantiationService=k,this.configurationService=M,this.logService=$,this.telemetryService=q,this.storageService=J,this.userDataSyncEnablementService=H,this.userDataProfilesService=G,this.productService=z,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=O.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(n,-1,void 0),this._register((0,A.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(T,O){this.checkEnablement();const k=(0,b.generateUuid)();try{const J=(0,t.createSyncHeaders)(k);O&&(J["Cache-Control"]="no-cache"),T=await this.userDataSyncStoreService.manifest(T,J)}catch(J){const H=t.UserDataSyncError.toUserDataSyncError(J);throw y(H,k,this.userDataSyncStoreManagementService,this.telemetryService),H}const M=!1,$=this;let q;return{manifest:T,async run(){if(M)throw new Error("Can run a task only once");return q=(0,r.createCancelablePromise)(J=>$.sync(T,k,J)),q.finally(()=>q=void 0)},stop(){return q?.cancel(),$.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const T=(0,b.generateUuid)(),O=(0,t.createSyncHeaders)(T);let k;try{k=await this.userDataSyncStoreService.manifest(null,O)}catch(q){const J=t.UserDataSyncError.toUserDataSyncError(q);throw y(J,T,this.userDataSyncStoreManagementService,this.telemetryService),J}await this.resetLocal();const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0),$=async()=>{await this.stop(),await this.resetLocal()};return new u(T,k?.latest??null,this.userDataProfilesService.defaultProfile,O,M.enabled,$,this.configurationService,this.logService)}async sync(T,O,k){if(k.isCancellationRequested)return;const M=new Date().getTime();this._syncErrors=[];try{this.logService.info("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const $=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile($,T,O,k));const q=$.enabled.find(J=>J.resource==="profiles");if(q){const J=await q.getLastSyncedProfiles()||[];if(k.isCancellationRequested)return;for(const H of J){if(k.isCancellationRequested)return;const G=this.userDataProfilesService.profiles.find(x=>x.id===H.id);if(!G){this.logService.error(`Settings Profile with id:${H.id} and name: ${H.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",H.name);const z=this.getOrCreateActiveProfileSynchronizer(G,H);this._syncErrors.push(...await this.syncProfile(z,T,O,k))}}this.logService.info(`Sync done. Took ${new Date().getTime()-M}ms`),this.updateLastSyncTime()}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncProfile(T,O,k,M){return(await T.sync(O,k,M)).map(([q,J])=>({profile:T.profile,syncResource:q,error:J}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(T=>T.stop()))}async resolveContent(T){for(const O of this.userDataProfilesService.profiles){const k=await this.performAction(O,async M=>{const $=await M.resolveContent(T);if($)return $});if(!(0,E.isUndefinedOrNull)(k))return k}return null}async replace(T,O){this.checkEnablement(),await this.performAction(T.profile,async k=>{if(T.syncResource===k.resource)return await k.replace(O),!0})}async accept(T,O,k,M){this.checkEnablement(),await this.performAction(T.profile,async $=>{if(T.syncResource===$.resource)return await $.accept(O,k),M&&await $.apply(!1,(0,t.createSyncHeaders)((0,b.generateUuid)())),!0})}async getRemoteSyncResourceHandles(T){return await this.performAction(T.profile,async k=>{if(k.resource===T.syncResource)return k.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(T){return await this.performAction(T.profile,async k=>{if(k.resource===T.syncResource)return k.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(T,O){return await this.performAction(T.profile,async M=>{if(M.resource===T.syncResource)return M.getAssociatedResources(O)})||[]}async getMachineId(T,O){return await this.performAction(T.profile,async M=>{if(M.resource===T.syncResource)return await M.getMachineId(O)||null})||void 0}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async O=>{if(O.resource!=="globalState"&&await O.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async O=>{if(await O.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(T){this.logService.error(T)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(n,-1),this.activeProfileSynchronizers){for(const[T]of this.activeProfileSynchronizers.values())try{await T.resetLocal()}catch(O){this.logService.error(O)}this.clearActiveProfileSynchronizers()}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(T,O){const k=new A.DisposableStore;try{const M=this.activeProfileSynchronizers.get(T.id);if(M){const G=await this.performActionWithProfileSynchronizer(M[0],O,k);return(0,E.isUndefined)(G)?null:G}if(T.isDefault){const G=k.add(this.instantiationService.createInstance(c,T,void 0)),z=await this.performActionWithProfileSynchronizer(G,O,k);return(0,E.isUndefined)(z)?null:z}if(!this.productService.enableSyncingProfiles)return null;const $=k.add(this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,T,void 0)),q=await this.userDataSyncStoreService.manifest(null),H=(await $.getRemoteSyncedProfiles(q?.latest??null)||[]).find(G=>G.id===T.id);if(H){const G=k.add(this.instantiationService.createInstance(c,T,H.collection)),z=await this.performActionWithProfileSynchronizer(G,O,k);return(0,E.isUndefined)(z)?null:z}return null}finally{k.dispose()}}async performActionWithProfileSynchronizer(T,O,k){const M=[...T.enabled,...T.disabled.map($=>k.add(T.createSynchronizer($)))];for(const $ of M){const q=await O($);if(!(0,E.isUndefined)(q))return q}}setStatus(T){const O=this._status;this._status!==T&&(this._status=T,this._onDidChangeStatus.fire(T),O==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const T=this.getActiveProfileSynchronizers().map(O=>O.conflicts).flat();(0,R.equals)(this._conflicts,T,(O,k)=>O.profile.id===k.profile.id&&O.syncResource===k.syncResource&&(0,R.equals)(O.conflicts,k.conflicts,(M,$)=>(0,P.isEqual)(M.previewResource,$.previewResource)))||(this._conflicts=T,this._onDidChangeConflicts.fire(T))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(T,O){let k=this.activeProfileSynchronizers.get(T.id);if(!k){const M=new A.DisposableStore,$=M.add(this.instantiationService.createInstance(c,T,O?.collection));M.add($.onDidChangeStatus(q=>this.setStatus(q))),M.add($.onDidChangeConflicts(q=>this.updateConflicts())),M.add($.onDidChangeLocal(q=>this._onDidChangeLocal.fire(q))),this.activeProfileSynchronizers.set(T.id,k=[$,M])}return k[0]}getActiveProfileSynchronizers(){const T=[];for(const[O]of this.activeProfileSynchronizers.values())T.push(O);return T}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,T])=>T.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=pe([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,p.IInstantiationService),K(3,I.IConfigurationService),K(4,t.IUserDataSyncLogService),K(5,S.ITelemetryService),K(6,h.IStorageService),K(7,t.IUserDataSyncEnablementService),K(8,C.IUserDataProfilesService),K(9,v.IProductService)],o),e.UserDataSyncService=o;class u extends A.Disposable{get status(){return this.synchronisers.some(T=>T.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(T=>T.status==="syncing")?"syncing":"idle"}constructor(T,O,k,M,$,q,J,H){super(),this.id=T,this.manifest=O,this.profile=k,this.syncHeaders=M,this.synchronisers=$,this.onStop=q,this.configurationService=J,this.logService=H,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,r.createCancelablePromise)(T=>this.getPreviews(T))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(T){throw this.logService.error(T),T}}async accept(T,O){try{return await this.performAction(T,k=>k.accept(T,O))}catch(k){throw this.logService.error(k),k}}async merge(T){try{return T?await this.performAction(T,O=>O.merge(T)):await this.mergeAll()}catch(O){throw this.logService.error(O),O}}async discard(T){try{return await this.performAction(T,O=>O.discard(T))}catch(O){throw this.logService.error(O),O}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const T=[];for(const{resourcePreviews:O}of this.previews)for(const k of O)k.mergeState==="conflict"&&T.push(k.previewResource);for(const O of T)await this.discard(O);return this.previews}catch(T){throw this.logService.error(T),T}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const T=[];for(const{syncResource:O,resourcePreviews:k}of this.previews){this.synchronizingResources.push([O,k.map(q=>q.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const M=this.synchronisers.find(q=>q.resource===O);for(const q of k)(q.localChange!==0||q.remoteChange!==0)&&q.mergeState==="preview"&&await M.merge(q.previewResource);const $=await M.apply(!1,this.syncHeaders);$&&T.push(this.toUserDataSyncResourcePreview(M.resource,$)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(q=>q[0]===O),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=T,this.previews}catch(T){throw this.logService.error(T),T}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const{syncResource:T,resourcePreviews:O}of this.previews){this.synchronizingResources.push([T,O.map(M=>M.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const k=this.synchronisers.find(M=>M.resource===T);for(const M of O)await k.accept(M.remoteResource);await k.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(M=>M[0]===T),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(T){throw this.logService.error(T),T}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const{syncResource:T,resourcePreviews:O}of this.previews){this.synchronizingResources.push([T,O.map(M=>M.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const k=this.synchronisers.find(M=>M.resource===T);for(const M of O)await k.accept(M.localResource);await k.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(M=>M[0]===T),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(T){throw this.logService.error(T),T}}async stop(){await this.onStop(),this.reset()}async performAction(T,O){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const k=this.previews.findIndex(({resourcePreviews:z})=>z.some(({localResource:x,previewResource:Y,remoteResource:te})=>(0,P.isEqual)(T,x)||(0,P.isEqual)(T,Y)||(0,P.isEqual)(T,te)));if(k===-1)return this.previews;const M=this.previews[k],$=M.resourcePreviews.find(({localResource:z,remoteResource:x,previewResource:Y})=>(0,P.isEqual)(z,T)||(0,P.isEqual)(x,T)||(0,P.isEqual)(Y,T));if(!$)return this.previews;let q=this.synchronizingResources.find(z=>z[0]===M.syncResource);q||(q=[M.syncResource,[]],this.synchronizingResources.push(q)),q[1].some(z=>(0,P.isEqual)(z,$.localResource))||(q[1].push($.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const J=this.synchronisers.find(z=>z.resource===this.previews[k].syncResource),H=await O(J);H?this.previews.splice(k,1,this.toUserDataSyncResourcePreview(J.resource,H)):this.previews.splice(k,1);const G=this.synchronizingResources.findIndex(z=>z[0]===M.syncResource);return this.synchronizingResources[G][1].splice(q[1].findIndex(z=>(0,P.isEqual)(z,$.localResource)),1),q[1].length||(this.synchronizingResources.splice(G,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const T=[];for(const O of this.previews){this.synchronizingResources.push([O.syncResource,O.resourcePreviews.map($=>$.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const k=this.synchronisers.find($=>$.resource===O.syncResource);let M=O;for(const $ of O.resourcePreviews)($.localChange!==0||$.remoteChange!==0)&&$.mergeState==="preview"&&(M=await k.merge($.previewResource));M&&T.push(this.toUserDataSyncResourcePreview(k.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex($=>$[0]===O.syncResource),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=T,this.previews}async getPreviews(T){const O=[],k=await this.getUserDataSyncConfiguration();for(const M of this.synchronisers){if(T.isCancellationRequested)return[];const $=await M.preview(this.manifest,k,this.syncHeaders);$&&O.push(this.toUserDataSyncResourcePreview(M.resource,$))}return O}async getUserDataSyncConfiguration(){const T=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.synchronisers.find(k=>k instanceof f.SettingsSynchroniser);if(O){const k=await O.getRemoteUserDataSyncConfiguration(this.manifest);return{...T,...k}}return T}toUserDataSyncResourcePreview(T,O){return{profile:this.profile,syncResource:T,isLastSyncFromCurrentMachine:O.isLastSyncFromCurrentMachine,resourcePreviews:O.resourcePreviews.map(_)}}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let c=class extends A.Disposable{get enabled(){return this._enabled.sort((T,O)=>T[1]-O[1]).map(([T])=>T)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(T=>!this.userDataSyncEnablementService.isResourceEnabled(T))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(T,O,k,M,$,q,J,H,G,z){super(),this._profile=T,this.collection=O,this.userDataSyncEnablementService=k,this.instantiationService=M,this.extensionGalleryService=$,this.userDataSyncStoreManagementService=q,this.telemetryService=J,this.logService=H,this.productService=G,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(z.onDidChangeProfiles(()=>{(z.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!z.defaultProfile.extensionsResource&&this._profile.extensionsResource)&&(this.deRegisterSynchronizer("extensions"),this._profile=z.defaultProfile,this.registerSynchronizer("extensions"))})),this._register(k.onDidChangeResourceEnablement(([x,Y])=>this.onDidChangeResourceEnablement(x,Y))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,x])=>x.dispose())));for(const x of t.ALL_SYNC_RESOURCES)k.isResourceEnabled(x)&&this.registerSynchronizer(x)}onDidChangeResourceEnablement(T,O){O?this.registerSynchronizer(T):this.deRegisterSynchronizer(T)}registerSynchronizer(T){if(this._enabled.some(([$])=>$.resource===T))return;if(T==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(T==="profiles"){if(!this._profile.isDefault)return;if(!this.productService.enableSyncingProfiles){this.logService.debug("Skipping profiles sync");return}}const O=new A.DisposableStore,k=O.add(this.createSynchronizer(T));O.add(k.onDidChangeStatus(()=>this.updateStatus())),O.add(k.onDidChangeConflicts(()=>this.updateConflicts())),O.add(k.onDidChangeLocal(()=>this._onDidChangeLocal.fire(T)));const M=this.getOrder(T);this._enabled.push([k,M,O])}deRegisterSynchronizer(T){const O=this._enabled.findIndex(([k])=>k.resource===T);if(O!==-1){const k=this._enabled.splice(O,1);for(const[M,,$]of k){if(M.status!=="idle"){const q=M.conflicts.conflicts.length>0;M.stop(),q&&this.updateConflicts(),this.updateStatus()}$.dispose()}}}createSynchronizer(T){switch(T){case"settings":return this.instantiationService.createInstance(f.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(a.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(l.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(i.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(g.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(m.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(T,O,k){if(k.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const $=[],q=(0,t.createSyncHeaders)(O);for(const J of M){if(k.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(J.resource))return[];try{const H=(this.collection?T?.collections?.[this.collection]?.latest:T?.latest)??null;await J.sync(H,q)}catch(H){const G=t.UserDataSyncError.toUserDataSyncError(H);if(y(G,O,this.userDataSyncStoreManagementService,this.telemetryService),d(H))throw G;this.logService.error(H),this.logService.error(`${J.resource}: ${(0,D.toErrorMessage)(H)}`),$.push([J.resource,G])}}return $}finally{this.updateStatus()}}async stop(){for(const T of this.enabled)try{T.status!=="idle"&&await T.stop()}catch(O){this.logService.error(O)}}async resetLocal(){for(const T of this.enabled)try{await T.resetLocal()}catch(O){this.logService.error(`${T.resource}: ${(0,D.toErrorMessage)(O)}`),this.logService.error(O)}}setStatus(T){this._status!==T&&(this._status=T,this._onDidChangeStatus.fire(T))}updateStatus(){return this.updateConflicts(),this.enabled.some(T=>T.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(T=>T.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const T=this.enabled.filter(O=>O.status==="hasConflicts").map(O=>O.conflicts);(0,R.equals)(this._conflicts,T,(O,k)=>O.syncResource===k.syncResource&&(0,R.equals)(O.conflicts,k.conflicts,(M,$)=>(0,P.isEqual)(M.previewResource,$.previewResource)))||(this._conflicts=T,this._onDidChangeConflicts.fire(T))}getOrder(T){switch(T){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};c=pe([K(2,t.IUserDataSyncEnablementService),K(3,p.IInstantiationService),K(4,w.IExtensionGalleryService),K(5,t.IUserDataSyncStoreManagementService),K(6,S.ITelemetryService),K(7,t.IUserDataSyncLogService),K(8,v.IProductService),K(9,C.IUserDataProfilesService)],c);function d(F){if(F instanceof t.UserDataSyncError)switch(F.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(F,T,O,k){k.publicLog2("sync/error",{code:F.code,serverCode:F instanceof t.UserDataSyncStoreError?String(F.serverCode):void 0,url:F instanceof t.UserDataSyncStoreError?F.url:void 0,resource:F.resource,executionId:T,service:O.userDataSyncStore.url.toString()})}function _(F){return{baseResource:F.baseResource,localResource:F.localResource,previewResource:F.previewResource,remoteResource:F.remoteResource,acceptedResource:F.acceptedResource,localChange:F.localChange,remoteChange:F.remoteChange,mergeState:F.mergeState}}}),define(ne[266],re([0,1,3,2,7,20,26]),function(Q,e,R,r,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(w,p){return{...w,profie:(0,L.reviveProfile)(w.profile,p.profilesHome.scheme)}}class E{constructor(p,v,h){this.service=p,this.userDataProfilesService=v,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(p,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(p,v,h){try{return await this._call(p,v,h)}catch(S){throw this.logService.error(S),S}}async _call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(D.URI.revive(h[0]));case"accept":return this.service.accept(P(h[0],this.userDataProfilesService),D.URI.revive(h[1]),h[2],h[3]);case"replace":return this.service.replace(P(h[0],this.userDataProfilesService),D.URI.revive(h[1]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getAssociatedResources":return this.service.getAssociatedResources(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:D.URI.revive(h[1].uri)});case"getMachineId":return this.service.getMachineId(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:D.URI.revive(h[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const S=v.substring(11),C=h[0],m=this.getManualSyncTask(C);switch(h=h.slice(1),S){case"preview":return m.preview();case"accept":return m.accept(D.URI.revive(h[0]),h[1]);case"merge":return m.merge(D.URI.revive(h[0]));case"discard":return m.discard(D.URI.revive(h[0]));case"discardConflicts":return m.discardConflicts();case"apply":return m.apply();case"pull":return m.pull();case"push":return m.push();case"stop":return m.stop();case"_getStatus":return m.status;case"dispose":return this.disposeManualSyncTask(m)}}throw new Error("Invalid call")}getManualSyncTask(p){const v=this.manualSyncTasks.get(this.createKey(p));if(!v)throw new Error(`Manual sync taks not found: ${p}`);return v.manualSyncTask}async createManualSyncTask(){const p=new r.DisposableStore,v=p.add(await this.service.createManualSyncTask());return p.add(v.onSynchronizeResources(h=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:h}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:p}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(p){p.dispose();const v=this.createKey(p.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=E;let b=class extends r.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(p,v){super(),this.userDataProfilesService=v,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,S,C){return p.call(h,S,C).then(null,m=>{throw A.UserDataSyncError.toUserDataSyncError(m)})},listen(h,S){return p.listen(h,S)}},this.channel.call("_getInitialData").then(([h,S,C])=>{this.updateStatus(h),this.updateConflicts(S),C&&this.updateLastSyncTime(C),this._register(this.channel.listen("onDidChangeStatus")(m=>this.updateStatus(m))),this._register(this.channel.listen("onDidChangeLastSyncTime")(m=>this.updateLastSyncTime(m)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(S=>({...S,error:A.UserDataSyncError.toUserDataSyncError(S.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:p,manifest:v,status:h}=await this.channel.call("createManualSyncTask"),S=this,C=new I(p,v,h,{async call(m,g,a){return S.channel.call(`manualSync/${m}`,[p,...Array.isArray(g)?g:[g]],a)},listen(m,g){return R.Event.map(R.Event.filter(S.channel.listen(`manualSync/${m}`,g),a=>!C.isDiposed()&&a.manualSyncTaskId===p),a=>a.data)}},this.userDataProfilesService);return C}replace(p,v){return this.channel.call("replace",[p,v])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(p,v,h,S){return this.channel.call("accept",[p,v,h,S])}resolveContent(p){return this.channel.call("resolveContent",[p])}async getLocalSyncResourceHandles(p){return(await this.channel.call("getLocalSyncResourceHandles",[p])).map(({created:h,uri:S})=>({created:h,uri:D.URI.revive(S)}))}async getRemoteSyncResourceHandles(p){return(await this.channel.call("getRemoteSyncResourceHandles",[p])).map(({created:h,uri:S})=>({created:h,uri:D.URI.revive(S)}))}async getAssociatedResources(p,v){return(await this.channel.call("getAssociatedResources",[p,v])).map(({resource:S,comparableResource:C})=>({resource:D.URI.revive(S),comparableResource:D.URI.revive(C)}))}async getMachineId(p,v){return this.channel.call("getMachineId",[p,v])}async updateStatus(p){this._status=p,this._onDidChangeStatus.fire(p)}async updateConflicts(p){this._conflicts=p.map(v=>({syncResource:v.syncResource,profile:(0,L.reviveProfile)(v.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:v.conflicts.map(h=>({...h,baseResource:D.URI.revive(h.baseResource),localResource:D.URI.revive(h.localResource),remoteResource:D.URI.revive(h.remoteResource),previewResource:D.URI.revive(h.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(p){this._lastSyncTime!==p&&(this._lastSyncTime=p,this._onDidChangeLastSyncTime.fire(p))}};b=pe([K(1,L.IUserDataProfilesService)],b),e.UserDataSyncChannelClient=b;class I extends r.Disposable{get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}constructor(p,v,h,S,C){super(),this.id=p,this.manifest=v,this.userDataProfilesService=C,this._disposed=!1,this._status=h;const m=this;this.channel={async call(g,a,f){try{const l=await S.call(g,a,f);return m.isDiposed()||(m._status=await S.call("_getStatus")),l}catch(l){throw A.UserDataSyncError.toUserDataSyncError(l)}},listen(g,a){return S.listen(g,a)}}}async preview(){const p=await this.channel.call("preview");return this.deserializePreviews(p)}async accept(p,v){const h=await this.channel.call("accept",[p,v]);return this.deserializePreviews(h)}async merge(p){const v=await this.channel.call("merge",[p]);return this.deserializePreviews(v)}async discard(p){const v=await this.channel.call("discard",[p]);return this.deserializePreviews(v)}async discardConflicts(){const p=await this.channel.call("discardConflicts");return this.deserializePreviews(p)}async apply(){const p=await this.channel.call("apply");return this.deserializePreviews(p)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(p){return p.map(({profile:v,syncResource:h,resourcePreviews:S,isLastSyncFromCurrentMachine:C})=>({profile:(0,L.reviveProfile)(v,this.userDataProfilesService.profilesHome.scheme),syncResource:h,isLastSyncFromCurrentMachine:C,resourcePreviews:S.map(m=>({...m,baseResource:D.URI.revive(m.baseResource),localResource:D.URI.revive(m.localResource),remoteResource:D.URI.revive(m.remoteResource),previewResource:D.URI.revive(m.previewResource),acceptedResource:D.URI.revive(m.acceptedResource)}))}))}}}),define(ne[267],re([0,1,6,24,9,3,2,127,4,17,15,7,30,18,14,13,25,45,48,21,26]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",i="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",n=100,o=1e3*60*5;let u=class extends A.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(T){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,T,-1,E.isWeb?0:1)}constructor(T,O,k){super(),this.productService=T,this.configurationService=O,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(k.onDidChangeValue,M=>M.key===f.SYNC_SERVICE_URL_TYPE&&M.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(T,O){T=E.isWeb&&T?.web?{...T,...T.web}:T;const k={...T||{},...O||{}};if(k&&(0,I.isString)(k.url)&&(0,I.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(M=>Array.isArray(k.authenticationProviders[M].scopes))){const M=k,$=!!M.canSwitch&&!O?.url,q=M.url===M.insidersUrl?"insiders":"stable",J=($?this.userDataSyncStoreType:void 0)||q,H=O?.url||(J==="insiders"?M.insidersUrl:J==="stable"?M.stableUrl:M.url);return{url:w.URI.parse(H),type:J,defaultType:q,defaultUrl:w.URI.parse(M.url),stableUrl:w.URI.parse(M.stableUrl),insidersUrl:w.URI.parse(M.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(M.authenticationProviders).reduce((G,z)=>(G.push({id:z,scopes:M.authenticationProviders[z].scopes}),G),[])}}}};u=pe([K(0,C.IProductService),K(1,v.IConfigurationService),K(2,a.IStorageService)],u),e.AbstractUserDataSyncStoreManagementService=u;let c=class extends u{constructor(T,O,k){super(T,O,k);const M=this.storageService.get(l,-1);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const $=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),-1,1):this.storageService.remove(l,-1)}async switch(T){T!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=T,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=pe([K(0,C.IProductService),K(1,v.IConfigurationService),K(2,a.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let d=class extends A.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(T,O,k,M,$,q,J){super(),this.requestService=k,this.logService=M,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(T),this.commonHeadersPromise=(0,g.getServiceMachineId)($,q,J).then(H=>{const G={"X-Client-Name":`${O.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":O.version};return O.commit&&(G["X-Client-Commit"]=O.commit),G}),this.session=new _(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(T,O){this.authToken={token:T,type:O}}updateUserDataSyncStoreUrl(T){this.userDataSyncStoreUrl=T?(0,b.joinPath)(T,"v1"):void 0}initDonotMakeRequestsUntil(){const T=this.storageService.getNumber(i,-1);T&&Date.now()<T&&this.setDonotMakeRequestsUntil(new Date(T))}setDonotMakeRequestsUntil(T){this._donotMakeRequestsUntil?.getTime()!==T?.getTime()&&(this._donotMakeRequestsUntil=T,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(O=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),O).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,O=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();T={...T},T["Content-Type"]="application/json";const k=await this.request(O,{type:"GET",headers:T},[],r.CancellationToken.None);return await(0,m.asJson)(k)||[]}async createCollection(T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();T={...T},T["Content-Type"]=P.Mimes.text;const k=await this.request(O,{type:"POST",headers:T},[],r.CancellationToken.None),M=await(0,m.asTextOrError)(k);if(!M)throw new f.UserDataSyncStoreError("Server did not return the collection id",O,"NoCollection",k.res.statusCode,k.res.headers[f.HEADER_OPERATION_ID]);return M}async deleteCollection(T,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=T?(0,b.joinPath)(this.userDataSyncStoreUrl,"collection",T).toString():(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},await this.request(k,{type:"DELETE",headers:O},[],r.CancellationToken.None)}async getAllResourceRefs(T,O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=this.getResourceUrl(this.userDataSyncStoreUrl,O,T),M={},$=await this.request(k.toString(),{type:"GET",headers:M},[],r.CancellationToken.None);return(await(0,m.asJson)($)||[]).map(({url:J,created:H})=>({ref:(0,b.relativePath)(k,k.with({path:J})),created:H*1e3}))}async resolveResourceContent(T,O,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,T),O).toString();M={...M},M["Cache-Control"]="no-cache";const q=await this.request($,{type:"GET",headers:M},[],r.CancellationToken.None);return await(0,m.asTextOrError)(q)}async deleteResource(T,O,k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=O!==null?(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,T),O).toString():this.getResourceUrl(this.userDataSyncStoreUrl,k,T).toString(),$={};await this.request(M,{type:"DELETE",headers:$},[],r.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),O={"Content-Type":P.Mimes.text};await this.request(T,{type:"DELETE",headers:O},[],r.CancellationToken.None)}async readResource(T,O,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,T),"latest").toString();M={...M},M["Cache-Control"]="no-cache",O&&(M["If-None-Match"]=O.ref);const q=await this.request($,{type:"GET",headers:M},[304],r.CancellationToken.None);let J=null;if(q.res.statusCode===304&&(J=O),J===null){const H=q.res.headers.etag;if(!H)throw new f.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);const G=await(0,m.asTextOrError)(q);if(!G&&q.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",$,"EmptyResponse",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);J={ref:H,content:G}}return J}async writeResource(T,O,k,M,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=this.getResourceUrl(this.userDataSyncStoreUrl,M,T).toString();$={...$},$["Content-Type"]=P.Mimes.text,k&&($["If-Match"]=k);const J=await this.request(q,{type:"POST",data:O,headers:$},[],r.CancellationToken.None),H=J.res.headers.etag;if(!H)throw new f.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",J.res.statusCode,J.res.headers[f.HEADER_OPERATION_ID]);return H}async manifest(T,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json",T&&(O["If-None-Match"]=T.ref);const M=await this.request(k,{type:"GET",headers:O},[304],r.CancellationToken.None);let $=null;if(M.res.statusCode===304&&($=T),!$){const J=M.res.headers.etag;if(!J)throw new f.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);const H=await(0,m.asTextOrError)(M);if(!H&&M.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",k,"EmptyResponse",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);H&&($={...JSON.parse(H),ref:J})}const q=this.storageService.get(s,-1);return q&&$&&q!==$.session&&this.clearSession(),$===null&&q&&this.clearSession(),$&&this.storageService.store(s,$.session,-1,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(T,O,k){return O?(0,b.joinPath)(T,"collection",O,"resource",k):(0,b.joinPath)(T,"resource",k)}clearSession(){this.storageService.remove(s,-1),this.storageService.remove(t,-1)}async request(T,O,k,M){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${O.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;O.headers={...O.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(O.headers),this.logService.trace("Sending request to server",{url:T,type:O.type,headers:{...O.headers,authorization:void 0}});let q;try{q=await this.session.request(T,O,M)}catch(z){if(!(z instanceof f.UserDataSyncStoreError)){let x="RequestFailed";const Y=(0,D.getErrorMessage)(z).toLowerCase();Y.includes("xhr timeout")?x="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?x="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":Y.includes("headers must be an object")?x="RequestHeadersNotObject":(0,D.isCancellationError)(z)&&(x="RequestCanceled"),z=new f.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,x,void 0,void 0)}throw this.logService.info("Request failed",T),z}const J=q.res.headers[f.HEADER_OPERATION_ID],H={url:T,status:q.res.statusCode,"execution-id":O.headers[f.HEADER_EXECUTION_ID],"operation-id":J},G=(0,m.isSuccess)(q)||q.res.statusCode&&k.indexOf(q.res.statusCode)!==-1;if(G?this.logService.trace("Request succeeded",H):this.logService.info("Request failed",H),q.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",q.res.statusCode,J);if(this._onTokenSucceed.fire(),q.res.statusCode===409)throw new f.UserDataSyncStoreError(`${O.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",q.res.statusCode,J);if(q.res.statusCode===410)throw new f.UserDataSyncStoreError(`${O.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",q.res.statusCode,J);if(q.res.statusCode===412)throw new f.UserDataSyncStoreError(`${O.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",q.res.statusCode,J);if(q.res.statusCode===413)throw new f.UserDataSyncStoreError(`${O.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",q.res.statusCode,J);if(q.res.statusCode===426)throw new f.UserDataSyncStoreError(`${O.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",q.res.statusCode,J);if(q.res.statusCode===429){const z=q.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new f.UserDataSyncStoreError(`${O.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",q.res.statusCode,J)):new f.UserDataSyncStoreError(`${O.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",q.res.statusCode,J)}if(!G)throw new f.UserDataSyncStoreError("Server returned "+q.res.statusCode,T,"Unknown",q.res.statusCode,J);return q}addSessionHeaders(T){let O=this.storageService.get(t,-1);O===void 0&&(O=(0,p.generateUuid)(),this.storageService.store(t,O,-1,1)),T["X-Machine-Session-Id"]=O;const k=this.storageService.get(s,-1);k!==void 0&&(T["X-User-Session-Id"]=k)}};d=pe([K(1,C.IProductService),K(2,m.IRequestService),K(3,f.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,S.IFileService),K(6,a.IStorageService)],d),e.UserDataSyncStoreClient=d;let y=class extends d{constructor(T,O,k,M,$,q,J){super(T.userDataSyncStore?.url,O,k,M,$,q,J),this._register(T.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(T.userDataSyncStore?.url)))}};y=pe([K(0,f.IUserDataSyncStoreManagementService),K(1,C.IProductService),K(2,m.IRequestService),K(3,f.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,S.IFileService),K(6,a.IStorageService)],y),e.UserDataSyncStoreService=y;class _{constructor(T,O,k,M){this.limit=T,this.interval=O,this.requestService=k,this.logService=M,this.requests=[],this.startTime=void 0}request(T,O,k){if(this.isExpired()&&this.reset(),O.url=T,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(T),this.requestService.request(O,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=_}),define(ne[268],re([0,1,3,59,25,21,23,263,26,73,76]),function(Q,e,R,r,D,L,A,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(v,h,S,C,m,g,a,f,l,i,s){super(v,h,S,C,m,a,f,l,i,s),this._register(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=pe([K(0,D.IProductService),K(1,E.IUserDataSyncStoreManagementService),K(2,E.IUserDataSyncStoreService),K(3,E.IUserDataSyncEnablementService),K(4,E.IUserDataSyncService),K(5,r.INativeHostService),K(6,E.IUserDataSyncLogService),K(7,b.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,I.IUserDataSyncMachinesService),K(10,L.IStorageService)],w),e.UserDataAutoSyncService=w}),define(ne[269],re([0,1,3,2,58,8,77,21,71,20]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let I=class extends A.AbstractUserDataSyncProfilesStorageService{constructor(p,v,h,S){super(h),this.mainProcessService=p;const C=p.getChannel("profileStorageListener"),m=this._register(new r.MutableDisposable);this._onDidChange=this._register(new R.Emitter({onFirstListenerAdd:()=>{m.value=C.listen("onDidChange")(g=>{S.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(a=>(0,b.reviveProfile)(a,v.profilesHome.scheme)),valueChanges:g.valueChanges.map(a=>({...a,profile:(0,b.reviveProfile)(a.profile,v.profilesHome.scheme)}))})})},onLastListenerRemove:()=>m.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(p){const v=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new E.ApplicationStorageDatabaseClient(v):new E.ProfileStorageDatabaseClient(v,p)}};I=pe([K(0,D.IMainProcessService),K(1,b.IUserDataProfilesService),K(2,P.IStorageService),K(3,L.ILogService)],I),e.UserDataSyncProfilesStorageService=I}),define(ne[270],re([0,1,95,22,4,17]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(b){function I(){let w=b.scheme===r.Schemas.file?(0,L.originalFSPath)(b):b.toString();return D.isLinux||(w=w.toLowerCase()),(0,R.createHash)("md5").update(w).digest("hex")}return{id:I(),configPath:b}}e.getWorkspaceIdentifier=A;function P(b,I){function w(){if(b.scheme!==r.Schemas.file)return(0,R.createHash)("md5").update(b.toString()).digest("hex");if(!I)return;let v;return D.isLinux?v=I.ino:D.isMacintosh?v=I.birthtime.getTime():D.isWindows&&(typeof I.birthtimeMs=="number"?v=Math.floor(I.birthtimeMs):v=I.birthtime.getTime()),(0,R.createHash)("md5").update(b.fsPath).update(v?String(v):"").digest("hex")}const p=w();if(typeof p=="string")return{id:p,uri:b}}e.getSingleFolderWorkspaceIdentifier=P;function E(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=E}),define(ne[271],re([0,1,6,9,2,12,28,14,58,8,59,71,111,270]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(C,m,g,a){super(),this.environmentService=C,this.logService=m,this.nativeHostService=g,this.mainProcessService=a,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const C=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),m=new w.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(C.map(async g=>{const a=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,g);g.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||g===p.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===g)||await m.isUsed(a)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await A.Promises.rm(a))}))}catch(C){(0,r.onUnexpectedError)(C)}}};h=pe([K(0,P.INativeEnvironmentService),K(1,b.ILogService),K(2,I.INativeHostService),K(3,E.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(ne[112],re([0,1,53,6,12,15,28,139,280,281]),function(Q,e,R,r,D,L,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(i,s){let t=s.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=s}}e.ExtractError=I;function w(l){const i=l.externalFileAttributes>>16||33188;return[448,56,7].map(s=>i&s).reduce((s,t)=>s+t,i&61440)}function p(l){if(l instanceof I)return l;let i;return/end of central directory record signature not found/.test(l.message)&&(i="CorruptZip"),new I(i,l)}function v(l,i,s,t,n,o){const u=D.dirname(i),c=D.join(t,u);if(!c.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const d=D.join(t,i);let y;return o.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(A.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((_,F)=>{if(!o.isCancellationRequested)try{y=(0,R.createWriteStream)(d,{mode:s}),y.once("close",()=>_()),y.once("error",F),l.once("error",F),l.pipe(y)}catch(T){F(T)}}))}function h(l,i,s,t){let n=(0,r.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{n.cancel(),l.close()}),new Promise((u,c)=>{const d=new r.Sequencer,y=_=>{_.isCancellationRequested||(o++,l.readEntry())};l.once("error",c),l.once("close",()=>n.then(()=>{t.isCancellationRequested||l.entryCount===o?u():c(new I("Incomplete",new Error(P.localize(1,null,o,l.entryCount))))},c)),l.readEntry(),l.on("entry",_=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(_.fileName)){y(t);return}const F=_.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const k=D.join(i,F);n=(0,r.createCancelablePromise)(M=>A.Promises.mkdir(k,{recursive:!0}).then(()=>y(M)).then(void 0,c));return}const T=C(l,_),O=w(_);n=(0,r.createCancelablePromise)(k=>d.queue(()=>T.then(M=>v(M,F,O,i,s,k).then(()=>y(k)))).then(null,c))})})}function S(l,i=!1){return new Promise((s,t)=>{(0,E.open)(l,i?{lazyEntries:!0}:void 0,(n,o)=>{n?t(p(n)):s((0,L.assertIsDefined)(o))})})}function C(l,i){return new Promise((s,t)=>{l.openReadStream(i,(n,o)=>{n?t(p(n)):s((0,L.assertIsDefined)(o))})})}function m(l,i){return new Promise((s,t)=>{const n=new b.ZipFile;i.forEach(u=>{u.contents?n.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&n.addFile(u.localPath,u.path)}),n.end();const o=(0,R.createWriteStream)(l);n.outputStream.pipe(o),n.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>s(l))})}e.zip=m;function g(l,i,s={},t){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=S(l,!0);return s.overwrite&&(o=o.then(u=>A.Promises.rm(i).then(()=>u))),o.then(u=>h(u,i,{sourcePathRegex:n},t))}e.extract=g;function a(l,i){return S(l).then(s=>new Promise((t,n)=>{s.on("entry",o=>{o.fileName===i&&C(s,o).then(u=>t(u),u=>n(u))}),s.once("close",()=>n(new Error(P.localize(2,null,i))))}))}function f(l,i){return a(l,i).then(s=>new Promise((t,n)=>{const o=[];s.once("error",n),s.on("data",u=>o.push(u)),s.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(ne[272],re([0,1,112,149]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(L){return(0,R.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,r.localize)(0,null))}})}e.getManifest=D}),define(ne[113],re([0,1,6,38,9,2,22,12,4,17,55,15,7,30,28,112,148,93,14,247,29,33,49,74,203,248,272,204,234,44,68,13,5,8,25,23,31,20]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l,i,s,t,n,o,u,c,d,y,_,F,T,O,k,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(f.IExtensionManagementService);let q=class extends a.AbstractExtensionManagementService{constructor(W,V,U,N,j,B,Z,oe,X,ie,se,ue){super(W,V,U,ie,ue),this.extensionsScannerService=j,this.extensionsProfileScannerService=B,this.downloadService=Z,this.fileService=X,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>he.postUninstall(we))),this.manifestCache=this._register(new u.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new c.ExtensionsWatcher(this,X,N,U,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const V=await this.collectFiles(W),U=await(0,S.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,V);return p.URI.file(U)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:V,cleanup:U}=await this.downloadVsix(W),N=P.resolve(V.fsPath);try{return await(0,o.getManifest)(N)}finally{await U()}}getInstalled(W,V){return this.extensionsScanner.scanExtensions(W??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(W,V={}){this.logService.trace("ExtensionManagementService#install",W.toString());const{location:U,cleanup:N}=await this.downloadVsix(W);try{const j=await(0,o.getManifest)(P.resolve(U.fsPath));if(j.engines&&j.engines.vscode&&!(0,y.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(C.localize(0,null,(0,l.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return await this.installExtension(j,U,V)}finally{await N()}}getMetadata(W){return this.extensionsScannerService.scanMetadata(W.location)}async updateMetadata(W,V){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const U={...V};return V.isPreReleaseVersion&&(U.preRelease=!0),W=await this.extensionsScanner.updateMetadata(W,U),this.manifestCache.invalidate(),W}async updateExtensionScope(W,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.updateMetadata(W,{isMachineScoped:V}),this.manifestCache.invalidate(),W}removeUninstalledExtensions(W){return this.extensionsScanner.cleanUp(W)}async downloadVsix(W){if(W.scheme===A.Schemas.file)return{location:W,async cleanup(){}};this.logService.trace("Downloading extension from",W.toString());const V=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(W,V),this.logService.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.fileService.del(V)}catch(N){this.logService.error(N)}}}}doCreateInstallExtensionTask(W,V,U){let N;if(p.URI.isUri(V))N=new z(W,V,U,this.galleryService,this.extensionsScanner,this.logService);else{const j=l.ExtensionKey.create(V).toString();N=this.installGalleryExtensionsTasks.get(j),N||(this.installGalleryExtensionsTasks.set(j,N=new G(W,V,U,this.extensionsDownloader,this.extensionsScanner,this.logService)),N.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(j)))}return U.profileLocation?new x(N,U.profileLocation,this.extensionsProfileScannerService):N}doCreateUninstallExtensionTask(W,V){return V.profileLocation?new te(W,V.profileLocation,this.extensionsProfileScannerService):new Y(W,V,this.extensionsScanner)}async collectFiles(W){const V=async N=>{let j=await h.Promises.readdir(N);j=j.map(oe=>P.join(N,oe));const B=await Promise.all(j.map(oe=>h.Promises.stat(oe)));let Z=Promise.resolve([]);return B.forEach((oe,X)=>{const ie=j[X];oe.isFile()&&(Z=Z.then(se=>[...se,ie])),oe.isDirectory()&&(Z=Z.then(se=>V(ie).then(ue=>[...se,...ue])))}),Z};return(await V(W.location.fsPath)).map(N=>({path:`extension/${P.relative(W.location.fsPath,N)}`,localPath:N}))}};q=pe([K(0,f.IExtensionGalleryService),K(1,k.ITelemetryService),K(2,T.ILogService),K(3,g.INativeEnvironmentService),K(4,s.IExtensionsScannerService),K(5,i.IExtensionsProfileScannerService),K(6,m.IDownloadService),K(7,F.IInstantiationService),K(8,_.IFileService),K(9,O.IProductService),K(10,M.IUriIdentityService),K(11,$.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let J=class extends L.Disposable{constructor(W,V,U,N){super(),this.beforeRemovingExtension=W,this.fileService=V,this.extensionsScannerService=U,this.logService=N,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(W){await this.removeUninstalledExtensions(),W&&await this.removeOutdatedExtensions()}async scanExtensions(W,V){const U={includeInvalid:!0,profileLocation:V};let N=[];return W===null||W===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},U,!1)):W===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(U)),N=W!==null?N.filter(j=>j.type===W):N,Promise.all(N.map(j=>this.toLocalExtension(j)))}async scanUserExtensions(W){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return Promise.all(V.map(U=>this.toLocalExtension(U)))}async extractUserExtension(W,V,U,N){const j=W.toString(),B=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),Z=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,j);try{await h.Promises.rm(Z)}catch{throw new f.ExtensionManagementError(C.localize(1,null,Z,W.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(W,V,B,N),U={...U,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(p.URI.file(B),U);try{await this.rename(W,B,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await h.Promises.rm(B)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(oe)}. Deleted from extracted location`,B),oe}return this.scanLocalExtension(p.URI.file(Z),1)}async updateMetadata(W,V){return await this.extensionsScannerService.updateMetadata(W.location,V),this.scanLocalExtension(W.location,W.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...W){const V=W.map(U=>l.ExtensionKey.create(U));await this.withUninstalledExtensions(U=>{V.forEach(N=>U[N.toString()]=!0)})}async setInstalled(W){await this.withUninstalledExtensions(N=>delete N[W.toString()]);const U=(await this.scanUserExtensions(!0)).find(N=>l.ExtensionKey.create(N).equals(W))||null;return U?this.updateMetadata(U,{installedTimestamp:Date.now()}):null}async removeExtension(W,V){this.logService.trace(`Deleting ${V} extension from disk`,W.identifier.id,W.location.fsPath),await h.Promises.rm(W.location.fsPath),this.logService.info("Deleted from disk",W.identifier.id,W.location.fsPath)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[l.ExtensionKey.create(W).toString()])}async withUninstalledExtensions(W){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(N){if(N.code!=="ENOENT")throw N}let U={};if(V)try{U=JSON.parse(V)}catch{}return W&&(W(U),Object.keys(U).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await h.Promises.rm(this.uninstalledPath)),U})}async extractAtLocation(W,V,U,N){this.logService.trace(`Started extracting the extension from ${V} to ${U}`);try{await h.Promises.rm(U)}catch(j){throw new f.ExtensionManagementError(this.joinErrors(j).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(V,U,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${U}:`,W.id)}catch(j){try{await h.Promises.rm(U)}catch{}let B=f.ExtensionManagementErrorCode.Extract;throw j instanceof S.ExtractError&&(j.type==="CorruptZip"?B=f.ExtensionManagementErrorCode.CorruptZip:j.type==="Incomplete"&&(B=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(j.message,B)}}async rename(W,V,U,N){try{await h.Promises.rename(V,U)}catch(j){if(E.isWindows&&j&&j.code==="EPERM"&&Date.now()<N)return this.logService.info(`Failed renaming ${V} to ${U} with 'EPERM' error. Trying again...`,W.id),this.rename(W,V,U,N);throw new f.ExtensionManagementError(j.message||C.localize(2,null,V,U),j.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(W,V){const U=await this.extensionsScannerService.scanExistingExtension(W,V,{includeInvalid:!0});if(U)return this.toLocalExtension(U);throw new Error(C.localize(3,null,W.path))}async toLocalExtension(W){const V=await this.fileService.resolve(W.location);let U,N;return V.children&&(U=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,N=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:U,changelogUrl:N,publisherDisplayName:W.metadata?.publisherDisplayName||null,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated}}async removeUninstalledExtensions(){const W=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const B of V)W[l.ExtensionKey.create(B).toString()]||U.add(B.identifier.id.toLowerCase());const N=(0,l.groupByExtension)(V,B=>B.identifier);await R.Promises.settled(N.map(async B=>{const Z=B.sort((oe,X)=>I.rcompare(oe.manifest.version,X.manifest.version))[0];U.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const j=V.filter(B=>W[l.ExtensionKey.create(B).toString()]);await R.Promises.settled(j.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const W=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=[],N=await this.extensionsScannerService.getTargetPlatform(),j=(0,l.groupByExtension)(V,B=>B.identifier);for(const B of j)if(B.length>1&&U.push(...B.sort((Z,oe)=>{const X=I.rcompare(Z.manifest.version,oe.manifest.version);return X!==0?X:Z.targetPlatform===N?-1:1}).slice(1)),B[0].type===0){const Z=W.find(oe=>(0,l.areSameExtensions)(oe.identifier,B[0].identifier));(!Z||I.gte(Z.manifest.version,B[0].manifest.version))&&U.push(B[0])}await R.Promises.settled(U.map(B=>this.removeExtension(B,"outdated")))}joinErrors(W){const V=Array.isArray(W)?W:[W];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((U,N)=>new Error(`${U.message}${U.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}};J=pe([K(1,_.IFileService),K(2,s.IExtensionsScannerService),K(3,T.ILogService)],J);class H extends a.AbstractExtensionTask{get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(W,V,U,N,j){super(),this.identifier=W,this.source=V,this.options=U,this.extensionsScanner=N,this.logService=j,this._operation=2}async installExtension(W,V){try{const U=await this.unsetUninstalledAndGetLocal(W.key);if(U)return W.metadata?this.extensionsScanner.updateMetadata(U,W.metadata):U}catch{throw E.isMacintosh?new f.ExtensionManagementError(C.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(C.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(W,V)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const U=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),U}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.toString()]}async extract({zipPath:W,key:V,metadata:U},N){const j=await this.extensionsScanner.extractUserExtension(V,W,U,N);return this.logService.info("Extracting completed.",V.id),j}}class G extends H{constructor(W,V,U,N,j,B){super(V.identifier,V,U,j,B),this.manifest=W,this.gallery=V,this.extensionsDownloader=N}async doRun(W){const U=(await this.extensionsScanner.scanExtensions(null,void 0)).find(B=>(0,l.areSameExtensions)(B.identifier,this.gallery.identifier));U&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,d.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||U?.isMachineScoped,isBuiltin:this.options.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(U,N),metadata:N};const j=await this.downloadExtension(this.gallery,this._operation);try{const B=await this.installExtension({zipPath:j,key:l.ExtensionKey.create(this.gallery),metadata:N},W);return U&&!this.options.profileLocation&&(U.targetPlatform!==B.targetPlatform||I.neq(U.manifest.version,B.manifest.version))&&await this.extensionsScanner.setUninstalled(U),{local:B,metadata:N}}catch(B){throw await this.deleteDownloadedVSIX(j),B}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(p.URI.file(W))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,D.getErrorMessage)(V))}}async downloadExtension(W,V){let U;try{this.logService.trace("Started downloading extension:",W.identifier.id),U=(await this.extensionsDownloader.downloadExtension(W,V)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,U)}catch(N){throw new f.ExtensionManagementError((0,a.joinErrors)(N).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(U),U}catch(N){throw await this.deleteDownloadedVSIX(U),new f.ExtensionManagementError((0,a.joinErrors)(N).message,f.ExtensionManagementErrorCode.Invalid)}}}class z extends H{constructor(W,V,U,N,j,B){super({id:(0,l.getGalleryExtensionId)(W.publisher,W.name)},V,U,j,B),this.manifest=W,this.location=V,this.galleryService=N}async doRun(W){const V=new l.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,l.areSameExtensions)(this.identifier,Z.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(j.isApplicationScoped=(0,d.isApplicationScopedExtension)(this.manifest),j.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=3,V.equals(new l.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(C.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const Z=await this.unsetUninstalledAndGetLocal(V);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(C.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:V,metadata:j},W),metadata:j}}async getMetadata(W,V,U){try{let[N]=await this.galleryService.getExtensions([{id:W,version:V}],U);if(N||([N]=await this.galleryService.getExtensions([{id:W}],U)),N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class x{constructor(W,V,U){this.task=W,this.profileLocation=V,this.extensionsProfileScannerService=U,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const W=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[W.local,W.metadata]],this.profileLocation),W}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends a.AbstractExtensionTask{constructor(W,V,U){super(),this.extension=W,this.options=V,this.extensionsScanner=U}async doRun(W){const V=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=l.ExtensionKey.create(this.extension);V.push(...U.filter(j=>N.equals(l.ExtensionKey.create(j))))}else V.push(...U.filter(N=>(0,l.areSameExtensions)(N.identifier,this.extension.identifier)));if(!V.length)throw new Error(C.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const N of V)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(j){throw new Error(C.localize(9,null,(0,r.toErrorMessage)(j)))}}}class te extends a.AbstractExtensionTask{constructor(W,V,U){super(),this.extension=W,this.profileLocation=V,this.extensionsProfileScannerService=U}async doRun(W){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[273],re([0,1,2,29,33,49,75,202,113,44,5,8,21,31,20]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let C=class extends R.Disposable{constructor(a,f,l,i,s,t,n,o){super(),this.userDataProfilesService=f,a.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(a,l,i,s,o),A.ExtensionStorageService.removeOutdatedExtensionVersions(a,n),this._register(t.createInstance(m))}};C=pe([K(0,E.INativeServerExtensionManagementService),K(1,h.IUserDataProfilesService),K(2,r.IExtensionGalleryService),K(3,A.IExtensionStorageService),K(4,r.IGlobalExtensionEnablementService),K(5,I.IInstantiationService),K(6,p.IStorageService),K(7,w.ILogService)],C),e.ExtensionsCleaner=C;let m=class extends R.Disposable{constructor(a,f,l,i,s){super(),this.extensionManagementService=a,this.userDataProfilesService=f,this.extensionsProfileScannerService=l,this.uriIdentityService=i,this.logService=s,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new R.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:a,removed:f,all:l}){try{await Promise.all(f.map(i=>i.extensionsResource?this.removeExtensionsFromProfile(i.extensionsResource):Promise.resolve()))}catch(i){this.logService.error(i)}if(l.length===1){this.profileModeDisposables.clear();const i=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{i.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{a.length&&(await Promise.all(a.map(i=>i.extensionsResource?this.populateExtensionsFromProfile(i.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new R.DisposableStore,this.profileModeDisposables.value.add((0,R.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(i=>this.onDidChangeProfiles(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(i=>this.onDidUninstallExtension(i))),await this.uninstallExtensionsNotInProfiles()))}catch(i){this.logService.error(i)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(l=>!this.profileExtensionsLocations.has(this.getKey(l.identifier,l.manifest.version)));f.length&&await Promise.all(f.map(l=>this.extensionManagementService.uninstall(l,S)))}async onDidInstallExtensions(a){for(const{local:f,profileLocation:l}of a)!f||!l||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),l)}async onDidUninstallExtension(a){!a.profileLocation||!a.version||this.removeExtensionWithKey(this.getKey(a.identifier,a.version),a.profileLocation)&&await this.uninstallExtensions([{identifier:a.identifier,version:a.version}])}async populateExtensionsFromProfile(a){const f=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const l of f)this.addExtensionWithKey(this.getKey(l.identifier,l.version),a)}async removeExtensionsFromProfile(a){const f=[];for(const l of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(l,a))continue;const i=this.fromKey(l);i&&f.push(i)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(a,f){let l=this.profileExtensionsLocations.get(a);l||(l=[],this.profileExtensionsLocations.set(a,l)),l.push(f)}removeExtensionWithKey(a,f){const l=this.profileExtensionsLocations.get(a);if(l){const i=l.findIndex(s=>this.uriIdentityService.extUri.isEqual(s,f));i>-1&&l.splice(i,1)}return l?.length?!1:(this.profileExtensionsLocations.delete(a),!0)}async uninstallExtensions(a){const l=(await this.extensionManagementService.getAllUserInstalled()).filter(i=>a.some(s=>this.getKey(i.identifier,i.manifest.version)===this.getKey(s.identifier,s.version)));l.length&&await Promise.all(l.map(i=>this.extensionManagementService.uninstall(i,S)))}getKey(a,f){return`${b.ExtensionIdentifier.toKey(a.id)}@${f}`}fromKey(a){const[f,l]=(0,D.getIdAndVersion)(a);return l?{identifier:{id:f},version:l}:void 0}};m=pe([K(0,E.INativeServerExtensionManagementService),K(1,h.IUserDataProfilesService),K(2,L.IExtensionsProfileScannerService),K(3,v.IUriIdentityService),K(4,w.ILogService)],m)}),define(ne[282],re([0,1,89,37,38,9,2,22,17,7,39,137,195,273,196,188,189,271,177,180,18,200,92,219,93,210,14,216,250,251,29,179,252,113,94,175,13,191,193,56,5,186,97,187,58,69,205,8,98,59,99,25,45,21,253,104,23,105,106,107,50,223,108,225,231,75,110,26,73,261,243,244,76,262,265,266,267,268,269,77,245,103,218,72,233,207,232,102,215,31,235,4,236,181,198,197,74,249,20,49,194,60,254,213,222,246]),function(Q,e,R,r,D,L,A,P,E,b,I,w,p,v,h,S,C,m,g,a,f,l,i,s,t,n,o,u,c,d,y,_,F,T,O,k,M,$,q,J,H,G,z,x,Y,te,ce,W,V,U,N,j,B,Z,oe,X,ie,se,ue,he,ve,we,Ee,Pe,Ue,ze,Ve,We,ae,fe,de,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee,le,me,ge,Se,be,Re,Te,qe,Le,Ne,xe,Xe,Ze,Rt,vt,Dt,kt,St,yt,Lt,wt,Tt,At,_t,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends A.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(He,et)=>{this.onDisposeWorker(et)};R.ipcRenderer.on(Oe,je),this._register((0,A.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(W.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,A.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(m.UnusedWorkspaceStorageDataCleaner),ye.createInstance(C.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(v.ExtensionsCleaner),ye.createInstance(Ot.UserDataProfilesCleaner)))}async initServices(){const ye=new z.ServiceCollection,Oe={_serviceBrand:void 0,...N.default};ye.set(j.IProductService,Oe);const je=new I.StaticRouter(Ye=>Ye==="main"),He=new x.MessagePortMainProcessService(this.server,je);ye.set(Y.IMainProcessService,He);const et=this.configuration.policiesData?new Lt.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new wt.NullPolicyService;ye.set(wt.IPolicyService,et);const Be=new u.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(o.INativeEnvironmentService,Be);const ot=new V.LogLevelChannelClient(this.server.getChannel("logLevel",je)),tt=new V.LoggerChannelClient(this.configuration.logLevel,ot.onDidChangeLogLevel,He.getChannel("logger"));ye.set(W.ILoggerService,tt);const lt=this._register(new W.MultiplexLogService([this._register(new W.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,E.joinPath)(b.URI.file(Be.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new V.FollowerLogService(ot,lt));ye.set(W.ILogService,Ge),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Ge),ye.set(Te.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ye.set(M.IFileService,Je);const ut=this._register(new q.DiskFileSystemProvider(Ge));Je.registerProvider(P.Schemas.file,ut);const ht=this._register(new Xe.FileUserDataProvider(P.Schemas.file,this._register(new Ze.DiskFileSystemProviderClient(He.getChannel(Ze.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:xe.isLinux})),P.Schemas.vscodeUserData,Ge));Je.registerProvider(P.Schemas.vscodeUserData,ht);const it=this._register(new Tt.UserDataProfilesNativeService(this.configuration.profiles,He,Be));ye.set(St.IUserDataProfilesService,it);const Ke=this._register(new l.ConfigurationService(it.defaultProfile.settingsResource,Je,et,Ge));ye.set(f.IConfigurationService,Ke);const rt=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},He,Be);ye.set(Z.IStorageService,rt),this._register((0,A.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]),ye.set(Le.IUriIdentityService,new Ne.UriIdentityService(Je)),ye.set(B.IRequestService,new At.SharedProcessRequestService(He,Ke,Ge)),ye.set(g.IChecksumService,new J.SyncDescriptor(a.ChecksumService,void 0,!1)),ye.set(vt.IV8InspectProfilingService,new J.SyncDescriptor(Rt.InspectProfilingService,void 0,!1));const at=I.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(U.INativeHostService,at),ye.set(t.IDownloadService,new J.SyncDescriptor(n.DownloadService,void 0,!0));const ft=this._register(new ee.ActiveWindowManager(at)),Ft=new I.StaticRouter(Ye=>ft.getActiveClientId().then(dt=>Ye===dt));ye.set(O.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ft)));let ct;const st=[],bt=(0,ve.isInternalTelemetry)(Oe,Ke);if((0,ve.supportsTelemetry)(Oe,Be)){const Ye=new ue.TelemetryLogAppender(tt,Be);st.push(Ye);const{installSourcePath:dt}=Be;if(Oe.aiConfig?.ariaKey){const Pt=new _t.OneDataSystemAppender(bt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>Pt.flush())),st.push(Pt)}ct=new he.TelemetryService({appenders:st,commonProperties:(0,X.resolveCommonProperties)(Je,(0,r.release)(),(0,r.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,bt,dt),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Be)},Ke,Oe)}else{ct=ve.NullTelemetryService;const Ye=ve.NullAppender;st.push(Ye)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(st)),ye.set(ie.ITelemetryService,ct);const Nt=new we.CustomEndpointTelemetryService(Ke,ct,tt,Be,Oe);ye.set(ie.ICustomEndpointTelemetryService,Nt),ye.set(yt.IExtensionsProfileScannerService,new J.SyncDescriptor(yt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Dt.IExtensionsScannerService,new J.SyncDescriptor(kt.ExtensionsScannerService,void 0,!0)),ye.set(T.INativeServerExtensionManagementService,new J.SyncDescriptor(T.ExtensionManagementService,void 0,!0)),ye.set(y.IExtensionGalleryService,new J.SyncDescriptor(d.ExtensionGalleryService,void 0,!0)),ye.set(y.IExtensionTipsService,new J.SyncDescriptor(F.ExtensionTipsService,void 0,!1)),ye.set(te.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(i.IDiagnosticsService,new J.SyncDescriptor(s.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new de.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(y.IGlobalExtensionEnablementService,new J.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),ye.set(Ve.IIgnoredExtensionsManagementService,new J.SyncDescriptor(Ve.IgnoredExtensionsManagementService,void 0,!0)),ye.set(ze.IExtensionStorageService,new J.SyncDescriptor(ze.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Me.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new J.SyncDescriptor(_e.UserDataSyncProfilesStorageService,void 0,!0));const Ct=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,Be,Ge);return Ct.initialize(),ye.set(Pe.ILocalPtyService,this._register(Ct)),ye.set(le.ISignService,new J.SyncDescriptor(me.SignService,void 0,!1)),ye.set(ge.ISharedTunnelsService,new J.SyncDescriptor(Se.SharedTunnelsService)),ye.set(be.ISharedProcessTunnelService,new J.SyncDescriptor(Re.SharedProcessTunnelService)),new G.InstantiationService(ye)}initChannels(ye){const Oe=new _.ExtensionManagementChannel(ye.get(y.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=I.ProxyChannel.fromService(ye.get(te.ILanguagePackService));this.server.registerChannel("languagePacks",je);const He=I.ProxyChannel.fromService(ye.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const et=new _.ExtensionTipsChannel(ye.get(y.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Be=I.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",Be);const ot=I.ProxyChannel.fromService(ye.get(vt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",ot);const tt=new de.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const lt=I.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",lt);const Ge=new de.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new de.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ut=new $e.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(St.IUserDataProfilesService),ye.get(W.ILogService));this.server.registerChannel("userDataSync",ut);const ht=this._register(ye.get(H.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),it=new de.UserDataAutoSyncChannel(ht);this.server.registerChannel("userDataAutoSync",it);const Ke=ye.get(Pe.ILocalPtyService),rt=I.ProxyChannel.fromService(Ke);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,rt);const at=I.ProxyChannel.fromService(ye.get(be.ISharedProcessTunnelService));this.server.registerChannel(be.ipcSharedProcessTunnelChannelName,at);const ft=I.ProxyChannel.fromService(ye.get(Te.ISharedProcessWorkerService));this.server.registerChannel(Te.ipcSharedProcessWorkerChannelName,ft)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,D.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Mt(Et){const ye=new Ut(Et);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Mt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bd782eb059e133d3a20fdb446b8feb0010a278ad/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
